diff -pruN 0.3.0-6/CHANGES.rst 0.5.1-1/CHANGES.rst
--- 0.3.0-6/CHANGES.rst	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/CHANGES.rst	2020-04-06 16:34:05.000000000 +0000
@@ -1,13 +1,54 @@
-=======================
- citeproc-py changelog
-=======================
+Changelog
+---------
 
-This document summarizes the major changes for each release.
+Release 0.5.1 (2020-03-06)
+~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-.. contents::
+Bug fixed:
+
+* avoid rnc2rng 2.6.2 which breaks installation of citeproc-py
+
+Release 0.5.0 (2020-02-09)
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Enhancements:
+
+* handle commas and ampersands in a functional style
+* Number: handle commas and ampersands
+* added symbol for textquotesingle
+* specify fallback locales for fr-CA and es-CL
+* improved page number and ranges parsing
+
+Bug fixed:
+
+* don't fail on empty page ranges (#90) (bbm)
+* detect end of file while parsing incorrect bib (#59) (John Vandenberg)
+
+Other changes:
+
+* Removed 3.2-3.4 and added 3.7, 3.8 to supported Pythons
+* Refactored locales handling
+
+Release 0.4.0 (2017-06-23)
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+New features:
+
+* allow specifying the encoding of a BibTeX database file (#20 and #25)
+* BibTeX 'month' field: support integers and "<month> <day>" values
+* BibTeX 'pages' field: support "10", "10+", "10-12" and "10--12" formats
+* BibTeX entry types: map the non-standard 'thesis' and 'report' entries
+* update the CSL schema to version 1.0.1 (#5)
+* update the CSL locales to commit 49bf3fc0
+
+Bug fixed:
+
+* avoid crash when there is nothing to affix (David Lesieur)
+* fix BibTeX month to CSL month mapping (#24)
+* strip leading/trailing whitespace from BibTeX values (#37)
 
 Release 0.3.0 (2014-11-07)
-==========================
+~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 Major improvements to the BibTeX parser:
 
@@ -22,7 +63,7 @@ Other changes:
 * disable RelaxNG validation of CSL styles by default (API change)
 
 Release 0.2.0 (2014-10-25)
-==========================
+~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 * bad cite callback function can determine how a bad cite is displayed (hetsch)
 * added option to disable RelaxNG validation (Jasper Op de Coul)
diff -pruN 0.3.0-6/citeproc/data/locales/locales-af-ZA.xml 0.5.1-1/citeproc/data/locales/locales-af-ZA.xml
--- 0.3.0-6/citeproc/data/locales/locales-af-ZA.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-af-ZA.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>bladsy</single>
       <multiple>bladsye</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>bladsy</single>
+      <multiple>bladsye</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraaf</single>
       <multiple>paragrawe</multiple>
@@ -169,6 +173,10 @@
       <single>bl</single>
       <multiple>bll</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>bl</single>
+      <multiple>bll</multiple>
+    </term>
     <term name="paragraph" form="short">para</term>
     <term name="part" form="short">pt</term>
     <term name="section" form="short">sec</term>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">onder redaksie van</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">red</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ar-AR.xml 0.5.1-1/citeproc/data/locales/locales-ar-AR.xml
--- 0.3.0-6/citeproc/data/locales/locales-ar-AR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ar-AR.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,298 +0,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="ar-AR">
-  <info>
-    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
-  </info>
-  <style-options punctuation-in-quote="false"/>
-  <date form="text">
-    <date-part name="day" suffix=" "/>
-    <date-part name="month" suffix=", "/>
-    <date-part name="year"/>
-  </date>
-  <date form="numeric">
-    <date-part name="day" suffix="/"/>
-    <date-part name="month" form="numeric" suffix="/"/>
-    <date-part name="year"/>
-  </date>
-  <terms>
-    <term name="accessed">تاريخ الوصول</term>
-    <term name="and">و</term>
-    <term name="and others">وآخرون</term>
-    <term name="anonymous">مجهول</term>
-    <term name="anonymous" form="short">مجهول</term>
-    <term name="at">عند</term>
-    <term name="available at">available at</term>
-    <term name="by">عن طريق</term>
-    <term name="circa">حوالي</term>
-    <term name="circa" form="short">حو.</term>
-    <term name="cited">وثق</term>
-    <term name="edition">
-      <single>الطبعة</single>
-      <multiple>الطبعات</multiple>
-    </term>
-    <term name="edition" form="short">ط.</term>
-    <term name="et-al">وآخ.</term>
-    <term name="forthcoming">التالي</term>
-    <term name="from">من</term>
-    <term name="ibid">المرجع السابق</term>
-    <term name="in">في</term>
-    <term name="in press">قيد النشر</term>
-    <term name="internet">انترنت</term>
-    <term name="interview">مقابلة</term>
-    <term name="letter">خطاب</term>
-    <term name="no date">دون تاريخ</term>
-    <term name="no date" form="short">د.ت</term>
-    <term name="online">على الخط المباشر</term>
-    <term name="presented at">قُدَّم في</term>
-    <term name="reference">
-      <single>مرجع</single>
-      <multiple>مراجع</multiple>
-    </term>
-    <term name="reference" form="short">
-      <single>مرجع</single>
-      <multiple>مراجع</multiple>
-    </term>
-    <term name="retrieved">استرجع في</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
-
-    <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">ب.م.</term>
-    <term name="bc">ق.م.</term>
-
-    <!-- PUNCTUATION -->
-    <term name="open-quote">"</term>
-    <term name="close-quote">"</term>
-    <term name="open-inner-quote">'</term>
-    <term name="close-inner-quote">'</term>
-    <term name="page-range-delimiter">–</term>
-
-    <!-- ORDINALS -->
-    <term name="ordinal"/>
-
-    <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">الاول</term>
-    <term name="long-ordinal-02">الثاني</term>
-    <term name="long-ordinal-03">الثالث</term>
-    <term name="long-ordinal-04">الرابع</term>
-    <term name="long-ordinal-05">الخامس</term>
-    <term name="long-ordinal-06">السادس</term>
-    <term name="long-ordinal-07">السابع</term>
-    <term name="long-ordinal-08">الثامن</term>
-    <term name="long-ordinal-09">التاسع</term>
-    <term name="long-ordinal-10">العاشر</term>
-
-    <!-- LONG LOCATOR FORMS -->
-    <term name="book">
-      <single>كتاب</single>
-      <multiple>كتب</multiple>
-    </term>
-    <term name="chapter">
-      <single>فصل</single>
-      <multiple>فصول</multiple>
-    </term>
-    <term name="column">
-      <single>عمود</single>
-      <multiple>أعمدة</multiple>
-    </term>
-    <term name="figure">
-      <single>رسم توضيحي</single>
-      <multiple>رسوم توضيحية</multiple>
-    </term>
-    <term name="folio">
-      <single>ورقة</single>
-      <multiple>أوراق</multiple>
-    </term>
-    <term name="issue">
-      <single>عدد</single>
-      <multiple>أعداد</multiple>
-    </term>
-    <term name="line">
-      <single>سطر</single>
-      <multiple>أسطر</multiple>
-    </term>
-    <term name="note">
-      <single>ملاحظة</single>
-      <multiple>ملاحظات</multiple>
-    </term>
-    <term name="opus">
-      <single>نوته موسيقية</single>
-      <multiple>نوت موسيقية</multiple>
-    </term>
-    <term name="page">
-      <single>صفحة</single>
-      <multiple>صفحات</multiple>
-    </term>
-    <term name="paragraph">
-      <single>فقرة</single>
-      <multiple>فقرات</multiple>
-    </term>
-    <term name="part">
-      <single>جزء</single>
-      <multiple>أجزاء</multiple>
-    </term>
-    <term name="section">
-      <single>قسم</single>
-      <multiple>أقسام</multiple>
-    </term>
-    <term name="sub verbo">
-      <single>تفسير فرعي</single>
-      <multiple>تفسيرات فرعية</multiple>
-    </term>
-    <term name="verse">
-      <single>بيت شعر</single>
-      <multiple>أبيات شعر</multiple>
-    </term>
-    <term name="volume">
-      <single>مجلد</single>
-      <multiple>مجلدات</multiple>
-    </term>
-
-    <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">كتاب</term>
-    <term name="chapter" form="short">فصل</term>
-    <term name="column" form="short">عمود</term>
-    <term name="figure" form="short">رسم توضيحي</term>
-    <term name="folio" form="short">مطوية</term>
-    <term name="issue" form="short">عدد</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">نوتة موسيقية</term>
-    <term name="page" form="short">
-      <single>ص</single>
-      <multiple>ص.ص.</multiple>
-    </term>
-    <term name="paragraph" form="short">فقرة</term>
-    <term name="part" form="short">ج.</term>
-    <term name="section" form="short">قسم</term>
-    <term name="sub verbo" form="short">
-      <single>تفسير فرعي</single>
-      <multiple>تفسيرات فرعية</multiple>
-    </term>
-    <term name="verse" form="short">
-      <single>بيت شعر</single>
-      <multiple>أبيات شعر</multiple>
-    </term>
-    <term name="volume" form="short">
-      <single>مج.</single>
-      <multiple>مج.</multiple>
-    </term>
-
-    <!-- SYMBOL LOCATOR FORMS -->
-    <term name="paragraph" form="symbol">
-      <single>¶</single>
-      <multiple>¶¶</multiple>
-    </term>
-    <term name="section" form="symbol">
-      <single>§</single>
-      <multiple>§§</multiple>
-    </term>
-
-    <!-- LONG ROLE FORMS -->
-    <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
-    </term>
-    <term name="editor">
-      <single>محرر</single>
-      <multiple>محررين</multiple>
-    </term>
-    <term name="editorial-director">
-      <single>رئيس التحرير</single>
-      <multiple>رؤساء التحرير</multiple>
-    </term>
-    <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
-    </term>
-    <term name="translator">
-      <single>مترجم</single>
-      <multiple>مترجمين</multiple>
-    </term>
-    <term name="editortranslator">
-      <single>مترجم ومحرر</single>
-      <multiple>مترجمين ومحررين</multiple>
-    </term>
-
-    <!-- SHORT ROLE FORMS -->
-    <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
-    </term>
-    <term name="editor" form="short">
-      <single>محرر</single>
-      <multiple>محررين</multiple>
-    </term>
-    <term name="editorial-director" form="short">
-      <single>مشرف على الطبعة</single>
-      <multiple>مشرفين على الطبعة</multiple>
-    </term>
-    <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
-    </term>
-    <term name="translator" form="short">
-      <single>مترجم</single>
-      <multiple>مترجمين</multiple>
-    </term>
-    <term name="editortranslator" form="short">
-      <single>مترجم ومشرف على الطباعه</single>
-      <multiple>مترجمين ومشرفين على الطباعه</multiple>
-    </term>
-
-    <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">تحرير</term>
-    <term name="editorial-director" form="verb">اعداد</term>
-    <term name="illustrator" form="verb">illustrated by</term>
-    <term name="interviewer" form="verb">مقابلة بواسطة</term>
-    <term name="recipient" form="verb">مرسل الى</term>
-    <term name="reviewed-author" form="verb">by</term>
-    <term name="translator" form="verb">ترجمة</term>
-    <term name="editortranslator" form="verb">اعداد وترجمة</term>
-
-    <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">تحرير</term>
-    <term name="editorial-director" form="verb-short">اشرف على الطبعة</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">ترجمة</term>
-    <term name="editortranslator" form="verb-short">ترجمه واشرف على الطباعه</term>
-
-    <!-- LONG MONTH FORMS -->
-    <term name="month-01">يناير</term>
-    <term name="month-02">فبراير</term>
-    <term name="month-03">مارس</term>
-    <term name="month-04">ابريل</term>
-    <term name="month-05">مايو</term>
-    <term name="month-06">يونيو</term>
-    <term name="month-07">يوليو</term>
-    <term name="month-08">اغسطس</term>
-    <term name="month-09">سبتمبر</term>
-    <term name="month-10">اكتوبر</term>
-    <term name="month-11">نوفمبر</term>
-    <term name="month-12">ديسمبر</term>
-
-    <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">يناير</term>
-    <term name="month-02" form="short">فبراير</term>
-    <term name="month-03" form="short">مارس</term>
-    <term name="month-04" form="short">ابريل</term>
-    <term name="month-05" form="short">مايو</term>
-    <term name="month-06" form="short">يونيو</term>
-    <term name="month-07" form="short">يوليو</term>
-    <term name="month-08" form="short">اغسطس</term>
-    <term name="month-09" form="short">سبتمبر</term>
-    <term name="month-10" form="short">اكتوبر</term>
-    <term name="month-11" form="short">نوفمبر</term>
-    <term name="month-12" form="short">ديسمبر</term>
-
-    <!-- SEASONS -->
-    <term name="season-01">الربيع</term>
-    <term name="season-02">الصيف</term>
-    <term name="season-03">الخريف</term>
-    <term name="season-04">الشتاء</term>
-  </terms>
-</locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ar.xml 0.5.1-1/citeproc/data/locales/locales-ar.xml
--- 0.3.0-6/citeproc/data/locales/locales-ar.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ar.xml	2020-04-06 16:40:32.000000000 +0000
@@ -0,0 +1,306 @@
+<?xml version="1.0" encoding="utf-8"?>
+<locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="ar">
+  <info>
+    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
+    <updated>2012-07-04T23:31:02+00:00</updated>
+  </info>
+  <style-options punctuation-in-quote="false"/>
+  <date form="text">
+    <date-part name="day" suffix=" "/>
+    <date-part name="month" suffix=", "/>
+    <date-part name="year"/>
+  </date>
+  <date form="numeric">
+    <date-part name="day" suffix="/"/>
+    <date-part name="month" form="numeric" suffix="/"/>
+    <date-part name="year"/>
+  </date>
+  <terms>
+    <term name="accessed">تاريخ الوصول</term>
+    <term name="and">و</term>
+    <term name="and others">وآخرون</term>
+    <term name="anonymous">مجهول</term>
+    <term name="anonymous" form="short">مجهول</term>
+    <term name="at">عند</term>
+    <term name="available at">موجود في</term>
+    <term name="by">عن طريق</term>
+    <term name="circa">حوالي</term>
+    <term name="circa" form="short">حو.</term>
+    <term name="cited">وثق</term>
+    <term name="edition">
+      <single>الطبعة</single>
+      <multiple>الطبعات</multiple>
+    </term>
+    <term name="edition" form="short">ط.</term>
+    <term name="et-al">وآخ.</term>
+    <term name="forthcoming">التالي</term>
+    <term name="from">من</term>
+    <term name="ibid">المرجع السابق</term>
+    <term name="in">في</term>
+    <term name="in press">قيد النشر</term>
+    <term name="internet">انترنت</term>
+    <term name="interview">مقابلة</term>
+    <term name="letter">خطاب</term>
+    <term name="no date">دون تاريخ</term>
+    <term name="no date" form="short">د.ت</term>
+    <term name="online">على الخط المباشر</term>
+    <term name="presented at">قُدَّم في</term>
+    <term name="reference">
+      <single>مرجع</single>
+      <multiple>مراجع</multiple>
+    </term>
+    <term name="reference" form="short">
+      <single>مرجع</single>
+      <multiple>مراجع</multiple>
+    </term>
+    <term name="retrieved">استرجع في</term>
+    <term name="scale">scale</term>
+    <term name="version">version</term>
+
+    <!-- ANNO DOMINI; BEFORE CHRIST -->
+    <term name="ad">ب.م.</term>
+    <term name="bc">ق.م.</term>
+
+    <!-- PUNCTUATION -->
+    <term name="open-quote">"</term>
+    <term name="close-quote">"</term>
+    <term name="open-inner-quote">'</term>
+    <term name="close-inner-quote">'</term>
+    <term name="page-range-delimiter">–</term>
+
+    <!-- ORDINALS -->
+    <term name="ordinal"></term>
+
+    <!-- LONG ORDINALS -->
+    <term name="long-ordinal-01">الاول</term>
+    <term name="long-ordinal-02">الثاني</term>
+    <term name="long-ordinal-03">الثالث</term>
+    <term name="long-ordinal-04">الرابع</term>
+    <term name="long-ordinal-05">الخامس</term>
+    <term name="long-ordinal-06">السادس</term>
+    <term name="long-ordinal-07">السابع</term>
+    <term name="long-ordinal-08">الثامن</term>
+    <term name="long-ordinal-09">التاسع</term>
+    <term name="long-ordinal-10">العاشر</term>
+
+    <!-- LONG LOCATOR FORMS -->
+    <term name="book">
+      <single>كتاب</single>
+      <multiple>كتب</multiple>
+    </term>
+    <term name="chapter">
+      <single>فصل</single>
+      <multiple>فصول</multiple>
+    </term>
+    <term name="column">
+      <single>عمود</single>
+      <multiple>أعمدة</multiple>
+    </term>
+    <term name="figure">
+      <single>رسم توضيحي</single>
+      <multiple>رسوم توضيحية</multiple>
+    </term>
+    <term name="folio">
+      <single>ورقة</single>
+      <multiple>أوراق</multiple>
+    </term>
+    <term name="issue">
+      <single>عدد</single>
+      <multiple>أعداد</multiple>
+    </term>
+    <term name="line">
+      <single>سطر</single>
+      <multiple>أسطر</multiple>
+    </term>
+    <term name="note">
+      <single>ملاحظة</single>
+      <multiple>ملاحظات</multiple>
+    </term>
+    <term name="opus">
+      <single>نوته موسيقية</single>
+      <multiple>نوت موسيقية</multiple>
+    </term>
+    <term name="page">
+      <single>صفحة</single>
+      <multiple>صفحات</multiple>
+    </term>
+    <term name="number-of-pages">
+      <single>صفحة</single>
+      <multiple>صفحات</multiple>
+    </term>
+    <term name="paragraph">
+      <single>فقرة</single>
+      <multiple>فقرات</multiple>
+    </term>
+    <term name="part">
+      <single>جزء</single>
+      <multiple>أجزاء</multiple>
+    </term>
+    <term name="section">
+      <single>قسم</single>
+      <multiple>أقسام</multiple>
+    </term>
+    <term name="sub verbo">
+      <single>تفسير فرعي</single>
+      <multiple>تفسيرات فرعية</multiple>
+    </term>
+    <term name="verse">
+      <single>بيت شعر</single>
+      <multiple>أبيات شعر</multiple>
+    </term>
+    <term name="volume">
+      <single>مجلد</single>
+      <multiple>مجلدات</multiple>
+    </term>
+
+    <!-- SHORT LOCATOR FORMS -->
+    <term name="book" form="short">كتاب</term>
+    <term name="chapter" form="short">فصل</term>
+    <term name="column" form="short">عمود</term>
+    <term name="figure" form="short">رسم توضيحي</term>
+    <term name="folio" form="short">مطوية</term>
+    <term name="issue" form="short">عدد</term>
+    <term name="line" form="short">l.</term>
+    <term name="note" form="short">n.</term>
+    <term name="opus" form="short">نوتة موسيقية</term>
+    <term name="page" form="short">
+      <single>ص</single>
+      <multiple>ص.ص.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>ص</single>
+      <multiple>ص.ص.</multiple>
+    </term>
+    <term name="paragraph" form="short">فقرة</term>
+    <term name="part" form="short">ج.</term>
+    <term name="section" form="short">قسم</term>
+    <term name="sub verbo" form="short">
+      <single>تفسير فرعي</single>
+      <multiple>تفسيرات فرعية</multiple>
+    </term>
+    <term name="verse" form="short">
+      <single>بيت شعر</single>
+      <multiple>أبيات شعر</multiple>
+    </term>
+    <term name="volume" form="short">
+      <single>مج.</single>
+      <multiple>مج.</multiple>
+    </term>
+
+    <!-- SYMBOL LOCATOR FORMS -->
+    <term name="paragraph" form="symbol">
+      <single>¶</single>
+      <multiple>¶¶</multiple>
+    </term>
+    <term name="section" form="symbol">
+      <single>§</single>
+      <multiple>§§</multiple>
+    </term>
+
+    <!-- LONG ROLE FORMS -->
+    <term name="director">
+      <single>مدور</single>
+      <multiple>مدورين</multiple>
+    </term>
+    <term name="editor">
+      <single>محرر</single>
+      <multiple>محررين</multiple>
+    </term>
+    <term name="editorial-director">
+      <single>رئيس التحرير</single>
+      <multiple>رؤساء التحرير</multiple>
+    </term>
+    <term name="illustrator">
+      <single>illustrator</single>
+      <multiple>illustrators</multiple>
+    </term>
+    <term name="translator">
+      <single>مترجم</single>
+      <multiple>مترجمين</multiple>
+    </term>
+    <term name="editortranslator">
+      <single>مترجم ومحرر</single>
+      <multiple>مترجمين ومحررين</multiple>
+    </term>
+
+    <!-- SHORT ROLE FORMS -->
+    <term name="director" form="short">
+      <single>dir.</single>
+      <multiple>dirs.</multiple>
+    </term>
+    <term name="editor" form="short">
+      <single>محرر</single>
+      <multiple>محررين</multiple>
+    </term>
+    <term name="editorial-director" form="short">
+      <single>مشرف على الطبعة</single>
+      <multiple>مشرفين على الطبعة</multiple>
+    </term>
+    <term name="illustrator" form="short">
+      <single>ill.</single>
+      <multiple>ills.</multiple>
+    </term>
+    <term name="translator" form="short">
+      <single>مترجم</single>
+      <multiple>مترجمين</multiple>
+    </term>
+    <term name="editortranslator" form="short">
+      <single>مترجم ومشرف على الطباعه</single>
+      <multiple>مترجمين ومشرفين على الطباعه</multiple>
+    </term>
+
+    <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb"></term>
+    <term name="director" form="verb">directed by</term>
+    <term name="editor" form="verb">تحرير</term>
+    <term name="editorial-director" form="verb">اعداد</term>
+    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="interviewer" form="verb">مقابلة بواسطة</term>
+    <term name="recipient" form="verb">مرسل الى</term>
+    <term name="reviewed-author" form="verb">بـ</term>
+    <term name="translator" form="verb">ترجمة</term>
+    <term name="editortranslator" form="verb">اعداد وترجمة</term>
+
+    <!-- SHORT VERB ROLE FORMS -->
+    <term name="director" form="verb-short">dir.</term>
+    <term name="editor" form="verb-short">تحرير</term>
+    <term name="editorial-director" form="verb-short">اشرف على الطبعة</term>
+    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="translator" form="verb-short">ترجمة</term>
+    <term name="editortranslator" form="verb-short">ترجمه واشرف على الطباعه</term>
+
+    <!-- LONG MONTH FORMS -->
+    <term name="month-01">يناير</term>
+    <term name="month-02">فبراير</term>
+    <term name="month-03">مارس</term>
+    <term name="month-04">ابريل</term>
+    <term name="month-05">مايو</term>
+    <term name="month-06">يونيو</term>
+    <term name="month-07">يوليو</term>
+    <term name="month-08">اغسطس</term>
+    <term name="month-09">سبتمبر</term>
+    <term name="month-10">اكتوبر</term>
+    <term name="month-11">نوفمبر</term>
+    <term name="month-12">ديسمبر</term>
+
+    <!-- SHORT MONTH FORMS -->
+    <term name="month-01" form="short">يناير</term>
+    <term name="month-02" form="short">فبراير</term>
+    <term name="month-03" form="short">مارس</term>
+    <term name="month-04" form="short">ابريل</term>
+    <term name="month-05" form="short">مايو</term>
+    <term name="month-06" form="short">يونيو</term>
+    <term name="month-07" form="short">يوليو</term>
+    <term name="month-08" form="short">اغسطس</term>
+    <term name="month-09" form="short">سبتمبر</term>
+    <term name="month-10" form="short">اكتوبر</term>
+    <term name="month-11" form="short">نوفمبر</term>
+    <term name="month-12" form="short">ديسمبر</term>
+
+    <!-- SEASONS -->
+    <term name="season-01">الربيع</term>
+    <term name="season-02">الصيف</term>
+    <term name="season-03">الخريف</term>
+    <term name="season-04">الشتاء</term>
+  </terms>
+</locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-bg-BG.xml 0.5.1-1/citeproc/data/locales/locales-bg-BG.xml
--- 0.3.0-6/citeproc/data/locales/locales-bg-BG.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-bg-BG.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>страница</single>
       <multiple>страници</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>страница</single>
+      <multiple>страници</multiple>
+    </term>
     <term name="paragraph">
       <single>параграф</single>
       <multiple>параграфи</multiple>
@@ -169,6 +173,10 @@
       <single>с</single>
       <multiple>с-ци</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>с</single>
+      <multiple>с-ци</multiple>
+    </term>
     <term name="paragraph" form="short">п</term>
     <term name="part" form="short">ч</term>
     <term name="section" form="short">разд</term>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">редактиран от</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ред</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ca-AD.xml 0.5.1-1/citeproc/data/locales/locales-ca-AD.xml
--- 0.3.0-6/citeproc/data/locales/locales-ca-AD.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ca-AD.xml	2020-04-06 16:40:32.000000000 +0000
@@ -16,7 +16,7 @@
     <date-part name="year"/>
   </date>
   <terms>
-    <term name="accessed">accedit</term>
+    <term name="accessed">consulta</term>
     <term name="and">i</term>
     <term name="and others">i altres</term>
     <term name="anonymous">anònim</term>
@@ -124,6 +124,10 @@
       <single>pàgina</single>
       <multiple>pàgines</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>pàgina</single>
+      <multiple>pàgines</multiple>
+    </term>
     <term name="paragraph">
       <single>paràgraf</single>
       <multiple>paràgrafs</multiple>
@@ -163,6 +167,10 @@
       <single>p.</single>
       <multiple>p.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>p.</multiple>
+    </term>
     <term name="paragraph" form="short">par.</term>
     <term name="part" form="short">pt.</term>
     <term name="section" form="short">sec.</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">per</term>
     <term name="director" form="verb">dirigit per</term>
     <term name="editor" form="verb">editat per</term>
     <term name="editorial-director" form="verb">editat per</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">editat i traduït per</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">per</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-cs-CZ.xml 0.5.1-1/citeproc/data/locales/locales-cs-CZ.xml
--- 0.3.0-6/citeproc/data/locales/locales-cs-CZ.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-cs-CZ.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -54,7 +54,7 @@
       <single>ref.</single>
       <multiple>ref.</multiple>
     </term>
-    <term name="retrieved">dostupné</term>
+    <term name="retrieved">získáno</term>
     <term name="scale">měřítko</term>
     <term name="version">verze</term>
 
@@ -125,6 +125,10 @@
       <single>strana</single>
       <multiple>strany</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>strana</single>
+      <multiple>strany</multiple>
+    </term>
     <term name="paragraph">
       <single>odstavec</single>
       <multiple>odstavce</multiple>
@@ -164,6 +168,10 @@
       <single>s.</single>
       <multiple>s.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
     <term name="paragraph" form="short">odst.</term>
     <term name="part" form="short">č.</term>
     <term name="section" form="short">sek.</term>
@@ -243,6 +251,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb"></term>
     <term name="director" form="verb">řídil</term>
     <term name="editor" form="verb">editoval</term>
     <term name="editorial-director" form="verb">editoval</term>
@@ -254,7 +263,6 @@
     <term name="editortranslator" form="verb">editoval a přeložil</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"></term>
     <term name="director" form="verb-short">řed.</term>
     <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-cy-GB.xml 0.5.1-1/citeproc/data/locales/locales-cy-GB.xml
--- 0.3.0-6/citeproc/data/locales/locales-cy-GB.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-cy-GB.xml	2020-04-06 16:40:32.000000000 +0000
@@ -0,0 +1,312 @@
+<?xml version="1.0" encoding="utf-8"?>
+<locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="cy-GB">
+  <info>
+    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
+    <updated>2014-10-08T12:00:00+00:00</updated>
+  </info>
+  <style-options punctuation-in-quote="false"/>
+  <date form="text">
+    <date-part name="day" suffix=" "/>
+    <date-part name="month" suffix=" "/>
+    <date-part name="year"/>
+  </date>
+  <date form="numeric">
+    <date-part name="day" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="month" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="year"/>
+  </date>
+  <terms>
+    <term name="accessed">gwelwyd</term>
+    <term name="and">a/ac</term>
+    <term name="and others">ac eraill</term>
+    <term name="anonymous">di-enw</term>
+    <term name="anonymous" form="short">dienw</term>
+    <term name="at">at</term>
+    <term name="available at">ar gael</term>
+    <term name="by">gan</term>
+    <term name="circa">circa</term>
+    <term name="circa" form="short">c.</term>
+    <term name="cited">dyfynnwyd</term>
+    <term name="edition">
+      <single>argraffiad</single>
+      <multiple>argraffiadau</multiple>
+    </term>
+    <term name="edition" form="short">arg.</term>
+    <term name="et-al">et al.</term>
+    <term name="forthcoming">ar fin ymddangos</term>
+    <term name="from">gan</term>
+    <term name="ibid">ibid.</term>
+    <term name="in">yn</term>
+    <term name="in press">yn y wasg</term>
+    <term name="internet">rhyngrwyd</term>
+    <term name="interview">cyfweliad</term>
+    <term name="letter">llythyr</term>
+    <term name="no date">dim dyddiad</term>
+    <term name="no date" form="short">d.d.</term>
+    <term name="online">arlein</term>
+    <term name="presented at">cyflwynwyd yn</term>
+    <term name="reference">
+      <single>cyfeirnod</single>
+      <multiple>cyfeirnodau</multiple>
+    </term>
+    <term name="reference" form="short">
+      <single>cyf.</single>
+      <multiple>cyf’au.</multiple>
+    </term>
+    <term name="retrieved">gwelwyd</term>
+    <term name="scale">graddfa</term>
+    <term name="version">fersiwn</term>
+
+    <!-- ANNO DOMINI; BEFORE CHRIST -->
+    <term name="ad">OC</term>
+    <term name="bc">CC</term>
+
+    <!-- PUNCTUATION -->
+    <term name="open-quote">‘</term>
+    <term name="close-quote">’</term>
+    <term name="open-inner-quote">“</term>
+    <term name="close-inner-quote">”</term>
+    <term name="page-range-delimiter">–</term>
+
+    <!-- ORDINALS -->
+    <term name="ordinal">th</term>
+    <term name="ordinal-01">af</term>
+    <term name="ordinal-02">il</term>
+    <term name="ordinal-03">ydd</term>
+    <term name="ordinal-11">ed</term>
+    <term name="ordinal-12">ed</term>
+    <term name="ordinal-13">ed</term>
+
+    <!-- LONG ORDINALS -->
+    <term name="long-ordinal-01">cyntaf</term>
+    <term name="long-ordinal-02">ail</term>
+    <term name="long-ordinal-03">trydydd</term>
+    <term name="long-ordinal-04">pedwerydd</term>
+    <term name="long-ordinal-05">pumed</term>
+    <term name="long-ordinal-06">chweched</term>
+    <term name="long-ordinal-07">seithfed</term>
+    <term name="long-ordinal-08">wythfed</term>
+    <term name="long-ordinal-09">nawfed</term>
+    <term name="long-ordinal-10">degfed</term>
+
+    <!-- LONG LOCATOR FORMS -->
+    <term name="book">
+      <single>llyfr</single>
+      <multiple>llyfrau</multiple>
+    </term>
+    <term name="chapter">
+      <single>pennod</single>
+      <multiple>penodau</multiple>
+    </term>
+    <term name="column">
+      <single>colofn</single>
+      <multiple>colofnau</multiple>
+    </term>
+    <term name="figure">
+      <single>ffigwr</single>
+      <multiple>ffigyrau</multiple>
+    </term>
+    <term name="folio">
+      <single>ffolio</single>
+      <multiple>ffolios</multiple>
+    </term>
+    <term name="issue">
+      <single>rhifyn</single>
+      <multiple>rhifynnau</multiple>
+    </term>
+    <term name="line">
+      <single>llinell</single>
+      <multiple>llinellau</multiple>
+    </term>
+    <term name="note">
+      <single>nodyn</single>
+      <multiple>nodiadau</multiple>
+    </term>
+    <term name="opus">
+      <single>opus</single>
+      <multiple>opera</multiple>
+    </term>
+    <term name="page">
+      <single>tudalen</single>
+      <multiple>tudalennau</multiple>
+    </term>
+    <term name="number-of-pages">
+      <single>tudalen</single>
+      <multiple>tudalennau</multiple>
+    </term>
+    <term name="paragraph">
+      <single>paragraff</single>
+      <multiple>paragraffau</multiple>
+    </term>
+    <term name="part">
+      <single>rhan</single>
+      <multiple>rhannau</multiple>
+    </term>
+    <term name="section">
+      <single>adran</single>
+      <multiple>adrannau</multiple>
+    </term>
+    <term name="sub verbo">
+      <single>sub verbo</single>
+      <multiple>sub verbis</multiple>
+    </term>
+    <term name="verse">
+      <single>pennill</single>
+      <multiple>penillion</multiple>
+    </term>
+    <term name="volume">
+      <single>cyfrol</single>
+      <multiple>cyfrolau</multiple>
+    </term>
+
+    <!-- SHORT LOCATOR FORMS -->
+    <term name="book" form="short">llyfr.</term>
+    <term name="chapter" form="short">pen.</term>
+    <term name="column" form="short">col.</term>
+    <term name="figure" form="short">ffig.</term>
+    <term name="folio" form="short">ff.</term>
+    <term name="issue" form="short">rhif.</term>
+    <term name="line" form="short">ll.</term>
+    <term name="note" form="short">n.</term>
+    <term name="opus" form="short">op.</term>
+    <term name="page" form="short">
+      <single>t.</single>
+      <multiple>tt.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>t.</single>
+      <multiple>tt.</multiple>
+    </term>
+    <term name="paragraph" form="short">para.</term>
+    <term name="part" form="short">rhan.</term>
+    <term name="section" form="short">adr.</term>
+    <term name="sub verbo" form="short">
+      <single>s.v.</single>
+      <multiple>s.vv.</multiple>
+    </term>
+    <term name="verse" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="volume" form="short">
+      <single>rhif.</single>
+      <multiple>rhifu.</multiple>
+    </term>
+
+    <!-- SYMBOL LOCATOR FORMS -->
+    <term name="paragraph" form="symbol">
+      <single>¶</single>
+      <multiple>¶¶</multiple>
+    </term>
+    <term name="section" form="symbol">
+      <single>§</single>
+      <multiple>§§</multiple>
+    </term>
+
+    <!-- LONG ROLE FORMS -->
+    <term name="director">
+      <single>cyfarwyddwr</single>
+      <multiple>cyfarwyddwyr</multiple>
+    </term>
+    <term name="editor">
+      <single>golygydd</single>
+      <multiple>golygyddion</multiple>
+    </term>
+    <term name="editorial-director">
+      <single>cyfarwyddwr-golygyddol</single>
+      <multiple>cyfarwyddwyr-golygyddol</multiple>
+    </term>
+    <term name="illustrator">
+      <single>darlunydd</single>
+      <multiple>darlunwyr</multiple>
+    </term>
+    <term name="translator">
+      <single>cyfieithydd</single>
+      <multiple>cyfieithwyr</multiple>
+    </term>
+    <term name="editortranslator">
+      <single>golygydd a chyfieithydd</single>
+      <multiple>golygyddion a chyfieithwyr</multiple>
+    </term>
+
+    <!-- SHORT ROLE FORMS -->
+    <term name="director" form="short">
+      <single>cyf.</single>
+      <multiple>cyfy.</multiple>
+    </term>
+    <term name="editor" form="short">
+      <single>gol.</single>
+      <multiple>goln.</multiple>
+    </term>
+    <term name="editorial-director" form="short">
+      <single>gol.</single>
+      <multiple>goln.</multiple>
+    </term>
+    <term name="illustrator" form="short">
+      <single>darlun.</single>
+      <multiple>darlun.</multiple>
+    </term>
+    <term name="translator" form="short">
+      <single>cyf.</single>
+      <multiple>cyf.</multiple>
+    </term>
+    <term name="editortranslator" form="short">
+      <single>gol. a chyf.</single>
+      <multiple>goln. a chyf.</multiple>
+    </term>
+
+    <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">gan</term>
+    <term name="director" form="verb">cyfarwyddwyd gan</term>
+    <term name="editor" form="verb">golygwyd gan</term>
+    <term name="editorial-director" form="verb">cyfarwyddwyd a golygwyd gan</term>
+    <term name="illustrator" form="verb">darlunwyd gan</term>
+    <term name="interviewer" form="verb">cyfweliad gan</term>
+    <term name="recipient" form="verb">i</term>
+    <term name="reviewed-author" form="verb">gan</term>
+    <term name="translator" form="verb">cyfieithwyd gan </term>
+    <term name="editortranslator" form="verb">golygwyd a chyfieithwyd gan</term>
+
+    <!-- SHORT VERB ROLE FORMS -->
+    <term name="director" form="verb-short">cyf. gan</term>
+    <term name="editor" form="verb-short">gol. gan</term>
+    <term name="editorial-director" form="verb-short">cyf.-gol. gan</term>
+    <term name="illustrator" form="verb-short">darlun. gan</term>
+    <term name="translator" form="verb-short">cyf. gan</term>
+    <term name="editortranslator" form="verb-short">gol. a chyf. gan</term>
+
+    <!-- LONG MONTH FORMS -->
+    <term name="month-01">Ionawr</term>
+    <term name="month-02">Chwefror</term>
+    <term name="month-03">Mawrth</term>
+    <term name="month-04">Ebrill</term>
+    <term name="month-05">Mai</term>
+    <term name="month-06">Mehefin</term>
+    <term name="month-07">Gorffennaf</term>
+    <term name="month-08">Awst</term>
+    <term name="month-09">Medi</term>
+    <term name="month-10">Hydref</term>
+    <term name="month-11">Tachwedd</term>
+    <term name="month-12">Rhagfyr</term>
+
+    <!-- SHORT MONTH FORMS -->
+    <term name="month-01" form="short">Ion.</term>
+    <term name="month-02" form="short">Chwe.</term>
+    <term name="month-03" form="short">Maw.</term>
+    <term name="month-04" form="short">Ebr.</term>
+    <term name="month-05" form="short">Mai</term>
+    <term name="month-06" form="short">Meh.</term>
+    <term name="month-07" form="short">Gorff.</term>
+    <term name="month-08" form="short">Aws.</term>
+    <term name="month-09" form="short">Med.</term>
+    <term name="month-10" form="short">Hyd.</term>
+    <term name="month-11" form="short">Tach.</term>
+    <term name="month-12" form="short">Rhag.</term>
+
+    <!-- SEASONS -->
+    <term name="season-01">Gwanwyn</term>
+    <term name="season-02">Haf</term>
+    <term name="season-03">Hydref</term>
+    <term name="season-04">Gaeaf</term>
+  </terms>
+</locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-da-DK.xml 0.5.1-1/citeproc/data/locales/locales-da-DK.xml
--- 0.3.0-6/citeproc/data/locales/locales-da-DK.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-da-DK.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -16,33 +16,33 @@
     <date-part name="year"/>
   </date>
   <terms>
-    <term name="accessed">åbnet</term>
+    <term name="accessed">set</term>
     <term name="and">og</term>
     <term name="and others">med flere</term>
     <term name="anonymous">anonym</term>
     <term name="anonymous" form="short">anon.</term>
     <term name="at">på</term>
-    <term name="available at">available at</term>
+    <term name="available at">tilgængelig hos</term>
     <term name="by">af</term>
     <term name="circa">cirka</term>
     <term name="circa" form="short">ca.</term>
-    <term name="cited">citeret</term>
+    <term name="cited">henvist</term>
     <term name="edition">
       <single>udgave</single>
       <multiple>udgaver</multiple>
     </term>
     <term name="edition" form="short">udg.</term>
-    <term name="et-al">et al.</term>
+    <term name="et-al">m.fl.</term>
     <term name="forthcoming">kommende</term>
     <term name="from">fra</term>
     <term name="ibid">ibid.</term>
     <term name="in">i</term>
-    <term name="in press">i tryk</term>
+    <term name="in press">i trykken</term>
     <term name="internet">internet</term>
     <term name="interview">interview</term>
     <term name="letter">brev</term>
-    <term name="no date">ingen dato</term>
-    <term name="no date" form="short">udateret</term>
+    <term name="no date">uden år</term>
+    <term name="no date" form="short">u.å.</term>
     <term name="online">online</term>
     <term name="presented at">præsenteret ved</term>
     <term name="reference">
@@ -54,16 +54,16 @@
       <multiple>refr.</multiple>
     </term>
     <term name="retrieved">hentet</term>
-    <term name="scale">scale</term>
+    <term name="scale">skala</term>
     <term name="version">version</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">e.Kr</term>
-    <term name="bc">f.Kr</term>
+    <term name="ad">e.v.t.</term>
+    <term name="bc">f.v.t.</term>
 
     <!-- PUNCTUATION -->
-    <term name="open-quote">«</term>
-    <term name="close-quote">»</term>
+    <term name="open-quote">“</term>
+    <term name="close-quote">”</term>
     <term name="open-inner-quote">‘</term>
     <term name="close-inner-quote">’</term>
     <term name="page-range-delimiter">–</term>
@@ -102,7 +102,7 @@
     </term>
     <term name="folio">
       <single>folio</single>
-      <multiple>folier</multiple>
+      <multiple>folio</multiple>
     </term>
     <term name="issue">
       <single>nummer</single>
@@ -118,12 +118,16 @@
     </term>
     <term name="opus">
       <single>opus</single>
-      <multiple>opuser</multiple>
+      <multiple>opus</multiple>
     </term>
     <term name="page">
       <single>side</single>
       <multiple>sider</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>side</single>
+      <multiple>sider</multiple>
+    </term>
     <term name="paragraph">
       <single>afsnit</single>
       <multiple>afsnit</multiple>
@@ -133,12 +137,12 @@
       <multiple>dele</multiple>
     </term>
     <term name="section">
-      <single>sektion</single>
-      <multiple>sektionerne</multiple>
+      <single>paragraf</single>
+      <multiple>paragraffer</multiple>
     </term>
     <term name="sub verbo">
-      <single>sub verbo</single>
-      <multiple>sub verbis</multiple>
+      <single>sub voce</single>
+      <multiple>sub voce</multiple>
     </term>
     <term name="verse">
       <single>vers</single>
@@ -163,12 +167,16 @@
       <single>s.</single>
       <multiple>s.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
     <term name="paragraph" form="short">afs.</term>
     <term name="part" form="short">d.</term>
-    <term name="section" form="short">sekt.</term>
+    <term name="section" form="short">par.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
-      <multiple>s.vv.</multiple>
+      <multiple>s.v.</multiple>
     </term>
     <term name="verse" form="short">
       <single>v.</single>
@@ -191,8 +199,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>instruktør</single>
+      <multiple>instruktører</multiple>
     </term>
     <term name="editor">
       <single>redaktør</single>
@@ -204,7 +212,7 @@
     </term>
     <term name="illustrator">
       <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <multiple>illustratorer</multiple>
     </term>
     <term name="translator">
       <single>oversætter</single>
@@ -217,8 +225,8 @@
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>instr.</single>
+      <multiple>instr.</multiple>
     </term>
     <term name="editor" form="short">
       <single>red.</single>
@@ -230,7 +238,7 @@
     </term>
     <term name="illustrator" form="short">
       <single>ill.</single>
-      <multiple>ills.</multiple>
+      <multiple>ill.</multiple>
     </term>
     <term name="translator" form="short">
       <single>overs.</single>
@@ -242,19 +250,19 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">af</term>
+    <term name="director" form="verb">instrueret af</term>
     <term name="editor" form="verb">redigeret af</term>
     <term name="editorial-director" form="verb">redigeret af</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">illustreret af</term>
     <term name="interviewer" form="verb">interviewet af</term>
     <term name="recipient" form="verb">modtaget af</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">af</term>
     <term name="translator" form="verb">oversat af</term>
     <term name="editortranslator" form="verb">redigeret &amp; oversat af</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">af</term>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">instr.</term>
     <term name="editor" form="verb-short">red.</term>
     <term name="editorial-director" form="verb-short">red.</term>
     <term name="illustrator" form="verb-short">illus.</term>
@@ -262,37 +270,37 @@
     <term name="editortranslator" form="verb-short">red. &amp; overs. af</term>
 
     <!-- LONG MONTH FORMS -->
-    <term name="month-01">Januar</term>
-    <term name="month-02">Februar</term>
-    <term name="month-03">Marts</term>
-    <term name="month-04">April</term>
-    <term name="month-05">Maj</term>
-    <term name="month-06">Juni</term>
-    <term name="month-07">Juli</term>
-    <term name="month-08">August</term>
-    <term name="month-09">September</term>
-    <term name="month-10">Oktober</term>
-    <term name="month-11">November</term>
-    <term name="month-12">December</term>
+    <term name="month-01">januar</term>
+    <term name="month-02">februar</term>
+    <term name="month-03">marts</term>
+    <term name="month-04">april</term>
+    <term name="month-05">maj</term>
+    <term name="month-06">juni</term>
+    <term name="month-07">juli</term>
+    <term name="month-08">august</term>
+    <term name="month-09">september</term>
+    <term name="month-10">oktober</term>
+    <term name="month-11">november</term>
+    <term name="month-12">december</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">Jan.</term>
-    <term name="month-02" form="short">Feb.</term>
-    <term name="month-03" form="short">Mar.</term>
-    <term name="month-04" form="short">Apr.</term>
-    <term name="month-05" form="short">Maj</term>
-    <term name="month-06" form="short">Jun.</term>
-    <term name="month-07" form="short">Jul.</term>
-    <term name="month-08" form="short">Aug.</term>
-    <term name="month-09" form="short">Sep.</term>
-    <term name="month-10" form="short">Okt.</term>
-    <term name="month-11" form="short">Nov.</term>
-    <term name="month-12" form="short">Dec.</term>
+    <term name="month-01" form="short">jan.</term>
+    <term name="month-02" form="short">feb.</term>
+    <term name="month-03" form="short">mar.</term>
+    <term name="month-04" form="short">apr.</term>
+    <term name="month-05" form="short">maj</term>
+    <term name="month-06" form="short">jun.</term>
+    <term name="month-07" form="short">jul.</term>
+    <term name="month-08" form="short">aug.</term>
+    <term name="month-09" form="short">sep.</term>
+    <term name="month-10" form="short">okt.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dec.</term>
 
     <!-- SEASONS -->
     <term name="season-01">Forår</term>
     <term name="season-02">Sommer</term>
     <term name="season-03">Efterår</term>
-    <term name="season-04">vinter</term>
+    <term name="season-04">Vinter</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-de-AT.xml 0.5.1-1/citeproc/data/locales/locales-de-AT.xml
--- 0.3.0-6/citeproc/data/locales/locales-de-AT.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-de-AT.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -20,9 +20,9 @@
     <term name="and">und</term>
     <term name="and others">und andere</term>
     <term name="anonymous">ohne Autor</term>
-    <term name="anonymous" form="short">o. A.</term>
+    <term name="anonymous" form="short">o.&#160;A.</term>
     <term name="at">auf</term>
-    <term name="available at">available at</term>
+    <term name="available at">verfügbar unter</term>
     <term name="by">von</term>
     <term name="circa">circa</term>
     <term name="circa" form="short">ca.</term>
@@ -32,8 +32,8 @@
       <multiple>Auflagen</multiple>
     </term>
     <term name="edition" form="short">Aufl.</term>
-    <term name="et-al">u. a.</term>
-    <term name="forthcoming">i. E.</term>
+    <term name="et-al">u.&#160;a.</term>
+    <term name="forthcoming">i.&#160;E.</term>
     <term name="from">von</term>
     <term name="ibid">ebd.</term>
     <term name="in">in</term>
@@ -42,7 +42,7 @@
     <term name="interview">Interview</term>
     <term name="letter">Brief</term>
     <term name="no date">ohne Datum</term>
-    <term name="no date" form="short">o. J.</term>
+    <term name="no date" form="short">o.&#160;J.</term>
     <term name="online">online</term>
     <term name="presented at">gehalten auf der</term>
     <term name="reference">
@@ -54,12 +54,12 @@
       <multiple>Ref.</multiple>
     </term>
     <term name="retrieved">abgerufen</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">Maßstab</term>
+    <term name="version">Version</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">n. Chr.</term>
-    <term name="bc">v. Chr.</term>
+    <term name="ad">&#160;n.&#160;Chr.</term>
+    <term name="bc">&#160;v.&#160;Chr.</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">„</term>
@@ -124,6 +124,10 @@
       <single>Seite</single>
       <multiple>Seiten</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>Seite</single>
+      <multiple>Seiten</multiple>
+    </term>
     <term name="paragraph">
       <single>Absatz</single>
       <multiple>Absätze</multiple>
@@ -163,12 +167,16 @@
       <single>S.</single>
       <multiple>S.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>S.</single>
+      <multiple>S.</multiple>
+    </term>
     <term name="paragraph" form="short">Abs.</term>
     <term name="part" form="short">Teil</term>
     <term name="section" form="short">Abschn.</term>
     <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
+      <single>s.&#160;v.</single>
+      <multiple>s.&#160;vv.</multiple>
     </term>
     <term name="verse" form="short">
       <single>V.</single>
@@ -191,78 +199,88 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>Regisseur</single>
+      <multiple>Regisseure</multiple>
     </term>
     <term name="editor">
       <single>Herausgeber</single>
       <multiple>Herausgeber</multiple>
     </term>
+    <term name="collection-editor">
+      <single>Reihenherausgeber</single>
+      <multiple>Reihenherausgeber</multiple>
+    </term>
     <term name="editorial-director">
       <single>Herausgeber</single>
       <multiple>Herausgeber</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>Illustrator</single>
+      <multiple>Illustratoren</multiple>
     </term>
     <term name="translator">
       <single>Übersetzer</single>
       <multiple>Übersetzer</multiple>
     </term>
     <term name="editortranslator">
-      <single>Herausgeber &amp; Übersetzer</single>
-      <multiple>Herausgeber &amp; Übersetzer</multiple>
+      <single>Herausgeber&#160;&amp; Übersetzer</single>
+      <multiple>Herausgeber&#160;&amp; Übersetzer</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>Reg.</single>
+      <multiple>Reg.</multiple>
     </term>
     <term name="editor" form="short">
       <single>Hrsg.</single>
       <multiple>Hrsg.</multiple>
     </term>
+    <term name="collection-editor" form="short">
+      <single>Hrsg.</single>
+      <multiple>Hrsg.</multiple>
+    </term>
     <term name="editorial-director" form="short">
       <single>Hrsg.</single>
       <multiple>Hrsg.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>Ill.</single>
+      <multiple>Ill.</multiple>
     </term>
     <term name="translator" form="short">
       <single>Übers.</single>
       <multiple>Übers.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>Hrsg. &amp; Übers.</single>
-      <multiple>Hrsg. &amp; Übers</multiple>
+      <single>Hrsg.&#160;&amp; Übers.</single>
+      <multiple>Hrsg.&#160;&amp; Übers</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">von</term>
+    <term name="director" form="verb">Regie von</term>
     <term name="editor" form="verb">herausgegeben von</term>
+    <term name="collection-editor" form="verb">herausgegeben von</term>
     <term name="editorial-director" form="verb">herausgegeben von</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">illustriert von</term>
     <term name="interviewer" form="verb">interviewt von</term>
     <term name="recipient" form="verb">an</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">von</term>
     <term name="translator" form="verb">übersetzt von</term>
     <term name="editortranslator" form="verb">herausgegeben und übersetzt von</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">von</term>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">Reg.</term>
     <term name="editor" form="verb-short">hg. von</term>
+    <term name="collection-editor" form="verb-short">hg. von</term>
     <term name="editorial-director" form="verb-short">hg. von</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">illus. von</term>
     <term name="translator" form="verb-short">übers. von</term>
-    <term name="editortranslator" form="verb-short">hg. &amp; übers. von</term>
+    <term name="editortranslator" form="verb-short">hg.&#160;&amp; übers. von</term>
 
     <!-- LONG MONTH FORMS -->
-    <term name="month-01">Januar</term>
+    <term name="month-01">Jänner</term>
     <term name="month-02">Februar</term>
     <term name="month-03">März</term>
     <term name="month-04">April</term>
@@ -276,7 +294,7 @@
     <term name="month-12">Dezember</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">Jan.</term>
+    <term name="month-01" form="short">Jän.</term>
     <term name="month-02" form="short">Feb.</term>
     <term name="month-03" form="short">März</term>
     <term name="month-04" form="short">Apr.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-de-CH.xml 0.5.1-1/citeproc/data/locales/locales-de-CH.xml
--- 0.3.0-6/citeproc/data/locales/locales-de-CH.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-de-CH.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -20,9 +20,9 @@
     <term name="and">und</term>
     <term name="and others">und andere</term>
     <term name="anonymous">ohne Autor</term>
-    <term name="anonymous" form="short">o. A.</term>
+    <term name="anonymous" form="short">o.&#160;A.</term>
     <term name="at">auf</term>
-    <term name="available at">available at</term>
+    <term name="available at">verfügbar unter</term>
     <term name="by">von</term>
     <term name="circa">circa</term>
     <term name="circa" form="short">ca.</term>
@@ -32,8 +32,8 @@
       <multiple>Auflagen</multiple>
     </term>
     <term name="edition" form="short">Aufl.</term>
-    <term name="et-al">u. a.</term>
-    <term name="forthcoming">i. E.</term>
+    <term name="et-al">u.&#160;a.</term>
+    <term name="forthcoming">i.&#160;E.</term>
     <term name="from">von</term>
     <term name="ibid">ebd.</term>
     <term name="in">in</term>
@@ -42,7 +42,7 @@
     <term name="interview">Interview</term>
     <term name="letter">Brief</term>
     <term name="no date">ohne Datum</term>
-    <term name="no date" form="short">o. J.</term>
+    <term name="no date" form="short">o.&#160;J.</term>
     <term name="online">online</term>
     <term name="presented at">gehalten auf der</term>
     <term name="reference">
@@ -54,18 +54,18 @@
       <multiple>Ref.</multiple>
     </term>
     <term name="retrieved">abgerufen</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">Massstab</term>
+    <term name="version">Version</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">n. Chr.</term>
-    <term name="bc">v. Chr.</term>
+    <term name="ad">&#160;n.&#160;Chr.</term>
+    <term name="bc">&#160;v.&#160;Chr.</term>
 
     <!-- PUNCTUATION -->
-    <term name="open-quote">„</term>
-    <term name="close-quote">“</term>
-    <term name="open-inner-quote">‚</term>
-    <term name="close-inner-quote">‘</term>
+    <term name="open-quote">«</term>
+    <term name="close-quote">»</term>
+    <term name="open-inner-quote">‹</term>
+    <term name="close-inner-quote">›</term>
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
@@ -124,6 +124,10 @@
       <single>Seite</single>
       <multiple>Seiten</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>Seite</single>
+      <multiple>Seiten</multiple>
+    </term>
     <term name="paragraph">
       <single>Absatz</single>
       <multiple>Absätze</multiple>
@@ -163,12 +167,16 @@
       <single>S.</single>
       <multiple>S.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>S.</single>
+      <multiple>S.</multiple>
+    </term>
     <term name="paragraph" form="short">Abs.</term>
     <term name="part" form="short">Teil</term>
     <term name="section" form="short">Abschn.</term>
     <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
+      <single>s.&#160;v.</single>
+      <multiple>s.&#160;vv.</multiple>
     </term>
     <term name="verse" form="short">
       <single>V.</single>
@@ -191,8 +199,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>Regisseur</single>
+      <multiple>Regisseure</multiple>
     </term>
     <term name="editor">
       <single>Herausgeber</single>
@@ -203,22 +211,22 @@
       <multiple>Herausgeber</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>Illustrator</single>
+      <multiple>Illustratoren</multiple>
     </term>
     <term name="translator">
       <single>Übersetzer</single>
       <multiple>Übersetzer</multiple>
     </term>
     <term name="editortranslator">
-      <single>Herausgeber &amp; Übersetzer</single>
-      <multiple>Herausgeber &amp; Übersetzer</multiple>
+      <single>Herausgeber&#160;&amp; Übersetzer</single>
+      <multiple>Herausgeber&#160;&amp; Übersetzer</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>Reg.</single>
+      <multiple>Reg.</multiple>
     </term>
     <term name="editor" form="short">
       <single>Hrsg.</single>
@@ -229,37 +237,37 @@
       <multiple>Hrsg.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>Ill.</single>
+      <multiple>Ill.</multiple>
     </term>
     <term name="translator" form="short">
       <single>Übers.</single>
       <multiple>Übers.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>Hrsg. &amp; Übers.</single>
-      <multiple>Hrsg. &amp; Übers</multiple>
+      <single>Hrsg.&#160;&amp; Übers.</single>
+      <multiple>Hrsg.&#160;&amp; Übers</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">von</term>
+    <term name="director" form="verb">Regie von</term>
     <term name="editor" form="verb">herausgegeben von</term>
     <term name="editorial-director" form="verb">herausgegeben von</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">illustriert von</term>
     <term name="interviewer" form="verb">interviewt von</term>
     <term name="recipient" form="verb">an</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">von</term>
     <term name="translator" form="verb">übersetzt von</term>
     <term name="editortranslator" form="verb">herausgegeben und übersetzt von</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">von</term>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">Reg.</term>
     <term name="editor" form="verb-short">hg. von</term>
     <term name="editorial-director" form="verb-short">hg. von</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">illus. von</term>
     <term name="translator" form="verb-short">übers. von</term>
-    <term name="editortranslator" form="verb-short">hg. &amp; übers. von</term>
+    <term name="editortranslator" form="verb-short">hg.&#160;&amp; übers. von</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">Januar</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-de-DE.xml 0.5.1-1/citeproc/data/locales/locales-de-DE.xml
--- 0.3.0-6/citeproc/data/locales/locales-de-DE.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-de-DE.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -20,7 +20,7 @@
     <term name="and">und</term>
     <term name="and others">und andere</term>
     <term name="anonymous">ohne Autor</term>
-    <term name="anonymous" form="short">o. A.</term>
+    <term name="anonymous" form="short">o.&#160;A.</term>
     <term name="at">auf</term>
     <term name="available at">verfügbar unter</term>
     <term name="by">von</term>
@@ -32,8 +32,8 @@
       <multiple>Auflagen</multiple>
     </term>
     <term name="edition" form="short">Aufl.</term>
-    <term name="et-al">u. a.</term>
-    <term name="forthcoming">i. E.</term>
+    <term name="et-al">u.&#160;a.</term>
+    <term name="forthcoming">i.&#160;E.</term>
     <term name="from">von</term>
     <term name="ibid">ebd.</term>
     <term name="in">in</term>
@@ -42,7 +42,7 @@
     <term name="interview">Interview</term>
     <term name="letter">Brief</term>
     <term name="no date">ohne Datum</term>
-    <term name="no date" form="short">o. J.</term>
+    <term name="no date" form="short">o.&#160;J.</term>
     <term name="online">online</term>
     <term name="presented at">gehalten auf der</term>
     <term name="reference">
@@ -58,8 +58,8 @@
     <term name="version">Version</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">n. Chr.</term>
-    <term name="bc">v. Chr.</term>
+    <term name="ad">&#160;n.&#160;Chr.</term>
+    <term name="bc">&#160;v.&#160;Chr.</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">„</term>
@@ -124,6 +124,10 @@
       <single>Seite</single>
       <multiple>Seiten</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>Seite</single>
+      <multiple>Seiten</multiple>
+    </term>
     <term name="paragraph">
       <single>Absatz</single>
       <multiple>Absätze</multiple>
@@ -156,19 +160,23 @@
     <term name="figure" form="short">Abb.</term>
     <term name="folio" form="short">Fol.</term>
     <term name="issue" form="short">Nr.</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="line" form="short">Z.</term>
+    <term name="note" form="short">N.</term>
     <term name="opus" form="short">op.</term>
     <term name="page" form="short">
       <single>S.</single>
       <multiple>S.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>S.</single>
+      <multiple>S.</multiple>
+    </term>
     <term name="paragraph" form="short">Abs.</term>
     <term name="part" form="short">Teil</term>
     <term name="section" form="short">Abschn.</term>
     <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
+      <single>s.&#160;v.</single>
+      <multiple>s.&#160;vv.</multiple>
     </term>
     <term name="verse" form="short">
       <single>V.</single>
@@ -176,7 +184,7 @@
     </term>
     <term name="volume" form="short">
       <single>Bd.</single>
-      <multiple>Bd.</multiple>
+      <multiple>Bde.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -198,32 +206,40 @@
       <single>Herausgeber</single>
       <multiple>Herausgeber</multiple>
     </term>
+    <term name="collection-editor">
+      <single>Reihenherausgeber</single>
+      <multiple>Reihenherausgeber</multiple>
+    </term>
     <term name="editorial-director">
       <single>Herausgeber</single>
       <multiple>Herausgeber</multiple>
     </term>
     <term name="illustrator">
       <single>Illustrator</single>
-      <multiple>illustratoren</multiple>
+      <multiple>Illustratoren</multiple>
     </term>
     <term name="translator">
       <single>Übersetzer</single>
       <multiple>Übersetzer</multiple>
     </term>
     <term name="editortranslator">
-      <single>Herausgeber &amp; Übersetzer</single>
-      <multiple>Herausgeber &amp; Übersetzer</multiple>
+      <single>Herausgeber&#160;&amp; Übersetzer</single>
+      <multiple>Herausgeber&#160;&amp; Übersetzer</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
       <single>Reg.</single>
-      <multiple>Reg..</multiple>
+      <multiple>Reg.</multiple>
     </term>
     <term name="editor" form="short">
       <single>Hrsg.</single>
       <multiple>Hrsg.</multiple>
     </term>
+    <term name="collection-editor" form="short">
+      <single>Hrsg.</single>
+      <multiple>Hrsg.</multiple>
+    </term>
     <term name="editorial-director" form="short">
       <single>Hrsg.</single>
       <multiple>Hrsg.</multiple>
@@ -237,13 +253,15 @@
       <multiple>Übers.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>Hrsg. &amp; Übers.</single>
-      <multiple>Hrsg. &amp; Übers</multiple>
+      <single>Hrsg.&#160;&amp; Übers.</single>
+      <multiple>Hrsg.&#160;&amp; Übers</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">von</term>
+    <term name="director" form="verb">Regie von</term>
     <term name="editor" form="verb">herausgegeben von</term>
+    <term name="collection-editor" form="verb">herausgegeben von</term>
     <term name="editorial-director" form="verb">herausgegeben von</term>
     <term name="illustrator" form="verb">illustriert von</term>
     <term name="interviewer" form="verb">interviewt von</term>
@@ -253,13 +271,13 @@
     <term name="editortranslator" form="verb">herausgegeben und übersetzt von</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">von</term>
     <term name="director" form="verb-short">Reg.</term>
     <term name="editor" form="verb-short">hg. von</term>
+    <term name="collection-editor" form="verb-short">hg. von</term>
     <term name="editorial-director" form="verb-short">hg. von</term>
     <term name="illustrator" form="verb-short">illus. von</term>
     <term name="translator" form="verb-short">übers. von</term>
-    <term name="editortranslator" form="verb-short">hg. &amp; übers. von</term>
+    <term name="editortranslator" form="verb-short">hg.&#160;&amp; übers. von</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">Januar</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-el-GR.xml 0.5.1-1/citeproc/data/locales/locales-el-GR.xml
--- 0.3.0-6/citeproc/data/locales/locales-el-GR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-el-GR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="el-GR">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2013-11-08T20:31:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -22,12 +22,12 @@
     <term name="anonymous">ανώνυμο</term>
     <term name="anonymous" form="short">ανών.</term>
     <term name="at">εφ.</term>
-    <term name="available at">available at</term>
+    <term name="available at">διαθέσιμο στο</term>
     <term name="by">από</term>
     <term name="circa">περίπου</term>
     <term name="circa" form="short">περ.</term>
     <term name="cited">παρατίθεται</term>
-    <term name="edition">
+    <term name="edition" gender="feminine">
       <single>έκδοση</single>
       <multiple>εκδόσεις</multiple>
     </term>
@@ -54,8 +54,8 @@
       <multiple>παρ.</multiple>
     </term>
     <term name="retrieved">ανακτήθηκε</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">κλίμακα</term>
+    <term name="version">εκδοχή</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
     <term name="ad">μ.Χ.</term>
@@ -69,7 +69,9 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">ος</term>
+    <term name="ordinal">ο</term>
+    <term name="ordinal-01" gender-form="feminine" match="whole-number">η</term>
+    <term name="ordinal-01" gender-form="masculine" match="whole-number">ος</term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">πρώτος</term>
@@ -86,7 +88,7 @@
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
       <single>βιβλίο</single>
-      <multiple>βιβλίο</multiple>
+      <multiple>βιβλία</multiple>
     </term>
     <term name="chapter">
       <single>κεφάλαιο</single>
@@ -124,6 +126,10 @@
       <single>σελίδα</single>
       <multiple>σελίδες</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>σελίδα</single>
+      <multiple>σελίδες</multiple>
+    </term>
     <term name="paragraph">
       <single>παράγραφος</single>
       <multiple>παράγραφοι</multiple>
@@ -156,13 +162,17 @@
     <term name="figure" form="short">εικ.</term>
     <term name="folio" form="short">φάκ</term>
     <term name="issue" form="short">τχ.</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="line" form="short">γρ.</term>
+    <term name="note" form="short">σημ.</term>
     <term name="opus" form="short">έργ.</term>
     <term name="page" form="short">
       <single>σ</single>
       <multiple>σσ</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>σ</single>
+      <multiple>σσ</multiple>
+    </term>
     <term name="paragraph" form="short">παρ.</term>
     <term name="part" form="short">μέρ.</term>
     <term name="section" form="short">τμ.</term>
@@ -191,8 +201,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>Διευθυντής</single>
+      <multiple>Διευθυντές</multiple>
     </term>
     <term name="editor">
       <single>επιμελητής</single>
@@ -203,8 +213,8 @@
       <multiple>διευθυντές σειράς</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>εικονογράφος</single>
+      <multiple>εικονογράφοι</multiple>
     </term>
     <term name="translator">
       <single>μεταφραστής</single>
@@ -217,8 +227,8 @@
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>δ/ντης.</single>
+      <multiple>δ/ντές.</multiple>
     </term>
     <term name="editor" form="short">
       <single>επιμ.</single>
@@ -229,8 +239,8 @@
       <multiple>δ/ντές σειρας</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>εικ.</single>
+      <multiple>εικ..</multiple>
     </term>
     <term name="translator" form="short">
       <single>μτφ.</single>
@@ -242,22 +252,22 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">στον συλλ. τόμο</term>
+    <term name="director" form="verb">διεύθυνση</term>
     <term name="editor" form="verb">επιμέλεια</term>
     <term name="editorial-director" form="verb">διεύθυνση σειράς</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">εικονογράφηση:</term>
     <term name="interviewer" form="verb">συνέντευξη</term>
     <term name="recipient" form="verb">παραλήπτης</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">συγγραφέας:</term>
     <term name="translator" form="verb">μετάφραση</term>
     <term name="editortranslator" form="verb">μετάφραση και επιμέλεια</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">στον συλλ. τόμο</term>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">διευθ.</term>
     <term name="editor" form="verb-short">επιμέλ.</term>
     <term name="editorial-director" form="verb-short">δ/νση σειράς</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">εικον.</term>
     <term name="translator" form="verb-short">μετάφρ.</term>
     <term name="editortranslator" form="verb-short">μετάφρ. και επιμέλ.</term>
 
diff -pruN 0.3.0-6/citeproc/data/locales/locales-en-GB.xml 0.5.1-1/citeproc/data/locales/locales-en-GB.xml
--- 0.3.0-6/citeproc/data/locales/locales-en-GB.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-en-GB.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="en-GB">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2015-10-10T23:31:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -130,9 +130,13 @@
       <single>page</single>
       <multiple>pages</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>page</single>
+      <multiple>pages</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraph</single>
-      <multiple>paragraph</multiple>
+      <multiple>paragraphs</multiple>
     </term>
     <term name="part">
       <single>part</single>
@@ -156,22 +160,62 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">bk.</term>
-    <term name="chapter" form="short">chap.</term>
-    <term name="column" form="short">col.</term>
-    <term name="figure" form="short">fig.</term>
-    <term name="folio" form="short">f.</term>
-    <term name="issue" form="short">no.</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op.</term>
+    <term name="book" form="short">
+      <single>bk.</single>
+      <multiple>bks</multiple>
+    </term>
+    <term name="chapter" form="short">
+      <single>chap.</single>
+      <multiple>chaps</multiple>
+    </term>
+    <term name="column" form="short">
+      <single>col.</single>
+      <multiple>cols</multiple>
+    </term>
+    <term name="figure" form="short">
+      <single>fig.</single>
+      <multiple>figs</multiple>
+    </term>
+    <term name="folio" form="short">
+      <single>fol.</single>
+      <multiple>fols</multiple>
+    </term>
+    <term name="issue" form="short">
+      <single>no.</single>
+      <multiple>nos.</multiple>
+    </term>
+    <term name="line" form="short">
+      <single>l.</single>
+      <multiple>ll.</multiple>
+    </term>
+    <term name="note" form="short">
+      <single>n.</single>
+      <multiple>nn.</multiple>
+    </term>
+    <term name="opus" form="short">
+      <single>op.</single>
+      <multiple>opp.</multiple>
+    </term>
     <term name="page" form="short">
       <single>p.</single>
       <multiple>pp.</multiple>
     </term>
-    <term name="paragraph" form="short">para.</term>
-    <term name="part" form="short">pt.</term>
-    <term name="section" form="short">sec.</term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="paragraph" form="short">
+      <single>para.</single>
+      <multiple>paras</multiple>
+    </term>
+    <term name="part" form="short">
+      <single>pt.</single>
+      <multiple>pts</multiple>
+    </term>
+    <term name="section" form="short">
+      <single>sec.</single>
+      <multiple>secs</multiple>
+    </term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
@@ -182,7 +226,7 @@
     </term>
     <term name="volume" form="short">
       <single>vol.</single>
-      <multiple>vols.</multiple>
+      <multiple>vols</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -248,6 +292,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">edited by</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +304,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir. by</term>
     <term name="editor" form="verb-short">ed. by</term>
     <term name="editorial-director" form="verb-short">ed. by</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-en-US.xml 0.5.1-1/citeproc/data/locales/locales-en-US.xml
--- 0.3.0-6/citeproc/data/locales/locales-en-US.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-en-US.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="en-US">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2015-10-10T23:31:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="true"/>
   <date form="text">
@@ -130,9 +130,13 @@
       <single>page</single>
       <multiple>pages</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>page</single>
+      <multiple>pages</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraph</single>
-      <multiple>paragraph</multiple>
+      <multiple>paragraphs</multiple>
     </term>
     <term name="part">
       <single>part</single>
@@ -156,22 +160,62 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">bk.</term>
-    <term name="chapter" form="short">chap.</term>
-    <term name="column" form="short">col.</term>
-    <term name="figure" form="short">fig.</term>
-    <term name="folio" form="short">f.</term>
-    <term name="issue" form="short">no.</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op.</term>
+    <term name="book" form="short">
+      <single>bk.</single>
+      <multiple>bks.</multiple>
+    </term>
+    <term name="chapter" form="short">
+      <single>chap.</single>
+      <multiple>chaps.</multiple>
+    </term>
+    <term name="column" form="short">
+      <single>col.</single>
+      <multiple>cols.</multiple>
+    </term>
+    <term name="figure" form="short">
+      <single>fig.</single>
+      <multiple>figs.</multiple>
+    </term>
+    <term name="folio" form="short">
+      <single>fol.</single>
+      <multiple>fols.</multiple>
+    </term>
+    <term name="issue" form="short">
+      <single>no.</single>
+      <multiple>nos.</multiple>
+    </term>
+    <term name="line" form="short">
+      <single>l.</single>
+      <multiple>ll.</multiple>
+    </term>
+    <term name="note" form="short">
+      <single>n.</single>
+      <multiple>nn.</multiple>
+    </term>
+    <term name="opus" form="short">
+      <single>op.</single>
+      <multiple>opp.</multiple>
+    </term>
     <term name="page" form="short">
       <single>p.</single>
       <multiple>pp.</multiple>
     </term>
-    <term name="paragraph" form="short">para.</term>
-    <term name="part" form="short">pt.</term>
-    <term name="section" form="short">sec.</term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="paragraph" form="short">
+      <single>para.</single>
+      <multiple>paras.</multiple>
+    </term>
+    <term name="part" form="short">
+      <single>pt.</single>
+      <multiple>pts.</multiple>
+    </term>
+    <term name="section" form="short">
+      <single>sec.</single>
+      <multiple>secs.</multiple>
+    </term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
@@ -248,6 +292,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">edited by</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +304,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir. by</term>
     <term name="editor" form="verb-short">ed. by</term>
     <term name="editorial-director" form="verb-short">ed. by</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-es-CL.xml 0.5.1-1/citeproc/data/locales/locales-es-CL.xml
--- 0.3.0-6/citeproc/data/locales/locales-es-CL.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-es-CL.xml	2020-04-06 16:40:32.000000000 +0000
@@ -0,0 +1,310 @@
+<?xml version="1.0" encoding="utf-8"?>
+<locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="es-CL">
+  <info>
+    <translator>
+      <name>Scott Sadowsky</name>
+      <uri>http://sadowsky.cl/</uri>
+    </translator>
+    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
+    <updated>2013-10-28T13:57:31-04:00</updated>
+  </info>
+  <style-options punctuation-in-quote="false"/>
+  <date form="text">
+    <date-part name="day" suffix=" de "/>
+    <date-part name="month" suffix=" de "/>
+    <date-part name="year"/>
+  </date>
+  <date form="numeric">
+    <date-part name="day" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="month" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="year"/>
+  </date>
+  <terms>
+    <term name="accessed">accedido</term>
+    <term name="and">y</term>
+    <term name="and others">et&#160;al.</term>
+    <term name="anonymous">anónimo</term>
+    <term name="anonymous" form="short">anón.</term>
+    <term name="at">en</term>
+    <term name="available at">disponible en</term>
+    <term name="by">de</term>
+    <term name="circa">circa</term>
+    <term name="circa" form="short">c.</term>
+    <term name="cited">citado</term>
+    <term name="edition">
+      <single>edición</single>
+      <multiple>ediciones</multiple>
+    </term>
+    <term name="edition" form="short">ed.</term>
+    <term name="et-al">et&#160;al.</term>
+    <term name="forthcoming">en preparación</term>
+    <term name="from">a partir de</term>
+    <term name="ibid">ibid.</term>
+    <term name="in">en</term>
+    <term name="in press">en imprenta</term>
+    <term name="internet">internet</term>
+    <term name="interview">entrevista</term>
+    <term name="letter">carta</term>
+    <term name="no date">sin fecha</term>
+    <term name="no date" form="short">s.&#160;f.</term>
+    <term name="online">en línea</term>
+    <term name="presented at">presentado en</term>
+    <term name="reference">
+      <single>referencia</single>
+      <multiple>referencias</multiple>
+    </term>
+    <term name="reference" form="short">
+      <single>ref.</single>
+      <multiple>refs.</multiple>
+    </term>
+    <term name="retrieved">recuperado</term>
+    <term name="scale">escala</term>
+    <term name="version">versión</term>
+
+    <!-- ANNO DOMINI; BEFORE CHRIST -->
+    <term name="ad">d.&#160;C.</term>
+    <term name="bc">a.&#160;C.</term>
+
+    <!-- PUNCTUATION -->
+    <term name="open-quote">“</term>
+    <term name="close-quote">”</term>
+    <term name="open-inner-quote">‘</term>
+    <term name="close-inner-quote">’</term>
+    <term name="page-range-delimiter">–</term>
+
+    <!-- ORDINALS -->
+    <term name="ordinal">ª</term>
+
+    <!-- LONG ORDINALS -->
+    <term name="long-ordinal-01">primera</term>
+    <term name="long-ordinal-02">segunda</term>
+    <term name="long-ordinal-03">tercera</term>
+    <term name="long-ordinal-04">cuarta</term>
+    <term name="long-ordinal-05">quinta</term>
+    <term name="long-ordinal-06">sexta</term>
+    <term name="long-ordinal-07">séptima</term>
+    <term name="long-ordinal-08">octava</term>
+    <term name="long-ordinal-09">novena</term>
+    <term name="long-ordinal-10">décima</term>
+
+    <!-- LONG LOCATOR FORMS -->
+    <term name="book">
+      <single>libro</single>
+      <multiple>libros</multiple>
+    </term>
+    <term name="chapter">
+      <single>capítulo</single>
+      <multiple>capítulos</multiple>
+    </term>
+    <term name="column">
+      <single>columna</single>
+      <multiple>columnas</multiple>
+    </term>
+    <term name="figure">
+      <single>figura</single>
+      <multiple>figuras</multiple>
+    </term>
+    <term name="folio">
+      <single>folio</single>
+      <multiple>folios</multiple>
+    </term>
+    <term name="issue">
+      <single>número</single>
+      <multiple>números</multiple>
+    </term>
+    <term name="line">
+      <single>línea</single>
+      <multiple>líneas</multiple>
+    </term>
+    <term name="note">
+      <single>nota</single>
+      <multiple>notas</multiple>
+    </term>
+    <term name="opus">
+      <single>opus</single>
+      <multiple>opera</multiple>
+    </term>
+    <term name="page">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
+    <term name="number-of-pages">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
+    <term name="paragraph">
+      <single>párrafo</single>
+      <multiple>párrafos</multiple>
+    </term>
+    <term name="part">
+      <single>parte</single>
+      <multiple>partes</multiple>
+    </term>
+    <term name="section">
+      <single>sección</single>
+      <multiple>secciones</multiple>
+    </term>
+    <term name="sub verbo">
+      <single>sub voce</single>
+      <multiple>sub vocibus</multiple>
+    </term>
+    <term name="verse">
+      <single>verso</single>
+      <multiple>versos</multiple>
+    </term>
+    <term name="volume">
+      <single>volumen</single>
+      <multiple>volúmenes</multiple>
+    </term>
+
+    <!-- SHORT LOCATOR FORMS -->
+    <term name="book" form="short">lib.</term>
+    <term name="chapter" form="short">cap.</term>
+    <term name="column" form="short">col.</term>
+    <term name="figure" form="short">fig.</term>
+    <term name="folio" form="short">f.</term>
+    <term name="issue" form="short">nº</term>
+    <term name="line" form="short">l.</term>
+    <term name="note" form="short">n.</term>
+    <term name="opus" form="short">op.</term>
+    <term name="page" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="paragraph" form="short">párr.</term>
+    <term name="part" form="short">pt.</term>
+    <term name="section" form="short">sec.</term>
+    <term name="sub verbo" form="short">
+      <single>s.&#160;v.</single>
+      <multiple>s.&#160;vv.</multiple>
+    </term>
+    <term name="verse" form="short">
+      <single>v.</single>
+      <multiple>vv.</multiple>
+    </term>
+    <term name="volume" form="short">
+      <single>vol.</single>
+      <multiple>vols.</multiple>
+    </term>
+
+    <!-- SYMBOL LOCATOR FORMS -->
+    <term name="paragraph" form="symbol">
+      <single>§</single>
+      <multiple>§</multiple>
+    </term>
+    <term name="section" form="symbol">
+      <single>§</single>
+      <multiple>§</multiple>
+    </term>
+
+    <!-- LONG ROLE FORMS -->
+    <term name="director">
+      <single>director</single>
+      <multiple>directores</multiple>
+    </term>
+    <term name="editor">
+      <single>editor</single>
+      <multiple>editores</multiple>
+    </term>
+    <term name="editorial-director">
+      <single>coordinador</single>
+      <multiple>coordinadores</multiple>
+    </term>
+    <term name="illustrator">
+      <single>ilustrador</single>
+      <multiple>ilustradores</multiple>
+    </term>
+    <term name="translator">
+      <single>traductor</single>
+      <multiple>traductores</multiple>
+    </term>
+    <term name="editortranslator">
+      <single>editor y traductor</single>
+      <multiple>editores y traductores</multiple>
+    </term>
+
+    <!-- SHORT ROLE FORMS -->
+    <term name="director" form="short">
+      <single>dir.</single>
+      <multiple>dirs.</multiple>
+    </term>
+    <term name="editor" form="short">
+      <single>ed.</single>
+      <multiple>eds.</multiple>
+    </term>
+    <term name="editorial-director" form="short">
+      <single>coord.</single>
+      <multiple>coords.</multiple>
+    </term>
+    <term name="illustrator" form="short">
+      <single>ilust.</single>
+      <multiple>ilusts.</multiple>
+    </term>
+    <term name="translator" form="short">
+      <single>trad.</single>
+      <multiple>trads.</multiple>
+    </term>
+    <term name="editortranslator" form="short">
+      <single>ed. y trad.</single>
+      <multiple>eds. y trads.</multiple>
+    </term>
+
+    <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">de</term>
+    <term name="director" form="verb">dirigido por</term>
+    <term name="editor" form="verb">editado por</term>
+    <term name="editorial-director" form="verb">coordinado por</term>
+    <term name="illustrator" form="verb">ilustrado por</term>
+    <term name="interviewer" form="verb">entrevistado por</term>
+    <term name="recipient" form="verb">a</term>
+    <term name="reviewed-author" form="verb">por</term>
+    <term name="translator" form="verb">traducido por</term>
+    <term name="editortranslator" form="verb">editado y traducido por</term>
+
+    <!-- SHORT VERB ROLE FORMS -->
+    <term name="director" form="verb-short">dir.</term>
+    <term name="editor" form="verb-short">ed.</term>
+    <term name="editorial-director" form="verb-short">coord.</term>
+    <term name="illustrator" form="verb-short">ilust.</term>
+    <term name="translator" form="verb-short">trad.</term>
+    <term name="editortranslator" form="verb-short">ed. y trad.</term>
+
+    <!-- LONG MONTH FORMS -->
+    <term name="month-01">enero</term>
+    <term name="month-02">febrero</term>
+    <term name="month-03">marzo</term>
+    <term name="month-04">abril</term>
+    <term name="month-05">mayo</term>
+    <term name="month-06">junio</term>
+    <term name="month-07">julio</term>
+    <term name="month-08">agosto</term>
+    <term name="month-09">septiembre</term>
+    <term name="month-10">octubre</term>
+    <term name="month-11">noviembre</term>
+    <term name="month-12">diciembre</term>
+
+    <!-- SHORT MONTH FORMS -->
+    <term name="month-01" form="short">ene.</term>
+    <term name="month-02" form="short">feb.</term>
+    <term name="month-03" form="short">mar.</term>
+    <term name="month-04" form="short">abr.</term>
+    <term name="month-05" form="short">may</term>
+    <term name="month-06" form="short">jun.</term>
+    <term name="month-07" form="short">jul.</term>
+    <term name="month-08" form="short">ago.</term>
+    <term name="month-09" form="short">sep.</term>
+    <term name="month-10" form="short">oct.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dic.</term>
+
+    <!-- SEASONS -->
+    <term name="season-01">primavera</term>
+    <term name="season-02">verano</term>
+    <term name="season-03">otoño</term>
+    <term name="season-04">invierno</term>
+  </terms>
+</locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-es-ES.xml 0.5.1-1/citeproc/data/locales/locales-es-ES.xml
--- 0.3.0-6/citeproc/data/locales/locales-es-ES.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-es-ES.xml	2020-04-06 16:40:32.000000000 +0000
@@ -124,6 +124,10 @@
       <single>página</single>
       <multiple>páginas</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
     <term name="paragraph">
       <single>párrafo</single>
       <multiple>párrafos</multiple>
@@ -163,6 +167,10 @@
       <single>p.</single>
       <multiple>pp.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
     <term name="paragraph" form="short">párr.</term>
     <term name="part" form="short">pt.</term>
     <term name="section" form="short">sec.</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">de</term>
     <term name="director" form="verb">dirigido por</term>
     <term name="editor" form="verb">editado por</term>
     <term name="editorial-director" form="verb">editado por</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">editado y traducido por</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">de</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-es-MX.xml 0.5.1-1/citeproc/data/locales/locales-es-MX.xml
--- 0.3.0-6/citeproc/data/locales/locales-es-MX.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-es-MX.xml	2020-04-06 16:40:32.000000000 +0000
@@ -0,0 +1,351 @@
+<?xml version="1.0" encoding="utf-8"?>
+<locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="es-MX">
+  <info>
+    <translator>
+      <name>Juan Ignacio Flores Salgado</name>
+      <uri>https://www.mendeley.com/profiles/juan-ignacio-flores-salgado/</uri>
+    </translator>
+    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
+    <updated>2015-06-13T13:57:31-04:00</updated>
+  </info>
+  <style-options punctuation-in-quote="false"/>
+  <date form="text">
+    <date-part name="day" prefix="el " suffix=" de "/>
+    <date-part name="month" suffix=" de "/>
+    <date-part name="year"/>
+  </date>
+  <date form="numeric">
+    <date-part name="day" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="month" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="year"/>
+  </date>
+  <terms>
+    <term name="accessed">consultado</term>
+    <term name="and">y</term>
+    <term name="and others">et&#160;al.</term>
+    <term name="anonymous">anónimo</term>
+    <term name="anonymous" form="short">anón.</term>
+    <term name="at">en</term>
+    <term name="available at">disponible en</term>
+    <term name="by">de</term>
+    <term name="circa">circa</term>
+    <term name="circa" form="short">c.</term>
+    <term name="cited">citado</term>
+    <term name="edition">
+      <single>edición</single>
+      <multiple>ediciones</multiple>
+    </term>
+    <term name="edition" form="short">
+      <single>ed.</single>
+      <multiple>eds.</multiple>
+    </term>
+    <term name="et-al">et&#160;al.</term>
+    <term name="forthcoming">en preparación</term>
+    <term name="from">a partir de</term>
+    <term name="ibid">ibid.</term>
+    <term name="in">en</term>
+    <term name="in press">en imprenta</term>
+    <term name="internet">internet</term>
+    <term name="interview">entrevista</term>
+    <term name="letter">carta</term>
+    <term name="no date">sin fecha</term>
+    <term name="no date" form="short">s/f</term>
+    <term name="online">en línea</term>
+    <term name="presented at">presentado en</term>
+    <term name="reference">
+      <single>referencia</single>
+      <multiple>referencias</multiple>
+    </term>
+    <term name="reference" form="short">
+      <single>ref.</single>
+      <multiple>refs.</multiple>
+    </term>
+    <term name="retrieved">recuperado</term>
+    <term name="scale">escala</term>
+    <term name="version">versión</term>
+    
+    <!-- ANNO DOMINI; BEFORE CHRIST -->
+    <term name="ad">d.&#160;C.</term>
+    <term name="bc">a.&#160;C.</term>
+    
+    <!-- PUNCTUATION -->
+    <term name="open-quote">“</term>
+    <term name="close-quote">”</term>
+    <term name="open-inner-quote">‘</term>
+    <term name="close-inner-quote">’</term>
+    <term name="page-range-delimiter">–</term>
+    
+    <!-- ORDINALS -->
+    <term name="ordinal">a</term>
+    <term name="ordinal-01" gender-form="feminine" match="whole-number">a</term>
+    <term name="ordinal-01" gender-form="masculine" match="whole-number">o</term>
+    
+    <!-- LONG ORDINALS -->
+    <term name="long-ordinal-01">primera</term>
+    <term name="long-ordinal-02">segunda</term>
+    <term name="long-ordinal-03">tercera</term>
+    <term name="long-ordinal-04">cuarta</term>
+    <term name="long-ordinal-05">quinta</term>
+    <term name="long-ordinal-06">sexta</term>
+    <term name="long-ordinal-07">séptima</term>
+    <term name="long-ordinal-08">octava</term>
+    <term name="long-ordinal-09">novena</term>
+    <term name="long-ordinal-10">décima</term>
+    
+    <!-- LONG LOCATOR FORMS -->
+    <term name="book">
+      <single>libro</single>
+      <multiple>libros</multiple>
+    </term>
+    <term name="chapter">
+      <single>capítulo</single>
+      <multiple>capítulos</multiple>
+    </term>
+    <term name="column">
+      <single>columna</single>
+      <multiple>columnas</multiple>
+    </term>
+    <term name="figure">
+      <single>figura</single>
+      <multiple>figuras</multiple>
+    </term>
+    <term name="folio">
+      <single>folio</single>
+      <multiple>folios</multiple>
+    </term>
+    <term name="issue">
+      <single>número</single>
+      <multiple>números</multiple>
+    </term>
+    <term name="line">
+      <single>línea</single>
+      <multiple>líneas</multiple>
+    </term>
+    <term name="note">
+      <single>nota</single>
+      <multiple>notas</multiple>
+    </term>
+    <term name="opus">
+      <single>opus</single>
+      <multiple>opera</multiple>
+    </term>
+    <term name="page">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
+    <term name="number-of-pages">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
+    <term name="paragraph">
+      <single>párrafo</single>
+      <multiple>párrafos</multiple>
+    </term>
+    <term name="part">
+      <single>parte</single>
+      <multiple>partes</multiple>
+    </term>
+    <term name="section">
+      <single>sección</single>
+      <multiple>secciones</multiple>
+    </term>
+    <term name="sub verbo">
+      <single>sub voce</single>
+      <multiple>sub vocibus</multiple>
+    </term>
+    <term name="verse">
+      <single>verso</single>
+      <multiple>versos</multiple>
+    </term>
+    <term name="volume">
+      <single>volumen</single>
+      <multiple>volúmenes</multiple>
+    </term>
+    
+    <!-- SHORT LOCATOR FORMS -->
+    <term name="book" form="short">
+      <single>lib.</single>
+      <multiple>libs.</multiple>
+    </term>
+    <term name="chapter" form="short">
+      <single>cap.</single>
+      <multiple>caps.</multiple>
+    </term>
+    <term name="column" form="short">
+      <single>col.</single>
+      <multiple>cols.</multiple>
+    </term>
+    <term name="figure" form="short">
+      <single>fig.</single>
+      <multiple>figs.</multiple>
+    </term>
+    <term name="folio" form="short">
+      <single>f.</single>
+      <multiple>ff.</multiple>
+    </term>
+    <term name="issue" form="short">
+      <single>núm.</single>
+      <multiple>núms.</multiple>
+    </term>
+    <term name="line" form="short">
+      <single>l.</single>
+      <multiple>ls.</multiple>
+    </term>
+    <term name="note" form="short">
+      <single>n.</single>
+      <multiple>nn.</multiple>
+    </term>
+    <term name="opus" form="short">
+      <single>op.</single>
+      <multiple>opp.</multiple>
+    </term>
+    <term name="page" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="paragraph" form="short">
+      <single>párr.</single>
+      <multiple>párrs.</multiple>
+    </term>
+    <term name="part" form="short">
+      <single>pt.</single>
+      <multiple>pts.</multiple>
+    </term>
+    <term name="section" form="short">
+      <single>sec.</single>
+      <multiple>secs.</multiple>
+    </term>
+    <term name="sub verbo" form="short">
+      <single>s.&#160;v.</single>
+      <multiple>s.&#160;vv.</multiple>
+    </term>
+    <term name="verse" form="short">
+      <single>v.</single>
+      <multiple>vv.</multiple>
+    </term>
+    <term name="volume" form="short">
+      <single>vol.</single>
+      <multiple>vols.</multiple>
+    </term>
+    
+    <!-- SYMBOL LOCATOR FORMS -->
+    <term name="paragraph" form="symbol">
+      <single>¶</single>
+      <multiple>¶</multiple>
+    </term>
+    <term name="section" form="symbol">
+      <single>§</single>
+      <multiple>§</multiple>
+    </term>
+    
+    <!-- LONG ROLE FORMS -->
+    <term name="director">
+      <single>director</single>
+      <multiple>directores</multiple>
+    </term>
+    <term name="editor">
+      <single>editor</single>
+      <multiple>editores</multiple>
+    </term>
+    <term name="editorial-director">
+      <single>coordinador</single>
+      <multiple>coordinadores</multiple>
+    </term>
+    <term name="illustrator">
+      <single>ilustrador</single>
+      <multiple>ilustradores</multiple>
+    </term>
+    <term name="translator">
+      <single>traductor</single>
+      <multiple>traductores</multiple>
+    </term>
+    <term name="editortranslator">
+      <single>editor y traductor</single>
+      <multiple>editores y traductores</multiple>
+    </term>
+    
+    <!-- SHORT ROLE FORMS -->
+    <term name="director" form="short">
+      <single>dir.</single>
+      <multiple>dirs.</multiple>
+    </term>
+    <term name="editor" form="short">
+      <single>ed.</single>
+      <multiple>eds.</multiple>
+    </term>
+    <term name="editorial-director" form="short">
+      <single>coord.</single>
+      <multiple>coords.</multiple>
+    </term>
+    <term name="illustrator" form="short">
+      <single>ilust.</single>
+      <multiple>ilusts.</multiple>
+    </term>
+    <term name="translator" form="short">
+      <single>trad.</single>
+      <multiple>trads.</multiple>
+    </term>
+    <term name="editortranslator" form="short">
+      <single>ed. y trad.</single>
+      <multiple>eds. y trads.</multiple>
+    </term>
+    
+    <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">de</term>
+    <term name="director" form="verb">dirigido por</term>
+    <term name="editor" form="verb">editado por</term>
+    <term name="editorial-director" form="verb">coordinado por</term>
+    <term name="illustrator" form="verb">ilustrado por</term>
+    <term name="interviewer" form="verb">entrevistado por</term>
+    <term name="recipient" form="verb">a</term>
+    <term name="reviewed-author" form="verb">por</term>
+    <term name="translator" form="verb">traducido por</term>
+    <term name="editortranslator" form="verb">editado y traducido por</term>
+    
+    <!-- SHORT VERB ROLE FORMS -->
+    <term name="director" form="verb-short">dir.</term>
+    <term name="editor" form="verb-short">ed.</term>
+    <term name="editorial-director" form="verb-short">coord.</term>
+    <term name="illustrator" form="verb-short">ilust.</term>
+    <term name="translator" form="verb-short">trad.</term>
+    <term name="editortranslator" form="verb-short">ed. y trad.</term>
+    
+    <!-- LONG MONTH FORMS -->
+    <term name="month-01">enero</term>
+    <term name="month-02">febrero</term>
+    <term name="month-03">marzo</term>
+    <term name="month-04">abril</term>
+    <term name="month-05">mayo</term>
+    <term name="month-06">junio</term>
+    <term name="month-07">julio</term>
+    <term name="month-08">agosto</term>
+    <term name="month-09">septiembre</term>
+    <term name="month-10">octubre</term>
+    <term name="month-11">noviembre</term>
+    <term name="month-12">diciembre</term>
+    
+    <!-- SHORT MONTH FORMS -->
+    <term name="month-01" form="short">ene.</term>
+    <term name="month-02" form="short">feb.</term>
+    <term name="month-03" form="short">mar.</term>
+    <term name="month-04" form="short">abr.</term>
+    <term name="month-05" form="short">may</term>
+    <term name="month-06" form="short">jun.</term>
+    <term name="month-07" form="short">jul.</term>
+    <term name="month-08" form="short">ago.</term>
+    <term name="month-09" form="short">sep.</term>
+    <term name="month-10" form="short">oct.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dic.</term>
+    
+    <!-- SEASONS -->
+    <term name="season-01">primavera</term>
+    <term name="season-02">verano</term>
+    <term name="season-03">otoño</term>
+    <term name="season-04">invierno</term>
+  </terms>
+</locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-et-EE.xml 0.5.1-1/citeproc/data/locales/locales-et-EE.xml
--- 0.3.0-6/citeproc/data/locales/locales-et-EE.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-et-EE.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -21,9 +21,9 @@
     <term name="and others">ja teised</term>
     <term name="anonymous">anonüümne</term>
     <term name="anonymous" form="short">anon</term>
-    <term name="at"/>
+    <term name="at"></term>
     <term name="available at">available at</term>
-    <term name="by"/>
+    <term name="by"></term>
     <term name="circa">umbes</term>
     <term name="circa" form="short">u</term>
     <term name="cited">tsiteeritud</term>
@@ -34,9 +34,9 @@
     <term name="edition" form="short">tr</term>
     <term name="et-al">et al.</term>
     <term name="forthcoming">ilmumisel</term>
-    <term name="from"/>
+    <term name="from"></term>
     <term name="ibid">ibid.</term>
-    <term name="in"/>
+    <term name="in"></term>
     <term name="in press">trükis</term>
     <term name="internet">internet</term>
     <term name="interview">intervjuu</term>
@@ -69,7 +69,7 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal"/>
+    <term name="ordinal">.</term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">esimene</term>
@@ -124,6 +124,10 @@
       <single>lehekülg</single>
       <multiple>leheküljed</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>lehekülg</single>
+      <multiple>leheküljed</multiple>
+    </term>
     <term name="paragraph">
       <single>lõik</single>
       <multiple>lõigud</multiple>
@@ -163,6 +167,10 @@
       <single>lk</single>
       <multiple>lk</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>lk</single>
+      <multiple>lk</multiple>
+    </term>
     <term name="paragraph" form="short">lõik</term>
     <term name="part" form="short">osa</term>
     <term name="section" form="short">alajaot.</term>
@@ -242,18 +250,18 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb"></term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">toimetanud</term>
     <term name="editorial-director" form="verb">toimetanud</term>
     <term name="illustrator" form="verb">illustrated by</term>
     <term name="interviewer" form="verb">intervjueerinud</term>
-    <term name="recipient" form="verb"/>
+    <term name="recipient" form="verb"></term>
     <term name="reviewed-author" form="verb">by</term>
     <term name="translator" form="verb">tõlkinud</term>
     <term name="editortranslator" form="verb">toimetanud &amp; tõlkinud</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">toim</term>
     <term name="editorial-director" form="verb-short">toim</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-eu.xml 0.5.1-1/citeproc/data/locales/locales-eu.xml
--- 0.3.0-6/citeproc/data/locales/locales-eu.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-eu.xml	2020-04-06 16:40:32.000000000 +0000
@@ -124,6 +124,10 @@
       <single>orrialdea</single>
       <multiple>orrialdeak</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>orrialdea</single>
+      <multiple>orrialdeak</multiple>
+    </term>
     <term name="paragraph">
       <single>paragrafoa</single>
       <multiple>paragrafoak</multiple>
@@ -163,6 +167,10 @@
       <single>or.</single>
       <multiple>or.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>or.</single>
+      <multiple>or.</multiple>
+    </term>
     <term name="paragraph" form="short">par.</term>
     <term name="part" form="short">zt.</term>
     <term name="section" form="short">atal.</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb"></term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">-(e)k argitaratua</term>
     <term name="editorial-director" form="verb">-(e)k argitaratua</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">-(e)k argitaratu eta itzulia</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">arg.</term>
     <term name="editorial-director" form="verb-short">arg.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-fa-IR.xml 0.5.1-1/citeproc/data/locales/locales-fa-IR.xml
--- 0.3.0-6/citeproc/data/locales/locales-fa-IR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-fa-IR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,13 +6,13 @@
   </info>
   <style-options punctuation-in-quote="true"/>
   <date form="text">
+    <date-part name="day" suffix=" "/>
     <date-part name="month" suffix=" "/>
-    <date-part name="day" form="numeric-leading-zeros" suffix=", "/>
     <date-part name="year"/>
   </date>
   <date form="numeric">
-    <date-part name="month" form="numeric-leading-zeros" suffix="/"/>
     <date-part name="day" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="month" form="numeric-leading-zeros" suffix="/"/>
     <date-part name="year"/>
   </date>
   <terms>
@@ -22,18 +22,18 @@
     <term name="anonymous">ناشناس</term>
     <term name="anonymous" form="short">ناشناس</term>
     <term name="at">در</term>
-    <term name="available at">available at</term>
+    <term name="available at">قابل دسترس در</term>
     <term name="by">توسط</term>
-    <term name="circa">circa</term>
+    <term name="circa">تقریباً</term>
     <term name="circa" form="short">c.</term>
-    <term name="cited">یادکرد</term>
+    <term name="cited">ارجاع شده</term>
     <term name="edition">
       <single>ویرایش</single>
       <multiple>ویرایش‌های</multiple>
     </term>
     <term name="edition" form="short">ویرایش</term>
-    <term name="et-al">و دیگران</term>
-    <term name="forthcoming">forthcoming</term>
+    <term name="et-al">و همکاران</term>
+    <term name="forthcoming">در دست انتشار</term>
     <term name="from">از</term>
     <term name="ibid">همان</term>
     <term name="in">در</term>
@@ -43,7 +43,7 @@
     <term name="letter">نامه</term>
     <term name="no date">بدون تاریخ</term>
     <term name="no date" form="short">بدون تاریخ</term>
-    <term name="online">برخط</term>
+    <term name="online">آنلاین</term>
     <term name="presented at">ارائه شده در</term>
     <term name="reference">
       <single>مرجع</single>
@@ -55,11 +55,11 @@
     </term>
     <term name="retrieved">retrieved</term>
     <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="version">نسخه</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">بعد از میلاد</term>
+    <term name="bc">قبل از میلاد</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">“</term>
@@ -69,13 +69,7 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
+    <term name="ordinal"></term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">اول</term>
@@ -130,6 +124,10 @@
       <single>صفحه</single>
       <multiple>صفحات</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>صفحه</single>
+      <multiple>صفحات</multiple>
+    </term>
     <term name="paragraph">
       <single>پاراگراف</single>
       <multiple>پاراگراف‌های</multiple>
@@ -143,8 +141,8 @@
       <multiple>قسمت‌های</multiple>
     </term>
     <term name="sub verbo">
-      <single>sub verbo</single>
-      <multiple>sub verbis</multiple>
+      <single>در ذیلِ واژه</single>
+      <multiple>در ذیلِ واژه‌های</multiple>
     </term>
     <term name="verse">
       <single>بیت</single>
@@ -162,13 +160,17 @@
     <term name="figure" form="short">تصویر</term>
     <term name="folio" form="short">برگ</term>
     <term name="issue" form="short">ش</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="line" form="short">خط</term>
+    <term name="note" form="short">یادداشت</term>
     <term name="opus" form="short">قطعه</term>
     <term name="page" form="short">
       <single>ص</single>
       <multiple>صص</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>ص</single>
+      <multiple>صص</multiple>
+    </term>
     <term name="paragraph" form="short">پاراگراف</term>
     <term name="part" form="short">بخش</term>
     <term name="section" form="short">قسمت</term>
@@ -201,24 +203,24 @@
       <multiple>directors</multiple>
     </term>
     <term name="editor">
-      <single>ویرایشگر</single>
-      <multiple>ویرایشگران</multiple>
+      <single>ویراستار</single>
+      <multiple>ویراستاران</multiple>
     </term>
     <term name="editorial-director">
-      <single>ویرایشگر</single>
-      <multiple>ویرایشگران</multiple>
+      <single>ویراستار</single>
+      <multiple>ویراستاران</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>طراح گرافیک</single>
+      <multiple>طراحان گرافیک</multiple>
     </term>
     <term name="translator">
       <single>مترجم</single>
       <multiple>مترجمین</multiple>
     </term>
     <term name="editortranslator">
-      <single>ویرایشگر و مترجم</single>
-      <multiple>ویرایشگران و مترجمین</multiple>
+      <single>ویراستار و مترجم</single>
+      <multiple>ویراستاران و مترجمین</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
@@ -227,43 +229,43 @@
       <multiple>dirs.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>ویرایشگر</single>
-      <multiple>ویرایشگران</multiple>
+      <single>ویراستار</single>
+      <multiple>ویراستاران</multiple>
     </term>
     <term name="editorial-director" form="short">
-      <single>ویرایشگر</single>
-      <multiple>ویرایشگران</multiple>
+      <single>ویراستار</single>
+      <multiple>ویراستاران</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>تصویرگر</single>
+      <multiple>تصویرگران</multiple>
     </term>
     <term name="translator" form="short">
       <single>مترجم</single>
       <multiple>مترجمین</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>ویرایشگر و مترجم</single>
-      <multiple>ویرایشگران و مترجمین</multiple>
+      <single>ویراستار و مترجم</single>
+      <multiple>ویراستاران و مترجمین</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">edited by</term>
+    <term name="container-author" form="verb">توسط</term>
+    <term name="director" form="verb">زیر نظر</term>
+    <term name="editor" form="verb">ویراسته‌ی</term>
     <term name="editorial-director" form="verb">ویراسته‌ی</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">طراحی گرافیکی از</term>
     <term name="interviewer" form="verb">مصاحبه توسط</term>
     <term name="recipient" form="verb">به</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">بازبینی توسط</term>
     <term name="translator" form="verb">ترجمه‌ی</term>
     <term name="editortranslator" form="verb">ترجمه و ویراسته‌ی</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">توسط</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ویراسته‌ی</term>
     <term name="editorial-director" form="verb-short">ویراسته‌ی</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">طراحی از</term>
     <term name="translator" form="verb-short">ترجمه‌ی</term>
     <term name="editortranslator" form="verb-short">ترجمه و ویراسته‌ی</term>
 
diff -pruN 0.3.0-6/citeproc/data/locales/locales-fi-FI.xml 0.5.1-1/citeproc/data/locales/locales-fi-FI.xml
--- 0.3.0-6/citeproc/data/locales/locales-fi-FI.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-fi-FI.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,13 +6,13 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
   <date form="numeric">
     <date-part name="day" suffix="."/>
-    <date-part name="month" suffix="."/>
+    <date-part name="month" form="numeric" suffix="."/>
     <date-part name="year"/>
   </date>
   <terms>
@@ -22,7 +22,7 @@
     <term name="anonymous">tuntematon</term>
     <term name="anonymous" form="short">tuntematon</term>
     <term name="at">osoitteessa</term>
-    <term name="available at">available at</term>
+    <term name="available at">saatavissa</term>
     <term name="by">tekijä</term>
     <term name="circa">noin</term>
     <term name="circa" form="short">n.</term>
@@ -34,7 +34,7 @@
     <term name="edition" form="short">p.</term>
     <term name="et-al">ym.</term>
     <term name="forthcoming">tulossa</term>
-    <term name="from">alkaen</term>
+    <term name="from">osoitteesta</term>
     <term name="ibid">mt.</term>
     <term name="in">teoksessa</term>
     <term name="in press">painossa</term>
@@ -42,7 +42,7 @@
     <term name="interview">haastattelu</term>
     <term name="letter">kirje</term>
     <term name="no date">ei päivämäärää</term>
-    <term name="no date" form="short">n.d.</term>
+    <term name="no date" form="short">ei pvm.</term>
     <term name="online">verkossa</term>
     <term name="presented at">esitetty tilaisuudessa</term>
     <term name="reference">
@@ -50,12 +50,12 @@
       <multiple>viittaukset</multiple>
     </term>
     <term name="reference" form="short">
-      <single>viit..</single>
+      <single>viit.</single>
       <multiple>viit.</multiple>
     </term>
     <term name="retrieved">noudettu</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">mittakaava</term>
+    <term name="version">versio</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
     <term name="ad">eaa.</term>
@@ -113,8 +113,8 @@
       <multiple>rivit</multiple>
     </term>
     <term name="note">
-      <single>muistiinpano</single>
-      <multiple>muistiinpanot</multiple>
+      <single>huomautus</single>
+      <multiple>huomautukset</multiple>
     </term>
     <term name="opus">
       <single>opus</single>
@@ -124,6 +124,10 @@
       <single>sivu</single>
       <multiple>sivut</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>sivu</single>
+      <multiple>sivut</multiple>
+    </term>
     <term name="paragraph">
       <single>kappale</single>
       <multiple>kappaleet</multiple>
@@ -156,13 +160,17 @@
     <term name="figure" form="short">kuv.</term>
     <term name="folio" form="short">fol.</term>
     <term name="issue" form="short">nro</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="line" form="short">r.</term>
+    <term name="note" form="short">huom.</term>
     <term name="opus" form="short">op.</term>
     <term name="page" form="short">
       <single>s.</single>
       <multiple>ss.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>ss.</multiple>
+    </term>
     <term name="paragraph" form="short">kappale</term>
     <term name="part" form="short">osa</term>
     <term name="section" form="short">osa</term>
@@ -175,8 +183,8 @@
       <multiple>säk.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>vol.</single>
-      <multiple>vol.</multiple>
+      <single>vsk.</single>
+      <multiple>vsk.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -191,8 +199,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>ohjaaja</single>
+      <multiple>ohjaajat</multiple>
     </term>
     <term name="editor">
       <single>toimittaja</single>
@@ -203,22 +211,22 @@
       <multiple>toimittajat</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>kuvittaja</single>
+      <multiple>kuvittajat</multiple>
     </term>
     <term name="translator">
-      <single>suomentaja</single>
-      <multiple>suomentajat</multiple>
+      <single>kääntäjä</single>
+      <multiple>kääntäjät</multiple>
     </term>
     <term name="editortranslator">
-      <single>toimittaja ja suomentaja</single>
-      <multiple>toimittajat ja suomentajat</multiple>
+      <single>toimittaja ja kääntäjä</single>
+      <multiple>toimittajat ja kääntäjät</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>ohj.</single>
+      <multiple>ohj.</multiple>
     </term>
     <term name="editor" form="short">
       <single>toim.</single>
@@ -229,51 +237,51 @@
       <multiple>toim.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>kuv.</single>
+      <multiple>kuv.</multiple>
     </term>
     <term name="translator" form="short">
-      <single>suom.</single>
-      <multiple>suom.</multiple>
+      <single>käänt.</single>
+      <multiple>käänt.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>toim. ja suom.</single>
-      <multiple>toim. ja suom.</multiple>
+      <single>toim. ja käänt.</single>
+      <multiple>toim. ja käänt.</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb"></term>
+    <term name="director" form="verb">ohjannut</term>
     <term name="editor" form="verb">toimittanut</term>
     <term name="editorial-director" form="verb">toimittanut</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">kuvittanut</term>
     <term name="interviewer" form="verb">haastatellut</term>
     <term name="recipient" form="verb">vastaanottaja</term>
-    <term name="reviewed-author" form="verb">by</term>
-    <term name="translator" form="verb">suomentanut</term>
-    <term name="editortranslator" form="verb">toimittanut ja suomentanut</term>
+    <term name="reviewed-author" form="verb"></term>
+    <term name="translator" form="verb">kääntänyt</term>
+    <term name="editortranslator" form="verb">toimittanut ja kääntänyt</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">ohj.</term>
     <term name="editor" form="verb-short">toim.</term>
     <term name="editorial-director" form="verb-short">toim.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">suom.</term>
-    <term name="editortranslator" form="verb-short">toim. ja suom.</term>
+    <term name="illustrator" form="verb-short">kuv.</term>
+    <term name="translator" form="verb-short">käänt.</term>
+    <term name="editortranslator" form="verb-short">toim. ja käänt.</term>
 
     <!-- LONG MONTH FORMS -->
-    <term name="month-01">tammikuu</term>
-    <term name="month-02">helmikuu</term>
-    <term name="month-03">maaliskuu</term>
-    <term name="month-04">huhtikuu</term>
-    <term name="month-05">toukokuu</term>
-    <term name="month-06">kesäkuu</term>
-    <term name="month-07">heinäkuu</term>
-    <term name="month-08">elokuu</term>
-    <term name="month-09">syyskuu</term>
-    <term name="month-10">lokakuu</term>
-    <term name="month-11">marraskuu</term>
-    <term name="month-12">joulukuu</term>
+    <term name="month-01">tammikuuta</term>
+    <term name="month-02">helmikuuta</term>
+    <term name="month-03">maaliskuuta</term>
+    <term name="month-04">huhtikuuta</term>
+    <term name="month-05">toukokuuta</term>
+    <term name="month-06">kesäkuuta</term>
+    <term name="month-07">heinäkuuta</term>
+    <term name="month-08">elokuuta</term>
+    <term name="month-09">syyskuuta</term>
+    <term name="month-10">lokakuuta</term>
+    <term name="month-11">marraskuuta</term>
+    <term name="month-12">joulukuuta</term>
 
     <!-- SHORT MONTH FORMS -->
     <term name="month-01" form="short">tammi</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-fr-CA.xml 0.5.1-1/citeproc/data/locales/locales-fr-CA.xml
--- 0.3.0-6/citeproc/data/locales/locales-fr-CA.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-fr-CA.xml	2020-04-06 16:40:32.000000000 +0000
@@ -25,7 +25,7 @@
     <term name="anonymous">anonyme</term>
     <term name="anonymous" form="short">anon.</term>
     <term name="at">sur</term>
-    <term name="available at">disponible sur</term>
+    <term name="available at">disponible à</term>
     <term name="by">par</term>
     <term name="circa">vers</term>
     <term name="circa" form="short">v.</term>
@@ -129,6 +129,10 @@
       <single>page</single>
       <multiple>pages</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>page</single>
+      <multiple>pages</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraphe</single>
       <multiple>paragraphes</multiple>
@@ -174,6 +178,10 @@
       <single>p.</single>
       <multiple>p.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>p.</multiple>
+    </term>
     <term name="paragraph" form="short">paragr.</term>
     <term name="part" form="short">part.</term>
     <term name="section" form="short">sect.</term>
@@ -253,6 +261,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">par</term>
     <term name="director" form="verb">réalisé par</term>
     <term name="editor" form="verb">édité par</term>
     <term name="editorial-director" form="verb">sous la direction de</term>
@@ -264,7 +273,6 @@
     <term name="editortranslator" form="verb">édité et traduit par</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">par</term>
     <term name="director" form="verb-short">réal. par</term>
     <term name="editor" form="verb-short">éd. par</term>
     <term name="editorial-director" form="verb-short">ss la dir. de</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-fr-FR.xml 0.5.1-1/citeproc/data/locales/locales-fr-FR.xml
--- 0.3.0-6/citeproc/data/locales/locales-fr-FR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-fr-FR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -129,6 +129,10 @@
       <single>page</single>
       <multiple>pages</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>page</single>
+      <multiple>pages</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraphe</single>
       <multiple>paragraphes</multiple>
@@ -174,6 +178,10 @@
       <single>p.</single>
       <multiple>p.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>p.</multiple>
+    </term>
     <term name="paragraph" form="short">paragr.</term>
     <term name="part" form="short">part.</term>
     <term name="section" form="short">sect.</term>
@@ -253,6 +261,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">par</term>
     <term name="director" form="verb">réalisé par</term>
     <term name="editor" form="verb">édité par</term>
     <term name="editorial-director" form="verb">sous la direction de</term>
@@ -264,7 +273,6 @@
     <term name="editortranslator" form="verb">édité et traduit par</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">par</term>
     <term name="director" form="verb-short">réal. par</term>
     <term name="editor" form="verb-short">éd. par</term>
     <term name="editorial-director" form="verb-short">ss la dir. de</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-he-IL.xml 0.5.1-1/citeproc/data/locales/locales-he-IL.xml
--- 0.3.0-6/citeproc/data/locales/locales-he-IL.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-he-IL.xml	2020-04-06 16:40:32.000000000 +0000
@@ -16,38 +16,38 @@
     <date-part name="year"/>
   </date>
   <terms>
-    <term name="accessed">גישה</term>
+    <term name="accessed">נבדק לאחרונה</term>
     <term name="and">ו</term>
-    <term name="and others">and others</term>
-    <term name="anonymous">anonymous</term>
+    <term name="and others">ואחרים</term>
+    <term name="anonymous">אלמוני</term>
     <term name="anonymous" form="short">anon</term>
     <term name="at">-ב</term>
-    <term name="available at">available at</term>
-    <term name="by">by</term>
-    <term name="circa">circa</term>
+    <term name="available at">זמין ב</term>
+    <term name="by">על-ידי</term>
+    <term name="circa">לערך</term>
     <term name="circa" form="short">c.</term>
-    <term name="cited">cited</term>
+    <term name="cited">מצוטט ב</term>
     <term name="edition">
-      <single>edition</single>
-      <multiple>editions</multiple>
+      <single>מהדורה</single>
+      <multiple>מהדורות</multiple>
     </term>
     <term name="edition" form="short">ed</term>
     <term name="et-al">ואחרים</term>
-    <term name="forthcoming">forthcoming</term>
+    <term name="forthcoming">צפוי</term>
     <term name="from">מתוך</term>
     <term name="ibid">שם</term>
     <term name="in">בתוך</term>
-    <term name="in press">in press</term>
-    <term name="internet">internet</term>
-    <term name="interview">interview</term>
-    <term name="letter">letter</term>
-    <term name="no date">no date</term>
+    <term name="in press">בהדפסה</term>
+    <term name="internet">אינטרנט</term>
+    <term name="interview">ראיון</term>
+    <term name="letter">מכתב</term>
+    <term name="no date">אין נתונים</term>
     <term name="no date" form="short">nd</term>
-    <term name="online">online</term>
-    <term name="presented at">presented at the</term>
+    <term name="online">מקוון</term>
+    <term name="presented at">הוצג ב</term>
     <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
+      <single>הפניה</single>
+      <multiple>הפניות</multiple>
     </term>
     <term name="reference" form="short">
       <single>ref.</single>
@@ -55,11 +55,11 @@
     </term>
     <term name="retrieved">אוחזר</term>
     <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="version">גירסה</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">לספירה</term>
+    <term name="bc">לפני הספירה</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">“</term>
@@ -78,16 +78,16 @@
     <term name="ordinal-13">th</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">first</term>
-    <term name="long-ordinal-02">second</term>
-    <term name="long-ordinal-03">third</term>
-    <term name="long-ordinal-04">fourth</term>
-    <term name="long-ordinal-05">fifth</term>
-    <term name="long-ordinal-06">sixth</term>
-    <term name="long-ordinal-07">seventh</term>
-    <term name="long-ordinal-08">eighth</term>
-    <term name="long-ordinal-09">ninth</term>
-    <term name="long-ordinal-10">tenth</term>
+    <term name="long-ordinal-01">ראשון</term>
+    <term name="long-ordinal-02">שני</term>
+    <term name="long-ordinal-03">שלישי</term>
+    <term name="long-ordinal-04">רביעי</term>
+    <term name="long-ordinal-05">חמישי</term>
+    <term name="long-ordinal-06">שישי</term>
+    <term name="long-ordinal-07">שביעי</term>
+    <term name="long-ordinal-08">שמיני</term>
+    <term name="long-ordinal-09">תשיעי</term>
+    <term name="long-ordinal-10">עשירי</term>
 
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
@@ -107,8 +107,8 @@
       <multiple>figures</multiple>
     </term>
     <term name="folio">
-      <single>folio</single>
-      <multiple>folios</multiple>
+      <single>פוליו</single>
+      <multiple>פוליו</multiple>
     </term>
     <term name="issue">
       <single>מספר</single>
@@ -119,8 +119,8 @@
       <multiple>שורות</multiple>
     </term>
     <term name="note">
-      <single>note</single>
-      <multiple>notes</multiple>
+      <single>הערה</single>
+      <multiple>הערות</multiple>
     </term>
     <term name="opus">
       <single>אופוס</single>
@@ -130,17 +130,21 @@
       <single>עמוד</single>
       <multiple>עמודים</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>עמוד</single>
+      <multiple>עמודים</multiple>
+    </term>
     <term name="paragraph">
-      <single>paragraph</single>
-      <multiple>פיסקה</multiple>
+      <single>פיסקה</single>
+      <multiple>פיסקאות</multiple>
     </term>
     <term name="part">
-      <single>part</single>
-      <multiple>parts</multiple>
+      <single>חלק</single>
+      <multiple>חלקים</multiple>
     </term>
     <term name="section">
-      <single>section</single>
-      <multiple>sections</multiple>
+      <single>סעיף</single>
+      <multiple>סעיפים</multiple>
     </term>
     <term name="sub verbo">
       <single>sub verbo</single>
@@ -169,9 +173,13 @@
       <single>'עמ</single>
       <multiple>'עמ</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>'עמ</single>
+      <multiple>'עמ</multiple>
+    </term>
     <term name="paragraph" form="short">para</term>
     <term name="part" form="short">pt</term>
-    <term name="section" form="short">sec</term>
+    <term name="section" form="short">ס'</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
@@ -197,20 +205,20 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>במאי</single>
+      <multiple>במאים</multiple>
     </term>
     <term name="editor">
       <single>עורך</single>
       <multiple>עורכים</multiple>
     </term>
     <term name="editorial-director">
-      <single>editor</single>
-      <multiple>editors</multiple>
+      <single>עורך ראשי</single>
+      <multiple>עורכים ראשיים</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>מאייר</single>
+      <multiple>מאיירים</multiple>
     </term>
     <term name="translator">
       <single>מתרגם</single>
@@ -248,18 +256,18 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">by</term>
+    <term name="director" form="verb">בוים ע"י</term>
     <term name="editor" form="verb">נערך ע"י</term>
-    <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
-    <term name="interviewer" form="verb">interview by</term>
-    <term name="recipient" form="verb">to</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="editorial-director" form="verb">בוים ע"י</term>
+    <term name="illustrator" form="verb">אויר ע"י</term>
+    <term name="interviewer" form="verb">רואיין ע"י</term>
+    <term name="recipient" form="verb">אל</term>
+    <term name="reviewed-author" form="verb">ע"י</term>
     <term name="translator" form="verb">תורגם ע"י</term>
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-hr-HR.xml 0.5.1-1/citeproc/data/locales/locales-hr-HR.xml
--- 0.3.0-6/citeproc/data/locales/locales-hr-HR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-hr-HR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -19,13 +19,13 @@
     <term name="accessed">pristupljeno</term>
     <term name="and">i</term>
     <term name="and others">i ostali</term>
-    <term name="anonymous">anonim</term>
+    <term name="anonymous">anonimno</term>
     <term name="anonymous" form="short">anon.</term>
     <term name="at">na</term>
-    <term name="available at">pristupačno na</term>
+    <term name="available at">dostupno na</term>
     <term name="by">od</term>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">c.</term>
+    <term name="circa">oko</term>
+    <term name="circa" form="short">oko</term>
     <term name="cited">citirano</term>
     <term name="edition">
       <single>izdanje</single>
@@ -37,12 +37,12 @@
     <term name="from">od</term>
     <term name="ibid">ibid.</term>
     <term name="in">u</term>
-    <term name="in press">u štampi</term>
+    <term name="in press">u tisku</term>
     <term name="internet">internet</term>
     <term name="interview">intervju</term>
     <term name="letter">pismo</term>
     <term name="no date">bez datuma</term>
-    <term name="no date" form="short">bez datuma</term>
+    <term name="no date" form="short">bez dat.</term>
     <term name="online">na internetu</term>
     <term name="presented at">predstavljeno na</term>
     <term name="reference">
@@ -58,8 +58,8 @@
     <term name="version">verzija</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad"></term>
+    <term name="bc">pr. Kr.</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">„</term>
@@ -69,13 +69,7 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
+    <term name="ordinal">.</term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">prvi</term>
@@ -99,8 +93,8 @@
       <multiple>poglavlja</multiple>
     </term>
     <term name="column">
-      <single>kolona</single>
-      <multiple>kolone</multiple>
+      <single>stupac</single>
+      <multiple>stupci</multiple>
     </term>
     <term name="figure">
       <single>crtež</single>
@@ -111,78 +105,86 @@
       <multiple>folije</multiple>
     </term>
     <term name="issue">
-      <single>broj</single>
-      <multiple>brojevi</multiple>
+      <single>izdanje</single>
+      <multiple>izdanja</multiple>
     </term>
     <term name="line">
-      <single>linija</single>
-      <multiple>linije</multiple>
+      <single>red</single>
+      <multiple>redovi</multiple>
     </term>
     <term name="note">
-      <single>beleška</single>
-      <multiple>beleške</multiple>
+      <single>bilješka</single>
+      <multiple>bilješke</multiple>
     </term>
     <term name="opus">
-      <single>opus</single>
-      <multiple>opera</multiple>
+      <single>djelo</single>
+      <multiple>djela</multiple>
     </term>
     <term name="page">
       <single>stranica</single>
       <multiple>stranice</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>stranica</single>
+      <multiple>stranice</multiple>
+    </term>
     <term name="paragraph">
-      <single>paragraf</single>
-      <multiple>paragrafi</multiple>
+      <single>pasus</single>
+      <multiple>pasusi</multiple>
     </term>
     <term name="part">
-      <single>deo</single>
-      <multiple>delova</multiple>
+      <single>dio</single>
+      <multiple>dijelova</multiple>
     </term>
     <term name="section">
-      <single>odeljak</single>
-      <multiple>odeljaka</multiple>
+      <single>odjeljak</single>
+      <multiple>odjeljci</multiple>
     </term>
     <term name="sub verbo">
       <single>sub verbo</single>
       <multiple>sub verbis</multiple>
     </term>
     <term name="verse">
-      <single>strofa</single>
-      <multiple>strofe</multiple>
+      <single>stih</single>
+      <multiple>stihovi</multiple>
     </term>
     <term name="volume">
-      <single>tom</single>
-      <multiple>tomova</multiple>
+      <single>svezak</single>
+      <multiple>svesci</multiple>
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">knj</term>
-    <term name="chapter" form="short">pog</term>
-    <term name="column" form="short">kol</term>
-    <term name="figure" form="short">црт</term>
-    <term name="folio" form="short">fol</term>
-    <term name="issue" form="short">izd</term>
-    <term name="line" form="short">l</term>
-    <term name="note" form="short">n</term>
-    <term name="opus" form="short">op</term>
+    <term name="book" form="short">knj.</term>
+    <term name="chapter" form="short">pogl.</term>
+    <term name="column" form="short">stup.</term>
+    <term name="figure" form="short">crt.</term>
+    <term name="folio" form="short">fol.</term>
+    <term name="issue" form="short">izd.</term>
+    <term name="line" form="short">red</term>
+    <term name="note" form="short">bilj.</term>
+    <term name="opus" form="short">sv.</term>
     <term name="page" form="short">
       <single>str.</single>
       <multiple>str.</multiple>
     </term>
-    <term name="paragraph" form="short">par</term>
-    <term name="part" form="short">deo</term>
-    <term name="section" form="short">od</term>
+    <term name="number-of-pages" form="short">
+      <single>str.</single>
+      <multiple>str.</multiple>
+    </term>
+    <term name="paragraph" form="short">par.</term>
+    <term name="part" form="short">dio</term>
+    <term name="section" form="short">od.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
     </term>
     <term name="verse" form="short">
-      <single>s</single>
-      <multiple>s</multiple>
+      <single>st.</single>
+      <multiple>st.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>tom</single>
-      <multiple>tomova</multiple>
+      <single>sv.</single>
+      <multiple>sv.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -197,42 +199,42 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>voditelj</single>
+      <multiple>voditelji</multiple>
     </term>
     <term name="editor">
-      <single>priređivač</single>
-      <multiple>priređivači</multiple>
+      <single>urednik</single>
+      <multiple>urednici</multiple>
     </term>
     <term name="editorial-director">
-      <single>priređivač</single>
-      <multiple>priređivači</multiple>
+      <single>urednik</single>
+      <multiple>urednici</multiple>
     </term>
     <term name="illustrator">
       <single>ilustrator</single>
       <multiple>ilustratori</multiple>
     </term>
     <term name="translator">
-      <single>prevodilac</single>
-      <multiple>prevodioci</multiple>
+      <single>prevoditelj</single>
+      <multiple>prevoditelji</multiple>
     </term>
     <term name="editortranslator">
-      <single>priređivač &amp; prevodilac</single>
-      <multiple>priređivači &amp; prevodioci</multiple>
+      <single>urednik &amp; prevoditelj</single>
+      <multiple>urednici &amp; prevoditelji</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>prir.</single>
-      <multiple>prir.</multiple>
+      <single>vod.</single>
+      <multiple>vod.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>prir.</single>
-      <multiple>prir.</multiple>
+      <single>ur.</single>
+      <multiple>ur.</multiple>
     </term>
     <term name="editorial-director" form="short">
-      <single>prir.</single>
-      <multiple>prir.</multiple>
+      <single>ur.-vod.</single>
+      <multiple>ur.-vod.</multiple>
     </term>
     <term name="illustrator" form="short">
       <single>il.</single>
@@ -243,61 +245,61 @@
       <multiple>prev.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>prir. &amp; prev.</single>
-      <multiple>prir. &amp; prev.</multiple>
+      <single>ur. &amp; prev.</single>
+      <multiple>ur. &amp; prev.</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">priredio</term>
-    <term name="editorial-director" form="verb">priredio</term>
-    <term name="illustrator" form="verb">ilustrovao</term>
-    <term name="interviewer" form="verb">intervjuisao</term>
-    <term name="recipient" form="verb">prima</term>
-    <term name="reviewed-author" form="verb">od</term>
+    <term name="container-author" form="verb">od</term>
+    <term name="director" form="verb">vodio</term>
+    <term name="editor" form="verb">uredio</term>
+    <term name="editorial-director" form="verb">uredio</term>
+    <term name="illustrator" form="verb">ilustrirao</term>
+    <term name="interviewer" form="verb">intervjuirao</term>
+    <term name="recipient" form="verb">primatelj</term>
+    <term name="reviewed-author" form="verb">pregledao</term>
     <term name="translator" form="verb">preveo</term>
-    <term name="editortranslator" form="verb">priredio &amp; preveo by</term>
+    <term name="editortranslator" form="verb">uredio &amp; preveo</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">prir.</term>
-    <term name="editorial-director" form="verb-short">prir.</term>
+    <term name="director" form="verb-short">vod.</term>
+    <term name="editor" form="verb-short">ur.</term>
+    <term name="editorial-director" form="verb-short">ur. vod.</term>
     <term name="illustrator" form="verb-short">ilus.</term>
     <term name="translator" form="verb-short">prev.</term>
-    <term name="editortranslator" form="verb-short">prir. &amp; prev. by</term>
+    <term name="editortranslator" form="verb-short">ur. &amp; prev.</term>
 
     <!-- LONG MONTH FORMS -->
-    <term name="month-01">januar</term>
-    <term name="month-02">februar</term>
-    <term name="month-03">mart</term>
-    <term name="month-04">april</term>
-    <term name="month-05">maj</term>
-    <term name="month-06">jun</term>
-    <term name="month-07">jul</term>
-    <term name="month-08">avgust</term>
-    <term name="month-09">septembar</term>
-    <term name="month-10">oktobar</term>
-    <term name="month-11">novembar</term>
-    <term name="month-12">decembar</term>
+    <term name="month-01">siječanj</term>
+    <term name="month-02">veljača</term>
+    <term name="month-03">ožujak</term>
+    <term name="month-04">travanj</term>
+    <term name="month-05">svibanj</term>
+    <term name="month-06">lipanj</term>
+    <term name="month-07">srpanj</term>
+    <term name="month-08">kolovoz</term>
+    <term name="month-09">rujan</term>
+    <term name="month-10">listopad</term>
+    <term name="month-11">studeni</term>
+    <term name="month-12">prosinac</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">jan.</term>
-    <term name="month-02" form="short">feb.</term>
-    <term name="month-03" form="short">mart</term>
-    <term name="month-04" form="short">apr.</term>
-    <term name="month-05" form="short">maj</term>
-    <term name="month-06" form="short">jun</term>
-    <term name="month-07" form="short">jul</term>
-    <term name="month-08" form="short">avg.</term>
-    <term name="month-09" form="short">sep.</term>
-    <term name="month-10" form="short">okt.</term>
-    <term name="month-11" form="short">nov.</term>
-    <term name="month-12" form="short">dec.</term>
+    <term name="month-01" form="short">sij.</term>
+    <term name="month-02" form="short">velj.</term>
+    <term name="month-03" form="short">ožu.</term>
+    <term name="month-04" form="short">tra.</term>
+    <term name="month-05" form="short">svi.</term>
+    <term name="month-06" form="short">lip.</term>
+    <term name="month-07" form="short">srp.</term>
+    <term name="month-08" form="short">kol.</term>
+    <term name="month-09" form="short">ruj.</term>
+    <term name="month-10" form="short">lis.</term>
+    <term name="month-11" form="short">stu.</term>
+    <term name="month-12" form="short">pros.</term>
 
     <!-- SEASONS -->
-    <term name="season-01">proleće</term>
-    <term name="season-02">leto</term>
+    <term name="season-01">proljeće</term>
+    <term name="season-02">ljeto</term>
     <term name="season-03">jesen</term>
     <term name="season-04">zima</term>
   </terms>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-hu-HU.xml 0.5.1-1/citeproc/data/locales/locales-hu-HU.xml
--- 0.3.0-6/citeproc/data/locales/locales-hu-HU.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-hu-HU.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="hu-HU">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2014-06-17T09:56:35+02:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -19,47 +19,51 @@
     <term name="accessed">elérés</term>
     <term name="and">és</term>
     <term name="and others">és mások</term>
-    <term name="anonymous">név nélkül</term>
-    <term name="anonymous" form="short">nn</term>
-    <term name="at"/>
-    <term name="available at">available at</term>
+    <term name="anonymous">szerző nélkül</term>
+    <term name="anonymous" form="short">sz. n.</term>
+    <term name="at"></term>
+    <term name="available at">elérhető</term>
     <term name="by">by</term>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">c.</term>
+    <term name="circa">körülbelül</term>
+    <term name="circa" form="short">kb.</term>
     <term name="cited">idézi</term>
     <term name="edition">
-      <single>edition</single>
-      <multiple>editions</multiple>
+      <single>kiadás</single>
+      <multiple>kiadás</multiple>
     </term>
-    <term name="edition" form="short">ed</term>
-    <term name="et-al">et al.</term>
+    <term name="edition" form="short">kiad.</term>
+    <term name="et-al">és mtsai.</term>
     <term name="forthcoming">megjelenés alatt</term>
     <term name="from">forrás</term>
-    <term name="ibid">ibid.</term>
+    <term name="ibid">uo.</term>
     <term name="in">in</term>
     <term name="in press">nyomtatás alatt</term>
     <term name="internet">internet</term>
     <term name="interview">interjú</term>
     <term name="letter">levél</term>
-    <term name="no date">no date</term>
-    <term name="no date" form="short">nd</term>
+    <term name="no date">évszám nélkül</term>
+    <term name="no date" form="short">é. n.</term>
     <term name="online">online</term>
     <term name="presented at">előadás</term>
     <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
+      <single>hivatkozás</single>
+      <multiple>hivatkozás</multiple>
     </term>
     <term name="reference" form="short">
-      <single>ref.</single>
-      <multiple>refs.</multiple>
+      <single>hiv.</single>
+      <multiple>hiv.</multiple>
     </term>
     <term name="retrieved">elérés</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">skála</term>
+    <term name="version">verzió</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">Kr. u.</term>
+    <term name="bc">Kr. e.</term>
+
+    <!-- ANNO DOMINI; BEFORE CHRIST -->
+    <term name="ad">i. sz.</term>
+    <term name="bc">i. e.</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">„</term>
@@ -69,25 +73,19 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
+    <term name="ordinal">.</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">first</term>
-    <term name="long-ordinal-02">second</term>
-    <term name="long-ordinal-03">third</term>
-    <term name="long-ordinal-04">fourth</term>
-    <term name="long-ordinal-05">fifth</term>
-    <term name="long-ordinal-06">sixth</term>
-    <term name="long-ordinal-07">seventh</term>
-    <term name="long-ordinal-08">eighth</term>
-    <term name="long-ordinal-09">ninth</term>
-    <term name="long-ordinal-10">tenth</term>
+    <term name="long-ordinal-01">első</term>
+    <term name="long-ordinal-02">második</term>
+    <term name="long-ordinal-03">harmadik</term>
+    <term name="long-ordinal-04">negyedik</term>
+    <term name="long-ordinal-05">ötödik</term>
+    <term name="long-ordinal-06">hatodik</term>
+    <term name="long-ordinal-07">hetedik</term>
+    <term name="long-ordinal-08">nyolcadik</term>
+    <term name="long-ordinal-09">kilencedik</term>
+    <term name="long-ordinal-10">tizedik</term>
 
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
@@ -123,13 +121,17 @@
       <multiple>jegyzet</multiple>
     </term>
     <term name="opus">
-      <single>opus</single>
-      <multiple>opera</multiple>
+      <single>mű</single>
+      <multiple>mű</multiple>
     </term>
     <term name="page">
       <single>oldal</single>
       <multiple>oldal</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>oldal</single>
+      <multiple>oldal</multiple>
+    </term>
     <term name="paragraph">
       <single>bekezdés</single>
       <multiple>bekezdés</multiple>
@@ -157,32 +159,36 @@
 
     <!-- SHORT LOCATOR FORMS -->
     <term name="book" form="short">könyv</term>
-    <term name="chapter" form="short">fej</term>
-    <term name="column" form="short">oszl</term>
-    <term name="figure" form="short">ábr</term>
-    <term name="folio" form="short">fol</term>
-    <term name="issue" form="short">sz</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="chapter" form="short">fej.</term>
+    <term name="column" form="short">oszl.</term>
+    <term name="figure" form="short">ábr.</term>
+    <term name="folio" form="short">fol.</term>
+    <term name="issue" form="short">sz.</term>
+    <term name="line" form="short">s.</term>
+    <term name="note" form="short">j.</term>
+    <term name="opus" form="short">op.</term>
     <term name="page" form="short">
-      <single>o</single>
-      <multiple>o</multiple>
+      <single>o.</single>
+      <multiple>o.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>o.</single>
+      <multiple>o.</multiple>
     </term>
-    <term name="paragraph" form="short">bek</term>
+    <term name="paragraph" form="short">bek.</term>
     <term name="part" form="short">rész</term>
-    <term name="section" form="short">szak</term>
+    <term name="section" form="short">szak.</term>
     <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
+      <single>s. v.</single>
+      <multiple>s. vv.</multiple>
     </term>
     <term name="verse" form="short">
-      <single>vsz</single>
-      <multiple>vsz</multiple>
+      <single>vsz.</single>
+      <multiple>vsz.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>vol</single>
-      <multiple>vols</multiple>
+      <single>köt.</single>
+      <multiple>köt.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -197,75 +203,75 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>igazgató</single>
+      <multiple>igazgató</multiple>
     </term>
     <term name="editor">
       <single>szerkesztő</single>
       <multiple>szerkesztő</multiple>
     </term>
     <term name="editorial-director">
-      <single>editor</single>
-      <multiple>editors</multiple>
+      <single>szerkesztőségi igazgató</single>
+      <multiple>szerkesztőségi igazgató</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>illusztrátor</single>
+      <multiple>illusztrátor</multiple>
     </term>
     <term name="translator">
       <single>fordító</single>
       <multiple>fordító</multiple>
     </term>
     <term name="editortranslator">
-      <single>editor &amp; translator</single>
-      <multiple>editors &amp; translators</multiple>
+      <single>szerkesztő &amp; fordító</single>
+      <multiple>szerkesztő &amp; fordító</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>ig.</single>
+      <multiple>ig.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>szerk</single>
-      <multiple>szerk</multiple>
+      <single>szerk.</single>
+      <multiple>szerk.</multiple>
     </term>
     <term name="editorial-director" form="short">
-      <single>ed.</single>
-      <multiple>eds.</multiple>
+      <single>szerk. ig.</single>
+      <multiple>szerk. ig.</multiple>
     </term>
     <term name="illustrator" form="short">
       <single>ill.</single>
-      <multiple>ills.</multiple>
+      <multiple>ill.</multiple>
     </term>
     <term name="translator" form="short">
-      <single>ford</single>
-      <multiple>ford</multiple>
+      <single>ford.</single>
+      <multiple>ford.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
+      <single>szerk. &amp; ford.</single>
+      <multiple>szerk. &amp; ford.</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">szerkesztette</term>
     <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">illusztrálta</term>
     <term name="interviewer" form="verb">interjúkészítő</term>
     <term name="recipient" form="verb">címzett</term>
     <term name="reviewed-author" form="verb">by</term>
     <term name="translator" form="verb">fordította</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="editortranslator" form="verb">szerkesztette &amp; fordította</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">szerk</term>
+    <term name="director" form="verb-short">ig.</term>
+    <term name="editor" form="verb-short">szerk.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">ford</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="illustrator" form="verb-short">ill.</term>
+    <term name="translator" form="verb-short">ford.</term>
+    <term name="editortranslator" form="verb-short">szerk. &amp; ford.</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">január</term>
@@ -282,23 +288,23 @@
     <term name="month-12">december</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">jan</term>
-    <term name="month-02" form="short">febr</term>
-    <term name="month-03" form="short">márc</term>
-    <term name="month-04" form="short">ápr</term>
-    <term name="month-05" form="short">máj</term>
-    <term name="month-06" form="short">jún</term>
-    <term name="month-07" form="short">júl</term>
-    <term name="month-08" form="short">aug</term>
-    <term name="month-09" form="short">szept</term>
-    <term name="month-10" form="short">okt</term>
-    <term name="month-11" form="short">nov</term>
-    <term name="month-12" form="short">dec</term>
+    <term name="month-01" form="short">jan.</term>
+    <term name="month-02" form="short">febr.</term>
+    <term name="month-03" form="short">márc.</term>
+    <term name="month-04" form="short">ápr.</term>
+    <term name="month-05" form="short">máj.</term>
+    <term name="month-06" form="short">jún.</term>
+    <term name="month-07" form="short">júl.</term>
+    <term name="month-08" form="short">aug.</term>
+    <term name="month-09" form="short">szept.</term>
+    <term name="month-10" form="short">okt.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dec.</term>
 
     <!-- SEASONS -->
-    <term name="season-01">Spring</term>
-    <term name="season-02">Summer</term>
-    <term name="season-03">Autumn</term>
-    <term name="season-04">Winter</term>
+    <term name="season-01">tavasz</term>
+    <term name="season-02">nyár</term>
+    <term name="season-03">ősz</term>
+    <term name="season-04">tél</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-id-ID.xml 0.5.1-1/citeproc/data/locales/locales-id-ID.xml
--- 0.3.0-6/citeproc/data/locales/locales-id-ID.xml	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-id-ID.xml	2020-04-06 16:40:32.000000000 +0000
@@ -0,0 +1,312 @@
+<?xml version="1.0" encoding="utf-8"?>
+<locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="id-ID">
+  <info>
+  <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
+    <updated>2015-08-05T23:31:02+00:00</updated>
+  </info>
+  <style-options punctuation-in-quote="true"/>
+  <date form="text">
+    <date-part name="day" suffix=" "/>
+    <date-part name="month" suffix=" "/>
+    <date-part name="year"/>
+  </date>
+  <date form="numeric">
+    <date-part name="day" form="numeric-leading-zeros" suffix="-"/>
+    <date-part name="month" form="numeric-leading-zeros" suffix="-"/>
+    <date-part name="year"/>
+  </date>
+  <terms>
+    <term name="accessed">diakses</term>
+    <term name="and">dan</term>
+    <term name="and others">dan lainnya</term>
+    <term name="anonymous">anonim</term>
+    <term name="anonymous" form="short">anon.</term>
+    <term name="at">pada</term>
+    <term name="available at">tersedia pada</term>
+    <term name="by">by</term>
+    <term name="circa">circa</term>
+    <term name="circa" form="short">c.</term>
+    <term name="cited">dikutip</term>
+    <term name="edition">
+      <single>edisi</single>
+      <multiple>edisi</multiple>
+    </term>
+    <term name="edition" form="short">ed.</term>
+    <term name="et-al">et al.</term>
+    <term name="forthcoming">mendatang</term>
+    <term name="from">dari</term>
+    <term name="ibid">ibid.</term>
+    <term name="in">in</term>
+    <term name="in press">in press</term>
+    <term name="internet">internet</term>
+    <term name="interview">wawancara</term>
+    <term name="letter">surat</term>
+    <term name="no date">tanpa tanggal</term>
+    <term name="no date" form="short">n.d.</term>
+    <term name="online">daring</term>
+    <term name="presented at">dipresentasikan pada</term>
+    <term name="reference">
+      <single>reference</single>
+      <multiple>references</multiple>
+    </term>
+    <term name="reference" form="short">
+      <single>ref.</single>
+      <multiple>ref.</multiple>
+    </term>
+    <term name="retrieved">diambil</term>
+    <term name="scale">skala</term>
+    <term name="version">versi</term>
+
+    <!-- ANNO DOMINI; BEFORE CHRIST -->
+    <term name="ad">M</term>
+    <term name="bc">SM</term>
+
+    <!-- PUNCTUATION -->
+    <term name="open-quote">“</term>
+    <term name="close-quote">”</term>
+    <term name="open-inner-quote">‘</term>
+    <term name="close-inner-quote">’</term>
+    <term name="page-range-delimiter">–</term>
+
+    <!-- ORDINALS -->
+    <term name="ordinal"></term>
+    <term name="ordinal-01"></term>
+    <term name="ordinal-02"></term>
+    <term name="ordinal-03"></term>
+    <term name="ordinal-11"></term>
+    <term name="ordinal-12"></term>
+    <term name="ordinal-13"></term>
+
+    <!-- LONG ORDINALS -->
+    <term name="long-ordinal-01">pertama</term>
+    <term name="long-ordinal-02">kedua</term>
+    <term name="long-ordinal-03">ketiga</term>
+    <term name="long-ordinal-04">keempat</term>
+    <term name="long-ordinal-05">kelima</term>
+    <term name="long-ordinal-06">keenam</term>
+    <term name="long-ordinal-07">ketujuh</term>
+    <term name="long-ordinal-08">kedelapan</term>
+    <term name="long-ordinal-09">kesembilan</term>
+    <term name="long-ordinal-10">kesepuluh</term>
+
+    <!-- LONG LOCATOR FORMS -->
+    <term name="book">
+      <single>buku</single>
+      <multiple>buku</multiple>
+    </term>
+    <term name="chapter">
+      <single>bab</single>
+      <multiple>bab</multiple>
+    </term>
+    <term name="column">
+      <single>kolom</single>
+      <multiple>kolom</multiple>
+    </term>
+    <term name="figure">
+      <single>gambar</single>
+      <multiple>gambar</multiple>
+    </term>
+    <term name="folio">
+      <single>folio</single>
+      <multiple>folio</multiple>
+    </term>
+    <term name="issue">
+      <single>nomor</single>
+      <multiple>nomor</multiple>
+    </term>
+    <term name="line">
+      <single>baris</single>
+      <multiple>baris</multiple>
+    </term>
+    <term name="note">
+      <single>catatan</single>
+      <multiple>catatan</multiple>
+    </term>
+    <term name="opus">
+      <single>opus</single>
+      <multiple>opera</multiple>
+    </term>
+    <term name="page">
+      <single>halaman</single>
+      <multiple>halaman</multiple>
+    </term>
+    <term name="number-of-pages">
+      <single>halaman</single>
+      <multiple>halaman</multiple>
+    </term>
+    <term name="paragraph">
+      <single>paragraf</single>
+      <multiple>paragraf</multiple>
+    </term>
+    <term name="part">
+      <single>bagian</single>
+      <multiple>bagian</multiple>
+    </term>
+    <term name="section">
+      <single>section</single>
+      <multiple>section</multiple>
+    </term>
+    <term name="sub verbo">
+      <single>sub verbo</single>
+      <multiple>sub verbis</multiple>
+    </term>
+    <term name="verse">
+      <single>ayat</single>
+      <multiple>ayat</multiple>
+    </term>
+    <term name="volume">
+      <single>volume</single>
+      <multiple>volume</multiple>
+    </term>
+
+    <!-- SHORT LOCATOR FORMS -->
+    <term name="book" form="short">bk.</term>
+    <term name="chapter" form="short">chap.</term>
+    <term name="column" form="short">col.</term>
+    <term name="figure" form="short">gam.</term>
+    <term name="folio" form="short">f.</term>
+    <term name="issue" form="short">no.</term>
+    <term name="line" form="short">l.</term>
+    <term name="note" form="short">n.</term>
+    <term name="opus" form="short">op.</term>
+    <term name="page" form="short">
+      <single>hal.</single>
+      <multiple>hal.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>hal.</single>
+      <multiple>hal.</multiple>
+    </term>
+    <term name="paragraph" form="short">para.</term>
+    <term name="part" form="short">pt.</term>
+    <term name="section" form="short">sec.</term>
+    <term name="sub verbo" form="short">
+      <single>s.v.</single>
+      <multiple>s.vv.</multiple>
+    </term>
+    <term name="verse" form="short">
+      <single>a.</single>
+      <multiple>a.</multiple>
+    </term>
+    <term name="volume" form="short">
+      <single>vol.</single>
+      <multiple>vol.</multiple>
+    </term>
+
+    <!-- SYMBOL LOCATOR FORMS -->
+    <term name="paragraph" form="symbol">
+      <single>¶</single>
+      <multiple>¶¶</multiple>
+    </term>
+    <term name="section" form="symbol">
+      <single>§</single>
+      <multiple>§§</multiple>
+    </term>
+
+    <!-- LONG ROLE FORMS -->
+    <term name="director">
+      <single>direktur</single>
+      <multiple>direktur</multiple>
+    </term>
+    <term name="editor">
+      <single>editor</single>
+      <multiple>editor</multiple>
+    </term>
+    <term name="editorial-director">
+      <single>editor</single>
+      <multiple>editor</multiple>
+    </term>
+    <term name="illustrator">
+      <single>ilustrator</single>
+      <multiple>ilustrator</multiple>
+    </term>
+    <term name="translator">
+      <single>penerjemah</single>
+      <multiple>penerjemah</multiple>
+    </term>
+    <term name="editortranslator">
+      <single>editor &amp; penerjemah</single>
+      <multiple>editor &amp; penerjemah</multiple>
+    </term>
+
+    <!-- SHORT ROLE FORMS -->
+    <term name="director" form="short">
+      <single>dir.</single>
+      <multiple>dirs.</multiple>
+    </term>
+    <term name="editor" form="short">
+      <single>ed.</single>
+      <multiple>ed.</multiple>
+    </term>
+    <term name="editorial-director" form="short">
+      <single>ed.</single>
+      <multiple>ed.</multiple>
+    </term>
+    <term name="illustrator" form="short">
+      <single>il.</single>
+      <multiple>il.</multiple>
+    </term>
+    <term name="translator" form="short">
+      <single>penerj.</single>
+      <multiple>penerj.</multiple>
+    </term>
+    <term name="editortranslator" form="short">
+      <single>ed. &amp; tran.</single>
+      <multiple>ed. &amp; tran.</multiple>
+    </term>
+
+    <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">oleh</term>
+    <term name="director" form="verb">diarahkan oleh</term>
+    <term name="editor" form="verb">diedit oleh</term>
+    <term name="editorial-director" form="verb">diedit oleh</term>
+    <term name="illustrator" form="verb">diilustrasi oleh</term>
+    <term name="interviewer" form="verb">interview oleh</term>
+    <term name="recipient" form="verb">kepada</term>
+    <term name="reviewed-author" form="verb">oleh</term>
+    <term name="translator" form="verb">diterjemahkan oleh</term>
+    <term name="editortranslator" form="verb">disunting &amp; diterjemahkan oleh</term>
+
+    <!-- SHORT VERB ROLE FORMS -->
+    <term name="director" form="verb-short">dir. oleh</term>
+    <term name="editor" form="verb-short">ed. oleh</term>
+    <term name="editorial-director" form="verb-short">ed. oleh</term>
+    <term name="illustrator" form="verb-short">illus. oleh</term>
+    <term name="translator" form="verb-short">trans. oleh</term>
+    <term name="editortranslator" form="verb-short">ed. &amp; trans. oleh</term>
+
+    <!-- LONG MONTH FORMS -->
+    <term name="month-01">Januari</term>
+    <term name="month-02">Februari</term>
+    <term name="month-03">Maret</term>
+    <term name="month-04">April</term>
+    <term name="month-05">Mei</term>
+    <term name="month-06">Juni</term>
+    <term name="month-07">Juli</term>
+    <term name="month-08">Agustus</term>
+    <term name="month-09">September</term>
+    <term name="month-10">Oktober</term>
+    <term name="month-11">November</term>
+    <term name="month-12">Desember</term>
+
+    <!-- SHORT MONTH FORMS -->
+    <term name="month-01" form="short">Jan</term>
+    <term name="month-02" form="short">Feb</term>
+    <term name="month-03" form="short">Mar</term>
+    <term name="month-04" form="short">Apr</term>
+    <term name="month-05" form="short">Mei</term>
+    <term name="month-06" form="short">Jun</term>
+    <term name="month-07" form="short">Jul</term>
+    <term name="month-08" form="short">Agu</term>
+    <term name="month-09" form="short">Sep</term>
+    <term name="month-10" form="short">Okt</term>
+    <term name="month-11" form="short">Nov</term>
+    <term name="month-12" form="short">Des</term>
+
+    <!-- SEASONS -->
+    <term name="season-01">Semi</term>
+    <term name="season-02">Panas</term>
+    <term name="season-03">Gugur</term>
+    <term name="season-04">Dingin</term>
+  </terms>
+</locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-is-IS.xml 0.5.1-1/citeproc/data/locales/locales-is-IS.xml
--- 0.3.0-6/citeproc/data/locales/locales-is-IS.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-is-IS.xml	2020-04-06 16:40:32.000000000 +0000
@@ -11,7 +11,7 @@
     <date-part name="year"/>
   </date>
   <date form="numeric">
-    <date-part name="day" suffix="."/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix="."/>
     <date-part name="year"/>
   </date>
@@ -22,7 +22,7 @@
     <term name="anonymous">nafnlaus</term>
     <term name="anonymous" form="short">nafnl.</term>
     <term name="at">af</term>
-    <term name="available at">available at</term>
+    <term name="available at">aðgengilegt á</term>
     <term name="by">eftir</term>
     <term name="circa">sirka</term>
     <term name="circa" form="short">u.þ.b.</term>
@@ -55,7 +55,7 @@
     </term>
     <term name="retrieved">sótt</term>
     <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="version">útgáfa</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
     <term name="ad">e.Kr.</term>
@@ -105,16 +105,16 @@
       <multiple>handrit</multiple>
     </term>
     <term name="issue">
-      <single>númer</single>
-      <multiple>númer</multiple>
+      <single>tölublað</single>
+      <multiple>tölublöð</multiple>
     </term>
     <term name="line">
       <single>lína</single>
       <multiple>línur</multiple>
     </term>
     <term name="note">
-      <single>skilaboð</single>
-      <multiple>skilaboð</multiple>
+      <single>athugasemd</single>
+      <multiple>athugasemdir</multiple>
     </term>
     <term name="opus">
       <single>tónverk</single>
@@ -124,6 +124,10 @@
       <single>blaðsíða</single>
       <multiple>blaðsíður</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>blaðsíða</single>
+      <multiple>blaðsíður</multiple>
+    </term>
     <term name="paragraph">
       <single>málsgrein</single>
       <multiple>málsgreinar</multiple>
@@ -150,19 +154,23 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">b.</term>
+    <term name="book" form="short">bók</term>
     <term name="chapter" form="short">k.</term>
     <term name="column" form="short">d.</term>
     <term name="figure" form="short">mynd.</term>
     <term name="folio" form="short">handr.</term>
-    <term name="issue" form="short">nr.</term>
+    <term name="issue" form="short">tbl.</term>
     <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="note" form="short">ath.</term>
     <term name="opus" form="short">tónv.</term>
     <term name="page" form="short">
       <single>bls.</single>
       <multiple>bls.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>bls.</single>
+      <multiple>bls.</multiple>
+    </term>
     <term name="paragraph" form="short">málsgr.</term>
     <term name="part" form="short">hl.</term>
     <term name="section" form="short">hl.</term>
@@ -175,8 +183,8 @@
       <multiple>v.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>bindi</single>
-      <multiple>bindi</multiple>
+      <single>b.</single>
+      <multiple>b.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -191,8 +199,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>leikstjóri</single>
+      <multiple>leikstjórar</multiple>
     </term>
     <term name="editor">
       <single>ritstjóri</single>
@@ -203,8 +211,8 @@
       <multiple>ritstjórar</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>höfundur myndskreytinga</single>
+      <multiple>höfundar myndskreytinga</multiple>
     </term>
     <term name="translator">
       <single>þýðandi</single>
@@ -217,8 +225,8 @@
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>leikstj.</single>
+      <multiple>leikstj.</multiple>
     </term>
     <term name="editor" form="short">
       <single>ritstj.</single>
@@ -229,8 +237,8 @@
       <multiple>ritstj.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>höf. mynd.</single>
+      <multiple>höf. mynd.</multiple>
     </term>
     <term name="translator" form="short">
       <single>þýð.</single>
@@ -242,24 +250,24 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">ritstjóri</term>
-    <term name="editorial-director" form="verb">ritstjóri</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="container-author" form="verb">eftir</term>
+    <term name="director" form="verb">leikstýrt af</term>
+    <term name="editor" form="verb">ritstýrt af</term>
+    <term name="editorial-director" form="verb">ritstýrt af</term>
+    <term name="illustrator" form="verb">myndskreytt af</term>
     <term name="interviewer" form="verb">viðtal tók</term>
     <term name="recipient" form="verb">til</term>
     <term name="reviewed-author" form="verb">by</term>
     <term name="translator" form="verb">þýddi</term>
-    <term name="editortranslator" form="verb">ritstjóri og þýðandi</term>
+    <term name="editortranslator" form="verb">ritstýrt og þýtt af</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">eftir</term>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ritst.</term>
-    <term name="editorial-director" form="verb-short">ritst.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="director" form="verb-short">leikstj.</term>
+    <term name="editor" form="verb-short">ritstj.</term>
+    <term name="editorial-director" form="verb-short">ritstj.</term>
+    <term name="illustrator" form="verb-short">myndskr.</term>
     <term name="translator" form="verb-short">þýð.</term>
-    <term name="editortranslator" form="verb-short">ritst. og þýð.</term>
+    <term name="editortranslator" form="verb-short">ritstj. og þýð.</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">janúar</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-it-IT.xml 0.5.1-1/citeproc/data/locales/locales-it-IT.xml
--- 0.3.0-6/citeproc/data/locales/locales-it-IT.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-it-IT.xml	2020-04-06 16:40:32.000000000 +0000
@@ -124,6 +124,10 @@
       <single>pagina</single>
       <multiple>pagine</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>pagina</single>
+      <multiple>pagine</multiple>
+    </term>
     <term name="paragraph">
       <single>capoverso</single>
       <multiple>capoversi</multiple>
@@ -163,6 +167,10 @@
       <single>pag.</single>
       <multiple>pagg.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>pag.</single>
+      <multiple>pagg.</multiple>
+    </term>
     <term name="paragraph" form="short">cpv.</term>
     <term name="part" form="short">pt.</term>
     <term name="section" form="short">par.</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">di</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">a cura di</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">a cura di e tradotto da</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">di</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">a c. di</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ja-JP.xml 0.5.1-1/citeproc/data/locales/locales-ja-JP.xml
--- 0.3.0-6/citeproc/data/locales/locales-ja-JP.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ja-JP.xml	2020-04-06 16:40:32.000000000 +0000
@@ -16,7 +16,7 @@
     <date-part name="day" suffix="日"/>
   </date>
   <terms>
-    <term name="accessed">アクセス</term>
+    <term name="accessed">参照</term>
     <term name="and">と</term>
     <term name="and others">and others</term>
     <term name="anonymous">anonymous</term>
@@ -28,15 +28,15 @@
     <term name="circa" form="short">c.</term>
     <term name="cited">cited</term>
     <term name="edition">
-      <single>edition</single>
-      <multiple>editions</multiple>
+      <single>版</single>
+      <multiple>版</multiple>
     </term>
-    <term name="edition" form="short">ed</term>
-    <term name="et-al">他</term>
+    <term name="edition" form="short">版</term>
+    <term name="et-al">ほか</term>
     <term name="forthcoming">近刊</term>
     <term name="from">から</term>
     <term name="ibid">前掲</term>
-    <term name="in"/>
+    <term name="in"></term>
     <term name="in press">in press</term>
     <term name="internet">internet</term>
     <term name="interview">interview</term>
@@ -130,6 +130,10 @@
       <single>ページ</single>
       <multiple>ページ</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>ページ</single>
+      <multiple>ページ</multiple>
+    </term>
     <term name="paragraph">
       <single>段落</single>
       <multiple>段落</multiple>
@@ -156,33 +160,37 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">bk</term>
-    <term name="chapter" form="short">chap</term>
-    <term name="column" form="short">col</term>
-    <term name="figure" form="short">fig</term>
-    <term name="folio" form="short">f</term>
-    <term name="issue" form="short">号</term>
+    <term name="book" form="short">bk.</term>
+    <term name="chapter" form="short">chap.</term>
+    <term name="column" form="short">col.</term>
+    <term name="figure" form="short">fig.</term>
+    <term name="folio" form="short">f.</term>
+    <term name="issue" form="short">no.</term>
     <term name="line" form="short">l.</term>
     <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="opus" form="short">op.</term>
     <term name="page" form="short">
-      <single>p</single>
-      <multiple>p</multiple>
+      <single>p.</single>
+      <multiple>pp.</multiple>
     </term>
-    <term name="paragraph" form="short">para</term>
-    <term name="part" form="short">pt</term>
-    <term name="section" form="short">sec</term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="paragraph" form="short">para.</term>
+    <term name="part" form="short">pt.</term>
+    <term name="section" form="short">sec.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
     </term>
     <term name="verse" form="short">
-      <single>v</single>
-      <multiple>vv</multiple>
+      <single>v.</single>
+      <multiple>vv.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>vol</single>
-      <multiple>vols</multiple>
+      <single>vol.</single>
+      <multiple>vols.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -201,8 +209,8 @@
       <multiple>directors</multiple>
     </term>
     <term name="editor">
-      <single>編集者</single>
-      <multiple>編集者</multiple>
+      <single>編</single>
+      <multiple>編</multiple>
     </term>
     <term name="editorial-director">
       <single>editor</single>
@@ -227,8 +235,8 @@
       <multiple>dirs.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>編集者</single>
-      <multiple>編集者</multiple>
+      <single>編</single>
+      <multiple>編</multiple>
     </term>
     <term name="editorial-director" form="short">
       <single>ed.</single>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">編集者：</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,12 +268,11 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ed</term>
+    <term name="editor" form="verb-short">編集者：</term>
     <term name="editorial-director" form="verb-short">ed.</term>
     <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">trans</term>
+    <term name="translator" form="verb-short">翻訳者：</term>
     <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
 
     <!-- LONG MONTH FORMS -->
diff -pruN 0.3.0-6/citeproc/data/locales/locales.json 0.5.1-1/citeproc/data/locales/locales.json
--- 0.3.0-6/citeproc/data/locales/locales.json	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales.json	2020-04-06 16:40:32.000000000 +0000
@@ -0,0 +1,258 @@
+{
+    "primary-dialects": {
+        "af": "af-ZA",
+        "ar": "ar",
+        "bg": "bg-BG",
+        "ca": "ca-AD",
+        "cs": "cs-CZ",
+        "cy": "cy-GB",
+        "da": "da-DK",
+        "de": "de-DE",
+        "el": "el-GR",
+        "en": "en-US",
+        "es": "es-ES",
+        "et": "et-EE",
+        "eu": "eu",
+        "fa": "fa-IR",
+        "fi": "fi-FI",
+        "fr": "fr-FR",
+        "he": "he-IL",
+        "hr": "hr-HR",
+        "hu": "hu-HU",
+        "id": "id-ID",
+        "is": "is-IS",
+        "it": "it-IT",
+        "ja": "ja-JP",
+        "km": "km-KH",
+        "ko": "ko-KR",
+        "lt": "lt-LT",
+        "lv": "lv-LV",
+        "mn": "mn-MN",
+        "nb": "nb-NO",
+        "nl": "nl-NL",
+        "nn": "nn-NO",
+        "pl": "pl-PL",
+        "pt": "pt-PT",
+        "ro": "ro-RO",
+        "ru": "ru-RU",
+        "sk": "sk-SK",
+        "sl": "sl-SI",
+        "sr": "sr-RS",
+        "sv": "sv-SE",
+        "th": "th-TH",
+        "tr": "tr-TR",
+        "uk": "uk-UA",
+        "vi": "vi-VN",
+        "zh": "zh-CN"
+    },
+    "language-names": {
+        "af-ZA": [
+            "Afrikaans",
+            "Afrikaans"
+        ],
+        "ar": [
+            "العربية",
+            "Arabic"
+        ],
+        "bg-BG": [
+            "Български",
+            "Bulgarian"
+        ],
+        "ca-AD": [
+            "Català",
+            "Catalan"
+        ],
+        "cs-CZ": [
+            "Čeština",
+            "Czech"
+        ],
+        "cy-GB": [
+            "Cymraeg",
+            "Welsh"
+        ],
+        "da-DK": [
+            "Dansk",
+            "Danish"
+        ],
+        "de-AT": [
+            "Deutsch (Österreich)",
+            "German (Austria)"
+        ],
+        "de-CH": [
+            "Deutsch (Schweiz)",
+            "German (Switzerland)"
+        ],
+        "de-DE": [
+            "Deutsch (Deutschland)",
+            "German (Germany)"
+        ],
+        "el-GR": [
+            "Ελληνικά",
+            "Greek"
+        ],
+        "en-GB": [
+            "English (UK)",
+            "English (UK)"
+        ],
+        "en-US": [
+            "English (US)",
+            "English (US)"
+        ],
+        "es-CL": [
+            "Español (Chile)",
+            "Spanish (Chile)"
+        ],
+        "es-ES": [
+            "Español (España)",
+            "Spanish (Spain)"
+        ],
+        "es-MX": [
+            "Español (México)",
+            "Spanish (Mexico)"
+        ],
+        "et-EE": [
+            "Eesti",
+            "Estonian"
+        ],
+        "eu": [
+            "Euskara",
+            "Basque"
+        ],
+        "fa-IR": [
+            "فارسی",
+            "Persian"
+        ],
+        "fi-FI": [
+            "Suomi",
+            "Finnish"
+        ],
+        "fr-CA": [
+            "Français (Canada)",
+            "French (Canada)"
+        ],
+        "fr-FR": [
+            "Français (France)",
+            "French (France)"
+        ],
+        "he-IL": [
+            "עברית",
+            "Hebrew"
+        ],
+        "hr-HR": [
+            "Hrvatski",
+            "Croatian"
+        ],
+        "hu-HU": [
+            "Magyar",
+            "Hungarian"
+        ],
+        "id-ID": [
+            "Bahasa Indonesia",
+            "Indonesian"    
+        ],
+        "is-IS": [
+            "Íslenska",
+            "Icelandic"
+        ],
+        "it-IT": [
+            "Italiano",
+            "Italian"
+        ],
+        "ja-JP": [
+            "日本語",
+            "Japanese"
+        ],
+        "km-KH": [
+            "ភាសាខ្មែរ",
+            "Khmer"
+        ],
+        "ko-KR": [
+            "한국어",
+            "Korean"
+        ],
+        "lt-LT": [
+            "Lietuvių",
+            "Lithuanian"
+        ],
+        "lv-LV": [
+            "Latviešu",
+            "Latvian"
+        ],
+        "mn-MN": [
+            "Монгол",
+            "Mongolian"
+        ],
+        "nb-NO": [
+            "Norsk bokmål",
+            "Norwegian (Bokmål)"
+        ],
+        "nl-NL": [
+            "Nederlands",
+            "Dutch"
+        ],
+        "nn-NO": [
+            "Norsk nynorsk",
+            "Norwegian (Nynorsk)"
+        ],
+        "pl-PL": [
+            "Polski",
+            "Polish"
+        ],
+        "pt-BR": [
+            "Português (Brasil)",
+            "Portuguese (Brazil)"
+        ],
+        "pt-PT": [
+            "Português (Portugal)",
+            "Portuguese (Portugal)"
+        ],
+        "ro-RO": [
+            "Română",
+            "Romanian"
+        ],
+        "ru-RU": [
+            "Русский",
+            "Russian"
+        ],
+        "sk-SK": [
+            "Slovenčina",
+            "Slovak"
+        ],
+        "sl-SI": [
+            "Slovenščina",
+            "Slovenian"
+        ],
+        "sr-RS": [
+            "Српски / Srpski",
+            "Serbian"
+        ],
+        "sv-SE": [
+            "Svenska",
+            "Swedish"
+        ],
+        "th-TH": [
+            "ไทย",
+            "Thai"
+        ],
+        "tr-TR": [
+            "Türkçe",
+            "Turkish"
+        ],
+        "uk-UA": [
+            "Українська",
+            "Ukrainian"
+        ],
+        "vi-VN": [
+            "Tiếng Việt",
+            "Vietnamese"
+        ],
+        "zh-CN": [
+            "中文 (中国大陆)",
+            "Chinese (PRC)"
+        ],
+        "zh-TW": [
+            "中文 (台灣)",
+            "Chinese (Taiwan)"
+        ]
+    }
+}
diff -pruN 0.3.0-6/citeproc/data/locales/locales-km-KH.xml 0.5.1-1/citeproc/data/locales/locales-km-KH.xml
--- 0.3.0-6/citeproc/data/locales/locales-km-KH.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-km-KH.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>ទំព័រ</single>
       <multiple>ទំព័រ</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>ទំព័រ</single>
+      <multiple>ទំព័រ</multiple>
+    </term>
     <term name="paragraph">
       <single>កថាខណ្ឌ</single>
       <multiple>កថាខណ្ឌ</multiple>
@@ -169,6 +173,10 @@
       <single>p.</single>
       <multiple>pp.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
     <term name="paragraph" form="short">para.</term>
     <term name="part" form="short">pt.</term>
     <term name="section" form="short">sec.</term>
@@ -205,7 +213,7 @@
       <multiple>editors</multiple>
     </term>
     <term name="editorial-director">
-      <single/>
+      <single></single>
       <multiple>editors</multiple>
     </term>
     <term name="illustrator">
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">edited by</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ko-KR.xml 0.5.1-1/citeproc/data/locales/locales-ko-KR.xml
--- 0.3.0-6/citeproc/data/locales/locales-ko-KR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ko-KR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>페이지</single>
       <multiple>페이지</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>페이지</single>
+      <multiple>페이지</multiple>
+    </term>
     <term name="paragraph">
       <single>단락</single>
       <multiple>단락</multiple>
@@ -169,6 +173,10 @@
       <single>p</single>
       <multiple>pp</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p</single>
+      <multiple>pp</multiple>
+    </term>
     <term name="paragraph" form="short">para</term>
     <term name="part" form="short">pt</term>
     <term name="section" form="short">sec</term>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">편집자：</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-lt-LT.xml 0.5.1-1/citeproc/data/locales/locales-lt-LT.xml
--- 0.3.0-6/citeproc/data/locales/locales-lt-LT.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-lt-LT.xml	2020-04-06 16:40:32.000000000 +0000
@@ -5,18 +5,16 @@
       <name>Valdemaras Klumbys</name>
     </translator>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2017-01-18T10:31:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text" delimiter=" ">
-
     <!-- "2011 m. lapkričio 1 d." -->
     <date-part name="year" suffix=" m."/>
     <date-part name="month"/>
     <date-part name="day" form="numeric" suffix=" d."/>
   </date>
   <date form="numeric" delimiter="-">
-
     <!-- "2011-11-01" -->
     <date-part name="year"/>
     <date-part name="month" form="numeric-leading-zeros"/>
@@ -28,23 +26,23 @@
     <term name="and others">ir kt.</term>
     <term name="anonymous">anonimas</term>
     <term name="anonymous" form="short">anon.</term>
-    <term name="at"/>
-    <term name="available at">available at</term>
-    <term name="by"/>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">ca.</term>
-    <term name="cited">cituojama pagal</term>
-    <term name="edition">
+    <term name="at"></term>
+    <term name="available at">adresas</term>
+    <term name="by"></term>
+    <term name="circa">apie</term>
+    <term name="circa" form="short">apie</term>
+    <term name="cited">žiūrėta</term>
+    <term name="edition" gender="masculine">
       <single>leidimas</single>
       <multiple>leidimai</multiple>
     </term>
     <term name="edition" form="short">leid.</term>
-    <term name="et-al">et al.</term>
+    <term name="et-al">ir kt.</term>
     <term name="forthcoming">ruošiamas</term>
-    <term name="from"/>
-    <term name="ibid">ibid.</term>
-    <term name="in"/>
-    <term name="in press">spaudoje</term>
+    <term name="from"></term>
+    <term name="ibid">ten pat</term>
+    <term name="in"></term>
+    <term name="in press">priimta spaudai</term>
     <term name="internet">prieiga per internetą</term>
     <term name="interview">interviu</term>
     <term name="letter">laiškas</term>
@@ -61,8 +59,8 @@
       <multiple>nuor.</multiple>
     </term>
     <term name="retrieved">gauta</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">mastelis</term>
+    <term name="version">versija</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
     <term name="ad">po Kr.</term>
@@ -77,6 +75,12 @@
 
     <!-- ORDINALS -->
     <term name="ordinal">-asis</term>
+    <term name="ordinal" gender-form="masculine">-asis</term>
+    <term name="ordinal" gender-form="feminine">-oji</term>
+    <term name="ordinal-03" gender-form="masculine">-iasis</term>
+    <term name="ordinal-13" gender-form="masculine">-asis</term>
+    <term name="ordinal-03" gender-form="feminine">-ioji</term>
+    <term name="ordinal-13" gender-form="feminine">-oji</term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">pirmasis</term>
@@ -90,6 +94,17 @@
     <term name="long-ordinal-09">devintasis</term>
     <term name="long-ordinal-10">dešimtasis</term>
 
+    <term name="long-ordinal-01" gender-form="feminine">pirmoji</term>
+    <term name="long-ordinal-02" gender-form="feminine">antroji</term>
+    <term name="long-ordinal-03" gender-form="feminine">trečioji</term>
+    <term name="long-ordinal-04" gender-form="feminine">ketvirtoji</term>
+    <term name="long-ordinal-05" gender-form="feminine">penktoji</term>
+    <term name="long-ordinal-06" gender-form="feminine">šeštoji</term>
+    <term name="long-ordinal-07" gender-form="feminine">septintoji</term>
+    <term name="long-ordinal-08" gender-form="feminine">aštuntoji</term>
+    <term name="long-ordinal-09" gender-form="feminine">devintoji</term>
+    <term name="long-ordinal-10" gender-form="feminine">dešimtoji</term>
+    
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
       <single>knyga</single>
@@ -111,7 +126,7 @@
       <single>lapas</single>
       <multiple>lapai</multiple>
     </term>
-    <term name="issue">
+    <term name="issue" gender="masculine">
       <single>numeris</single>
       <multiple>numeriai</multiple>
     </term>
@@ -124,13 +139,17 @@
       <multiple>pastabos</multiple>
     </term>
     <term name="opus">
-      <single>opus</single>
-      <multiple>opera</multiple>
+      <single>kūrinys</single>
+      <multiple>kūriniai</multiple>
     </term>
     <term name="page">
       <single>puslapis</single>
       <multiple>puslapiai</multiple>
     </term>
+    <term name="number-of-pages" gender="masculine">
+      <single>puslapis</single>
+      <multiple>puslapiai</multiple>
+    </term>
     <term name="paragraph">
       <single>pastraipa</single>
       <multiple>pastraipos</multiple>
@@ -151,7 +170,7 @@
       <single>eilėraštis</single>
       <multiple>eilėraščiai</multiple>
     </term>
-    <term name="volume">
+    <term name="volume" gender="masculine">
       <single>tomas</single>
       <multiple>tomai</multiple>
     </term>
@@ -163,13 +182,17 @@
     <term name="figure" form="short">il.</term>
     <term name="folio" form="short">l.</term>
     <term name="issue" form="short">nr.</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op.</term>
+    <term name="line" form="short">eil.</term>
+    <term name="note" form="short">pstb.</term>
+    <term name="opus" form="short">kūr.</term>
     <term name="page" form="short">
       <single>p.</single>
       <multiple>p.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>p.</multiple>
+    </term>
     <term name="paragraph" form="short">pastr.</term>
     <term name="part" form="short">d.</term>
     <term name="section" form="short">posk.</term>
@@ -198,8 +221,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>vadovas</single>
+      <multiple>vadovai</multiple>
     </term>
     <term name="editor">
       <single>sudarytojas</single>
@@ -210,8 +233,8 @@
       <multiple>atsakingieji redaktoriai</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>iliustratorius</single>
+      <multiple>iliustratoriai</multiple>
     </term>
     <term name="translator">
       <single>vertėjas</single>
@@ -224,8 +247,8 @@
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>vad.</single>
+      <multiple>vad.</multiple>
     </term>
     <term name="editor" form="short">
       <single>sud.</single>
@@ -236,8 +259,8 @@
       <multiple>ats. red.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>iliustr.</single>
+      <multiple>iliustr.</multiple>
     </term>
     <term name="translator" form="short">
       <single>vert.</single>
@@ -249,22 +272,22 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb"></term>
+    <term name="director" form="verb">vadovavo</term>
     <term name="editor" form="verb">sudarė</term>
     <term name="editorial-director" form="verb">parengė</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">iliustravo</term>
     <term name="interviewer" form="verb">interviu ėmė</term>
     <term name="recipient" form="verb">gavo</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">recenzavo</term>
     <term name="translator" form="verb">vertė</term>
     <term name="editortranslator" form="verb">sudarė ir vertė</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">vad.</term>
     <term name="editor" form="verb-short">sud.</term>
     <term name="editorial-director" form="verb-short">pareng.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">iliustr.</term>
     <term name="translator" form="verb-short">vert.</term>
     <term name="editortranslator" form="verb-short">sud. ir vert.</term>
 
diff -pruN 0.3.0-6/citeproc/data/locales/locales-lv-LV.xml 0.5.1-1/citeproc/data/locales/locales-lv-LV.xml
--- 0.3.0-6/citeproc/data/locales/locales-lv-LV.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-lv-LV.xml	2020-04-06 16:40:32.000000000 +0000
@@ -27,10 +27,10 @@
     <term name="and others">un citi</term>
     <term name="anonymous">anonīms</term>
     <term name="anonymous" form="short">anon.</term>
-    <term name="at"/>
+    <term name="at"></term>
     <term name="available at">pieejams</term>
     <term name="bc">p.m.ē.</term>
-    <term name="by"/>
+    <term name="by"></term>
     <term name="circa">apmēram</term>
     <term name="circa" form="short">apm.</term>
     <term name="cited">citēts</term>
@@ -139,6 +139,10 @@
       <single>lappuse</single>
       <multiple>lappuses</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>lappuse</single>
+      <multiple>lappuses</multiple>
+    </term>
     <term name="paragraph">
       <single>rindkopa</single>
       <multiple>rindkopas</multiple>
@@ -178,6 +182,10 @@
       <single>lpp.</single>
       <multiple>lpp.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>lpp.</single>
+      <multiple>lpp.</multiple>
+    </term>
     <term name="paragraph" form="short">rindk.</term>
     <term name="part" form="short">d.</term>
     <term name="section" form="short">apakšnod.</term>
@@ -297,6 +305,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb"></term>
     <term name="composer" form="verb">sastādīja</term>
     <term name="director" form="verb">vadīja</term>
     <term name="editor" form="verb">sagatavoja</term>
@@ -308,7 +317,6 @@
     <term name="translator" form="verb">tulkoja</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
     <term name="director" form="verb-short">sast.</term>
     <term name="editor" form="verb-short">sag.</term>
     <term name="editorial-director" form="verb-short">sag.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-mn-MN.xml 0.5.1-1/citeproc/data/locales/locales-mn-MN.xml
--- 0.3.0-6/citeproc/data/locales/locales-mn-MN.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-mn-MN.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>page</single>
       <multiple>pages</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>page</single>
+      <multiple>pages</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraph</single>
       <multiple>paragraph</multiple>
@@ -169,6 +173,10 @@
       <single>p</single>
       <multiple>pp</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p</single>
+      <multiple>pp</multiple>
+    </term>
     <term name="paragraph" form="short">para</term>
     <term name="part" form="short">pt</term>
     <term name="section" form="short">sec</term>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">edited by</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-nb-NO.xml 0.5.1-1/citeproc/data/locales/locales-nb-NO.xml
--- 0.3.0-6/citeproc/data/locales/locales-nb-NO.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-nb-NO.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -124,6 +124,10 @@
       <single>side</single>
       <multiple>sider</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>side</single>
+      <multiple>sider</multiple>
+    </term>
     <term name="paragraph">
       <single>avsnitt</single>
       <multiple>avsnitt</multiple>
@@ -163,6 +167,10 @@
       <single>s.</single>
       <multiple>s.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
     <term name="paragraph" form="short">avsn.</term>
     <term name="part" form="short">d.</term>
     <term name="section" form="short">pargr.</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">av</term>
     <term name="director" form="verb">regissert av</term>
     <term name="editor" form="verb">redigert av</term>
     <term name="editorial-director" form="verb">redigert av</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">redigert &amp; oversatt av</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">av</term>
     <term name="director" form="verb-short">regi</term>
     <term name="editor" form="verb-short">red.</term>
     <term name="editorial-director" form="verb-short">red.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-nl-NL.xml 0.5.1-1/citeproc/data/locales/locales-nl-NL.xml
--- 0.3.0-6/citeproc/data/locales/locales-nl-NL.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-nl-NL.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
       <uri>http://twitter.com/rintzezelle</uri>
     </translator>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2017-04-01T12:00:00+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -20,7 +20,7 @@
     <date-part name="year"/>
   </date>
   <terms>
-    <term name="accessed">bezocht</term>
+    <term name="accessed">geraadpleegd</term>
     <term name="and">en</term>
     <term name="and others">en anderen</term>
     <term name="anonymous">anoniem</term>
@@ -32,10 +32,10 @@
     <term name="circa" form="short">c.</term>
     <term name="cited">geciteerd</term>
     <term name="edition">
-      <single>editie</single>
-      <multiple>edities</multiple>
+      <single>druk</single>
+      <multiple>drukken</multiple>
     </term>
-    <term name="edition" form="short">ed.</term>
+    <term name="edition" form="short">dr.</term>
     <term name="et-al">e.a.</term>
     <term name="forthcoming">in voorbereiding</term>
     <term name="from">van</term>
@@ -146,6 +146,10 @@
       <single>pagina</single>
       <multiple>pagina's</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>pagina</single>
+      <multiple>pagina's</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraaf</single>
       <multiple>paragrafen</multiple>
@@ -185,6 +189,10 @@
       <single>p.</single>
       <multiple>pp.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
     <term name="paragraph" form="short">par.</term>
     <term name="part" form="short">deel</term>
     <term name="section" form="short">sec.</term>
@@ -264,9 +272,10 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">door</term>
     <term name="director" form="verb">geregisseerd door</term>
-    <term name="editor" form="verb">bewerkt door</term>
-    <term name="editorial-director" form="verb">bewerkt door</term>
+    <term name="editor" form="verb">onder redactie van</term>
+    <term name="editorial-director" form="verb">onder redactie van</term>
     <term name="illustrator" form="verb">geïllustreerd door</term>
     <term name="interviewer" form="verb">geïnterviewd door</term>
     <term name="recipient" form="verb">ontvangen door</term>
@@ -275,9 +284,8 @@
     <term name="editortranslator" form="verb">bewerkt &amp; vertaald door</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">door</term>
     <term name="director" form="verb-short">geregisseerd door</term>
-    <term name="editor" form="verb-short">bewerkt door</term>
+    <term name="editor" form="verb-short">onder redactie van</term>
     <term name="editorial-director" form="verb-short">bewerkt door</term>
     <term name="illustrator" form="verb-short">geïllustreerd door</term>
     <term name="translator" form="verb-short">vertaald door</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-nn-NO.xml 0.5.1-1/citeproc/data/locales/locales-nn-NO.xml
--- 0.3.0-6/citeproc/data/locales/locales-nn-NO.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-nn-NO.xml	2020-04-06 16:40:32.000000000 +0000
@@ -6,7 +6,7 @@
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" suffix=". "/>
+    <date-part name="day" form="ordinal" suffix=" "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year"/>
   </date>
@@ -124,6 +124,10 @@
       <single>side</single>
       <multiple>sider</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>side</single>
+      <multiple>sider</multiple>
+    </term>
     <term name="paragraph">
       <single>avsnitt</single>
       <multiple>avsnitt</multiple>
@@ -163,6 +167,10 @@
       <single>s.</single>
       <multiple>s.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
     <term name="paragraph" form="short">avsn.</term>
     <term name="part" form="short">d.</term>
     <term name="section" form="short">par.</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">av</term>
     <term name="director" form="verb">regissert av</term>
     <term name="editor" form="verb">redigert av</term>
     <term name="editorial-director" form="verb">redigert av</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">redigert &amp; omsett av</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">av</term>
     <term name="director" form="verb-short">regi</term>
     <term name="editor" form="verb-short">red.</term>
     <term name="editorial-director" form="verb-short">red.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-pl-PL.xml 0.5.1-1/citeproc/data/locales/locales-pl-PL.xml
--- 0.3.0-6/citeproc/data/locales/locales-pl-PL.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-pl-PL.xml	2020-04-06 16:40:32.000000000 +0000
@@ -109,8 +109,8 @@
       <multiple>numery</multiple>
     </term>
     <term name="line">
-      <single>wers</single>
-      <multiple>wersy</multiple>
+      <single>wiersz</single>
+      <multiple>wiersze</multiple>
     </term>
     <term name="note">
       <single>notatka</single>
@@ -124,6 +124,10 @@
       <single>strona</single>
       <multiple>strony</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>strona</single>
+      <multiple>strony</multiple>
+    </term>
     <term name="paragraph">
       <single>akapit</single>
       <multiple>akapity</multiple>
@@ -161,6 +165,10 @@
     <term name="opus" form="short">op.</term>
     <term name="page" form="short">
       <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
       <multiple>ss.</multiple>
     </term>
     <term name="paragraph" form="short">akap.</term>
@@ -217,8 +225,8 @@
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dyr.</single>
-      <multiple>dyr.</multiple>
+      <single>reż.</single>
+      <multiple>reż.</multiple>
     </term>
     <term name="editor" form="short">
       <single>red.</single>
@@ -242,10 +250,11 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">przez</term>
+    <term name="director" form="verb">reżyserowane przez</term>
     <term name="editor" form="verb">zredagowane przez</term>
     <term name="editorial-director" form="verb">zredagowane przez</term>
-    <term name="illustrator" form="verb">ilustrowane przez by</term>
+    <term name="illustrator" form="verb">ilustrowane przez</term>
     <term name="interviewer" form="verb">przeprowadzony przez</term>
     <term name="recipient" form="verb">dla</term>
     <term name="reviewed-author" form="verb">przez</term>
@@ -253,8 +262,7 @@
     <term name="editortranslator" form="verb">zredagowane i przetłumaczone przez</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">przez</term>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">reż.</term>
     <term name="editor" form="verb-short">red.</term>
     <term name="editorial-director" form="verb-short">red.</term>
     <term name="illustrator" form="verb-short">il.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-pt-BR.xml 0.5.1-1/citeproc/data/locales/locales-pt-BR.xml
--- 0.3.0-6/citeproc/data/locales/locales-pt-BR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-pt-BR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -1,12 +1,12 @@
 <?xml version="1.0" encoding="utf-8"?>
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="pt-BR">
   <info>
+    <updated>2016-05-16T00:00:00+03:00</updated>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
   </info>
-  <style-options punctuation-in-quote="false"/>
+  <style-options punctuation-in-quote="false" limit-day-ordinals-to-day-1="true"/>
   <date form="text">
-    <date-part name="day" suffix=" de "/>
+    <date-part name="day" form="ordinal" suffix=" de "/>
     <date-part name="month" suffix=" de "/>
     <date-part name="year"/>
   </date>
@@ -22,7 +22,7 @@
     <term name="anonymous">anônimo</term>
     <term name="anonymous" form="short">anon</term>
     <term name="at">em</term>
-    <term name="available at">available at</term>
+    <term name="available at">disponível em</term>
     <term name="by">por</term>
     <term name="circa">circa</term>
     <term name="circa" form="short">c.</term>
@@ -54,34 +54,46 @@
       <multiple>refs.</multiple>
     </term>
     <term name="retrieved">recuperado</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">escala</term>
+    <term name="version">versão</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">DC</term>
+    <term name="bc">AC</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">“</term>
     <term name="close-quote">”</term>
     <term name="open-inner-quote">‘</term>
     <term name="close-inner-quote">’</term>
-    <term name="page-range-delimiter">–</term>
+    <term name="page-range-delimiter">&#8211;</term>
 
     <!-- ORDINALS -->
     <term name="ordinal">º</term>
+    <term name="ordinal-01" gender-form="feminine" match="whole-number">ª</term>
+    <term name="ordinal-01" gender-form="masculine" match="whole-number">º</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">primeiro</term>
-    <term name="long-ordinal-02">segundo</term>
-    <term name="long-ordinal-03">terceiro</term>
-    <term name="long-ordinal-04">quarto</term>
-    <term name="long-ordinal-05">quinto</term>
-    <term name="long-ordinal-06">sexto</term>
-    <term name="long-ordinal-07">sétimo</term>
-    <term name="long-ordinal-08">oitavo</term>
-    <term name="long-ordinal-09">nono</term>
-    <term name="long-ordinal-10">décimo</term>
+    <term name="long-ordinal-01" gender-form="masculine">primeiro</term>
+    <term name="long-ordinal-02" gender-form="masculine">segundo</term>
+    <term name="long-ordinal-03" gender-form="masculine">terceiro</term>
+    <term name="long-ordinal-04" gender-form="masculine">quarto</term>
+    <term name="long-ordinal-05" gender-form="masculine">quinto</term>
+    <term name="long-ordinal-06" gender-form="masculine">sexto</term>
+    <term name="long-ordinal-07" gender-form="masculine">sétimo</term>
+    <term name="long-ordinal-08" gender-form="masculine">oitavo</term>
+    <term name="long-ordinal-09" gender-form="masculine">nono</term>
+    <term name="long-ordinal-10" gender-form="masculine">décimo</term>
+    <term name="long-ordinal-01" gender-form="feminine">primeira</term>
+    <term name="long-ordinal-02" gender-form="feminine">segunda</term>
+    <term name="long-ordinal-03" gender-form="feminine">terceira</term>
+    <term name="long-ordinal-04" gender-form="feminine">quarta</term>
+    <term name="long-ordinal-05" gender-form="feminine">quinta</term>
+    <term name="long-ordinal-06" gender-form="feminine">sexta</term>
+    <term name="long-ordinal-07" gender-form="feminine">sétima</term>
+    <term name="long-ordinal-08" gender-form="feminine">oitava</term>
+    <term name="long-ordinal-09" gender-form="feminine">nona</term>
+    <term name="long-ordinal-10" gender-form="feminine">décima</term>
 
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
@@ -124,6 +136,10 @@
       <single>página</single>
       <multiple>páginas</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
     <term name="paragraph">
       <single>parágrafo</single>
       <multiple>parágrafos</multiple>
@@ -163,6 +179,10 @@
       <single>p.</single>
       <multiple>p.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>p.</multiple>
+    </term>
     <term name="paragraph" form="short">parag.</term>
     <term name="part" form="short">pt.</term>
     <term name="section" form="short">seç.</term>
@@ -191,8 +211,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>diretor</single>
+      <multiple>diretores</multiple>
     </term>
     <term name="editor">
       <single>organizador</single>
@@ -200,11 +220,11 @@
     </term>
     <term name="editorial-director">
       <single>editor</single>
-      <multiple>editors</multiple>
+      <multiple>editores</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>ilustrador</single>
+      <multiple>ilustradores</multiple>
     </term>
     <term name="translator">
       <single>tradutor</single>
@@ -229,8 +249,8 @@
       <multiple>eds.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>il.</single>
+      <multiple>ils.</multiple>
     </term>
     <term name="translator" form="short">
       <single>trad.</single>
@@ -242,22 +262,22 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">por</term>
+    <term name="director" form="verb">dirigido por</term>
     <term name="editor" form="verb">organizado por</term>
     <term name="editorial-director" form="verb">editado por</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="illustrator" form="verb">ilustrado por</term>
     <term name="interviewer" form="verb">entrevista de</term>
     <term name="recipient" form="verb">para</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">por</term>
     <term name="translator" form="verb">traduzido por</term>
-    <term name="editortranslator" form="verb">editado &amp; traduzido por</term>
+    <term name="editortranslator" form="verb">editado e traduzido por</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">por</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">org.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">ilus.</term>
     <term name="translator" form="verb-short">trad.</term>
     <term name="editortranslator" form="verb-short">ed. e trad. por</term>
 
diff -pruN 0.3.0-6/citeproc/data/locales/locales-pt-PT.xml 0.5.1-1/citeproc/data/locales/locales-pt-PT.xml
--- 0.3.0-6/citeproc/data/locales/locales-pt-PT.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-pt-PT.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,10 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="pt-PT">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2013-09-20T23:31:02+00:00</updated>
+    <translator>
+      <name>Jonadabe PT</name>
+    </translator>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -20,7 +23,7 @@
     <term name="and">e</term>
     <term name="and others">e outros</term>
     <term name="anonymous">anónimo</term>
-    <term name="anonymous" form="short">anón</term>
+    <term name="anonymous" form="short">anón.</term>
     <term name="at">em</term>
     <term name="available at">disponível em</term>
     <term name="by">por</term>
@@ -31,7 +34,7 @@
       <single>edição</single>
       <multiple>edições</multiple>
     </term>
-    <term name="edition" form="short">ed</term>
+    <term name="edition" form="short">ed.</term>
     <term name="et-al">et al.</term>
     <term name="forthcoming">a publicar</term>
     <term name="from">de</term>
@@ -46,8 +49,8 @@
     <term name="online">em linha</term>
     <term name="presented at">apresentado na</term>
     <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
+      <single>referência</single>
+      <multiple>referências</multiple>
     </term>
     <term name="reference" form="short">
       <single>ref.</single>
@@ -69,25 +72,30 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
+    <term name="ordinal" gender-form="masculine" match="whole-number">.º</term>
+    <term name="ordinal" gender-form="feminine" match="whole-number">.ª</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">primeiro</term>
-    <term name="long-ordinal-02">segundo</term>
-    <term name="long-ordinal-03">terceiro</term>
-    <term name="long-ordinal-04">quarto</term>
-    <term name="long-ordinal-05">quinto</term>
-    <term name="long-ordinal-06">sexto</term>
-    <term name="long-ordinal-07">sétimo</term>
-    <term name="long-ordinal-08">oitavo</term>
-    <term name="long-ordinal-09">nono</term>
-    <term name="long-ordinal-10">décimo</term>
+    <term name="long-ordinal-01" gender-form="masculine">primeiro</term>
+    <term name="long-ordinal-01" gender-form="feminine">primeira</term>
+    <term name="long-ordinal-02" gender-form="masculine">segundo</term>
+    <term name="long-ordinal-02" gender-form="feminine">segunda</term>    
+    <term name="long-ordinal-03" gender-form="masculine">terceiro</term>
+    <term name="long-ordinal-03" gender-form="feminine">terceira</term>    
+    <term name="long-ordinal-04" gender-form="masculine">quarto</term>
+    <term name="long-ordinal-04" gender-form="feminine">quarta</term>
+    <term name="long-ordinal-05" gender-form="masculine">quinto</term>
+    <term name="long-ordinal-05" gender-form="feminine">quinta</term>
+    <term name="long-ordinal-06" gender-form="masculine">sexto</term>
+    <term name="long-ordinal-06" gender-form="feminine">sexta</term>
+    <term name="long-ordinal-07" gender-form="masculine">sétimo</term>
+    <term name="long-ordinal-07" gender-form="feminine">sétima</term>
+    <term name="long-ordinal-08" gender-form="masculine">oitavo</term>
+    <term name="long-ordinal-08" gender-form="feminine">oitava</term>
+    <term name="long-ordinal-09" gender-form="masculine">nono</term>
+    <term name="long-ordinal-09" gender-form="feminine">nona</term>
+    <term name="long-ordinal-10" gender-form="masculine">décimo</term>
+    <term name="long-ordinal-10" gender-form="feminine">décima</term>
 
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
@@ -112,7 +120,7 @@
     </term>
     <term name="issue">
       <single>número</single>
-      <multiple>número</multiple>
+      <multiple>números</multiple>
     </term>
     <term name="line">
       <single>linha</single>
@@ -130,6 +138,10 @@
       <single>página</single>
       <multiple>páginas</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>página</single>
+      <multiple>páginas</multiple>
+    </term>
     <term name="paragraph">
       <single>parágrafo</single>
       <multiple>parágrafos</multiple>
@@ -156,22 +168,26 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">liv</term>
-    <term name="chapter" form="short">cap</term>
-    <term name="column" form="short">col</term>
-    <term name="figure" form="short">fig</term>
-    <term name="folio" form="short">f</term>
-    <term name="issue" form="short">n</term>
+    <term name="book" form="short">liv.</term>
+    <term name="chapter" form="short">cap.</term>
+    <term name="column" form="short">col.</term>
+    <term name="figure" form="short">fig.</term>
+    <term name="folio" form="short">f.</term>
+    <term name="issue" form="short">n.</term>
     <term name="line" form="short">l.</term>
     <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="opus" form="short">op.</term>
     <term name="page" form="short">
-      <single>p</single>
-      <multiple>pp</multiple>
+      <single>p.</single>
+      <multiple>pp.</multiple>
     </term>
-    <term name="paragraph" form="short">par</term>
-    <term name="part" form="short">pt</term>
-    <term name="section" form="short">sec</term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
+    <term name="paragraph" form="short">par.</term>
+    <term name="part" form="short">pt.</term>
+    <term name="section" form="short">sec.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
@@ -181,8 +197,8 @@
       <multiple>vv</multiple>
     </term>
     <term name="volume" form="short">
-      <single>vol</single>
-      <multiple>vols</multiple>
+      <single>vol.</single>
+      <multiple>vols.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -198,7 +214,7 @@
     <!-- LONG ROLE FORMS -->
     <term name="director">
       <single>director</single>
-      <multiple>directors</multiple>
+      <multiple>directores</multiple>
     </term>
     <term name="editor">
       <single>editor</single>
@@ -206,19 +222,19 @@
     </term>
     <term name="editorial-director">
       <single>editor</single>
-      <multiple>editors</multiple>
+      <multiple>editores</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>ilustrador</single>
+      <multiple>ilustradores</multiple>
     </term>
     <term name="translator">
       <single>tradutor</single>
       <multiple>tradutores</multiple>
     </term>
     <term name="editortranslator">
-      <single>editor &amp; translator</single>
-      <multiple>editors &amp; translators</multiple>
+      <single>editor &amp; tradutor</single>
+      <multiple>editores &amp; tradutores</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
@@ -227,45 +243,45 @@
       <multiple>dirs.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>ed</single>
-      <multiple>eds</multiple>
+      <single>ed.</single>
+      <multiple>eds.</multiple>
     </term>
     <term name="editorial-director" form="short">
       <single>ed.</single>
       <multiple>eds.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>il.</single>
+      <multiple>ils.</multiple>
     </term>
     <term name="translator" form="short">
-      <single>trad</single>
-      <multiple>trads</multiple>
+      <single>trad.</single>
+      <multiple>trads.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
+      <single>ed. &amp; trad.</single>
+      <multiple>eds. &amp; trads.</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb">por</term>
+    <term name="director" form="verb">dirigido por</term>
     <term name="editor" form="verb">editado por</term>
-    <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="editorial-director" form="verb">editorial de</term>
+    <term name="illustrator" form="verb">ilustrado por</term>
     <term name="interviewer" form="verb">entrevistado por</term>
     <term name="recipient" form="verb">para</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">revisto por</term>
     <term name="translator" form="verb">traduzido por</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="editortranslator" form="verb">editado &amp; traduzido por</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ed</term>
+    <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">trad</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="illustrator" form="verb-short">ilus.</term>
+    <term name="translator" form="verb-short">trad.</term>
+    <term name="editortranslator" form="verb-short">ed. &amp; trad. por</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">Janeiro</term>
@@ -282,18 +298,18 @@
     <term name="month-12">Dezembro</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">Jan</term>
-    <term name="month-02" form="short">Fev</term>
-    <term name="month-03" form="short">Mar</term>
-    <term name="month-04" form="short">Abr</term>
-    <term name="month-05" form="short">Mai</term>
-    <term name="month-06" form="short">Jun</term>
-    <term name="month-07" form="short">Jul</term>
-    <term name="month-08" form="short">Ago</term>
-    <term name="month-09" form="short">Set</term>
-    <term name="month-10" form="short">Out</term>
-    <term name="month-11" form="short">Nov</term>
-    <term name="month-12" form="short">Dez</term>
+    <term name="month-01" form="short">Jan.</term>
+    <term name="month-02" form="short">Fev.</term>
+    <term name="month-03" form="short">Mar.</term>
+    <term name="month-04" form="short">Abr.</term>
+    <term name="month-05" form="short">Mai.</term>
+    <term name="month-06" form="short">Jun.</term>
+    <term name="month-07" form="short">Jul.</term>
+    <term name="month-08" form="short">Ago.</term>
+    <term name="month-09" form="short">Set.</term>
+    <term name="month-10" form="short">Out.</term>
+    <term name="month-11" form="short">Nov.</term>
+    <term name="month-12" form="short">Dez.</term>
 
     <!-- SEASONS -->
     <term name="season-01">Primavera</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ro-RO.xml 0.5.1-1/citeproc/data/locales/locales-ro-RO.xml
--- 0.3.0-6/citeproc/data/locales/locales-ro-RO.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ro-RO.xml	2020-04-06 16:40:32.000000000 +0000
@@ -74,7 +74,7 @@
 
     <!-- ORDINALS -->
     <term name="ordinal">-lea</term>
-    <term name="ordinal-01" match="whole-number"/>
+    <term name="ordinal-01" match="whole-number"></term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">primul</term>
@@ -129,6 +129,10 @@
       <single>pagina</single>
       <multiple>paginile</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>pagina</single>
+      <multiple>paginile</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraful</single>
       <multiple>paragrafele</multiple>
@@ -168,6 +172,10 @@
       <single>p.</single>
       <multiple>pp.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p.</single>
+      <multiple>pp.</multiple>
+    </term>
     <term name="paragraph" form="short">par.</term>
     <term name="part" form="short">part.</term>
     <term name="section" form="short">sec.</term>
@@ -247,6 +255,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">de</term>
     <term name="director" form="verb">coordonat de</term>
     <term name="editor" form="verb">ediție de</term>
     <term name="editorial-director" form="verb">ediție de</term>
@@ -258,7 +267,6 @@
     <term name="editortranslator" form="verb">ediție &amp; traducere de</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">de</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-ru-RU.xml 0.5.1-1/citeproc/data/locales/locales-ru-RU.xml
--- 0.3.0-6/citeproc/data/locales/locales-ru-RU.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-ru-RU.xml	2020-04-06 16:40:32.000000000 +0000
@@ -26,13 +26,13 @@
     <term name="anonymous">аноним</term>
     <term name="anonymous" form="short">анон.</term>
     <term name="at">на</term>
-    <term name="available at">available at</term>
-    <term name="by"/>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">ca.</term>
+    <term name="available at">доступно на</term>
+    <term name="by"></term>
+    <term name="circa">около</term>
+    <term name="circa" form="short">ок.</term>
     <term name="cited">цитируется по</term>
     <term name="cited" form="short">цит. по</term>
-    <term name="edition">
+    <term name="edition"> <!-- gender="neuter" -->
       <single>издание</single>
       <multiple>издания</multiple>
     </term>
@@ -48,19 +48,21 @@
     <term name="letter">письмо</term>
     <term name="no date">без даты</term>
     <term name="no date" form="short">б. д.</term>
-    <term name="online">online</term>
+    <term name="online">онлайн</term>
     <term name="presented at">представлено на</term>
+    <!-- Сложно подобрать один перевод для следующего термина. В зависимости от контекста это может быть "работа" или "источник" или вообще опускаться -->
     <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
+      <single>ссылка</single>
+      <multiple>ссылки</multiple>
     </term>
+    <!-- сокращения для "ссылка" не используются, но для некоторых случаев может подойти "ист." -->
     <term name="reference" form="short">
-      <single>ref.</single>
-      <multiple>refs.</multiple>
+      <single>ссылка</single>
+      <multiple>ссылки</multiple>
     </term>
     <term name="retrieved">извлечено</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">масштаб</term>
+    <term name="version">версия</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
     <term name="ad">н. э.</term>
@@ -74,21 +76,43 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">й</term>
+    <term name="ordinal">-е</term>
+    <term name="ordinal" gender-form="masculine">-й</term>
+    <term name="ordinal" gender-form="feminine">-я</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">первый</term>
-    <term name="long-ordinal-02">второй</term>
-    <term name="long-ordinal-03">третий</term>
-    <term name="long-ordinal-04">четвертый</term>
-    <term name="long-ordinal-05">пятый</term>
-    <term name="long-ordinal-06">шестой</term>
-    <term name="long-ordinal-07">седьмой</term>
-    <term name="long-ordinal-08">восьмой</term>
-    <term name="long-ordinal-09">девятый</term>
-    <term name="long-ordinal-10">десятый</term>
-
+    <term name="long-ordinal-01">первое</term>
+    <term name="long-ordinal-02">второе</term>
+    <term name="long-ordinal-03">третье</term>
+    <term name="long-ordinal-04">четвертое</term>
+    <term name="long-ordinal-05">пятое</term>
+    <term name="long-ordinal-06">шестое</term>
+    <term name="long-ordinal-07">седьмое</term>
+    <term name="long-ordinal-08">восьмое</term>
+    <term name="long-ordinal-09">девятое</term>
+    <term name="long-ordinal-10">десятое</term>
+    <term name="long-ordinal-01" gender-form="masculine">первый</term>
+    <term name="long-ordinal-02" gender-form="masculine">второй</term>
+    <term name="long-ordinal-03" gender-form="masculine">третий</term>
+    <term name="long-ordinal-04" gender-form="masculine">четвертый</term>
+    <term name="long-ordinal-05" gender-form="masculine">пятый</term>
+    <term name="long-ordinal-06" gender-form="masculine">шестой</term>
+    <term name="long-ordinal-07" gender-form="masculine">седьмой</term>
+    <term name="long-ordinal-08" gender-form="masculine">восьмой</term>
+    <term name="long-ordinal-09" gender-form="masculine">девятый</term>
+    <term name="long-ordinal-10" gender-form="masculine">десятый</term>
+    <term name="long-ordinal-01" gender-form="feminine">первая</term>
+    <term name="long-ordinal-02" gender-form="feminine">вторая</term>
+    <term name="long-ordinal-03" gender-form="feminine">третья</term>
+    <term name="long-ordinal-04" gender-form="feminine">четвертая</term>
+    <term name="long-ordinal-05" gender-form="feminine">пятая</term>
+    <term name="long-ordinal-06" gender-form="feminine">шестая</term>
+    <term name="long-ordinal-07" gender-form="feminine">седьмая</term>
+    <term name="long-ordinal-08" gender-form="feminine">восьмая</term>
+    <term name="long-ordinal-09" gender-form="feminine">девятая</term>
+    <term name="long-ordinal-10" gender-form="feminine">десятая</term>
     <!-- LONG LOCATOR FORMS -->
+    <!-- Currently only a few of locator terms are gender-assignable -->
     <term name="book">
       <single>книга</single>
       <multiple>книги</multiple>
@@ -109,7 +133,7 @@
       <single>лист</single>
       <multiple>листы</multiple>
     </term>
-    <term name="issue">
+    <term name="issue" gender="masculine">
       <single>выпуск</single>
       <multiple>выпуски</multiple>
     </term>
@@ -129,6 +153,11 @@
       <single>страница</single>
       <multiple>страницы</multiple>
     </term>
+    <!-- для однообразности здесь тоже указали род, но использование кол-ва страниц с порядковым числительным маловероятно -->
+    <term name="number-of-pages" gender="feminine">
+      <single>страница</single>
+      <multiple>страницы</multiple>
+    </term>
     <term name="paragraph">
       <single>параграф</single>
       <multiple>параграфы</multiple>
@@ -141,44 +170,49 @@
       <single>раздел</single>
       <multiple>разделы</multiple>
     </term>
-    <term name="sub verbo">
-      <single>смотри</single>
-      <multiple>смотри</multiple>
-    </term>
+    <term name="sub verbo">смотри</term>
     <term name="verse">
       <single>стих</single>
       <multiple>стихи</multiple>
     </term>
-    <term name="volume">
+    <term name="volume" gender="masculine">
       <single>том</single>
       <multiple>тома</multiple>
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
+    <!-- Ниже для всех однобуквенных сокращений приведены двухбуквенные варианты множественного числа. Если последние нежелательны (например, по ГОСТу для библиографии "С. 23-35") то это должно определяться в самом стиле (plural="never") -->
     <term name="book" form="short">кн.</term>
     <term name="chapter" form="short">гл.</term>
     <term name="column" form="short">стб.</term>
     <term name="figure" form="short">рис.</term>
-    <term name="folio" form="short">л.</term>
-    <term name="issue" form="short">№</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="folio" form="short">
+      <single>л.</single>
+      <multiple>лл.</multiple>
+    </term>
+    <term name="issue" form="short">вып.</term>
+    <term name="line" form="short">стр.</term>
+    <term name="note" form="short">прим.</term>
     <term name="opus" form="short">соч.</term>
     <term name="page" form="short">
       <single>с.</single>
-      <multiple>с.</multiple>
+      <multiple>сс.</multiple>
     </term>
-    <term name="paragraph" form="short">пара.</term>
-    <term name="part" form="short">ч.</term>
-    <term name="section" form="short">разд.</term>
-    <term name="sub verbo" form="short">
-      <single>см.</single>
-      <multiple>см.</multiple>
-    </term>
-    <term name="verse" form="short">
-      <single>ст.</single>
-      <multiple>ст.</multiple>
+    <term name="number-of-pages" form="short">
+      <single>с.</single>
+      <multiple>сс.</multiple>
+    </term>
+    <term name="paragraph" form="short">
+      <single>п.</single>
+      <multiple>пп.</multiple>
+    </term>
+    <term name="part" form="short">
+      <single>ч.</single>
+      <multiple>чч.</multiple>
     </term>
+    <term name="section" form="short">разд.</term>
+    <term name="sub verbo" form="short">см.</term>
+    <term name="verse" form="short">ст.</term>
     <term name="volume" form="short">
       <single>т.</single>
       <multiple>тт.</multiple>
@@ -196,8 +230,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>режиссер</single>
+      <multiple>режиссеры</multiple>
     </term>
     <term name="editor">
       <single>редактор</single>
@@ -208,8 +242,8 @@
       <multiple>ответственные редакторы</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>иллюстратор</single>
+      <multiple>иллюстраторы</multiple>
     </term>
     <term name="translator">
       <single>переводчик</single>
@@ -221,52 +255,36 @@
     </term>
 
     <!-- SHORT ROLE FORMS -->
-    <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
-    </term>
-    <term name="editor" form="short">
-      <single>ред.</single>
-      <multiple>ред.</multiple>
-    </term>
-    <term name="editorial-director" form="short">
-      <single>отв. ред.</single>
-      <multiple>отв. ред.</multiple>
-    </term>
-    <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
-    </term>
-    <term name="translator" form="short">
-      <single>перев.</single>
-      <multiple>перев.</multiple>
-    </term>
-    <term name="editortranslator" form="short">
-      <single>ред. и перев.</single>
-      <multiple>ред. и перев.</multiple>
-    </term>
+    <term name="director" form="short">реж.</term>
+    <term name="editor" form="short">ред.</term>
+    <term name="editorial-director" form="short">отв. ред.</term>
+    <term name="illustrator" form="short">ил.</term>
+    <term name="translator" form="short">пер.</term>
+    <term name="editortranslator" form="short">ред. и пер.</term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">отредактировано</term>
-    <term name="editorial-director" form="verb">отредактировано</term>
-    <term name="illustrator" form="verb">illustrated by</term>
-    <term name="interviewer" form="verb">интервью</term>
+    <!-- В этом и следующем разделе приведены наиболее широко используемые термины (например, "под редакцией" вместо "отредактировано"). Единственным недостатком является то, что разные термины требует разного падежа для последующих фамилий -->
+    <term name="container-author" form="verb"></term>
+    <term name="director" form="verb">режиссировано</term>
+    <term name="editor" form="verb">под редакцией</term>
+    <term name="editorial-director" form="verb">под ответственной редакцией</term>
+    <term name="illustrator" form="verb">иллюстрировано</term>
+    <term name="interviewer" form="verb">интервью проведено</term>
     <term name="recipient" form="verb">к</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb"></term>
     <term name="translator" form="verb">переведено</term>
-    <term name="editortranslator" form="verb">отредактировано и переведено</term>
+    <term name="editortranslator" form="verb">под редакцией и переведено</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ред.</term>
-    <term name="editorial-director" form="verb-short">отв. ред.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">перев.</term>
-    <term name="editortranslator" form="verb-short">ред. и перев.</term>
+    <term name="director" form="verb-short">реж.</term>
+    <term name="editor" form="verb-short">под ред.</term>
+    <term name="editorial-director" form="verb-short">под отв. ред.</term>
+    <term name="illustrator" form="verb-short">ил.</term>
+    <term name="translator" form="verb-short">пер.</term>
+    <term name="editortranslator" form="verb-short">под ред. и пер.</term>
 
     <!-- LONG MONTH FORMS -->
+    <!-- род месяцев не указываем, поскольку даже если использовать порядковые числительные в дате, то они должны соответствовать среднему роду, например "второе февраля" -->
     <term name="month-01">январь</term>
     <term name="month-02">февраль</term>
     <term name="month-03">март</term>
@@ -296,7 +314,7 @@
 
     <!-- SEASONS -->
     <term name="season-01">весна</term>
-    <term name="season-02">лета</term>
+    <term name="season-02">лето</term>
     <term name="season-03">осень</term>
     <term name="season-04">зима</term>
   </terms>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-sk-SK.xml 0.5.1-1/citeproc/data/locales/locales-sk-SK.xml
--- 0.3.0-6/citeproc/data/locales/locales-sk-SK.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-sk-SK.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="sk-SK">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2014-03-09T22:23:31+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -20,7 +20,7 @@
     <term name="and">a</term>
     <term name="and others">a ďalší</term>
     <term name="anonymous">anonym</term>
-    <term name="anonymous" form="short">anon</term>
+    <term name="anonymous" form="short">anon.</term>
     <term name="at">v</term>
     <term name="available at">available at</term>
     <term name="by">by</term>
@@ -31,8 +31,8 @@
       <single>vydanie</single>
       <multiple>vydania</multiple>
     </term>
-    <term name="edition" form="short">vyd</term>
-    <term name="et-al">et al</term>
+    <term name="edition" form="short">vyd.</term>
+    <term name="et-al">et al.</term>
     <term name="forthcoming">nadchádzajúci</term>
     <term name="from">z</term>
     <term name="ibid">ibid.</term>
@@ -130,6 +130,10 @@
       <single>strana</single>
       <multiple>strany</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>strana</single>
+      <multiple>strany</multiple>
+    </term>
     <term name="paragraph">
       <single>odstavec</single>
       <multiple>odstavce</multiple>
@@ -156,33 +160,37 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">k</term>
-    <term name="chapter" form="short">kap</term>
-    <term name="column" form="short">stĺp</term>
-    <term name="figure" form="short">obr</term>
-    <term name="folio" form="short">l</term>
-    <term name="issue" form="short">č</term>
+    <term name="book" form="short">k.</term>
+    <term name="chapter" form="short">kap.</term>
+    <term name="column" form="short">stĺp.</term>
+    <term name="figure" form="short">obr.</term>
+    <term name="folio" form="short">l.</term>
+    <term name="issue" form="short">č.</term>
     <term name="line" form="short">l.</term>
     <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="opus" form="short">op.</term>
     <term name="page" form="short">
-      <single>s</single>
-      <multiple>s</multiple>
+      <single>s.</single>
+      <multiple>s.</multiple>
     </term>
-    <term name="paragraph" form="short">par</term>
-    <term name="part" form="short">č</term>
-    <term name="section" form="short">sek</term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
+    <term name="paragraph" form="short">par.</term>
+    <term name="part" form="short">č.</term>
+    <term name="section" form="short">sek.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
     </term>
     <term name="verse" form="short">
-      <single>v</single>
-      <multiple>v</multiple>
+      <single>v.</single>
+      <multiple>v.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>roč</single>
-      <multiple>roč</multiple>
+      <single>roč.</single>
+      <multiple>roč.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -227,8 +235,8 @@
       <multiple>dirs.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>ed</single>
-      <multiple>ed</multiple>
+      <single>ed.</single>
+      <multiple>ed.</multiple>
     </term>
     <term name="editorial-director" form="short">
       <single>zost.</single>
@@ -239,8 +247,8 @@
       <multiple>ills.</multiple>
     </term>
     <term name="translator" form="short">
-      <single>prel</single>
-      <multiple>prel</multiple>
+      <single>prel.</single>
+      <multiple>prel.</multiple>
     </term>
     <term name="editortranslator" form="short">
       <single>ed. &amp; tran.</single>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">zostavil</term>
     <term name="editorial-director" form="verb">zostavil</term>
@@ -259,12 +268,11 @@
     <term name="editortranslator" form="verb">zostavil &amp; preložil</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ed</term>
+    <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
     <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">prel</term>
+    <term name="translator" form="verb-short">prel.</term>
     <term name="editortranslator" form="verb-short">zost. &amp; prel.</term>
 
     <!-- LONG MONTH FORMS -->
@@ -282,18 +290,18 @@
     <term name="month-12">december</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">jan</term>
-    <term name="month-02" form="short">feb</term>
-    <term name="month-03" form="short">mar</term>
-    <term name="month-04" form="short">apr</term>
-    <term name="month-05" form="short">máj</term>
-    <term name="month-06" form="short">jún</term>
-    <term name="month-07" form="short">júl</term>
-    <term name="month-08" form="short">aug</term>
-    <term name="month-09" form="short">sep</term>
-    <term name="month-10" form="short">okt</term>
-    <term name="month-11" form="short">nov</term>
-    <term name="month-12" form="short">dec</term>
+    <term name="month-01" form="short">jan.</term>
+    <term name="month-02" form="short">feb.</term>
+    <term name="month-03" form="short">mar.</term>
+    <term name="month-04" form="short">apr.</term>
+    <term name="month-05" form="short">máj.</term>
+    <term name="month-06" form="short">jún.</term>
+    <term name="month-07" form="short">júl.</term>
+    <term name="month-08" form="short">aug.</term>
+    <term name="month-09" form="short">sep.</term>
+    <term name="month-10" form="short">okt.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dec.</term>
 
     <!-- SEASONS -->
     <term name="season-01">Jar</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-sl-SI.xml 0.5.1-1/citeproc/data/locales/locales-sl-SI.xml
--- 0.3.0-6/citeproc/data/locales/locales-sl-SI.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-sl-SI.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,37 +2,37 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="sl-SI">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2014-11-06T09:41:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
-    <date-part name="day" form="numeric-leading-zeros" suffix=". "/>
+    <date-part name="day" form="numeric" suffix=". "/>
     <date-part name="month" suffix=" "/>
     <date-part name="year" suffix="."/>
   </date>
   <date form="numeric">
+    <date-part name="day" form="numeric" suffix=". "/>
+    <date-part name="month" form="numeric" suffix=". "/>
     <date-part name="year"/>
-    <date-part name="month" form="numeric-leading-zeros" prefix="-" range-delimiter="/"/>
-    <date-part name="day" form="numeric-leading-zeros" prefix="-" range-delimiter="/"/>
   </date>
   <terms>
-    <term name="accessed">dostopano</term>
+    <term name="accessed">pridobljeno</term>
     <term name="and">in</term>
     <term name="and others">in drugi</term>
     <term name="anonymous">anonimni</term>
-    <term name="anonymous" form="short">anon</term>
+    <term name="anonymous" form="short">anon.</term>
     <term name="at">pri</term>
-    <term name="available at">available at</term>
-    <term name="by">by</term>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">c.</term>
+    <term name="available at">dostopno na</term>
+    <term name="by"></term>
+    <term name="circa">približno</term>
+    <term name="circa" form="short">prib.</term>
     <term name="cited">citirano</term>
     <term name="edition">
       <single>izdaja</single>
       <multiple>izdaje</multiple>
     </term>
-    <term name="edition" form="short">iz</term>
-    <term name="et-al">idr.</term>
+    <term name="edition" form="short">izd.</term>
+    <term name="et-al">in dr.</term>
     <term name="forthcoming">pred izidom</term>
     <term name="from">od</term>
     <term name="ibid">isto</term>
@@ -41,25 +41,25 @@
     <term name="internet">internet</term>
     <term name="interview">intervju</term>
     <term name="letter">pismo</term>
-    <term name="no date">no date</term>
-    <term name="no date" form="short">b.d.</term>
+    <term name="no date">brez datuma</term>
+    <term name="no date" form="short">b. d.</term>
     <term name="online">na spletu</term>
     <term name="presented at">predstavljeno na</term>
     <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
+      <single>referenca</single>
+      <multiple>reference</multiple>
     </term>
     <term name="reference" form="short">
       <single>ref.</single>
-      <multiple>refs.</multiple>
+      <multiple>ref.</multiple>
     </term>
     <term name="retrieved">pridobljeno</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="scale">merilo</term>
+    <term name="version">različica</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">n. št.</term>
+    <term name="bc">pr. n. št.</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">„</term>
@@ -69,25 +69,19 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
+    <term name="ordinal">.</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">first</term>
-    <term name="long-ordinal-02">second</term>
-    <term name="long-ordinal-03">third</term>
-    <term name="long-ordinal-04">fourth</term>
-    <term name="long-ordinal-05">fifth</term>
-    <term name="long-ordinal-06">sixth</term>
-    <term name="long-ordinal-07">seventh</term>
-    <term name="long-ordinal-08">eighth</term>
-    <term name="long-ordinal-09">ninth</term>
-    <term name="long-ordinal-10">tenth</term>
+    <term name="long-ordinal-01">prva</term>
+    <term name="long-ordinal-02">druga</term>
+    <term name="long-ordinal-03">tretja</term>
+    <term name="long-ordinal-04">četrta</term>
+    <term name="long-ordinal-05">peta</term>
+    <term name="long-ordinal-06">šesta</term>
+    <term name="long-ordinal-07">sedma</term>
+    <term name="long-ordinal-08">osma</term>
+    <term name="long-ordinal-09">deveta</term>
+    <term name="long-ordinal-10">deseta</term>
 
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
@@ -124,12 +118,16 @@
     </term>
     <term name="opus">
       <single>opus</single>
-      <multiple>opera</multiple>
+      <multiple>opusi</multiple>
     </term>
     <term name="page">
       <single>stran</single>
       <multiple>strani</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>stran</single>
+      <multiple>strani</multiple>
+    </term>
     <term name="paragraph">
       <single>odstavek</single>
       <multiple>odstavki</multiple>
@@ -156,33 +154,37 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">knj</term>
-    <term name="chapter" form="short">pogl</term>
-    <term name="column" form="short">sto</term>
-    <term name="figure" form="short">sl</term>
-    <term name="folio" form="short">f</term>
-    <term name="issue" form="short">št</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="book" form="short">knj.</term>
+    <term name="chapter" form="short">pogl.</term>
+    <term name="column" form="short">stolp.</term>
+    <term name="figure" form="short">sl.</term>
+    <term name="folio" form="short">fol.</term>
+    <term name="issue" form="short">št.</term>
+    <term name="line" form="short">vrst.</term>
+    <term name="note" form="short">op.</term>
+    <term name="opus" form="short">opus</term>
     <term name="page" form="short">
-      <single>str</single>
-      <multiple>str</multiple>
+      <single>str.</single>
+      <multiple>str.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>str.</single>
+      <multiple>str.</multiple>
     </term>
-    <term name="paragraph" form="short">odst</term>
+    <term name="paragraph" form="short">odst.</term>
     <term name="part" form="short">del</term>
-    <term name="section" form="short">odsk</term>
+    <term name="section" form="short">ods.</term>
     <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
+      <single>s. v.</single>
+      <multiple>s. v.</multiple>
     </term>
     <term name="verse" form="short">
-      <single>v</single>
-      <multiple>v</multiple>
+      <single>v.</single>
+      <multiple>v.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>let</single>
-      <multiple>let</multiple>
+      <single>let.</single>
+      <multiple>let.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -197,75 +199,75 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>režiser</single>
+      <multiple>režiserji</multiple>
     </term>
     <term name="editor">
       <single>urednik</single>
       <multiple>uredniki</multiple>
     </term>
     <term name="editorial-director">
-      <single>editor</single>
-      <multiple>editors</multiple>
+      <single>glavni urednik</single>
+      <multiple>glavni uredniki</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>ilustrator</single>
+      <multiple>ilustratorji</multiple>
     </term>
     <term name="translator">
       <single>prevajalec</single>
       <multiple>prevajalci</multiple>
     </term>
     <term name="editortranslator">
-      <single>editor &amp; translator</single>
-      <multiple>editors &amp; translators</multiple>
+      <single>urednik &amp; prevajalec</single>
+      <multiple>uredniki &amp; prevajalci</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <single>rež.</single>
+      <multiple>rež.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>ur</single>
-      <multiple>ur</multiple>
+      <single>ur.</single>
+      <multiple>ur.</multiple>
     </term>
     <term name="editorial-director" form="short">
-      <single>ed.</single>
-      <multiple>eds.</multiple>
+      <single>gl. ur.</single>
+      <multiple>gl. ur.</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>ilus.</single>
+      <multiple>ilus.</multiple>
     </term>
     <term name="translator" form="short">
-      <single>prev</single>
-      <multiple>prev</multiple>
+      <single>prev.</single>
+      <multiple>prev.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
+      <single>ur. &amp; prev.</single>
+      <multiple>ur. &amp; prev.</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb"></term>
+    <term name="director" form="verb">režiral</term>
     <term name="editor" form="verb">uredil</term>
-    <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
+    <term name="editorial-director" form="verb">uredil</term>
+    <term name="illustrator" form="verb">ilustriral</term>
     <term name="interviewer" form="verb">intervjuval</term>
     <term name="recipient" form="verb">za</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">od</term>
     <term name="translator" form="verb">prevedel</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="editortranslator" form="verb">uredil &amp; prevedel</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ur</term>
-    <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">prev</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="director" form="verb-short">rež.</term>
+    <term name="editor" form="verb-short">ured.</term>
+    <term name="editorial-director" form="verb-short">ured.</term>
+    <term name="illustrator" form="verb-short">ilus.</term>
+    <term name="translator" form="verb-short">prev.</term>
+    <term name="editortranslator" form="verb-short">ured. &amp; prev. by</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">januar</term>
@@ -282,23 +284,23 @@
     <term name="month-12">december</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">jan</term>
-    <term name="month-02" form="short">feb</term>
-    <term name="month-03" form="short">mar</term>
-    <term name="month-04" form="short">apr</term>
+    <term name="month-01" form="short">jan.</term>
+    <term name="month-02" form="short">feb.</term>
+    <term name="month-03" form="short">mar.</term>
+    <term name="month-04" form="short">apr.</term>
     <term name="month-05" form="short">maj</term>
-    <term name="month-06" form="short">jun</term>
-    <term name="month-07" form="short">jul</term>
-    <term name="month-08" form="short">avg</term>
-    <term name="month-09" form="short">sep</term>
-    <term name="month-10" form="short">okt</term>
-    <term name="month-11" form="short">nov</term>
-    <term name="month-12" form="short">dec</term>
+    <term name="month-06" form="short">jun.</term>
+    <term name="month-07" form="short">jul.</term>
+    <term name="month-08" form="short">avg.</term>
+    <term name="month-09" form="short">sep.</term>
+    <term name="month-10" form="short">okt.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dec.</term>
 
     <!-- SEASONS -->
-    <term name="season-01">Spring</term>
-    <term name="season-02">Summer</term>
-    <term name="season-03">Autumn</term>
-    <term name="season-04">Winter</term>
+    <term name="season-01">pomlad</term>
+    <term name="season-02">poletje</term>
+    <term name="season-03">jesen</term>
+    <term name="season-04">zima</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-sr-RS.xml 0.5.1-1/citeproc/data/locales/locales-sr-RS.xml
--- 0.3.0-6/citeproc/data/locales/locales-sr-RS.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-sr-RS.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>страница</single>
       <multiple>странице</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>страница</single>
+      <multiple>странице</multiple>
+    </term>
     <term name="paragraph">
       <single>параграф</single>
       <multiple>параграфи</multiple>
@@ -169,6 +173,10 @@
       <single>стр.</single>
       <multiple>стр.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>стр.</single>
+      <multiple>стр.</multiple>
+    </term>
     <term name="paragraph" form="short">пар.</term>
     <term name="part" form="short">део</term>
     <term name="section" form="short">од.</term>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">уредио</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ур.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-sv-SE.xml 0.5.1-1/citeproc/data/locales/locales-sv-SE.xml
--- 0.3.0-6/citeproc/data/locales/locales-sv-SE.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-sv-SE.xml	2020-04-06 16:40:32.000000000 +0000
@@ -20,7 +20,7 @@
     <term name="and">och</term>
     <term name="and others">och andra</term>
     <term name="anonymous">anonym</term>
-    <term name="anonymous" form="short">anon</term>
+    <term name="anonymous" form="short">anon.</term>
     <term name="at">vid</term>
     <term name="available at">tillgänglig vid</term>
     <term name="by">av</term>
@@ -31,7 +31,7 @@
       <single>upplaga</single>
       <multiple>upplagor</multiple>
     </term>
-    <term name="edition" form="short">uppl</term>
+    <term name="edition" form="short">uppl.</term>
     <term name="et-al">m.fl.</term>
     <term name="forthcoming">kommande</term>
     <term name="from">från</term>
@@ -41,8 +41,8 @@
     <term name="internet">internet</term>
     <term name="interview">intervju</term>
     <term name="letter">brev</term>
-    <term name="no date">inget datum</term>
-    <term name="no date" form="short">nd</term>
+    <term name="no date">utan årtal</term>
+    <term name="no date" form="short">u.å.</term>
     <term name="online">online</term>
     <term name="presented at">presenterad vid</term>
     <term name="reference">
@@ -51,15 +51,15 @@
     </term>
     <term name="reference" form="short">
       <single>ref.</single>
-      <multiple>refs.</multiple>
+      <multiple>ref.</multiple>
     </term>
     <term name="retrieved">hämtad</term>
     <term name="scale">scale</term>
     <term name="version">version</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">e. Kr.</term>
-    <term name="bc">f. Kr.</term>
+    <term name="ad">e.Kr.</term>
+    <term name="bc">f.Kr.</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">”</term>
@@ -69,11 +69,11 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">e</term>
-    <term name="ordinal-01">a</term>
-    <term name="ordinal-02">a</term>
-    <term name="ordinal-11">e</term>
-    <term name="ordinal-12">e</term>
+    <term name="ordinal">:e</term>
+    <term name="ordinal-01">:a</term>
+    <term name="ordinal-02">:a</term>
+    <term name="ordinal-11">:e</term>
+    <term name="ordinal-12">:e</term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">första</term>
@@ -128,6 +128,10 @@
       <single>sida</single>
       <multiple>sidor</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>sida</single>
+      <multiple>sidor</multiple>
+    </term>
     <term name="paragraph">
       <single>stycke</single>
       <multiple>stycken</multiple>
@@ -150,26 +154,30 @@
     </term>
     <term name="volume">
       <single>volym</single>
-      <multiple>volumer</multiple>
+      <multiple>volymer</multiple>
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
     <term name="book" form="short">bok</term>
-    <term name="chapter" form="short">kap</term>
-    <term name="column" form="short">kol</term>
-    <term name="figure" form="short">fig</term>
-    <term name="folio" form="short">f</term>
-    <term name="issue" form="short">num</term>
+    <term name="chapter" form="short">kap.</term>
+    <term name="column" form="short">kol.</term>
+    <term name="figure" form="short">fig.</term>
+    <term name="folio" form="short">f.</term>
+    <term name="issue" form="short">nr</term>
     <term name="line" form="short">l.</term>
     <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="opus" form="short">op.</term>
     <term name="page" form="short">
-      <single>s</single>
-      <multiple>ss</multiple>
+      <single>s.</single>
+      <multiple>s.</multiple>
+    </term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>s.</multiple>
     </term>
-    <term name="paragraph" form="short">st</term>
+    <term name="paragraph" form="short">st.</term>
     <term name="part" form="short">del</term>
-    <term name="section" form="short">avs</term>
+    <term name="section" form="short">avs.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
@@ -179,8 +187,8 @@
       <multiple>verser</multiple>
     </term>
     <term name="volume" form="short">
-      <single>vol</single>
-      <multiple>vols</multiple>
+      <single>vol.</single>
+      <multiple>vol.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -225,8 +233,8 @@
       <multiple>dirs.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>red</single>
-      <multiple>reds</multiple>
+      <single>red.</single>
+      <multiple>red.</multiple>
     </term>
     <term name="editorial-director" form="short">
       <single>ed.</single>
@@ -234,69 +242,69 @@
     </term>
     <term name="illustrator" form="short">
       <single>ill.</single>
-      <multiple>ills.</multiple>
+      <multiple>ill.</multiple>
     </term>
     <term name="translator" form="short">
-      <single>övers</single>
-      <multiple>övers</multiple>
+      <single>övers.</single>
+      <multiple>övers.</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
+      <single>red. &amp; övers.</single>
+      <multiple>red. &amp; övers.</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">av</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">redigerad av</term>
     <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
-    <term name="interviewer" form="verb">intervju av</term>
+    <term name="illustrator" form="verb">illustrerad av</term>
+    <term name="interviewer" form="verb">intervjuad av</term>
     <term name="recipient" form="verb">till</term>
     <term name="reviewed-author" form="verb">by</term>
     <term name="translator" form="verb">översatt av</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="editortranslator" form="verb">redigerad &amp; översatt av</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">red</term>
+    <term name="editor" form="verb-short">red.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
     <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">övers</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="translator" form="verb-short">övers.</term>
+    <term name="editortranslator" form="verb-short">red. &amp; övers. av</term>
 
     <!-- LONG MONTH FORMS -->
-    <term name="month-01">Januari</term>
-    <term name="month-02">Februari</term>
-    <term name="month-03">Mars</term>
-    <term name="month-04">April</term>
-    <term name="month-05">Maj</term>
-    <term name="month-06">Juni</term>
-    <term name="month-07">Juli</term>
-    <term name="month-08">Augusti</term>
-    <term name="month-09">September</term>
-    <term name="month-10">Oktober</term>
-    <term name="month-11">November</term>
-    <term name="month-12">December</term>
+    <term name="month-01">januari</term>
+    <term name="month-02">februari</term>
+    <term name="month-03">mars</term>
+    <term name="month-04">april</term>
+    <term name="month-05">maj</term>
+    <term name="month-06">juni</term>
+    <term name="month-07">juli</term>
+    <term name="month-08">augusti</term>
+    <term name="month-09">september</term>
+    <term name="month-10">oktober</term>
+    <term name="month-11">november</term>
+    <term name="month-12">december</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">Jan</term>
-    <term name="month-02" form="short">Feb</term>
-    <term name="month-03" form="short">Mar</term>
-    <term name="month-04" form="short">Apr</term>
-    <term name="month-05" form="short">Maj</term>
-    <term name="month-06" form="short">Jun</term>
-    <term name="month-07" form="short">Jul</term>
-    <term name="month-08" form="short">Aug</term>
-    <term name="month-09" form="short">Sep</term>
-    <term name="month-10" form="short">Okt</term>
-    <term name="month-11" form="short">Nov</term>
-    <term name="month-12" form="short">Dec</term>
+    <term name="month-01" form="short">jan.</term>
+    <term name="month-02" form="short">feb.</term>
+    <term name="month-03" form="short">mar.</term>
+    <term name="month-04" form="short">apr.</term>
+    <term name="month-05" form="short">maj</term>
+    <term name="month-06" form="short">juni</term>
+    <term name="month-07" form="short">juli</term>
+    <term name="month-08" form="short">aug.</term>
+    <term name="month-09" form="short">sep.</term>
+    <term name="month-10" form="short">okt.</term>
+    <term name="month-11" form="short">nov.</term>
+    <term name="month-12" form="short">dec.</term>
 
     <!-- SEASONS -->
-    <term name="season-01">Vår</term>
-    <term name="season-02">Sommar</term>
-    <term name="season-03">Höst</term>
-    <term name="season-04">Vinter</term>
+    <term name="season-01">vår</term>
+    <term name="season-02">sommar</term>
+    <term name="season-03">höst</term>
+    <term name="season-04">vinter</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-th-TH.xml 0.5.1-1/citeproc/data/locales/locales-th-TH.xml
--- 0.3.0-6/citeproc/data/locales/locales-th-TH.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-th-TH.xml	2020-04-06 16:40:32.000000000 +0000
@@ -69,7 +69,7 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal"/>
+    <term name="ordinal"></term>
 
     <!-- LONG ORDINALS -->
     <term name="long-ordinal-01">หนึ่ง</term>
@@ -124,6 +124,10 @@
       <single>หน้า</single>
       <multiple>หน้า</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>หน้า</single>
+      <multiple>หน้า</multiple>
+    </term>
     <term name="paragraph">
       <single>ย่อหน้า</single>
       <multiple>ย่อหน้า</multiple>
@@ -163,6 +167,10 @@
       <single>น.</single>
       <multiple>น.</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>น.</single>
+      <multiple>น.</multiple>
+    </term>
     <term name="paragraph" form="short">ย่อหน้า</term>
     <term name="part" form="short">ส่วนย่อย</term>
     <term name="section" form="short">หมวด</term>
@@ -242,6 +250,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">โดย</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">เรียบเรียงโดย</term>
     <term name="editorial-director" form="verb">เรียบเรียงโดย</term>
@@ -253,7 +262,6 @@
     <term name="editortranslator" form="verb">แปลและเรียบเรียงโดย</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">โดย</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">โดย</term>
     <term name="editorial-director" form="verb-short">โดย</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-tr-TR.xml 0.5.1-1/citeproc/data/locales/locales-tr-TR.xml
--- 0.3.0-6/citeproc/data/locales/locales-tr-TR.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-tr-TR.xml	2020-04-06 16:40:32.000000000 +0000
@@ -11,12 +11,12 @@
     <date-part name="year"/>
   </date>
   <date form="numeric">
-    <date-part name="day" form="numeric-leading-zeros" suffix="/"/>
-    <date-part name="month" form="numeric-leading-zeros" suffix="/"/>
+    <date-part name="day" form="numeric-leading-zeros" suffix="."/>
+    <date-part name="month" form="numeric-leading-zeros" suffix="."/>
     <date-part name="year"/>
   </date>
   <terms>
-    <term name="accessed">erişildi</term>
+    <term name="accessed">erişim</term>
     <term name="and">ve</term>
     <term name="and others">ve diğerleri</term>
     <term name="anonymous">anonim</term>
@@ -31,11 +31,11 @@
       <single>baskı</single>
       <multiple>baskı</multiple>
     </term>
-    <term name="edition" form="short">ed</term>
-    <term name="et-al">ve diğerleri</term>
+    <term name="edition" form="short">baskı</term>
+    <term name="et-al">vd.</term>
     <term name="forthcoming">gelecek</term>
     <term name="from">adresinden erişildi</term>
-    <term name="ibid">ibid.</term>
+    <term name="ibid">a.g.e.</term>
     <term name="in">içinde</term>
     <term name="in press">basımda</term>
     <term name="internet">internet</term>
@@ -46,26 +46,26 @@
     <term name="online">çevrimiçi</term>
     <term name="presented at">sunulan</term>
     <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
+      <single>kaynak</single>
+      <multiple>kaynaklar</multiple>
     </term>
     <term name="reference" form="short">
-      <single>ref.</single>
-      <multiple>refs.</multiple>
+      <single>kay.</single>
+      <multiple>kay.</multiple>
     </term>
     <term name="retrieved">tarihinde</term>
     <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="version">versiyon</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">M.S</term>
+    <term name="ad">M.S.</term>
     <term name="bc">M.Ö.</term>
 
     <!-- PUNCTUATION -->
-    <term name="open-quote">«</term>
-    <term name="close-quote">»</term>
-    <term name="open-inner-quote">‹</term>
-    <term name="close-inner-quote">›</term>
+    <term name="open-quote">“</term>
+    <term name="close-quote">”</term>
+    <term name="open-inner-quote">‘</term>
+    <term name="close-inner-quote">’</term>
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
@@ -124,6 +124,10 @@
       <single>sayfa</single>
       <multiple>sayfalar</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>sayfa</single>
+      <multiple>sayfalar</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraf</single>
       <multiple>paragraflar</multiple>
@@ -150,33 +154,37 @@
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">kit</term>
-    <term name="chapter" form="short">böl</term>
-    <term name="column" form="short">süt</term>
-    <term name="figure" form="short">şek</term>
-    <term name="folio" form="short">f</term>
+    <term name="book" form="short">kit.</term>
+    <term name="chapter" form="short">böl.</term>
+    <term name="column" form="short">süt.</term>
+    <term name="figure" form="short">şek.</term>
+    <term name="folio" form="short">f.</term>
     <term name="issue" form="short">sayı</term>
-    <term name="line" form="short">l.</term>
+    <term name="line" form="short">satır</term>
     <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
+    <term name="opus" form="short">op.</term>
     <term name="page" form="short">
-      <single>s</single>
-      <multiple>ss</multiple>
+      <single>s.</single>
+      <multiple>ss.</multiple>
     </term>
-    <term name="paragraph" form="short">par</term>
-    <term name="part" form="short">kıs</term>
-    <term name="section" form="short">böl</term>
+    <term name="number-of-pages" form="short">
+      <single>s.</single>
+      <multiple>ss.</multiple>
+    </term>
+    <term name="paragraph" form="short">par.</term>
+    <term name="part" form="short">kıs.</term>
+    <term name="section" form="short">böl.</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
       <multiple>s.vv.</multiple>
     </term>
     <term name="verse" form="short">
-      <single>v</single>
-      <multiple>vv</multiple>
+      <single>v.</single>
+      <multiple>vv.</multiple>
     </term>
     <term name="volume" form="short">
-      <single>c</single>
-      <multiple>c</multiple>
+      <single>c.</single>
+      <multiple>c.</multiple>
     </term>
 
     <!-- SYMBOL LOCATOR FORMS -->
@@ -191,8 +199,8 @@
 
     <!-- LONG ROLE FORMS -->
     <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
+      <single>direktör</single>
+      <multiple>direktörler</multiple>
     </term>
     <term name="editor">
       <single>editör</single>
@@ -200,11 +208,11 @@
     </term>
     <term name="editorial-director">
       <single>editör</single>
-      <multiple>editör</multiple>
+      <multiple>editörler</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>illüstrasyon</single>
+      <multiple>illüstrasyon</multiple>
     </term>
     <term name="translator">
       <single>çeviren</single>
@@ -218,11 +226,11 @@
     <!-- SHORT ROLE FORMS -->
     <term name="director" form="short">
       <single>dir.</single>
-      <multiple>dirs.</multiple>
+      <multiple>dir.</multiple>
     </term>
     <term name="editor" form="short">
-      <single>ed</single>
-      <multiple>ed</multiple>
+      <single>ed.</single>
+      <multiple>ed.</multiple>
     </term>
     <term name="editorial-director" form="short">
       <single>ed.</single>
@@ -230,7 +238,7 @@
     </term>
     <term name="illustrator" form="short">
       <single>ill.</single>
-      <multiple>ills.</multiple>
+      <multiple>ill.</multiple>
     </term>
     <term name="translator" form="short">
       <single>çev.</single>
@@ -242,7 +250,8 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
+    <term name="container-author" form="verb"></term>
+    <term name="director" form="verb">direktör</term>
     <term name="editor" form="verb">editör</term>
     <term name="editorial-director" form="verb">düzenleyen</term>
     <term name="illustrator" form="verb">illustrated by</term>
@@ -253,11 +262,10 @@
     <term name="editortranslator" form="verb">düzenleyen &amp; çeviren by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short"/>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed.</term>
     <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="illustrator" form="verb-short">illüs.</term>
     <term name="translator" form="verb-short">çev.</term>
     <term name="editortranslator" form="verb-short">ed. &amp; çev.</term>
 
@@ -276,18 +284,18 @@
     <term name="month-12">Aralık</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">Oca</term>
-    <term name="month-02" form="short">Şub</term>
-    <term name="month-03" form="short">Mar</term>
-    <term name="month-04" form="short">Nis</term>
-    <term name="month-05" form="short">May</term>
-    <term name="month-06" form="short">Haz</term>
-    <term name="month-07" form="short">Tem</term>
-    <term name="month-08" form="short">Ağu</term>
-    <term name="month-09" form="short">Eyl</term>
-    <term name="month-10" form="short">Eki</term>
-    <term name="month-11" form="short">Kas</term>
-    <term name="month-12" form="short">Ara</term>
+    <term name="month-01" form="short">Oca.</term>
+    <term name="month-02" form="short">Şub.</term>
+    <term name="month-03" form="short">Mar.</term>
+    <term name="month-04" form="short">Nis.</term>
+    <term name="month-05" form="short">May.</term>
+    <term name="month-06" form="short">Haz.</term>
+    <term name="month-07" form="short">Tem.</term>
+    <term name="month-08" form="short">Ağu.</term>
+    <term name="month-09" form="short">Eyl.</term>
+    <term name="month-10" form="short">Eki.</term>
+    <term name="month-11" form="short">Kas.</term>
+    <term name="month-12" form="short">Ara.</term>
 
     <!-- SEASONS -->
     <term name="season-01">Bahar</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-uk-UA.xml 0.5.1-1/citeproc/data/locales/locales-uk-UA.xml
--- 0.3.0-6/citeproc/data/locales/locales-uk-UA.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-uk-UA.xml	2020-04-06 16:40:32.000000000 +0000
@@ -130,6 +130,10 @@
       <single>page</single>
       <multiple>pages</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>page</single>
+      <multiple>pages</multiple>
+    </term>
     <term name="paragraph">
       <single>paragraph</single>
       <multiple>paragraph</multiple>
@@ -169,6 +173,10 @@
       <single>p</single>
       <multiple>pp</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>p</single>
+      <multiple>pp</multiple>
+    </term>
     <term name="paragraph" form="short">para</term>
     <term name="part" form="short">pt</term>
     <term name="section" form="short">sec</term>
@@ -248,6 +256,7 @@
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">by</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">edited by</term>
     <term name="editorial-director" form="verb">edited by</term>
@@ -259,7 +268,6 @@
     <term name="editortranslator" form="verb">edited &amp; translated by</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">ed</term>
     <term name="editorial-director" form="verb-short">ed.</term>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-vi-VN.xml 0.5.1-1/citeproc/data/locales/locales-vi-VN.xml
--- 0.3.0-6/citeproc/data/locales/locales-vi-VN.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-vi-VN.xml	2020-04-06 16:40:32.000000000 +0000
@@ -19,19 +19,19 @@
     <term name="accessed">truy cập</term>
     <term name="and">và</term>
     <term name="and others">and others</term>
-    <term name="anonymous">anonymous</term>
-    <term name="anonymous" form="short">anon</term>
-    <term name="at">at</term>
+    <term name="anonymous">vô danh</term>
+    <term name="anonymous" form="short">v.d</term>
+    <term name="at">tại</term>
     <term name="available at">available at</term>
-    <term name="by">by</term>
+    <term name="by">bởi</term>
     <term name="circa">circa</term>
     <term name="circa" form="short">c.</term>
     <term name="cited">cited</term>
     <term name="edition">
-      <single>edition</single>
-      <multiple>editions</multiple>
+      <single>ấn bản</single>
+      <multiple>ấn bản</multiple>
     </term>
-    <term name="edition" form="short">ed</term>
+    <term name="edition" form="short">a.b</term>
     <term name="et-al">và c.s.</term>
     <term name="forthcoming">sắp tới</term>
     <term name="from">từ</term>
@@ -41,10 +41,10 @@
     <term name="internet">internet</term>
     <term name="interview">interview</term>
     <term name="letter">letter</term>
-    <term name="no date">no date</term>
+    <term name="no date">không ngày</term>
     <term name="no date" form="short">không ngày</term>
     <term name="online">online</term>
-    <term name="presented at">presented at the</term>
+    <term name="presented at">được trình bày tại</term>
     <term name="reference">
       <single>reference</single>
       <multiple>references</multiple>
@@ -62,10 +62,10 @@
     <term name="bc">BC</term>
 
     <!-- PUNCTUATION -->
-    <term name="open-quote">«</term>
-    <term name="close-quote">»</term>
-    <term name="open-inner-quote">‹</term>
-    <term name="close-inner-quote">›</term>
+    <term name="open-quote">“</term>
+    <term name="close-quote">”</term>
+    <term name="open-inner-quote">‘</term>
+    <term name="close-inner-quote">’</term>
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
@@ -78,25 +78,25 @@
     <term name="ordinal-13">th</term>
 
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">first</term>
-    <term name="long-ordinal-02">second</term>
-    <term name="long-ordinal-03">third</term>
-    <term name="long-ordinal-04">fourth</term>
-    <term name="long-ordinal-05">fifth</term>
-    <term name="long-ordinal-06">sixth</term>
-    <term name="long-ordinal-07">seventh</term>
-    <term name="long-ordinal-08">eighth</term>
-    <term name="long-ordinal-09">ninth</term>
-    <term name="long-ordinal-10">tenth</term>
+    <term name="long-ordinal-01">thứ nhất</term>
+    <term name="long-ordinal-02">thứ hai</term>
+    <term name="long-ordinal-03">thứ ba</term>
+    <term name="long-ordinal-04">thứ tư</term>
+    <term name="long-ordinal-05">thứ năm</term>
+    <term name="long-ordinal-06">thứ sáu</term>
+    <term name="long-ordinal-07">thứ bảy</term>
+    <term name="long-ordinal-08">thứ tám</term>
+    <term name="long-ordinal-09">thứ chính</term>
+    <term name="long-ordinal-10">thứ mười</term>
 
     <!-- LONG LOCATOR FORMS -->
     <term name="book">
-      <single>book</single>
-      <multiple>books</multiple>
+      <single>sách</single>
+      <multiple>sách</multiple>
     </term>
     <term name="chapter">
-      <single>chapter</single>
-      <multiple>chapters</multiple>
+      <single>chương</single>
+      <multiple>chương</multiple>
     </term>
     <term name="column">
       <single>column</single>
@@ -111,16 +111,16 @@
       <multiple>folios</multiple>
     </term>
     <term name="issue">
-      <single>number</single>
-      <multiple>numbers</multiple>
+      <single>số</single>
+      <multiple>số</multiple>
     </term>
     <term name="line">
       <single>dòng</single>
       <multiple>dòng</multiple>
     </term>
     <term name="note">
-      <single>note</single>
-      <multiple>notes</multiple>
+      <single>ghi chú</single>
+      <multiple>ghi chú</multiple>
     </term>
     <term name="opus">
       <single>opus</single>
@@ -130,13 +130,17 @@
       <single>trang</single>
       <multiple>trang</multiple>
     </term>
+    <term name="number-of-pages">
+      <single>trang</single>
+      <multiple>trang</multiple>
+    </term>
     <term name="paragraph">
       <single>đoạn văn</single>
       <multiple>đoạn văn</multiple>
     </term>
     <term name="part">
-      <single>part</single>
-      <multiple>parts</multiple>
+      <single>phần</single>
+      <multiple>phần</multiple>
     </term>
     <term name="section">
       <single>section</single>
@@ -147,30 +151,34 @@
       <multiple>sub verbis</multiple>
     </term>
     <term name="verse">
-      <single>verse</single>
-      <multiple>verses</multiple>
+      <single>câu</single>
+      <multiple>câu</multiple>
     </term>
     <term name="volume">
-      <single>volume</single>
-      <multiple>volumes</multiple>
+      <single>tập</single>
+      <multiple>tập</multiple>
     </term>
 
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">bk</term>
-    <term name="chapter" form="short">chap</term>
+    <term name="book" form="short">sách</term>
+    <term name="chapter" form="short">ch</term>
     <term name="column" form="short">col</term>
     <term name="figure" form="short">fig</term>
     <term name="folio" form="short">f</term>
     <term name="issue" form="short">số p.h</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
+    <term name="line" form="short">d.</term>
+    <term name="note" form="short">gc.</term>
     <term name="opus" form="short">op</term>
     <term name="page" form="short">
       <single>tr</single>
       <multiple>tr</multiple>
     </term>
+    <term name="number-of-pages" form="short">
+      <single>tr</single>
+      <multiple>tr</multiple>
+    </term>
     <term name="paragraph" form="short">para</term>
-    <term name="part" form="short">pt</term>
+    <term name="part" form="short">ph</term>
     <term name="section" form="short">sec</term>
     <term name="sub verbo" form="short">
       <single>s.v.</single>
@@ -205,20 +213,20 @@
       <multiple>biên tập viên</multiple>
     </term>
     <term name="editorial-director">
-      <single>editor</single>
-      <multiple>editors</multiple>
+      <single>biên tập viên</single>
+      <multiple>biên tập viên</multiple>
     </term>
     <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
+      <single>họa sĩ</single>
+      <multiple>họa sĩ</multiple>
     </term>
     <term name="translator">
       <single>biên dịch viên</single>
       <multiple>biên dịch viên</multiple>
     </term>
     <term name="editortranslator">
-      <single>editor &amp; translator</single>
-      <multiple>editors &amp; translators</multiple>
+      <single>biên tập viên &amp; biên dịch viên</single>
+      <multiple>biên tập viên &amp; biên dịch viên</multiple>
     </term>
 
     <!-- SHORT ROLE FORMS -->
@@ -231,41 +239,41 @@
       <multiple>b.t.v</multiple>
     </term>
     <term name="editorial-director" form="short">
-      <single>ed.</single>
-      <multiple>eds.</multiple>
+      <single>b.t.v</single>
+      <multiple>b.t.v</multiple>
     </term>
     <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
+      <single>h.s</single>
+      <multiple>h.s</multiple>
     </term>
     <term name="translator" form="short">
       <single>b.d.v</single>
       <multiple>b.d.v</multiple>
     </term>
     <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
+      <single>b.t.v &amp; b.d.v</single>
+      <multiple>b.t.v &amp; b.d.v</multiple>
     </term>
 
     <!-- VERB ROLE FORMS -->
+    <term name="container-author" form="verb">bởi</term>
     <term name="director" form="verb">directed by</term>
     <term name="editor" form="verb">biên tập bởi</term>
-    <term name="editorial-director" form="verb">edited by</term>
+    <term name="editorial-director" form="verb">biên tập bởi</term>
     <term name="illustrator" form="verb">illustrated by</term>
     <term name="interviewer" form="verb">interview by</term>
     <term name="recipient" form="verb">to</term>
-    <term name="reviewed-author" form="verb">by</term>
+    <term name="reviewed-author" form="verb">bởi</term>
     <term name="translator" form="verb">biên dịch bởi</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="editortranslator" form="verb">biên tập &amp; biên dịch bởi</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
     <term name="director" form="verb-short">dir.</term>
     <term name="editor" form="verb-short">b.t</term>
-    <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="editorial-director" form="verb-short">b.t</term>
+    <term name="illustrator" form="verb-short">h.s</term>
     <term name="translator" form="verb-short">b.d</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="editortranslator" form="verb-short">b.t &amp; b.d bởi</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">Tháng Giêng</term>
@@ -296,9 +304,9 @@
     <term name="month-12" form="short">tháng 12</term>
 
     <!-- SEASONS -->
-    <term name="season-01">Spring</term>
-    <term name="season-02">Summer</term>
-    <term name="season-03">Autumn</term>
-    <term name="season-04">Winter</term>
+    <term name="season-01">Mùa Xuân</term>
+    <term name="season-02">Mùa Hè</term>
+    <term name="season-03">Mùa Thu</term>
+    <term name="season-04">Mùa Đông</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-zh-CN.xml 0.5.1-1/citeproc/data/locales/locales-zh-CN.xml
--- 0.3.0-6/citeproc/data/locales/locales-zh-CN.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-zh-CN.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="zh-CN">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2014-05-15T23:31:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -12,179 +12,106 @@
   </date>
   <date form="numeric">
     <date-part name="year"/>
-    <date-part name="month" form="numeric" prefix="-" range-delimiter="/"/>
-    <date-part name="day" prefix="-" range-delimiter="/"/>
+    <date-part name="month" form="numeric-leading-zeros" prefix="/"/>
+    <date-part name="day" form="numeric-leading-zeros" prefix="/"/>
   </date>
   <terms>
-    <term name="accessed">accessed</term>
-    <term name="and">and</term>
-    <term name="and others">and others</term>
-    <term name="anonymous">anonymous</term>
-    <term name="anonymous" form="short">anon</term>
-    <term name="at">at</term>
-    <term name="available at">available at</term>
-    <term name="by">by</term>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">c.</term>
-    <term name="cited">cited</term>
-    <term name="edition">
-      <single>edition</single>
-      <multiple>editions</multiple>
-    </term>
-    <term name="edition" form="short">ed</term>
-    <term name="et-al">et al.</term>
-    <term name="forthcoming">forthcoming</term>
-    <term name="from">from</term>
-    <term name="ibid">ibid.</term>
-    <term name="in">in</term>
-    <term name="in press">in press</term>
-    <term name="internet">internet</term>
-    <term name="interview">interview</term>
-    <term name="letter">letter</term>
-    <term name="no date">no date</term>
-    <term name="no date" form="short">nd</term>
-    <term name="online">online</term>
-    <term name="presented at">presented at the</term>
-    <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
-    </term>
-    <term name="reference" form="short">
-      <single>ref.</single>
-      <multiple>refs.</multiple>
-    </term>
-    <term name="retrieved">retrieved</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="accessed">见於</term>
+    <term name="and">和</term>
+    <term name="and others">及其他</term>
+    <term name="anonymous">作者不详</term>
+    <term name="anonymous" form="short">无名氏</term>
+    <term name="at">於</term>
+    <term name="available at">载於</term>
+    <term name="by">著</term>
+    <term name="circa">介于</term>
+    <term name="circa" form="short">约</term>
+    <term name="cited">见引於</term>
+    <term name="edition">版本</term>
+    <term name="edition" form="short">本</term>
+    <term name="et-al">等</term>
+    <term name="forthcoming">即将出版</term>
+    <term name="from">从</term>
+    <term name="ibid">同上</term>
+    <term name="in">收入</term>
+    <term name="in press">送印中</term>
+    <term name="internet">网际网络</term>
+    <term name="interview">访谈</term>
+    <term name="letter">信函</term>
+    <term name="no date">日期不详</term>
+    <term name="no date" form="short">不详</term>
+    <term name="online">在线</term>
+    <term name="presented at">发表於</term>
+    <term name="reference">参考</term>
+    <term name="reference" form="short">参</term>
+    <term name="retrieved">取读于</term>
+    <term name="scale">比例</term>
+    <term name="version">版</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">公元</term>
+    <term name="bc">公元前</term>
 
     <!-- PUNCTUATION -->
-    <term name="open-quote">“</term>
-    <term name="close-quote">”</term>
-    <term name="open-inner-quote">‘</term>
-    <term name="close-inner-quote">’</term>
+    <term name="open-quote">《</term>
+    <term name="close-quote">》</term>
+    <term name="open-inner-quote">〈</term>
+    <term name="close-inner-quote">〉</term>
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
-
+    <term name="ordinal"></term>
+  
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">first</term>
-    <term name="long-ordinal-02">second</term>
-    <term name="long-ordinal-03">third</term>
-    <term name="long-ordinal-04">fourth</term>
-    <term name="long-ordinal-05">fifth</term>
-    <term name="long-ordinal-06">sixth</term>
-    <term name="long-ordinal-07">seventh</term>
-    <term name="long-ordinal-08">eighth</term>
-    <term name="long-ordinal-09">ninth</term>
-    <term name="long-ordinal-10">tenth</term>
+    <term name="long-ordinal-01">一</term>
+    <term name="long-ordinal-02">二</term>
+    <term name="long-ordinal-03">三</term>
+    <term name="long-ordinal-04">四</term>
+    <term name="long-ordinal-05">五</term>
+    <term name="long-ordinal-06">六</term>
+    <term name="long-ordinal-07">七</term>
+    <term name="long-ordinal-08">八</term>
+    <term name="long-ordinal-09">九</term>
+    <term name="long-ordinal-10">十</term>
 
     <!-- LONG LOCATOR FORMS -->
-    <term name="book">
-      <single>book</single>
-      <multiple>books</multiple>
-    </term>
-    <term name="chapter">
-      <single>chapter</single>
-      <multiple>chapters</multiple>
-    </term>
-    <term name="column">
-      <single>column</single>
-      <multiple>columns</multiple>
-    </term>
-    <term name="figure">
-      <single>figure</single>
-      <multiple>figures</multiple>
-    </term>
-    <term name="folio">
-      <single>folio</single>
-      <multiple>folios</multiple>
-    </term>
-    <term name="issue">
-      <single>number</single>
-      <multiple>numbers</multiple>
-    </term>
-    <term name="line">
-      <single>line</single>
-      <multiple>line</multiple>
-    </term>
-    <term name="note">
-      <single>note</single>
-      <multiple>notes</multiple>
-    </term>
-    <term name="opus">
-      <single>opus</single>
-      <multiple>opera</multiple>
-    </term>
-    <term name="page">
-      <single>page</single>
-      <multiple>pages</multiple>
-    </term>
-    <term name="paragraph">
-      <single>paragraph</single>
-      <multiple>paragraph</multiple>
-    </term>
-    <term name="part">
-      <single>part</single>
-      <multiple>parts</multiple>
-    </term>
-    <term name="section">
-      <single>section</single>
-      <multiple>sections</multiple>
-    </term>
-    <term name="sub verbo">
-      <single>sub verbo</single>
-      <multiple>sub verbis</multiple>
-    </term>
-    <term name="verse">
-      <single>verse</single>
-      <multiple>verses</multiple>
-    </term>
-    <term name="volume">
-      <single>volume</single>
-      <multiple>volumes</multiple>
-    </term>
-
+    <term name="book">册</term>
+    <term name="chapter">章</term>
+    <term name="column">栏</term>
+    <term name="figure">图表</term>       
+    <term name="folio">版</term>
+    <term name="issue">期</term>
+    <term name="line">行</term>
+    <term name="note">注脚</term>
+    <term name="opus">作品</term>      
+    <term name="page">页</term>
+    <term name="number-of-pages"> 总页数</term>      
+    <term name="paragraph">段落</term>
+    <term name="part">部分</term>     
+    <term name="section">节</term>         
+    <term name="sub verbo">另见</term>    
+    <term name="verse">篇</term>    
+    <term name="volume">卷</term>
+    
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">bk</term>
-    <term name="chapter" form="short">chap</term>
-    <term name="column" form="short">col</term>
-    <term name="figure" form="short">fig</term>
-    <term name="folio" form="short">f</term>
-    <term name="issue" form="short">no</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">op</term>
-    <term name="page" form="short">
-      <single>p</single>
-      <multiple>pp</multiple>
-    </term>
-    <term name="paragraph" form="short">para</term>
-    <term name="part" form="short">pt</term>
-    <term name="section" form="short">sec</term>
-    <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
-    </term>
-    <term name="verse" form="short">
-      <single>v</single>
-      <multiple>vv</multiple>
-    </term>
-    <term name="volume" form="short">
-      <single>vol</single>
-      <multiple>vols</multiple>
-    </term>
-
+    <term name="book" form="short">册</term>
+    <term name="chapter" form="short">章</term>
+    <term name="column" form="short">栏</term>
+    <term name="figure" form="short">图</term>
+    <term name="folio" form="short">版</term>
+    <term name="issue" form="short">期</term>
+    <term name="line" form="short">行</term>
+    <term name="note" form="short">注</term>
+    <term name="opus" form="short">op.</term>
+    <term name="page" form="short">页</term>   
+    <term name="number-of-pages" form="short">共</term>    
+    <term name="paragraph" form="short">段</term>
+    <term name="part" form="short">部</term>
+    <term name="section" form="short">节</term>
+    <term name="sub verbo" form="short">另见</term>   
+    <term name="verse" form="short">篇</term>      
+    <term name="volume" form="short">卷</term>
+    
     <!-- SYMBOL LOCATOR FORMS -->
     <term name="paragraph" form="symbol">
       <single>¶</single>
@@ -196,109 +123,74 @@
     </term>
 
     <!-- LONG ROLE FORMS -->
-    <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
-    </term>
-    <term name="editor">
-      <single>editor</single>
-      <multiple>editors</multiple>
-    </term>
-    <term name="editorial-director">
-      <single>editor</single>
-      <multiple>editors</multiple>
-    </term>
-    <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
-    </term>
-    <term name="translator">
-      <single>translator</single>
-      <multiple>translators</multiple>
-    </term>
-    <term name="editortranslator">
-      <single>editor &amp; translator</single>
-      <multiple>editors &amp; translators</multiple>
-    </term>
+    <term name="director">导演</term>     
+    <term name="editor">编辑</term> 
+    <term name="editorial-director">主编</term>     
+    <term name="illustrator">绘图</term>     
+    <term name="translator">翻译</term>      
+    <term name="editortranslator">编译</term>     
 
     <!-- SHORT ROLE FORMS -->
-    <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
-    </term>
-    <term name="editor" form="short">
-      <single>ed</single>
-      <multiple>eds</multiple>
-    </term>
-    <term name="editorial-director" form="short">
-      <single>ed.</single>
-      <multiple>eds.</multiple>
-    </term>
-    <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
-    </term>
-    <term name="translator" form="short">
-      <single>tran</single>
-      <multiple>trans</multiple>
-    </term>
-    <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
-    </term>
+    <term name="director" form="short">导演</term>     
+    <term name="editor" form="short">编</term>     
+    <term name="editorial-director" form="short">主编</term>     
+    <term name="illustrator" form="short">绘</term>   
+    <term name="translator" form="short">译</term>     
+    <term name="editortranslator" form="short">编译</term>    
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">edited by</term>
-    <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
-    <term name="interviewer" form="verb">interview by</term>
-    <term name="recipient" form="verb">to</term>
-    <term name="reviewed-author" form="verb">by</term>
-    <term name="translator" form="verb">translated by</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="container-author" form="verb">著</term>
+    <term name="director" form="verb">指导</term>
+    <term name="editor" form="verb">编辑</term>
+    <term name="editorial-director" form="verb">主编</term>
+    <term name="illustrator" form="verb">绘图</term>
+    <term name="interviewer" form="verb">采访</term>
+    <term name="recipient" form="verb">受函</term>
+    <term name="reviewed-author" form="verb">校订</term>
+    <term name="translator" form="verb">翻译</term>
+    <term name="editortranslator" form="verb">编译</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
-    <term name="director" form="verb-short">dir.</term>
-    <term name="editor" form="verb-short">ed</term>
-    <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
-    <term name="translator" form="verb-short">trans</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="director" form="verb-short">导</term>
+    <term name="editor" form="verb-short">编</term>
+    <term name="editorial-director" form="verb-short">主编</term>
+    <term name="illustrator" form="verb-short">绘</term>
+    <term name="translator" form="verb-short">译</term>
+    <term name="editortranslator" form="verb-short">编译</term>
+    <term name="reviewed-author" form="verb">校</term>
 
     <!-- LONG MONTH FORMS -->
-    <term name="month-01">January</term>
-    <term name="month-02">February</term>
-    <term name="month-03">March</term>
-    <term name="month-04">April</term>
-    <term name="month-05">May</term>
-    <term name="month-06">June</term>
-    <term name="month-07">July</term>
-    <term name="month-08">August</term>
-    <term name="month-09">September</term>
-    <term name="month-10">October</term>
-    <term name="month-11">November</term>
-    <term name="month-12">December</term>
+    <term name="month-01">一月</term>
+    <term name="month-02">二月</term>
+    <term name="month-03">三月</term>
+    <term name="month-04">四月</term>
+    <term name="month-05">五月</term>
+    <term name="month-06">六月</term>
+    <term name="month-07">七月</term>
+    <term name="month-08">八月</term>
+    <term name="month-09">九月</term>
+    <term name="month-10">十月</term>
+    <term name="month-11">十一月</term>
+    <term name="month-12">十二月</term>
 
     <!-- SHORT MONTH FORMS -->
-    <term name="month-01" form="short">Jan</term>
-    <term name="month-02" form="short">Feb</term>
-    <term name="month-03" form="short">Mar</term>
-    <term name="month-04" form="short">Apr</term>
-    <term name="month-05" form="short">May</term>
-    <term name="month-06" form="short">Jun</term>
-    <term name="month-07" form="short">Jul</term>
-    <term name="month-08" form="short">Aug</term>
-    <term name="month-09" form="short">Sep</term>
-    <term name="month-10" form="short">Oct</term>
-    <term name="month-11" form="short">Nov</term>
-    <term name="month-12" form="short">Dec</term>
+    <term name="month-01" form="short">1月</term>
+    <term name="month-02" form="short">2月</term>
+    <term name="month-03" form="short">3月</term>
+    <term name="month-04" form="short">4月</term>
+    <term name="month-05" form="short">5月</term>
+    <term name="month-06" form="short">6月</term>
+    <term name="month-07" form="short">7月</term>
+    <term name="month-08" form="short">8月</term>
+    <term name="month-09" form="short">9月</term>
+    <term name="month-10" form="short">10月</term>
+    <term name="month-11" form="short">11月</term>
+    <term name="month-12" form="short">12月</term>
 
     <!-- SEASONS -->
-    <term name="season-01">Spring</term>
-    <term name="season-02">Summer</term>
-    <term name="season-03">Autumn</term>
-    <term name="season-04">Winter</term>
+    <term name="season-01">春</term>
+    <term name="season-02">夏</term>
+    <term name="season-03">秋</term>
+    <term name="season-04">冬</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/locales/locales-zh-TW.xml 0.5.1-1/citeproc/data/locales/locales-zh-TW.xml
--- 0.3.0-6/citeproc/data/locales/locales-zh-TW.xml	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/locales/locales-zh-TW.xml	2020-04-06 16:40:32.000000000 +0000
@@ -2,7 +2,7 @@
 <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="zh-TW">
   <info>
     <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>
-    <updated>2012-07-04T23:31:02+00:00</updated>
+    <updated>2014-05-15T23:31:02+00:00</updated>
   </info>
   <style-options punctuation-in-quote="false"/>
   <date form="text">
@@ -16,50 +16,41 @@
     <date-part name="day" form="numeric-leading-zeros" prefix="/"/>
   </date>
   <terms>
-    <term name="accessed">被取用</term>
+    <term name="accessed">引見於</term>
     <term name="and">及</term>
     <term name="and others">及其他</term>
-    <term name="anonymous">不具名的</term>
-    <term name="anonymous" form="short">無名</term>
-    <term name="at">在</term>
-    <term name="available at">available at</term>
-    <term name="by">by</term>
-    <term name="circa">circa</term>
-    <term name="circa" form="short">c.</term>
-    <term name="cited">被引用</term>
-    <term name="edition">
-      <single>版本</single>
-      <multiple>版本</multiple>
-    </term>
-    <term name="edition" form="short">版</term>
-    <term name="et-al">等人</term>
-    <term name="forthcoming">將來的</term>
+    <term name="anonymous">作者不詳</term>
+    <term name="anonymous" form="short">無名氏</term>
+    <term name="at">於</term>
+    <term name="available at">載於</term>
+    <term name="by">著</term>
+    <term name="circa">介於</term>
+    <term name="circa" form="short">約</term>
+    <term name="cited">見引於</term>
+    <term name="edition">版本</term>
+    <term name="edition" form="short">本</term>
+    <term name="et-al">等</term>
+    <term name="forthcoming">即將出版</term>
     <term name="from">從</term>
-    <term name="ibid">同上出處</term>
-    <term name="in">在</term>
+    <term name="ibid">同上</term>
+    <term name="in">收入</term>
     <term name="in press">印行中</term>
-    <term name="internet">網際網路</term>
-    <term name="interview">訪問</term>
-    <term name="letter">信件</term>
-    <term name="no date">no date</term>
-    <term name="no date" form="short">無日期</term>
-    <term name="online">在線上</term>
-    <term name="presented at">簡報於</term>
-    <term name="reference">
-      <single>reference</single>
-      <multiple>references</multiple>
-    </term>
-    <term name="reference" form="short">
-      <single>ref.</single>
-      <multiple>refs.</multiple>
-    </term>
-    <term name="retrieved">被取回</term>
-    <term name="scale">scale</term>
-    <term name="version">version</term>
+    <term name="internet">互聯網</term>
+    <term name="interview">訪談</term>
+    <term name="letter">信函</term>
+    <term name="no date">日期不詳</term>
+    <term name="no date" form="short">不詳</term>
+    <term name="online">線上</term>
+    <term name="presented at">發表於</term>
+    <term name="reference">參考</term>
+    <term name="reference" form="short">參</term>
+    <term name="retrieved">讀取於</term>
+    <term name="scale">比例</term>
+    <term name="version">版</term>
 
     <!-- ANNO DOMINI; BEFORE CHRIST -->
-    <term name="ad">AD</term>
-    <term name="bc">BC</term>
+    <term name="ad">西元</term>
+    <term name="bc">西元前</term>
 
     <!-- PUNCTUATION -->
     <term name="open-quote">「</term>
@@ -69,122 +60,57 @@
     <term name="page-range-delimiter">–</term>
 
     <!-- ORDINALS -->
-    <term name="ordinal">th</term>
-    <term name="ordinal-01">st</term>
-    <term name="ordinal-02">nd</term>
-    <term name="ordinal-03">rd</term>
-    <term name="ordinal-11">th</term>
-    <term name="ordinal-12">th</term>
-    <term name="ordinal-13">th</term>
-
+    <term name="ordinal"></term>
+  
     <!-- LONG ORDINALS -->
-    <term name="long-ordinal-01">first</term>
-    <term name="long-ordinal-02">second</term>
-    <term name="long-ordinal-03">third</term>
-    <term name="long-ordinal-04">fourth</term>
-    <term name="long-ordinal-05">fifth</term>
-    <term name="long-ordinal-06">sixth</term>
-    <term name="long-ordinal-07">seventh</term>
-    <term name="long-ordinal-08">eighth</term>
-    <term name="long-ordinal-09">ninth</term>
-    <term name="long-ordinal-10">tenth</term>
+    <term name="long-ordinal-01">一</term>
+    <term name="long-ordinal-02">二</term>
+    <term name="long-ordinal-03">三</term>
+    <term name="long-ordinal-04">四</term>
+    <term name="long-ordinal-05">五</term>
+    <term name="long-ordinal-06">六</term>
+    <term name="long-ordinal-07">七</term>
+    <term name="long-ordinal-08">八</term>
+    <term name="long-ordinal-09">九</term>
+    <term name="long-ordinal-10">十</term>
 
     <!-- LONG LOCATOR FORMS -->
-    <term name="book">
-      <single>書</single>
-      <multiple>書</multiple>
-    </term>
-    <term name="chapter">
-      <single>章</single>
-      <multiple>章</multiple>
-    </term>
-    <term name="column">
-      <single>欄</single>
-      <multiple>欄</multiple>
-    </term>
-    <term name="figure">
-      <single>圖</single>
-      <multiple>圖</multiple>
-    </term>
-    <term name="folio">
-      <single>對開紙</single>
-      <multiple>對開紙</multiple>
-    </term>
-    <term name="issue">
-      <single>期數</single>
-      <multiple>期數</multiple>
-    </term>
-    <term name="line">
-      <single>行</single>
-      <multiple>行</multiple>
-    </term>
-    <term name="note">
-      <single>筆記</single>
-      <multiple>筆記</multiple>
-    </term>
-    <term name="opus">
-      <single>作品</single>
-      <multiple>作品</multiple>
-    </term>
-    <term name="page">
-      <single>頁</single>
-      <multiple>頁</multiple>
-    </term>
-    <term name="paragraph">
-      <single>段落</single>
-      <multiple>段落</multiple>
-    </term>
-    <term name="part">
-      <single>部</single>
-      <multiple>部</multiple>
-    </term>
-    <term name="section">
-      <single>節</single>
-      <multiple>節</multiple>
-    </term>
-    <term name="sub verbo">
-      <single>sub verbo</single>
-      <multiple>sub verbis</multiple>
-    </term>
-    <term name="verse">
-      <single>詩句</single>
-      <multiple>詩句</multiple>
-    </term>
-    <term name="volume">
-      <single>冊</single>
-      <multiple>冊</multiple>
-    </term>
-
+    <term name="book">冊</term>
+    <term name="chapter">章</term>
+    <term name="column">欄</term>
+    <term name="figure">圖表</term>       
+    <term name="folio">版</term>
+    <term name="issue">期</term>
+    <term name="line">行</term>
+    <term name="note">註腳</term>
+    <term name="opus">作品</term>      
+    <term name="page">頁</term>
+    <term name="number-of-pages">總頁數</term>      
+    <term name="paragraph">段落</term>
+    <term name="part">部分</term>     
+    <term name="section">節</term>         
+    <term name="sub verbo">另見</term>    
+    <term name="verse">篇</term>    
+    <term name="volume">卷</term>
+    
     <!-- SHORT LOCATOR FORMS -->
-    <term name="book" form="short">書</term>
+    <term name="book" form="short">冊</term>
     <term name="chapter" form="short">章</term>
     <term name="column" form="short">欄</term>
     <term name="figure" form="short">圖</term>
-    <term name="folio" form="short">開</term>
     <term name="issue" form="short">期</term>
-    <term name="line" form="short">l.</term>
-    <term name="note" form="short">n.</term>
-    <term name="opus" form="short">作</term>
-    <term name="page" form="short">
-      <single>頁</single>
-      <multiple>頁</multiple>
-    </term>
+    <term name="line" form="short">行</term>
+    <term name="note" form="short">註</term>
+    <term name="opus" form="short">op.</term>
+    <term name="page" form="short">頁</term>   
+    <term name="number-of-pages" form="short">共</term>    
     <term name="paragraph" form="short">段</term>
     <term name="part" form="short">部</term>
     <term name="section" form="short">節</term>
-    <term name="sub verbo" form="short">
-      <single>s.v.</single>
-      <multiple>s.vv.</multiple>
-    </term>
-    <term name="verse" form="short">
-      <single>句</single>
-      <multiple>句</multiple>
-    </term>
-    <term name="volume" form="short">
-      <single>冊</single>
-      <multiple>冊</multiple>
-    </term>
-
+    <term name="sub verbo" form="short">另見</term>   
+    <term name="verse" form="short">篇</term>      
+    <term name="volume" form="short">卷</term>
+    
     <!-- SYMBOL LOCATOR FORMS -->
     <term name="paragraph" form="symbol">
       <single>¶</single>
@@ -196,76 +122,52 @@
     </term>
 
     <!-- LONG ROLE FORMS -->
-    <term name="director">
-      <single>director</single>
-      <multiple>directors</multiple>
-    </term>
-    <term name="editor">
-      <single>編輯</single>
-      <multiple>編輯</multiple>
-    </term>
-    <term name="editorial-director">
-      <single>editor</single>
-      <multiple>editors</multiple>
-    </term>
-    <term name="illustrator">
-      <single>illustrator</single>
-      <multiple>illustrators</multiple>
-    </term>
-    <term name="translator">
-      <single>翻譯</single>
-      <multiple>翻譯</multiple>
-    </term>
-    <term name="editortranslator">
-      <single>editor &amp; translator</single>
-      <multiple>editors &amp; translators</multiple>
-    </term>
+    <term name="author">作者</term>     
+    <term name="director">導演</term>     
+    <term name="editor">編輯</term> 
+    <term name="editorial-director">主編</term>     
+    <term name="illustrator">繪圖師</term>
+    <term name="interviewer">採訪員</term>
+    <term name="recipient">收信人</term>     
+    <term name="translator">翻譯員</term>      
+    <term name="editortranslator">編譯員</term>
+    <term name="reviewed-author">評論人</term>
 
     <!-- SHORT ROLE FORMS -->
-    <term name="director" form="short">
-      <single>dir.</single>
-      <multiple>dirs.</multiple>
-    </term>
-    <term name="editor" form="short">
-      <single>編</single>
-      <multiple>編</multiple>
-    </term>
-    <term name="editorial-director" form="short">
-      <single>ed.</single>
-      <multiple>eds.</multiple>
-    </term>
-    <term name="illustrator" form="short">
-      <single>ill.</single>
-      <multiple>ills.</multiple>
-    </term>
-    <term name="translator" form="short">
-      <single>譯</single>
-      <multiple>譯</multiple>
-    </term>
-    <term name="editortranslator" form="short">
-      <single>ed. &amp; tran.</single>
-      <multiple>eds. &amp; trans.</multiple>
-    </term>
+    <term name="author" form="short">作者</term>     
+    <term name="director" form="short">導演</term>     
+    <term name="editor" form="short">編輯</term> 
+    <term name="editorial-director" form="short">主編</term>     
+    <term name="illustrator" form="short">繪圖師</term>
+    <term name="interviewer" form="short">採訪員</term>
+    <term name="recipient" form="short">收信人</term>     
+    <term name="translator" form="short">翻譯員</term>      
+    <term name="editortranslator" form="short">編譯員</term>
+    <term name="reviewed-author" form="short">評論人</term>
+
 
     <!-- VERB ROLE FORMS -->
-    <term name="director" form="verb">directed by</term>
-    <term name="editor" form="verb">編者是</term>
-    <term name="editorial-director" form="verb">edited by</term>
-    <term name="illustrator" form="verb">illustrated by</term>
-    <term name="interviewer" form="verb">訪問者是</term>
-    <term name="recipient" form="verb">授與</term>
-    <term name="reviewed-author" form="verb">by</term>
-    <term name="translator" form="verb">譯者是</term>
-    <term name="editortranslator" form="verb">edited &amp; translated by</term>
+    <term name="author" form="verb">著</term>
+    <term name="container-author" form="verb">著</term>
+    <term name="director" form="verb">指導</term>
+    <term name="editor" form="verb">編輯</term>
+    <term name="collection-editor" form="verb">點校</term>
+    <term name="editorial-director" form="verb">主編</term>
+    <term name="illustrator" form="verb">繪圖</term>
+    <term name="interviewer" form="verb">採訪</term>
+    <term name="recipient" form="verb">受函</term>
+    <term name="reviewed-author" form="verb">點評</term>
+    <term name="translator" form="verb">翻譯</term>
+    <term name="editortranslator" form="verb">編譯</term>
 
     <!-- SHORT VERB ROLE FORMS -->
-    <term name="container-author" form="verb-short">by</term>
-    <term name="director" form="verb-short">dir.</term>
+    <term name="director" form="verb-short">導</term>
     <term name="editor" form="verb-short">編</term>
-    <term name="editorial-director" form="verb-short">ed.</term>
-    <term name="illustrator" form="verb-short">illus.</term>
+    <term name="collection-editor" form="verb-short">校</term>
+    <term name="editorial-director" form="verb-short">編</term>
+    <term name="illustrator" form="verb-short">繪</term>
     <term name="translator" form="verb-short">譯</term>
-    <term name="editortranslator" form="verb-short">ed. &amp; trans. by</term>
+    <term name="reviewed-author" form="verb-short">評</term>
 
     <!-- LONG MONTH FORMS -->
     <term name="month-01">一月</term>
@@ -296,9 +198,9 @@
     <term name="month-12" form="short">12月</term>
 
     <!-- SEASONS -->
-    <term name="season-01">Spring</term>
-    <term name="season-02">Summer</term>
-    <term name="season-03">Autumn</term>
-    <term name="season-04">Winter</term>
+    <term name="season-01">春</term>
+    <term name="season-02">夏</term>
+    <term name="season-03">秋</term>
+    <term name="season-04">冬</term>
   </terms>
 </locale>
diff -pruN 0.3.0-6/citeproc/data/schema/csl-categories.rnc 0.5.1-1/citeproc/data/schema/csl-categories.rnc
--- 0.3.0-6/citeproc/data/schema/csl-categories.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-categories.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,36 @@
+
+## Categories for style metadata
+div {
+  category.citation-format =
+    "author" | "author-date" | "label" | "note" | "numeric"
+  
+  ## Use "generic-base" for styles that are non-discipline specific, such as
+  ## APA, Harvard, etc.
+  category.field =
+    "anthropology"
+    | "astronomy"
+    | "biology"
+    | "botany"
+    | "chemistry"
+    | "communications"
+    | "engineering"
+    | "generic-base"
+    | "geography"
+    | "geology"
+    | "history"
+    | "humanities"
+    | "law"
+    | "linguistics"
+    | "literature"
+    | "math"
+    | "medicine"
+    | "philosophy"
+    | "physics"
+    | "political_science"
+    | "psychology"
+    | "science"
+    | "social_science"
+    | "sociology"
+    | "theology"
+    | "zoology"
+}
diff -pruN 0.3.0-6/citeproc/data/schema/csl-categories.rng 0.5.1-1/citeproc/data/schema/csl-categories.rng
--- 0.3.0-6/citeproc/data/schema/csl-categories.rng	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-categories.rng	1970-01-01 00:00:00.000000000 +0000
@@ -1,51 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<grammar xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns:cs="http://purl.org/net/xbiblio/csl" xmlns="http://relaxng.org/ns/structure/1.0">
-  <div>
-    <define name="info-format-categories">
-      <choice>
-        <value>author-date</value>
-        <value>numeric</value>
-        <value>label</value>
-        <value>note</value>
-        <value>author</value>
-      </choice>
-    </define>
-    <define name="info-field-categories">
-      <a:documentation>"generic-base" is reserved for truly generic styles (APA, Harvard, etc.).</a:documentation>
-      <choice>
-        <value>anthropology</value>
-        <value>astronomy</value>
-        <value>biology</value>
-        <value>botany</value>
-        <value>chemistry</value>
-        <value>communications</value>
-        <value>engineering</value>
-        <value>generic-base</value>
-        <value>geography</value>
-        <value>geology</value>
-        <value>history</value>
-        <value>humanities</value>
-        <value>law</value>
-        <value>linguistics</value>
-        <value>literature</value>
-        <value>math</value>
-        <value>medicine</value>
-        <value>philosophy</value>
-        <value>physics</value>
-        <value>political_science</value>
-        <value>psychology</value>
-        <value>science</value>
-        <value>social_science</value>
-        <value>sociology</value>
-        <value>theology</value>
-        <value>zoology</value>
-        <ref name="info-categories.extension"/>
-      </choice>
-    </define>
-    <define name="info-categories.extension">
-      <a:documentation>Categories can be redefined in a customization schema, though please
-report obvious gaps for inclusion in the schema.</a:documentation>
-      <notAllowed/>
-    </define>
-  </div>
-</grammar>
diff -pruN 0.3.0-6/citeproc/data/schema/csl-data.rnc 0.5.1-1/citeproc/data/schema/csl-data.rnc
--- 0.3.0-6/citeproc/data/schema/csl-data.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-data.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,103 @@
+namespace dc = "http://purl.org/dc/elements/1.1/"
+
+dc:title [ "Citation Style Language Data" ]
+dc:creator [ "Bruce D'Arcus" ]
+dc:copyright [ "Bruce D'Arcus, 2009" ]
+dc:description [ "A schema for the CSL data model." ]
+include "csl-types.rnc"
+include "csl-variables.rnc"
+start = element references { reference+ }
+reference = element reference { type, id, uri?, container-uri?, (contributor* & date* & variable+) }
+
+## Types 
+div {
+  type = attribute type { cs-types }
+}
+
+## Identifiers
+div {
+
+   ## The id is an identifier unique to the scope of the file
+   id = attribute id { token }
+   
+   ## The URI is the global identity for the refererence; used to associate a citation reference to its data
+   uri = attribute uri { xsd:anyURI }
+  
+   ## the URI for containing items (such as edited books or journals)
+   container-uri = attribute container-uri { xsd:anyURI }
+}
+
+## Contributors
+div {
+   contributor =
+      element contributor {
+         attribute type { cs-names },
+         name-elements
+      }
+   name-elements =
+      element name { text }
+    | ((element given { text }? &
+       element family { text }?) &
+       element dropping-particle { text }? &
+       element non-dropping-particle { text }? &
+       element suffix { text }?)
+}
+
+## Dates
+div {
+   date =
+      element date { 
+         attribute type { cs-dates }, 
+         attribute circa { xsd:boolean }?,
+         (date-pattern | date-range)
+      }
+   date-pattern =
+      year-pattern,
+      ( ( month-pattern, day-pattern? ) | season-pattern )?
+   date-range =
+      element begin-date { date-pattern },
+      element end-date { date-pattern }?
+   year-pattern =
+      attribute year {
+         xsd:integer { maxInclusive="-1" }
+       | xsd:integer { minInclusive="1" }
+      }
+   month-pattern =
+      attribute month { xsd:integer { minInclusive="1" maxInclusive="12" } }
+   day-pattern =
+      attribute day { xsd:integer { minInclusive="1" maxInclusive="31" } }
+
+   # 1 = Spring, 2 = Summer, 3 = Fall, 4 = Winter
+   season-pattern =
+      attribute season { xsd:integer { minInclusive="1" maxInclusive="4" } }
+}
+
+## Simple Variables
+div {
+   variable =
+      element variable {
+         attribute type { cs-variables },
+         (simple-variable-pattern | rich-variable-pattern)
+      }
+   simple-variable-pattern = text
+   rich-variable-pattern =
+      (text
+       | element abbr { text }
+       | element b { text }
+       | element cite {
+          
+          ## cited title which is a part (like an article), and so typically rendered in quotes, rather than italicized
+          attribute class { "part" }?,
+          text
+       }
+       | element i { text }
+       | element sc { text }
+       | element span {
+          
+          ## text whose case should not be transformed (as with proper nouns)
+          attribute class { "protect" }?,
+          text
+       }
+       | element sup { text }
+       | element sub { text })+
+}
diff -pruN 0.3.0-6/citeproc/data/schema/csl-relaxed.rnc 0.5.1-1/citeproc/data/schema/csl-relaxed.rnc
--- 0.3.0-6/citeproc/data/schema/csl-relaxed.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-relaxed.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,13 @@
+namespace cs = "http://purl.org/net/xbiblio/csl"
+namespace dc = "http://purl.org/dc/elements/1.1/"
+
+dc:title [ "Citation Style Language Schema - Relaxed" ]
+dc:creator [ "Bruce D'Arcus" ]
+dc:rights [ "Permission to freely use, copy and distribute." ]
+dc:description [
+    "Relaxes the need for a cs:updated value in the official CSL schema."
+]
+
+include "csl.rnc"{
+   info-updated = element cs:updated { xsd:dateTime? }
+}
\ No newline at end of file
diff -pruN 0.3.0-6/citeproc/data/schema/csl.rnc 0.5.1-1/citeproc/data/schema/csl.rnc
--- 0.3.0-6/citeproc/data/schema/csl.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,1173 @@
+namespace a = "http://relaxng.org/ns/compatibility/annotations/1.0"
+namespace bibo = "http://purl.org/ontology/bibo/"
+namespace cs = "http://purl.org/net/xbiblio/csl"
+namespace dc = "http://purl.org/dc/elements/1.1/"
+namespace sch = "http://www.ascc.net/xml/schematron"
+namespace xhtml = "http://www.w3.org/1999/xhtml"
+
+# CSL schema metadata
+
+dc:title [ "Citation Style Language" ]
+dc:creator [ "Bruce D'Arcus" ]
+dc:creator [ "Simon Kornblith" ]
+bibo:editor [ "Frank Bennett" ]
+bibo:editor [ "Rintze Zelle" ]
+dc:rights [
+  "Copyright 2007-2012 by Frank Bennett, Bruce D'Arcus, Simon Kornblith, and Rintze Zelle. Permission to freely use, copy and distribute."
+]
+dc:description [
+  "RELAX NG compact schema for the Citation Style Language (CSL)."
+]
+# Embedded Schematron rules to detect calls to nonexistent macros
+
+sch:ns [ uri = "http://purl.org/net/xbiblio/csl" prefix = "cs" ]
+sch:pattern [
+  name = "Non-existing macros"
+  sch:rule [
+    context = "//cs:text[@macro]"
+    sch:assert [
+      test = "@macro = /cs:style/cs:macro/@name"
+      "This macro call has no corresponding macro."
+    ]
+  ]
+  sch:rule [
+    context = "//cs:key[@macro]"
+    sch:assert [
+      test = "@macro = /cs:style/cs:macro/@name"
+      "This macro call has no corresponding macro."
+    ]
+  ]
+]
+
+## Subparts of the CSL schema
+include "csl-terms.rnc"
+include "csl-types.rnc"
+include "csl-variables.rnc"
+include "csl-categories.rnc"
+[
+  a:documentation [
+    xhtml:h2 [ "cs:style and cs:locale - Root Elements" ]
+  ]
+]
+div {
+  start =
+    independent-style.style | dependent-style.style | locale-file.locale
+  
+  independent-style.style =
+    element cs:style {
+      
+      ## Select whether citations appear in-text or as notes.
+      attribute class { "in-text" | "note" },
+      style.default-locale,
+      style.options,
+      version,
+      independent-style.style.info,
+      (style.locale*
+       & style.macro*
+       & style.citation
+       & style.bibliography?)?
+    }
+  
+  dependent-style.style =
+    element cs:style {
+      style.default-locale,
+      version,
+      dependent-style.style.info,
+      dependent-style.style.legacy-attributes
+    }
+  
+  locale-file.locale =
+    element cs:locale {
+      
+      ## Specify the locale of the locale file.
+      attribute xml:lang { xsd:language },
+      version,
+      locale-file.locale.info?,
+      (locale.style-options & locale.date+ & locale.terms)
+    }
+  
+  style.default-locale =
+    
+    ## Set a default style locale.
+    attribute default-locale { xsd:language }?
+  
+  version =
+    
+    ## Indicate CSL version compatibility ("1.0" for CSL 1.0).
+    [ a:defaultValue = "1.0" ] attribute version { "1.0" }
+  
+  ## Obsolete for dependent styles. Will be disallowed with CSL 1.1.
+  dependent-style.style.legacy-attributes =
+    attribute class { "in-text" | "note" }?,
+    style.options
+}
+[
+  a:documentation [
+    xhtml:h2 [ "cs:info - Style and Locale File Metadata" ]
+  ]
+]
+div {
+  
+  ## Metadata for independent styles.
+  independent-style.style.info =
+    element cs:info {
+      info.author*
+      & info.category*
+      & info.contributor*
+      & info.id
+      & info.issn*
+      & info.eissn?
+      & info.issnl?
+      & independent-style.info.link*
+      & info.published?
+      & info.rights?
+      & info.summary?
+      & info.title
+      & info.title-short?
+      & info.updated
+    }
+  
+  ## Metadata for dependent styles.
+  dependent-style.style.info =
+    element cs:info {
+      info.author*
+      & info.category*
+      & info.contributor*
+      & info.id
+      & info.issn*
+      & info.eissn?
+      & info.issnl?
+      & dependent-style.info.link+
+      & info.published?
+      & info.rights?
+      & info.summary?
+      & info.title
+      & info.title-short?
+      & info.updated
+    }
+  
+  ## Metadata for locale files.
+  locale-file.locale.info =
+    element cs:info { info.translator* & info.rights? & info.updated? }
+  
+  info.author = element cs:author { personal-details }
+  
+  info.contributor = element cs:contributor { personal-details }
+  
+  info.translator = element cs:translator { personal-details }
+  
+  personal-details =
+    element cs:name { text }
+    & element cs:email { text }?
+    & element cs:uri { xsd:anyURI }?
+  
+  info.category =
+    
+    ## Specify the citation format of the style (using the "citation-format"
+    ## attribute) or the fields and disciplines for which the style is
+    ## relevant (using the "field" attribute).
+    element cs:category {
+      attribute citation-format { category.citation-format }
+      | attribute field { category.field }
+    }
+  
+  info.id =
+    
+    ## Specify the URI to establish the identity of the style. The URI
+    ## should be stable, unique and dereferenceable URI.
+    element cs:id { xsd:anyURI }
+  
+  info.issn =
+    
+    ## Specify the journal's ISSN(s) for journal-specific styles. An ISSN
+    ## must consist of four digits, a hyphen, three digits, and a check
+    ## digit (a numeral digit or roman X), e.g. "1234-1231".
+    element cs:issn { issn }
+  
+  info.eissn =
+    
+    ## Specify the journal's eISSN for journal-specific styles.
+    element cs:eissn { issn }
+  
+  info.issnl =
+    
+    ## Specify the journal's ISSN-L for journal-specific styles.
+    element cs:issnl { issn }
+  
+  issn = xsd:string { pattern = "\d{4}\-\d{3}(\d|x|X)" }
+  
+  independent-style.info.link =
+    element cs:link {
+      attribute href { xsd:anyURI },
+      
+      ## Specify how the URL relates to the style.
+      attribute rel {
+        
+        ## The URI of the CSL style itself.
+        "self"
+        | 
+          ## URI of the style from which the current style is derived.
+          "template"
+        | 
+          ## URI of style documentation.
+          "documentation"
+        | 
+          ## Obsolete for independent styles. Will be disallowed with
+          ## CSL 1.1.
+          "independent-parent"
+      },
+      info-text
+    }
+  
+  dependent-style.info.link =
+    element cs:link {
+      attribute href { xsd:anyURI },
+      
+      ## Specify how the URL relates to the style.
+      attribute rel {
+        
+        ## The URI of the CSL style itself.
+        "self"
+        | 
+          ## URI of the CSL style whose content should be used for
+          ## processing. Required for dependent styles.
+          "independent-parent"
+        | 
+          ## URI of style documentation.
+          "documentation"
+        | 
+          ## Obsolete for dependent styles. Will be disallowed with CSL
+          ## 1.1.
+          "template"
+      },
+      info-text
+    }
+  
+  info.published =
+    
+    ## Specify when the style was initially created or made available.
+    element cs:published { xsd:dateTime }
+  
+  info.rights =
+    element cs:rights {
+      attribute license { xsd:anyURI }?,
+      info-text
+    }
+  
+  info.summary = element cs:summary { info-text }
+  
+  info.title = element cs:title { info-text }
+  
+  info.title-short =
+    
+    ## Specify an abbreviated style title (e.g., "APA")
+    element cs:title-short { info-text }
+  
+  info.updated =
+    
+    ## Specify when the style was last updated (e.g.,
+    ## "2007-10-26T21:32:52+02:00")
+    element cs:updated { xsd:dateTime }
+  
+  info-text =
+    attribute xml:lang { xsd:language }?,
+    text
+}
+[ a:documentation [ xhtml:h2 [ "cs:locale in Independent Styles" ] ] ]
+div {
+  style.locale =
+    
+    ## Use to (re)define localized terms, dates and options.
+    element cs:locale {
+      
+      ## Specify the affected locale(s). If "xml:lang" is not set, the
+      ## "cs:locale" element affects all locales.
+      attribute xml:lang { xsd:language }?,
+      (locale.style-options? & locale.date* & locale.terms?)
+    }
+}
+[
+  a:documentation [
+    xhtml:h2 [ "cs:locale Contents - Localization Data" ]
+  ]
+]
+div {
+  
+  ## Localized global options are specified as attributes in the
+  ## cs:style-options element. If future versions of CSL include localized
+  ## options that are citation or bibliography specific, the elements
+  ## cs:citation-options and cs:bibliography-options can be added.
+  locale.style-options =
+    element cs:style-options {
+      
+      ## Limit the "ordinal" form to the first day of the month.
+      [ a:defaultValue = "false" ]
+      attribute limit-day-ordinals-to-day-1 { xsd:boolean }?,
+      
+      ## Specify whether punctuation (a period or comma) is placed within
+      ## or outside (default) the closing quotation mark.
+      [ a:defaultValue = "false" ]
+      attribute punctuation-in-quote { xsd:boolean }?
+    }
+  
+  locale.date =
+    element cs:date {
+      date.form,
+      delimiter,
+      font-formatting,
+      text-case,
+      locale.date.date-part+
+    }
+  
+  date.form =
+    
+    ## Select the localized date format ("text" or "numeric").
+    attribute form {
+      
+      ## Text date form (e.g., "December 15, 2005").
+      "text"
+      | 
+        ## Numeric date form (e.g., "2005-12-15").
+        "numeric"
+    }
+  
+  locale.date.date-part =
+    element cs:date-part {
+      affixes, font-formatting, text-case, (day | month | year)
+    }
+  
+  locale.terms = element cs:terms { terms.term+ }
+  
+  ## The "cs:term" element can either hold a basic string, or "cs:single" and
+  ## "cs:multiple" child elements to give singular and plural forms of the term.
+  terms.term =
+    element cs:term {
+      term.attributes,
+      (text | (term.single, term.multiple))
+    }
+  
+  term.attributes =
+    (attribute name { terms },
+     [ a:defaultValue = "long" ] attribute form { term.form }?)
+    | (attribute name { terms.ordinals },
+       attribute form { "long" }?,
+       attribute gender-form { "masculine" | "feminine" }?,
+       attribute match { "last-digit" | "last-two-digits" | "whole-number" }?)
+    | (attribute name { terms.long-ordinals },
+       attribute form { "long" }?,
+       attribute gender-form { "masculine" | "feminine" })
+    | (attribute name { terms.gender-assignable },
+       attribute form { "long" }?,
+       attribute gender { "masculine" | "feminine" })
+  
+  ## "verb-short" reverts to "verb" if the "verb-short" form is not available.
+  ## "symbol" reverts to "short" if the "symbol" form is not available.
+  ## "verb" and "short" revert to "long" if the specified form is not available.
+  term.form = "long" | "verb" | "short" | "verb-short" | "symbol"
+  term.single =
+    
+    ## Singular version of the term.
+    element cs:single { text }
+  
+  term.multiple =
+    
+    ## Plural version of the term.
+    element cs:multiple { text }
+}
+[ a:documentation [ xhtml:h2 [ "cs:macro" ] ] ]
+div {
+  style.macro =
+    
+    ## Use to create collections of (reusable) formatting instructions.
+    element cs:macro {
+      attribute name { xsd:NMTOKEN },
+      rendering-element+
+    }
+  
+  rendering-element =
+    rendering-element.names
+    | rendering-element.date
+    | rendering-element.label
+    | rendering-element.text
+    | rendering-element.number
+    | rendering-element.choose
+    | rendering-element.group
+}
+[ a:documentation [ xhtml:h2 [ "cs:citation and cs:bibliography" ] ] ]
+div {
+  style.citation =
+    
+    ## Use to describe the formatting of citations.
+    element cs:citation { citation.options, sort?, citation.layout }
+  
+  style.bibliography =
+    
+    ## Use to describe the formatting of the bibliography.
+    element cs:bibliography {
+      bibliography.options, sort?, bibliography.layout
+    }
+  
+  citation.layout =
+    element cs:layout {
+      affixes, delimiter, font-formatting, rendering-element+
+    }
+  
+  bibliography.layout =
+    element cs:layout { affixes, font-formatting, rendering-element+ }
+}
+[ a:documentation [ xhtml:h2 [ "cs:names Rendering Element" ] ] ]
+div {
+  rendering-element.names =
+    element cs:names {
+      names.attributes,
+      ((names.name?, names.et-al?) & names.label*),
+      names.substitute?
+    }
+  
+  names.attributes =
+    attribute variable {
+      list { variables.names+ }
+    },
+    affixes,
+    
+    ## Specify the delimiter for name lists of name variables rendered by
+    ## the same cs:names element.
+    delimiter,
+    display,
+    font-formatting
+  
+  names.name =
+    element cs:name {
+      name.attributes,
+      
+      ## Select the "long" (first name + last name, for Western names),
+      ## "short" (last name only, for Western names), or "count" name form
+      ## (returning the number of names in the name variable, which can be
+      ## useful for some sorting algorithms).
+      [ a:defaultValue = "long" ]
+      attribute form { "long" | "short" | "count" }?,
+      affixes,
+      
+      ## Set the delimiter for names in a name variable (e.g., ", " in
+      ## "Doe, Smith")
+      [ a:defaultValue = ", " ] delimiter,
+      font-formatting,
+      name.name-part*
+    }
+  
+  name.attributes =
+    
+    ## Use to separate the second-to-last and last name of a name list by
+    ## the "and" term or ampersand.
+    attribute and {
+      
+      ## Use the "and" term (e.g., "Doe, Johnson and Smith").
+      "text"
+      | 
+        ## Use the "ampersand" (e.g., "Doe, Johnson & Smith").
+        "symbol"
+    }?,
+    
+    ## Specify when the name delimiter is used between a truncated name list
+    ## and the "et-al" (or "and others") term in case of et-al abbreviation
+    ## (e.g., "Smith, Doe et al." or "Smith, Doe, et al.").
+    [ a:defaultValue = "contextual" ]
+    attribute delimiter-precedes-et-al {
+      
+      ## The name delimiter is only used when the truncated name list
+      ## consists of two or more names.
+      "contextual"
+      | 
+        ## The name delimiter is always used.
+        "always"
+      | 
+        ## The name delimiter is never used.
+        "never"
+      | 
+        ## The name delimiter is only used if the preceding name is inverted as
+        ## a result of the "name-as-sort-order" attribute.
+        "after-inverted-name"
+    }?,
+    
+    ## Specify when the name delimiter is used between the second-to-last
+    ## and last name of a non-truncated name list. Only has an effect when
+    ## the "and" term or ampersand is used (e.g., "Doe and Smith" or "Doe,
+    ## and Smith").
+    [ a:defaultValue = "contextual" ]
+    attribute delimiter-precedes-last {
+      
+      ## The name delimiter is only used when the name list consists of
+      ## three or more names.
+      "contextual"
+      | 
+        ## The name delimiter is always used.
+        "always"
+      | 
+        ## The name delimiter is never used.
+        "never"
+      | 
+        ## The name delimiter is only used if the preceding name is inverted as
+        ## a result of the "name-as-sort-order" attribute.
+        "after-inverted-name"
+    }?,
+    
+    ## Set the minimum number of names needed in a name variable to activate
+    ## et-al abbreviation.
+    attribute et-al-min { xsd:integer }?,
+    
+    ## Set the number of names to render when et-al abbreviation is active.
+    attribute et-al-use-first { xsd:integer }?,
+    
+    ## As "et-al-min", but only affecting subsequent citations to an item.
+    attribute et-al-subsequent-min { xsd:integer }?,
+    
+    ## As "et-al-use-first", but only affecting subsequent citations to an
+    ## item.
+    attribute et-al-subsequent-use-first { xsd:integer }?,
+    
+    ## If set to "true", the "et-al" (or "and others") term is replaced by
+    ## an ellipsis followed by the last name of the name variable.
+    [ a:defaultValue = "false" ]
+    attribute et-al-use-last { xsd:boolean }?,
+    
+    ## If set to "false", names are not initialized and "initialize-with"
+    ## only affects initials already present in the input data.
+    [ a:defaultValue = "true" ] attribute initialize { xsd:boolean }?,
+    
+    ## Activate initializing of given names. The attribute value is appended
+    ## to each initial (e.g., with ". ", "Orson Welles" becomes "O. Welles").
+    attribute initialize-with { text }?,
+    
+    ## Specify whether (and which) names should be rendered in their sort
+    ## order (e.g., "Doe, John" instead of "John Doe").
+    attribute name-as-sort-order {
+      
+      ## Render the first name of each name variable in sort order.
+      "first"
+      | 
+        ## Render all names in sort order.
+        "all"
+    }?,
+    
+    ## Sets the delimiter for name-parts that have switched positions as a
+    ## result of "name-as-sort-order" (e.g., ", " in "Doe, John").
+    [ a:defaultValue = ", " ] attribute sort-separator { text }?
+  
+  name.name-part =
+    
+    ## Use to format individual name parts (e.g., "Jane DOE").
+    element cs:name-part {
+      attribute name { "family" | "given" },
+      affixes,
+      font-formatting,
+      text-case
+    }
+  
+  names.et-al =
+    
+    ## Specify the term used for et-al abbreviation and its formatting. 
+    element cs:et-al {
+      
+      ## Select the term to use for et-al abbreviation.
+      [ a:defaultValue = "et-al" ]
+      attribute term { "et-al" | "and others" }?,
+      font-formatting,
+      names.et-al.legacy-attributes
+    }
+  
+  ## Ignored in CSL 1.0.1. Will be disallowed with CSL 1.1.
+  names.et-al.legacy-attributes = affixes
+  
+  ## Inherits variable from the parent cs:names element.
+  names.label =
+    element cs:label {
+      [ a:defaultValue = "long" ] attribute form { term.form }?,
+      label.attributes-shared
+    }
+  
+  names.substitute =
+    
+    ## Specify substitution options when the name variables selected on the
+    ## parent cs:names element are empty.
+    element cs:substitute { (substitute.names | rendering-element)+ }
+  
+  ## Short version of cs:names, without children, allowed in cs:substitute.
+  substitute.names = element cs:names { names.attributes }
+}
+[ a:documentation [ xhtml:h2 [ "cs:date Rendering Element" ] ] ]
+div {
+  rendering-element.date =
+    element cs:date {
+      attribute variable { variables.dates },
+      ((
+        ## Limit the date parts rendered.
+        [ a:defaultValue = "year-month-day" ]
+        attribute date-parts {
+          
+          ## Year, month and day
+          "year-month-day"
+          | 
+            ## Year and month
+            "year-month"
+          | 
+            ## Year only
+            "year"
+        }?,
+        date.form,
+        rendering-element.date.date-part.localized*)
+       | (rendering-element.date.date-part.non-localized+, delimiter)),
+      affixes,
+      display,
+      font-formatting,
+      text-case
+    }
+  
+  rendering-element.date.date-part.localized =
+    
+    ## Specify overriding formatting for localized dates (affixes
+    ## cannot be overridden, as these are considered locale-specific).
+    ## Example uses are forcing the use of leading-zeros, or of the
+    ## "short" month form. Has no effect on which, and in what order,
+    ## date parts are rendered.
+    element cs:date-part {
+      font-formatting, text-case, (day | month | year)
+    }
+  
+  rendering-element.date.date-part.non-localized =
+    
+    ## Specify, in the desired order, the date parts that should be
+    ## rendered and their formatting.
+    element cs:date-part {
+      affixes, font-formatting, text-case, (day | month | year)
+    }
+  
+  day =
+    attribute name { "day" },
+    
+    ## Day forms: "numeric" ("5"), "numeric-leading-zeros" ("05"), "ordinal"
+    ## ("5th").
+    [ a:defaultValue = "numeric" ]
+    attribute form { "numeric" | "numeric-leading-zeros" | "ordinal" }?,
+    range-delimiter
+  
+  month =
+    attribute name { "month" },
+    
+    ## Months forms: "long" (e.g., "January"), "short" ("Jan."), "numeric"
+    ## ("1"), and "numeric-leading-zeros" ("01").
+    [ a:defaultValue = "long" ]
+    attribute form {
+      "long" | "short" | "numeric" | "numeric-leading-zeros"
+    }?,
+    range-delimiter,
+    strip-periods
+  
+  year =
+    attribute name { "year" },
+    
+    ## Year forms: "long" ("2005"), "short" ("05").
+    [ a:defaultValue = "long" ] attribute form { "short" | "long" }?,
+    range-delimiter
+  
+  range-delimiter =
+    
+    ## Specify a delimiter for date ranges (by default the en-dash). A custom
+    ## delimiter is retrieved from the largest date part ("day", "month" or
+    ## "year") that differs between the two dates.
+    [ a:defaultValue = "–" ] attribute range-delimiter { text }?
+}
+[ a:documentation [ xhtml:h2 [ "cs:text Rendering Element" ] ] ]
+div {
+  rendering-element.text =
+    
+    ## Use to call macros, render variables, terms, or verbatim text.
+    element cs:text {
+      text.attributes,
+      affixes,
+      display,
+      font-formatting,
+      quotes,
+      strip-periods,
+      text-case
+    }
+  
+  text.attributes =
+    
+    ## Select a macro.
+    attribute macro { xsd:NMTOKEN }
+    | (
+       ## Select a term.
+       attribute term { terms },
+       [ a:defaultValue = "long" ] attribute form { term.form }?,
+       
+       ## Specify term plurality: singular ("false") or plural ("true").
+       [ a:defaultValue = "false" ] attribute plural { xsd:boolean }?)
+    | 
+      ## Specify verbatim text.
+      attribute value { text }
+    | (
+       ## Select a variable.
+       attribute variable { variables.standard },
+       [ a:defaultValue = "long" ] attribute form { "short" | "long" }?)
+}
+[ a:documentation [ xhtml:h2 [ "cs:number Rendering Element" ] ] ]
+div {
+  rendering-element.number =
+    
+    ## Use to render a number variable.
+    element cs:number {
+      number.attributes, affixes, display, font-formatting, text-case
+    }
+  
+  number.attributes =
+    attribute variable { variables.numbers },
+    
+    ## Number forms: "numeric" ("4"), "ordinal" ("4th"), "long-ordinal"
+    ## ("fourth"), "roman" ("iv").
+    [ a:defaultValue = "numeric" ]
+    attribute form { "numeric" | "ordinal" | "long-ordinal" | "roman" }?
+}
+[ a:documentation [ xhtml:h2 [ "cs:label Rendering Element" ] ] ]
+div {
+  rendering-element.label =
+    
+    ## Use to render a term whose pluralization depends on the content of a
+    ## variable. E.g., if "page" variable holds a range, the plural label
+    ## "pp." is selected instead of the singular "p.".
+    element cs:label { label.attributes, label.attributes-shared }
+  
+  label.attributes =
+    attribute variable { variables.numbers | "locator" | "page" },
+    [ a:defaultValue = "long" ]
+    attribute form { "long" | "short" | "symbol" }?
+  
+  label.attributes-shared =
+    
+    ## Specify when the plural version of a term is selected.
+    [ a:defaultValue = "contextual" ]
+    attribute plural { "always" | "never" | "contextual" }?,
+    affixes,
+    font-formatting,
+    strip-periods,
+    text-case
+}
+[ a:documentation [ xhtml:h2 [ "cs:group Rendering Element" ] ] ]
+div {
+  rendering-element.group =
+    
+    ## Use to group rendering elements. Groups are useful for setting a
+    ## delimiter for the group children, for organizing the layout of
+    ## bibliographic entries (using the "display" attribute), and for
+    ## suppressing the rendering of terms and verbatim text when variables
+    ## are empty.
+    element cs:group {
+      group.attributes,
+      affixes,
+      delimiter,
+      display,
+      font-formatting,
+      rendering-element+
+    }
+  
+  group.attributes = notAllowed?
+}
+[ a:documentation [ xhtml:h2 [ "Options" ] ] ]
+div {
+  style.options =
+    style.demote-non-dropping-particle,
+    style.initialize-with-hyphen,
+    style.page-range-format,
+    names-inheritable-options,
+    name-inheritable-options
+  
+  citation.options =
+    citation.cite-group-delimiter,
+    citation.collapse-options,
+    citation.disambiguate-options,
+    citation.near-note-distance,
+    names-inheritable-options,
+    name-inheritable-options
+  
+  bibliography.options =
+    bibliography.hanging-indent,
+    bibliography.line-formatting-options,
+    bibliography.second-field-align,
+    bibliography.subsequent-author-substitute-options,
+    names-inheritable-options,
+    name-inheritable-options
+  
+  style.demote-non-dropping-particle =
+    
+    ## Specify whether the non-dropping particle is demoted in inverted
+    ## names (e.g., "Koning, W. de").
+    [ a:defaultValue = "display-and-sort" ]
+    attribute demote-non-dropping-particle {
+      "never" | "sort-only" | "display-and-sort"
+    }?
+  
+  style.initialize-with-hyphen =
+    
+    ## Specify whether compound given names (e.g., "Jean-Luc") are
+    ## initialized with ("J-L") or without a hyphen ("JL").
+    [ a:defaultValue = "true" ]
+    attribute initialize-with-hyphen { xsd:boolean }?
+  
+  style.page-range-format =
+    
+    ## Reformat page ranges in the "page" variable.
+    attribute page-range-format {
+      "chicago" | "expanded" | "minimal" | "minimal-two"
+    }?
+  
+  citation.cite-group-delimiter =
+    
+    ## Activate cite grouping and specify the delimiter for cites within a
+    ## cite group.
+    [ a:defaultValue = ", " ] attribute cite-group-delimiter { text }?
+  
+  citation.collapse-options =
+    
+    ## Activate cite grouping and specify the method of citation collapsing.
+    attribute collapse {
+      
+      ## Collapse ranges of numeric cites, e.g. from "[1,2,3]" to "[1-3]".
+      "citation-number"
+      | 
+        ## Collapse cites by suppressing repeated names, e.g. from "(Doe
+        ## 2000, Doe 2001)" to "(Doe 2000, 2001)".
+        "year"
+      | 
+        ## Collapse cites as with "year", but also suppresses repeated
+        ## years, e.g. from "(Doe 2000a, Doe 2000b)" to "(Doe 2000a, b)".
+        "year-suffix"
+      | 
+        ## Collapses cites as with "year-suffix", but also collapses
+        ## ranges of year-suffixes, e.g. from "(Doe 2000a, Doe 2000b,
+        ## Doe 2000c)" to "(Doe 2000a-c)".
+        "year-suffix-ranged"
+    }?,
+    
+    ## Specify the delimiter between year-suffixes. Defaults to the cite
+    ## delimiter.
+    attribute year-suffix-delimiter { text }?,
+    
+    ## Specify the delimiter following a group of collapsed cites. Defaults
+    ## to the cite delimiter.
+    attribute after-collapse-delimiter { text }?
+  
+  citation.disambiguate-options =
+    
+    ## Set to "true" to activate disambiguation by showing names that were
+    ## originally hidden as a result of et-al abbreviation.
+    [ a:defaultValue = "false" ]
+    attribute disambiguate-add-names { xsd:boolean }?,
+    
+    ## Set to "true" to activate disambiguation by expanding names, showing
+    ## initials or full given names.
+    [ a:defaultValue = "false" ]
+    attribute disambiguate-add-givenname { xsd:boolean }?,
+    
+    ## Set to "true" to activate disambiguation by adding year-suffixes
+    ## (e.g., "(Doe 2007a, Doe 2007b)") for items from the same author(s)
+    ## and year.
+    [ a:defaultValue = "false" ]
+    attribute disambiguate-add-year-suffix { xsd:boolean }?,
+    
+    ## Specify how name are expanded for disambiguation.
+    [ a:defaultValue = "by-cite" ]
+    attribute givenname-disambiguation-rule {
+      
+      ## Each ambiguous names is progressively transformed until
+      ## disambiguated (when disambiguation is not possible, the name
+      ## remains in its original form).
+      "all-names"
+      | 
+        ## As "all-names", but name expansion is limited to showing
+        ## initials.
+        "all-names-with-initials"
+      | 
+        ## As "all-names", but disambiguation is limited to the first name
+        ## of each cite.
+        "primary-name"
+      | 
+        ## As "all-names-with-initials", but disambiguation is limited to
+        ## the first name of each cite.
+        "primary-name-with-initials"
+      | 
+        ## As "all-names", but only ambiguous names in ambiguous cites are
+        ## expanded.
+        "by-cite"
+    }?
+  
+  citation.near-note-distance =
+    
+    ## Set the number of preceding notes (footnotes or endnotes) within
+    ## which the current item needs to have been previously cited in order
+    ## for the "near-note" position to be "true".
+    [ a:defaultValue = "5" ]
+    attribute near-note-distance { xsd:integer }?
+  
+  bibliography.hanging-indent =
+    
+    ## Set to "true" to render bibliographic entries with hanging indents.
+    [ a:defaultValue = "false" ]
+    attribute hanging-indent { xsd:boolean }?
+  
+  bibliography.line-formatting-options =
+    
+    ## Set the spacing between bibliographic entries.
+    [ a:defaultValue = "1" ]
+    attribute entry-spacing { xsd:nonNegativeInteger }?,
+    
+    ## Set the spacing between bibliographic lines.
+    [ a:defaultValue = "1" ]
+    attribute line-spacing {
+      xsd:integer { minExclusive = "0" }
+    }?
+  
+  bibliography.second-field-align =
+    
+    ## Use to align any subsequent lines of bibliographic entries with the
+    ## beginning of the second field.
+    attribute second-field-align {
+      
+      ## Align the first field with the margin.
+      "flush"
+      | 
+        ## Put the first field in the margin and align all subsequent
+        ## lines of text with the margin.
+        "margin"
+    }?
+  
+  bibliography.subsequent-author-substitute-options =
+    
+    ## Substitute names that repeat in subsequent bibliographic entries by
+    ## the attribute value.
+    attribute subsequent-author-substitute { text }?,
+    
+    ## Specify the method of substitution of names repeated in subsequent
+    ## bibliographic entries.
+    [ a:defaultValue = "complete-all" ]
+    attribute subsequent-author-substitute-rule {
+      
+      ## Requires a match of all rendered names in the name variable, and
+      ## substitutes once for all names.
+      "complete-all"
+      | 
+        ## Requires a match of all rendered names in the name variable,
+        ## and substitutes for each name.
+        "complete-each"
+      | 
+        ## Substitutes for each name, until the first mismatch.
+        "partial-each"
+      | 
+        ## Substitutes the first name if it matches.
+        "partial-first"
+    }?
+  
+  ## Options affecting cs:names, for cs:style, cs:citation and cs:bibliography.
+  names-inheritable-options =
+    
+    ## Inheritable name option, companion for "delimiter" on cs:names.
+    attribute names-delimiter { text }?
+  
+  ## Options affecting cs:name, for cs:style, cs:citation and cs:bibliography.
+  name-inheritable-options =
+    name.attributes,
+    
+    ## Inheritable name option, companion for "delimiter" on cs:name.
+    attribute name-delimiter { text }?,
+    
+    ## Inheritable name option, companion for "form" on cs:name.
+    [ a:defaultValue = "long" ]
+    attribute name-form { "long" | "short" | "count" }?
+}
+[ a:documentation [ xhtml:h2 [ "cs:sort - Sorting" ] ] ]
+div {
+  sort =
+    
+    ## Specify how cites and bibliographic entries should be sorted. By
+    ## default, items appear in the order in which they were cited.
+    element cs:sort { sort.key+ }
+  
+  sort.key =
+    element cs:key {
+      (attribute variable { variables }
+       | attribute macro { xsd:NMTOKEN }),
+      
+      ## The minimum number of names needed in a name variable to activate
+      ## name list truncation. Overrides the values set on any
+      ## "et-al-(subsequent-)min" attributes.
+      attribute names-min { xsd:integer }?,
+      
+      ## The number of names to render when name list truncation is
+      ## activated. Overrides the values set on the
+      ## "et-al-(subsequent-)use-first" attributes.
+      attribute names-use-first { xsd:integer }?,
+      
+      ## Use to override the value of the "et-at-use-last" attribute.
+      attribute names-use-last { xsd:boolean }?,
+      
+      ## Select between an ascending and descending sort.
+      [ a:defaultValue = "ascending" ]
+      attribute sort { "ascending" | "descending" }?
+    }
+}
+[
+  a:documentation [ xhtml:h2 [ "cs:choose - Conditional Statements" ] ]
+]
+div {
+  rendering-element.choose =
+    
+    ## Use to conditionally render rendering elements.
+    element cs:choose { choose.if, choose.else-if*, choose.else? }
+  
+  choose.if = element cs:if { condition+, match, rendering-element* }
+  
+  choose.else-if =
+    element cs:else-if { condition+, match, rendering-element* }
+  
+  choose.else = element cs:else { rendering-element+ }
+  
+  condition =
+    
+    ## If used, the element content is only rendered if it disambiguates two
+    ## otherwise identical citations. This attempt at disambiguation is only
+    ## made after all other disambiguation methods have failed.
+    [ a:defaultValue = "true" ] attribute disambiguate { "true" }
+    | 
+      ## Tests whether the given variables contain numeric text.
+      attribute is-numeric {
+        list { variables+ }
+      }
+    | 
+      ## Tests whether the given date variables contain approximate dates.
+      attribute is-uncertain-date {
+        list { variables.dates+ }
+      }
+    | 
+      ## Tests whether the locator matches the given locator types.
+      attribute locator {
+        list { (terms.locator.testable | "sub-verbo")+ }
+      }
+    | 
+      ## Tests whether the cite position matches the given positions.
+      attribute position {
+        list {
+          ("first"
+           | "subsequent"
+           | "ibid"
+           | "ibid-with-locator"
+           | "near-note")+
+        }
+      }
+    | 
+      ## Tests whether the item matches the given types.
+      attribute type {
+        list { item-types+ }
+      }
+    | 
+      ## Tests whether the default ("long") forms of the given variables
+      ## contain non-empty values.
+      attribute variable {
+        list { variables+ }
+      }
+  
+  match =
+    
+    ## Set the testing logic.
+    [ a:defaultValue = "all" ]
+    attribute match {
+      
+      ## Element only tests "true" when all conditions test "true" for all
+      ## given test values.
+      "all"
+      | 
+        ## Element tests "true" when any condition tests "true" for any given
+        ## test value.
+        "any"
+      | 
+        ## Element only tests "true" when none of the conditions test "true"
+        ## for any given test value.
+        "none"
+    }?
+}
+
+## Formatting attributes.
+div {
+  affixes =
+    [ a:defaultValue = "" ] attribute prefix { text }?,
+    [ a:defaultValue = "" ] attribute suffix { text }?
+  
+  delimiter = attribute delimiter { text }?
+  
+  display =
+    
+    ## By default, bibliographic entries consist of continuous runs of text.
+    ## With the "display" attribute, portions of each entry can be
+    ## individually positioned.
+    attribute display {
+      
+      ## Places the content in a block stretching from margin to margin.
+      "block"
+      | 
+        ## Places the content in a block starting at the left margin.
+        "left-margin"
+      | 
+        ## Places the content in a block to the right of a preceding
+        ## "left-margin" block.
+        "right-inline"
+      | 
+        ## Places the content in a block indented to the right by a standard
+        ## amount.
+        "indent"
+    }?
+  
+  ## The font-formatting attributes are based on those of CSS and XSL-FO.
+  font-formatting =
+    [ a:defaultValue = "normal" ]
+    attribute font-style { "italic" | "normal" | "oblique" }?,
+    [ a:defaultValue = "normal" ]
+    attribute font-variant { "normal" | "small-caps" }?,
+    [ a:defaultValue = "normal" ]
+    attribute font-weight { "normal" | "bold" | "light" }?,
+    [ a:defaultValue = "none" ]
+    attribute text-decoration { "none" | "underline" }?,
+    [ a:defaultValue = "baseline" ]
+    attribute vertical-align { "baseline" | "sup" | "sub" }?
+  
+  quotes =
+    
+    ## When set to "true", quotes are placed around the rendered text.
+    [ a:defaultValue = "false" ] attribute quotes { xsd:boolean }?
+  
+  strip-periods =
+    
+    ## When set to "true", periods are removed from the rendered text.
+    [ a:defaultValue = "false" ]
+    attribute strip-periods { xsd:boolean }?
+  
+  text-case =
+    attribute text-case {
+      
+      ## Renders text in lowercase.
+      "lowercase"
+      | 
+        ## Renders text in uppercase.
+        "uppercase"
+      | 
+        ## Capitalizes the first character (other characters remain in
+        ## their original case).
+        "capitalize-first"
+      | 
+        ## Capitalizes the first character of every word (other characters
+        ## remain in their original case).
+        "capitalize-all"
+      | 
+        ## Renders text in title case.
+        "title"
+      | 
+        ## Renders text in sentence case.
+        "sentence"
+    }?
+}
diff -pruN 0.3.0-6/citeproc/data/schema/csl.rng 0.5.1-1/citeproc/data/schema/csl.rng
--- 0.3.0-6/citeproc/data/schema/csl.rng	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl.rng	2020-04-06 16:25:24.000000000 +0000
@@ -1,28 +1,20 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<grammar xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:atom="http://www.w3.org/2005/Atom" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns:sch="http://www.ascc.net/xml/schematron" xmlns:cs="http://purl.org/net/xbiblio/csl" xmlns="http://relaxng.org/ns/structure/1.0" datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes">
-  <!-- CSL schema metadata -->
+<grammar xmlns="http://relaxng.org/ns/structure/1.0"
+         xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0"
+         xmlns:bibo="http://purl.org/ontology/bibo/"
+         xmlns:cs="http://purl.org/net/xbiblio/csl"
+         xmlns:dc="http://purl.org/dc/elements/1.1/"
+         xmlns:sch="http://www.ascc.net/xml/schematron"
+         xmlns:xhtml="http://www.w3.org/1999/xhtml"
+         xmlns:xml="http://www.w3.org/XML/1998/namespace"
+         datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes">
   <dc:title>Citation Style Language</dc:title>
   <dc:creator>Bruce D'Arcus</dc:creator>
   <dc:creator>Simon Kornblith</dc:creator>
-  <dc:contributor>Frank Bennett</dc:contributor>
-  <dc:contributor>Rintze Zelle</dc:contributor>
-  <dc:copyright>Bruce D'Arcus and Simon Kornblith, 2007-2010</dc:copyright>
-  <dc:rights>Permission to freely use, copy and distribute.</dc:rights>
-  <dc:description>Citation Style Language (CSL) schema for describing bibliographic and citation formatting.</dc:description>
-  <start>
-    <a:documentation>Root element. cs:style for CSL styles, cs:locale for locales-xx-XX.xml files</a:documentation>
-    <choice>
-      <ref name="style"/>
-      <ref name="locale"/>
-    </choice>
-  </start>
-  <include href="csl-terms.rng">
-    <a:documentation>Subparts of the CSL schema</a:documentation>
-  </include>
-  <include href="csl-types.rng"/>
-  <include href="csl-variables.rng"/>
-  <include href="csl-categories.rng"/>
-  <!-- Embedded Schematron rules to detect undefined macro-calls in cs:text, cs:key -->
+  <bibo:editor>Frank Bennett</bibo:editor>
+  <bibo:editor>Rintze Zelle</bibo:editor>
+  <dc:rights>Copyright 2007-2012 by Frank Bennett, Bruce D'Arcus, Simon Kornblith, and Rintze Zelle. Permission to freely use, copy and distribute.</dc:rights>
+  <dc:description>RELAX NG compact schema for the Citation Style Language (CSL).</dc:description>
   <sch:ns uri="http://purl.org/net/xbiblio/csl" prefix="cs"/>
   <sch:pattern name="Non-existing macros">
     <sch:rule context="//cs:text[@macro]">
@@ -32,724 +24,1357 @@
       <sch:assert test="@macro = /cs:style/cs:macro/@name">This macro call has no corresponding macro.</sch:assert>
     </sch:rule>
   </sch:pattern>
+  <a:documentation>Subparts of the CSL schema</a:documentation>
   <div>
-    <a:documentation>The CSL data model consists of resources and variables. Primary resources are the 
-citation object itself, as well as related agents and events. Variables are 
-attributes of the resource: titles, dates, volume numbers, and so forth. From the 
-perspective of CSL, resources templates involve a list of variables. By contrast, 
-a variable can be accessed directly.
-In addition, CSL also contains structures for macros and parameter options.</a:documentation>
-    <define name="style">
-      <element name="cs:style">
-        <attribute name="version">
-          <a:documentation>Indicates with which version of the CSL schema the style is compatible</a:documentation>
-          <value>1.0</value>
-        </attribute>
-        <optional>
-          <attribute name="default-locale">
-            <a:documentation>Default style locale (optional)</a:documentation>
-            <data type="language"/>
-          </attribute>
-        </optional>
-        <attribute name="class">
-          <a:documentation>Style type (in-text citations or note-based)</a:documentation>
+    <a:documentation>Terms</a:documentation>
+    <define name="terms">
+      <choice>
+        <ref name="terms.gender-assignable"/>
+        <ref name="terms.gender-variants"/>
+        <ref name="terms.locator"/>
+        <ref name="variables.names"/>
+        <value>editortranslator</value>
+        <value>accessed</value>
+        <a:documentation>Miscellaneous terms</a:documentation>
+        <value>ad</value>
+        <value>and</value>
+        <value>and others</value>
+        <value>anonymous</value>
+        <value>at</value>
+        <value>available at</value>
+        <value>bc</value>
+        <value>by</value>
+        <value>circa</value>
+        <value>cited</value>
+        <value>et-al</value>
+        <value>forthcoming</value>
+        <value>from</value>
+        <value>ibid</value>
+        <value>in</value>
+        <value>in press</value>
+        <value>internet</value>
+        <value>interview</value>
+        <value>letter</value>
+        <value>no date</value>
+        <value>online</value>
+        <value>presented at</value>
+        <value>reference</value>
+        <value>retrieved</value>
+        <value>scale</value>
+        <value>version</value>
+        <value>open-quote</value>
+        <a:documentation>Punctuation</a:documentation>
+        <value>close-quote</value>
+        <value>open-inner-quote</value>
+        <value>close-inner-quote</value>
+        <value>page-range-delimiter</value>
+        <value>season-01</value>
+        <a:documentation>Seasons</a:documentation>
+        <value>season-02</value>
+        <value>season-03</value>
+        <value>season-04</value>
+        <ref name="category.field"/>
+      </choice>
+    </define>
+    <define name="terms.gender-assignable">
+      <a:documentation>Terms to which a gender may be assigned</a:documentation>
+      <choice>
+        <value>month-01</value>
+        <a:documentation>Months</a:documentation>
+        <value>month-02</value>
+        <value>month-03</value>
+        <value>month-04</value>
+        <value>month-05</value>
+        <value>month-06</value>
+        <value>month-07</value>
+        <value>month-08</value>
+        <value>month-09</value>
+        <value>month-10</value>
+        <value>month-11</value>
+        <value>month-12</value>
+        <ref name="terms.non-locator-number-variables"/>
+        <ref name="terms.locator-number-variables"/>
+      </choice>
+    </define>
+    <define name="terms.gender-variants">
+      <a:documentation>Terms for which gender variants may be specified</a:documentation>
+      <choice>
+        <ref name="terms.ordinals"/>
+        <ref name="terms.long-ordinals"/>
+      </choice>
+    </define>
+    <define name="terms.ordinals">
+      <data type="string">
+        <a:documentation>Ordinals</a:documentation>
+        <param name="pattern">ordinal(-\d{2})?</param>
+      </data>
+    </define>
+    <define name="terms.long-ordinals">
+      <choice>
+        <value>long-ordinal-01</value>
+        <a:documentation>Long ordinals</a:documentation>
+        <value>long-ordinal-02</value>
+        <value>long-ordinal-03</value>
+        <value>long-ordinal-04</value>
+        <value>long-ordinal-05</value>
+        <value>long-ordinal-06</value>
+        <value>long-ordinal-07</value>
+        <value>long-ordinal-08</value>
+        <value>long-ordinal-09</value>
+        <value>long-ordinal-10</value>
+      </choice>
+    </define>
+    <define name="terms.locator">
+      <a:documentation>Locators</a:documentation>
+      <choice>
+        <ref name="terms.locator.testable"/>
+        <value>sub verbo</value>
+        <a:documentation>"sub verbo" is recognized as "sub" &amp; "verbo" in attribute lists; term
+should be renamed to "sub-verbo"</a:documentation>
+      </choice>
+    </define>
+    <define name="terms.locator.testable">
+      <a:documentation>Locator terms that can be tested with the "locator" conditional
+("sub verbo" can be tested with "sub-verbo")</a:documentation>
+      <choice>
+        <value>book</value>
+        <value>chapter</value>
+        <value>column</value>
+        <value>figure</value>
+        <value>folio</value>
+        <value>line</value>
+        <value>note</value>
+        <value>opus</value>
+        <value>page</value>
+        <value>paragraph</value>
+        <value>part</value>
+        <value>section</value>
+        <value>verse</value>
+        <ref name="terms.locator-number-variables"/>
+      </choice>
+    </define>
+    <define name="terms.locator-number-variables">
+      <a:documentation>Locator terms with matching number variables</a:documentation>
+      <choice>
+        <value>issue</value>
+        <value>volume</value>
+      </choice>
+    </define>
+    <define name="terms.non-locator-number-variables">
+      <a:documentation>Non-locator terms accompanying number variables</a:documentation>
+      <choice>
+        <value>chapter-number</value>
+        <value>collection-number</value>
+        <value>edition</value>
+        <value>number</value>
+        <value>number-of-pages</value>
+        <value>number-of-volumes</value>
+      </choice>
+    </define>
+  </div>
+  <div>
+    <a:documentation>Item types</a:documentation>
+    <define name="item-types">
+      <choice>
+        <value>article</value>
+        <value>article-journal</value>
+        <value>article-magazine</value>
+        <value>article-newspaper</value>
+        <value>bill</value>
+        <value>book</value>
+        <value>broadcast</value>
+        <value>chapter</value>
+        <value>dataset</value>
+        <value>entry</value>
+        <value>entry-dictionary</value>
+        <value>entry-encyclopedia</value>
+        <value>figure</value>
+        <value>graphic</value>
+        <value>interview</value>
+        <value>legal_case</value>
+        <value>legislation</value>
+        <value>manuscript</value>
+        <value>map</value>
+        <value>motion_picture</value>
+        <value>musical_score</value>
+        <value>pamphlet</value>
+        <value>paper-conference</value>
+        <value>patent</value>
+        <value>personal_communication</value>
+        <value>post</value>
+        <value>post-weblog</value>
+        <value>report</value>
+        <value>review</value>
+        <value>review-book</value>
+        <value>song</value>
+        <value>speech</value>
+        <value>thesis</value>
+        <value>treaty</value>
+        <value>webpage</value>
+      </choice>
+    </define>
+  </div>
+  <div>
+    <a:documentation>Variables</a:documentation>
+    <define name="variables">
+      <a:documentation>All variables</a:documentation>
+      <choice>
+        <ref name="variables.dates"/>
+        <ref name="variables.names"/>
+        <ref name="variables.numbers"/>
+        <ref name="variables.strings"/>
+      </choice>
+    </define>
+    <define name="variables.standard">
+      <a:documentation>Standard variables</a:documentation>
+      <choice>
+        <ref name="variables.numbers"/>
+        <ref name="variables.strings"/>
+      </choice>
+    </define>
+    <define name="variables.dates">
+      <a:documentation>Date variables</a:documentation>
+      <choice>
+        <value>accessed</value>
+        <value>container</value>
+        <value>event-date</value>
+        <value>issued</value>
+        <value>original-date</value>
+        <value>submitted</value>
+      </choice>
+    </define>
+    <define name="variables.names">
+      <a:documentation>Name variables</a:documentation>
+      <choice>
+        <value>author</value>
+        <value>collection-editor</value>
+        <value>composer</value>
+        <value>container-author</value>
+        <value>director</value>
+        <value>editor</value>
+        <value>editorial-director</value>
+        <value>illustrator</value>
+        <value>interviewer</value>
+        <value>original-author</value>
+        <value>recipient</value>
+        <value>reviewed-author</value>
+        <value>translator</value>
+      </choice>
+    </define>
+    <define name="variables.numbers">
+      <a:documentation>Number variables</a:documentation>
+      <choice>
+        <value>chapter-number</value>
+        <value>collection-number</value>
+        <value>edition</value>
+        <value>issue</value>
+        <value>number</value>
+        <value>number-of-pages</value>
+        <value>number-of-volumes</value>
+        <value>volume</value>
+      </choice>
+    </define>
+    <define name="variables.strings">
+      <a:documentation>String variables</a:documentation>
+      <choice>
+        <value>abstract</value>
+        <value>annote</value>
+        <value>archive</value>
+        <value>archive_location</value>
+        <value>archive-place</value>
+        <value>authority</value>
+        <value>call-number</value>
+        <value>citation-label</value>
+        <value>citation-number</value>
+        <value>collection-title</value>
+        <value>container-title</value>
+        <value>container-title-short</value>
+        <value>dimensions</value>
+        <value>DOI</value>
+        <value>event</value>
+        <value>event-place</value>
+        <value>first-reference-note-number</value>
+        <value>genre</value>
+        <value>ISBN</value>
+        <value>ISSN</value>
+        <value>jurisdiction</value>
+        <value>keyword</value>
+        <value>locator</value>
+        <value>medium</value>
+        <value>note</value>
+        <value>original-publisher</value>
+        <value>original-publisher-place</value>
+        <value>original-title</value>
+        <value>page</value>
+        <value>page-first</value>
+        <value>PMID</value>
+        <value>PMCID</value>
+        <value>publisher</value>
+        <value>publisher-place</value>
+        <value>references</value>
+        <value>reviewed-title</value>
+        <value>scale</value>
+        <value>section</value>
+        <value>source</value>
+        <value>status</value>
+        <value>title</value>
+        <value>title-short</value>
+        <value>URL</value>
+        <value>version</value>
+        <value>year-suffix</value>
+      </choice>
+    </define>
+  </div>
+  <div>
+    <a:documentation>Categories for style metadata</a:documentation>
+    <define name="category.citation-format">
+      <choice>
+        <value>author</value>
+        <value>author-date</value>
+        <value>label</value>
+        <value>note</value>
+        <value>numeric</value>
+      </choice>
+    </define>
+    <define name="category.field">
+      <a:documentation>Use "generic-base" for styles that are non-discipline specific, such as
+APA, Harvard, etc.</a:documentation>
+      <choice>
+        <value>anthropology</value>
+        <value>astronomy</value>
+        <value>biology</value>
+        <value>botany</value>
+        <value>chemistry</value>
+        <value>communications</value>
+        <value>engineering</value>
+        <value>generic-base</value>
+        <value>geography</value>
+        <value>geology</value>
+        <value>history</value>
+        <value>humanities</value>
+        <value>law</value>
+        <value>linguistics</value>
+        <value>literature</value>
+        <value>math</value>
+        <value>medicine</value>
+        <value>philosophy</value>
+        <value>physics</value>
+        <value>political_science</value>
+        <value>psychology</value>
+        <value>science</value>
+        <value>social_science</value>
+        <value>sociology</value>
+        <value>theology</value>
+        <value>zoology</value>
+      </choice>
+    </define>
+  </div>
+  <div>
+    <a:documentation>
+      <xhtml:h2>cs:style and cs:locale - Root Elements</xhtml:h2>
+    </a:documentation>
+    <start>
+      <choice>
+        <ref name="independent-style.style"/>
+        <ref name="dependent-style.style"/>
+        <ref name="locale-file.locale"/>
+      </choice>
+    </start>
+    <define name="independent-style.style">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">style</name>
+        <attribute>
+          <a:documentation>Select whether citations appear in-text or as notes.</a:documentation>
+          <name ns="">class</name>
           <choice>
             <value>in-text</value>
             <value>note</value>
           </choice>
         </attribute>
-        <ref name="style-options"/>
-        <ref name="info"/>
+        <ref name="style.default-locale"/>
+        <ref name="style.options"/>
+        <ref name="version"/>
+        <ref name="independent-style.style.info"/>
         <optional>
           <interleave>
             <zeroOrMore>
-              <ref name="style-locale"/>
+              <ref name="style.locale"/>
             </zeroOrMore>
             <zeroOrMore>
-              <ref name="macro"/>
+              <ref name="style.macro"/>
             </zeroOrMore>
-            <ref name="citation"/>
+            <ref name="style.citation"/>
             <optional>
-              <ref name="bibliography"/>
+              <ref name="style.bibliography"/>
             </optional>
           </interleave>
         </optional>
       </element>
     </define>
+    <define name="dependent-style.style">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">style</name>
+        <ref name="style.default-locale"/>
+        <ref name="version"/>
+        <ref name="dependent-style.style.info"/>
+        <ref name="dependent-style.style.legacy-attributes"/>
+      </element>
+    </define>
+    <define name="locale-file.locale">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">locale</name>
+        <attribute>
+          <a:documentation>Specify the locale of the locale file.</a:documentation>
+          <name ns="http://www.w3.org/XML/1998/namespace">lang</name>
+          <data type="language"/>
+        </attribute>
+        <ref name="version"/>
+        <optional>
+          <ref name="locale-file.locale.info"/>
+        </optional>
+        <interleave>
+          <ref name="locale.style-options"/>
+          <oneOrMore>
+            <ref name="locale.date"/>
+          </oneOrMore>
+          <ref name="locale.terms"/>
+        </interleave>
+      </element>
+    </define>
+    <define name="style.default-locale">
+      <optional>
+        <attribute>
+          <a:documentation>Set a default style locale.</a:documentation>
+          <name ns="">default-locale</name>
+          <data type="language"/>
+        </attribute>
+      </optional>
+    </define>
+    <define name="version">
+      <attribute a:defaultValue="1.0">
+        <a:documentation>Indicate CSL version compatibility ("1.0" for CSL 1.0).</a:documentation>
+        <name ns="">version</name>
+        <value>1.0</value>
+      </attribute>
+    </define>
+    <define name="dependent-style.style.legacy-attributes">
+      <a:documentation>Obsolete for dependent styles. Will be disallowed with CSL 1.1.</a:documentation>
+      <optional>
+        <attribute>
+          <name ns="">class</name>
+          <choice>
+            <value>in-text</value>
+            <value>note</value>
+          </choice>
+        </attribute>
+      </optional>
+      <ref name="style.options"/>
+    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Style Metadata</xhtml:h2>
+      <xhtml:h2>cs:info - Style and Locale File Metadata</xhtml:h2>
     </a:documentation>
-    <define name="info">
-      <a:documentation>The Content model for CSL metadata is borrowed from Atom.</a:documentation>
-      <element name="cs:info">
+    <define name="independent-style.style.info">
+      <a:documentation>Metadata for independent styles.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">info</name>
         <interleave>
           <zeroOrMore>
-            <ref name="info-author"/>
+            <ref name="info.author"/>
           </zeroOrMore>
           <zeroOrMore>
-            <ref name="info-category"/>
+            <ref name="info.category"/>
           </zeroOrMore>
           <zeroOrMore>
-            <ref name="info-contributor"/>
+            <ref name="info.contributor"/>
           </zeroOrMore>
-          <ref name="info-id"/>
+          <ref name="info.id"/>
+          <zeroOrMore>
+            <ref name="info.issn"/>
+          </zeroOrMore>
+          <optional>
+            <ref name="info.eissn"/>
+          </optional>
+          <optional>
+            <ref name="info.issnl"/>
+          </optional>
           <zeroOrMore>
-            <ref name="info-issn"/>
+            <ref name="independent-style.info.link"/>
           </zeroOrMore>
           <optional>
-            <ref name="info-issnl"/>
+            <ref name="info.published"/>
           </optional>
+          <optional>
+            <ref name="info.rights"/>
+          </optional>
+          <optional>
+            <ref name="info.summary"/>
+          </optional>
+          <ref name="info.title"/>
+          <optional>
+            <ref name="info.title-short"/>
+          </optional>
+          <ref name="info.updated"/>
+        </interleave>
+      </element>
+    </define>
+    <define name="dependent-style.style.info">
+      <a:documentation>Metadata for dependent styles.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">info</name>
+        <interleave>
+          <zeroOrMore>
+            <ref name="info.author"/>
+          </zeroOrMore>
+          <zeroOrMore>
+            <ref name="info.category"/>
+          </zeroOrMore>
           <zeroOrMore>
-            <ref name="info-link"/>
+            <ref name="info.contributor"/>
           </zeroOrMore>
+          <ref name="info.id"/>
+          <zeroOrMore>
+            <ref name="info.issn"/>
+          </zeroOrMore>
+          <optional>
+            <ref name="info.eissn"/>
+          </optional>
+          <optional>
+            <ref name="info.issnl"/>
+          </optional>
+          <oneOrMore>
+            <ref name="dependent-style.info.link"/>
+          </oneOrMore>
+          <optional>
+            <ref name="info.published"/>
+          </optional>
           <optional>
-            <ref name="info-published"/>
+            <ref name="info.rights"/>
           </optional>
           <optional>
-            <ref name="info-rights"/>
+            <ref name="info.summary"/>
           </optional>
+          <ref name="info.title"/>
           <optional>
-            <ref name="info-summary"/>
+            <ref name="info.title-short"/>
           </optional>
-          <ref name="info-title"/>
-          <ref name="info-updated"/>
+          <ref name="info.updated"/>
         </interleave>
       </element>
     </define>
-    <define name="info-author">
-      <element name="cs:author">
-        <ref name="info-contributor-pattern"/>
+    <define name="locale-file.locale.info">
+      <a:documentation>Metadata for locale files.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">info</name>
+        <interleave>
+          <zeroOrMore>
+            <ref name="info.translator"/>
+          </zeroOrMore>
+          <optional>
+            <ref name="info.rights"/>
+          </optional>
+          <optional>
+            <ref name="info.updated"/>
+          </optional>
+        </interleave>
       </element>
     </define>
-    <define name="info-contributor">
-      <element name="cs:contributor">
-        <ref name="info-contributor-pattern"/>
+    <define name="info.author">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">author</name>
+        <ref name="personal-details"/>
       </element>
     </define>
-    <define name="info-contributor-pattern">
+    <define name="info.contributor">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">contributor</name>
+        <ref name="personal-details"/>
+      </element>
+    </define>
+    <define name="info.translator">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">translator</name>
+        <ref name="personal-details"/>
+      </element>
+    </define>
+    <define name="personal-details">
       <interleave>
-        <element name="cs:name">
+        <element>
+          <name ns="http://purl.org/net/xbiblio/csl">name</name>
           <text/>
         </element>
         <optional>
-          <element name="cs:email">
+          <element>
+            <name ns="http://purl.org/net/xbiblio/csl">email</name>
             <text/>
           </element>
         </optional>
         <optional>
-          <element name="cs:uri">
+          <element>
+            <name ns="http://purl.org/net/xbiblio/csl">uri</name>
             <data type="anyURI"/>
           </element>
         </optional>
       </interleave>
     </define>
-    <define name="info-category">
-      <a:documentation>The category element may be used to specify the citation format of the
-style (using the citation-format attribute) and the fields or disciplines
-for which the style is relevant (using the field attribute).</a:documentation>
-      <element name="cs:category">
+    <define name="info.category">
+      <element>
+        <a:documentation>Specify the citation format of the style (using the "citation-format"
+attribute) or the fields and disciplines for which the style is
+relevant (using the "field" attribute).</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">category</name>
         <choice>
-          <attribute name="citation-format">
-            <ref name="info-format-categories"/>
+          <attribute>
+            <name ns="">citation-format</name>
+            <ref name="category.citation-format"/>
           </attribute>
-          <attribute name="field">
-            <ref name="info-field-categories"/>
+          <attribute>
+            <name ns="">field</name>
+            <ref name="category.field"/>
           </attribute>
         </choice>
       </element>
     </define>
-    <define name="info-id">
-      <a:documentation>As in Atom, the cs:id element is a required URI that is globally-unique
-and persistant. To allow styles to be automatically updated, the URI of a
-style should not change once assigned. Ideally, the URI resolves to the
-correct CSL file: it should preferably point to the CSL style itself in
-case of independent styles, and to the independent-parent style in case
-of dependent styles.</a:documentation>
-      <element name="cs:id">
+    <define name="info.id">
+      <element>
+        <a:documentation>Specify the URI to establish the identity of the style. The URI
+should be stable, unique and dereferenceable URI.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">id</name>
         <data type="anyURI"/>
       </element>
     </define>
-    <define name="info-link">
-      <element name="cs:link">
-        <attribute name="href">
+    <define name="info.issn">
+      <element>
+        <a:documentation>Specify the journal's ISSN(s) for journal-specific styles. An ISSN
+must consist of four digits, a hyphen, three digits, and a check
+digit (a numeral digit or roman X), e.g. "1234-1231".</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">issn</name>
+        <ref name="issn"/>
+      </element>
+    </define>
+    <define name="info.eissn">
+      <element>
+        <a:documentation>Specify the journal's eISSN for journal-specific styles.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">eissn</name>
+        <ref name="issn"/>
+      </element>
+    </define>
+    <define name="info.issnl">
+      <element>
+        <a:documentation>Specify the journal's ISSN-L for journal-specific styles.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">issnl</name>
+        <ref name="issn"/>
+      </element>
+    </define>
+    <define name="issn">
+      <data type="string">
+        <param name="pattern">\d{4}\-\d{3}(\d|x|X)</param>
+      </data>
+    </define>
+    <define name="independent-style.info.link">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">link</name>
+        <attribute>
+          <name ns="">href</name>
           <data type="anyURI"/>
         </attribute>
-        <attribute name="rel">
-          <a:documentation>For transformation to Atom, the rel values should be expanded to
-include the base URI &lt;http://purl.org/net/xbiblio/csl/relations#&gt;.</a:documentation>
+        <attribute>
+          <a:documentation>Specify how the URL relates to the style.</a:documentation>
+          <name ns="">rel</name>
           <choice>
             <value>self</value>
-            <a:documentation>The URI of the CSL style itself. Used for automatic style
-updating.</a:documentation>
-            <value>independent-parent</value>
-            <a:documentation>The CSL style URI whose configuration content should be
-used for processing. Required for dependent styles.</a:documentation>
+            <a:documentation>The URI of the CSL style itself.</a:documentation>
             <value>template</value>
-            <a:documentation>The CSL style URI from which the current style is derived.</a:documentation>
+            <a:documentation>URI of the style from which the current style is derived.</a:documentation>
             <value>documentation</value>
-            <a:documentation>A documentation URI for the style.</a:documentation>
+            <a:documentation>URI of style documentation.</a:documentation>
+            <value>independent-parent</value>
+            <a:documentation>Obsolete for independent styles. Will be disallowed with
+CSL 1.1.</a:documentation>
           </choice>
         </attribute>
         <ref name="info-text"/>
       </element>
     </define>
-    <define name="info-published">
-      <element name="cs:published">
+    <define name="dependent-style.info.link">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">link</name>
+        <attribute>
+          <name ns="">href</name>
+          <data type="anyURI"/>
+        </attribute>
+        <attribute>
+          <a:documentation>Specify how the URL relates to the style.</a:documentation>
+          <name ns="">rel</name>
+          <choice>
+            <value>self</value>
+            <a:documentation>The URI of the CSL style itself.</a:documentation>
+            <value>independent-parent</value>
+            <a:documentation>URI of the CSL style whose content should be used for
+processing. Required for dependent styles.</a:documentation>
+            <value>documentation</value>
+            <a:documentation>URI of style documentation.</a:documentation>
+            <value>template</value>
+            <a:documentation>Obsolete for dependent styles. Will be disallowed with CSL
+1.1.</a:documentation>
+          </choice>
+        </attribute>
+        <ref name="info-text"/>
+      </element>
+    </define>
+    <define name="info.published">
+      <element>
+        <a:documentation>Specify when the style was initially created or made available.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">published</name>
         <data type="dateTime"/>
       </element>
     </define>
-    <define name="info-rights">
-      <element name="cs:rights">
+    <define name="info.rights">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">rights</name>
+        <optional>
+          <attribute>
+            <name ns="">license</name>
+            <data type="anyURI"/>
+          </attribute>
+        </optional>
         <ref name="info-text"/>
       </element>
     </define>
-    <define name="info-summary">
-      <element name="cs:summary">
+    <define name="info.summary">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">summary</name>
         <ref name="info-text"/>
       </element>
     </define>
-    <define name="info-title">
-      <element name="cs:title">
+    <define name="info.title">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">title</name>
         <ref name="info-text"/>
       </element>
     </define>
+    <define name="info.title-short">
+      <element>
+        <a:documentation>Specify an abbreviated style title (e.g., "APA")</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">title-short</name>
+        <ref name="info-text"/>
+      </element>
+    </define>
+    <define name="info.updated">
+      <element>
+        <a:documentation>Specify when the style was last updated (e.g.,
+"2007-10-26T21:32:52+02:00")</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">updated</name>
+        <data type="dateTime"/>
+      </element>
+    </define>
     <define name="info-text">
       <optional>
-        <attribute name="xml:lang">
+        <attribute>
+          <name ns="http://www.w3.org/XML/1998/namespace">lang</name>
           <data type="language"/>
         </attribute>
       </optional>
       <text/>
     </define>
-    <define name="info-issn">
-      <a:documentation>For journal-dedicated styles the journal's ISSNs or ISSN-L may be included.
-A valid ISSN(-L) consists of: four digits, a hyphen, three digits, and a 
-check digit, which can be a numeral digit or a roman X, e.g. "1234-1231".</a:documentation>
-      <element name="cs:issn">
-        <data type="string">
-          <param name="pattern">\d{4}\-\d{3}(\d|x|X)</param>
-        </data>
-      </element>
-    </define>
-    <define name="info-issnl">
-      <element name="cs:issnl">
-        <data type="string">
-          <param name="pattern">\d{4}\-\d{3}(\d|x|X)</param>
-        </data>
-      </element>
-    </define>
-    <define name="info-updated">
-      <a:documentation>a required update date-time stamp; for example, 2007-10-26T21:32:52+02:00</a:documentation>
-      <element name="cs:updated">
-        <data type="dateTime"/>
-      </element>
-    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Localization</xhtml:h2>
+      <xhtml:h2>cs:locale in Independent Styles</xhtml:h2>
     </a:documentation>
-    <define name="locale">
-      <a:documentation>Describes the structure of standalone locale files</a:documentation>
-      <element name="cs:locale">
-        <attribute name="xml:lang">
-          <a:documentation>Specifies the locale of the locale file.</a:documentation>
-          <data type="language"/>
-        </attribute>
-        <attribute name="version">
-          <a:documentation>Indicates with which version of the CSL schema the locale file is compatible</a:documentation>
-          <value>1.0</value>
-        </attribute>
-        <interleave>
-          <ref name="localized-terms"/>
-          <oneOrMore>
-            <ref name="localized-dates"/>
-          </oneOrMore>
-          <ref name="localized-options"/>
-        </interleave>
-      </element>
-    </define>
-    <define name="style-locale">
-      <a:documentation>In styles, cs:locale can be used to override localized terms, dates and options.</a:documentation>
-      <element name="cs:locale">
+    <define name="style.locale">
+      <element>
+        <a:documentation>Use to (re)define localized terms, dates and options.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">locale</name>
         <optional>
-          <attribute name="xml:lang">
-            <a:documentation>Specifies the locale to override. A cs:locale element without the
-xml:lang attribute can also be used: it overrides the content of
-all locales, but is in turn overridden by cs:locale elements with
-the xml:lang attribute.</a:documentation>
+          <attribute>
+            <a:documentation>Specify the affected locale(s). If "xml:lang" is not set, the
+"cs:locale" element affects all locales.</a:documentation>
+            <name ns="http://www.w3.org/XML/1998/namespace">lang</name>
             <data type="language"/>
           </attribute>
         </optional>
         <interleave>
           <optional>
-            <ref name="localized-terms"/>
+            <ref name="locale.style-options"/>
           </optional>
           <zeroOrMore>
-            <ref name="localized-dates"/>
+            <ref name="locale.date"/>
           </zeroOrMore>
           <optional>
-            <ref name="localized-options"/>
+            <ref name="locale.terms"/>
           </optional>
         </interleave>
       </element>
     </define>
-    <define name="localized-terms">
-      <element name="cs:terms">
+  </div>
+  <div>
+    <a:documentation>
+      <xhtml:h2>cs:locale Contents - Localization Data</xhtml:h2>
+    </a:documentation>
+    <define name="locale.style-options">
+      <a:documentation>Localized global options are specified as attributes in the
+cs:style-options element. If future versions of CSL include localized
+options that are citation or bibliography specific, the elements
+cs:citation-options and cs:bibliography-options can be added.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">style-options</name>
+        <optional>
+          <attribute a:defaultValue="false">
+            <a:documentation>Limit the "ordinal" form to the first day of the month.</a:documentation>
+            <name ns="">limit-day-ordinals-to-day-1</name>
+            <data type="boolean"/>
+          </attribute>
+        </optional>
+        <optional>
+          <attribute a:defaultValue="false">
+            <a:documentation>Specify whether punctuation (a period or comma) is placed within
+or outside (default) the closing quotation mark.</a:documentation>
+            <name ns="">punctuation-in-quote</name>
+            <data type="boolean"/>
+          </attribute>
+        </optional>
+      </element>
+    </define>
+    <define name="locale.date">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">date</name>
+        <ref name="date.form"/>
+        <ref name="delimiter"/>
+        <ref name="font-formatting"/>
+        <ref name="text-case"/>
         <oneOrMore>
-          <choice>
-            <ref name="simple-term"/>
-            <ref name="compound-term"/>
-          </choice>
+          <ref name="locale.date.date-part"/>
         </oneOrMore>
       </element>
     </define>
-    <define name="term-attributes">
-      <optional>
-        <attribute name="form">
-          <ref name="cs-term-forms"/>
-        </attribute>
-      </optional>
-      <attribute name="name">
-        <ref name="cs-terms"/>
+    <define name="date.form">
+      <attribute>
+        <a:documentation>Select the localized date format ("text" or "numeric").</a:documentation>
+        <name ns="">form</name>
+        <choice>
+          <value>text</value>
+          <a:documentation>Text date form (e.g., "December 15, 2005").</a:documentation>
+          <value>numeric</value>
+          <a:documentation>Numeric date form (e.g., "2005-12-15").</a:documentation>
+        </choice>
       </attribute>
     </define>
-    <define name="cs-term-forms">
-      <a:documentation>"verb-short" reverts to "verb" if the "verb-short" form is not available
-"symbol" reverts to "short" if the "symbol" form is not available
-"verb" and "short" revert to "long" if the specified form is not available</a:documentation>
+    <define name="locale.date.date-part">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">date-part</name>
+        <ref name="affixes"/>
+        <ref name="font-formatting"/>
+        <ref name="text-case"/>
+        <choice>
+          <ref name="day"/>
+          <ref name="month"/>
+          <ref name="year"/>
+        </choice>
+      </element>
+    </define>
+    <define name="locale.terms">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">terms</name>
+        <oneOrMore>
+          <ref name="terms.term"/>
+        </oneOrMore>
+      </element>
+    </define>
+    <define name="terms.term">
+      <a:documentation>The "cs:term" element can either hold a basic string, or "cs:single" and
+"cs:multiple" child elements to give singular and plural forms of the term.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">term</name>
+        <ref name="term.attributes"/>
+        <choice>
+          <text/>
+          <group>
+            <ref name="term.single"/>
+            <ref name="term.multiple"/>
+          </group>
+        </choice>
+      </element>
+    </define>
+    <define name="term.attributes">
+      <choice>
+        <group>
+          <attribute>
+            <name ns="">name</name>
+            <ref name="terms"/>
+          </attribute>
+          <optional>
+            <attribute a:defaultValue="long">
+              <name ns="">form</name>
+              <ref name="term.form"/>
+            </attribute>
+          </optional>
+        </group>
+        <group>
+          <attribute>
+            <name ns="">name</name>
+            <ref name="terms.ordinals"/>
+          </attribute>
+          <optional>
+            <attribute>
+              <name ns="">form</name>
+              <value>long</value>
+            </attribute>
+          </optional>
+          <optional>
+            <attribute>
+              <name ns="">gender-form</name>
+              <choice>
+                <value>masculine</value>
+                <value>feminine</value>
+              </choice>
+            </attribute>
+          </optional>
+          <optional>
+            <attribute>
+              <name ns="">match</name>
+              <choice>
+                <value>last-digit</value>
+                <value>last-two-digits</value>
+                <value>whole-number</value>
+              </choice>
+            </attribute>
+          </optional>
+        </group>
+        <group>
+          <attribute>
+            <name ns="">name</name>
+            <ref name="terms.long-ordinals"/>
+          </attribute>
+          <optional>
+            <attribute>
+              <name ns="">form</name>
+              <value>long</value>
+            </attribute>
+          </optional>
+          <attribute>
+            <name ns="">gender-form</name>
+            <choice>
+              <value>masculine</value>
+              <value>feminine</value>
+            </choice>
+          </attribute>
+        </group>
+        <group>
+          <attribute>
+            <name ns="">name</name>
+            <ref name="terms.gender-assignable"/>
+          </attribute>
+          <optional>
+            <attribute>
+              <name ns="">form</name>
+              <value>long</value>
+            </attribute>
+          </optional>
+          <attribute>
+            <name ns="">gender</name>
+            <choice>
+              <value>masculine</value>
+              <value>feminine</value>
+            </choice>
+          </attribute>
+        </group>
+      </choice>
+    </define>
+    <define name="term.form">
+      <a:documentation>"verb-short" reverts to "verb" if the "verb-short" form is not available.
+"symbol" reverts to "short" if the "symbol" form is not available.
+"verb" and "short" revert to "long" if the specified form is not available.</a:documentation>
       <choice>
         <value>long</value>
         <value>verb</value>
         <value>short</value>
         <value>verb-short</value>
         <value>symbol</value>
-        <ref name="cs-term-forms.extension"/>
       </choice>
     </define>
-    <div>
-      <a:documentation>Extension structures. You may override these in a customization 
-schema. If you do, please contact the xbiblio project to add 
-the term or form to the formal controlled list in the schema.</a:documentation>
-      <define name="cs-terms.extension">
-        <notAllowed/>
-      </define>
-      <define name="cs-term-forms.extension">
-        <notAllowed/>
-      </define>
-    </div>
-    <define name="simple-term">
-      <a:documentation>Simple terms are basic strings, used to represent genres, media, etc.</a:documentation>
-      <element name="cs:term">
-        <ref name="term-attributes"/>
-        <text/>
-      </element>
-    </define>
-    <define name="compound-term">
-      <a:documentation>Compound terms are those whose output can be either singular or plural. 
-Typically used for things like page number or editor labels.</a:documentation>
-      <element name="cs:term">
-        <ref name="term-attributes"/>
-        <ref name="single-term"/>
-        <ref name="multiple-term"/>
-      </element>
-    </define>
-    <define name="multiple-term">
-      <element name="cs:multiple">
+    <define name="term.single">
+      <element>
+        <a:documentation>Singular version of the term.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">single</name>
         <text/>
       </element>
     </define>
-    <define name="single-term">
-      <element name="cs:single">
+    <define name="term.multiple">
+      <element>
+        <a:documentation>Plural version of the term.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">multiple</name>
         <text/>
       </element>
     </define>
-    <define name="localized-dates">
-      <a:documentation>Instances of cs:date for which the form attribute is set are localized
-by default. Localized date formats can be overridden.</a:documentation>
-      <element name="cs:date">
-        <attribute name="form">
-          <a:documentation>Declares the type of date being defined.</a:documentation>
-          <choice>
-            <value>text</value>
-            <a:documentation>Text form of the date (e.g. "December 15, 2005" for en-US).</a:documentation>
-            <value>numeric</value>
-            <a:documentation>Numeric form of the date (e.g. "12-15-2005" for en-US)</a:documentation>
-          </choice>
-        </attribute>
-        <ref name="font-formatting">
-          <a:documentation>No affixes may be applied to cs:date in cs:locale</a:documentation>
-        </ref>
-        <ref name="delimiter"/>
-        <oneOrMore>
-          <element name="cs:date-part">
-            <ref name="affixes"/>
-            <ref name="text-case"/>
-            <ref name="font-formatting"/>
-            <choice>
-              <ref name="month"/>
-              <ref name="day"/>
-              <ref name="year"/>
-            </choice>
-          </element>
-        </oneOrMore>
-      </element>
-    </define>
-    <define name="localized-options">
-      <a:documentation>Locale specific options.</a:documentation>
-      <element name="cs:style-options">
-        <a:documentation>Localized global options are specified as attributes in the
-cs:style-options element. If future versions of CSL include localized
-options that are citation or bibliography specific, the elements
-cs:citation-options and cs:bibliography-options can be added.</a:documentation>
-        <optional>
-          <attribute name="punctuation-in-quote">
-            <a:documentation>Determines whether punctuation (commas and periods) goes within 
-the quotation marks, or outside (default).</a:documentation>
-            <data type="boolean"/>
-          </attribute>
-        </optional>
-      </element>
-    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Macros</xhtml:h2>
+      <xhtml:h2>cs:macro</xhtml:h2>
     </a:documentation>
-    <define name="macro">
-      <a:documentation>The macro element works something like in BibTeX, and provides a ready-made 
-bundle of formatting templates that can be easily reused elsewhere.</a:documentation>
-      <element name="cs:macro">
-        <attribute name="name">
+    <define name="style.macro">
+      <element>
+        <a:documentation>Use to create collections of (reusable) formatting instructions.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">macro</name>
+        <attribute>
+          <name ns="">name</name>
           <data type="NMTOKEN"/>
         </attribute>
         <oneOrMore>
-          <ref name="cs-element"/>
+          <ref name="rendering-element"/>
         </oneOrMore>
       </element>
     </define>
+    <define name="rendering-element">
+      <choice>
+        <ref name="rendering-element.names"/>
+        <ref name="rendering-element.date"/>
+        <ref name="rendering-element.label"/>
+        <ref name="rendering-element.text"/>
+        <ref name="rendering-element.number"/>
+        <ref name="rendering-element.choose"/>
+        <ref name="rendering-element.group"/>
+      </choice>
+    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Citation and Bibliography</xhtml:h2>
+      <xhtml:h2>cs:citation and cs:bibliography</xhtml:h2>
     </a:documentation>
-    <define name="citation">
-      <a:documentation>The cs:citation handles printing of citations. A citation may consist of
-one or more references to bibliographic sources. These references can either
-be simple in-text keys [doe99] or numeric markers [1], or more complex short
-descriptors common in author-date (Doe, 1999a) or note styles.</a:documentation>
-      <element name="cs:citation">
-        <interleave>
-          <ref name="citation-options"/>
-          <optional>
-            <ref name="sort"/>
-          </optional>
-        </interleave>
-        <ref name="citation-layout"/>
+    <define name="style.citation">
+      <element>
+        <a:documentation>Use to describe the formatting of citations.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">citation</name>
+        <ref name="citation.options"/>
+        <optional>
+          <ref name="sort"/>
+        </optional>
+        <ref name="citation.layout"/>
       </element>
     </define>
-    <define name="bibliography">
-      <element name="cs:bibliography">
-        <interleave>
-          <ref name="bibliography-options"/>
-          <optional>
-            <ref name="sort"/>
-          </optional>
-        </interleave>
-        <ref name="bibliography-layout"/>
+    <define name="style.bibliography">
+      <element>
+        <a:documentation>Use to describe the formatting of the bibliography.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">bibliography</name>
+        <ref name="bibliography.options"/>
+        <optional>
+          <ref name="sort"/>
+        </optional>
+        <ref name="bibliography.layout"/>
       </element>
     </define>
-    <define name="citation-layout">
-      <element name="cs:layout">
+    <define name="citation.layout">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">layout</name>
         <ref name="affixes"/>
-        <ref name="font-formatting"/>
         <ref name="delimiter"/>
-        <ref name="cs-element"/>
+        <ref name="font-formatting"/>
+        <oneOrMore>
+          <ref name="rendering-element"/>
+        </oneOrMore>
       </element>
     </define>
-    <define name="bibliography-layout">
-      <element name="cs:layout">
+    <define name="bibliography.layout">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">layout</name>
         <ref name="affixes"/>
         <ref name="font-formatting"/>
-        <ref name="cs-element"/>
+        <oneOrMore>
+          <ref name="rendering-element"/>
+        </oneOrMore>
       </element>
     </define>
-    <define name="cs-element">
-      <oneOrMore>
-        <choice>
-          <ref name="names"/>
-          <ref name="date"/>
-          <ref name="label"/>
-          <ref name="cs-text"/>
-          <ref name="cs-number"/>
-          <ref name="choose"/>
-          <ref name="group"/>
-        </choice>
-      </oneOrMore>
-    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Contributor Names</xhtml:h2>
+      <xhtml:h2>cs:names Rendering Element</xhtml:h2>
     </a:documentation>
-    <define name="names-opt">
-      <a:documentation>Options for cs:names, available for cs:style, cs:citation and cs:bibliography.</a:documentation>
-      <optional>
-        <attribute name="names-delimiter">
-          <a:documentation>Delimiter between names (delimiter between variables is on &lt;names&gt;
-tag, where it should be). This is ", " in "J. Doe, S. Smith."</a:documentation>
-        </attribute>
-      </optional>
+    <define name="rendering-element.names">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">names</name>
+        <ref name="names.attributes"/>
+        <interleave>
+          <group>
+            <optional>
+              <ref name="names.name"/>
+            </optional>
+            <optional>
+              <ref name="names.et-al"/>
+            </optional>
+          </group>
+          <zeroOrMore>
+            <ref name="names.label"/>
+          </zeroOrMore>
+        </interleave>
+        <optional>
+          <ref name="names.substitute"/>
+        </optional>
+      </element>
     </define>
-    <define name="names-attributes">
-      <ref name="affixes"/>
-      <ref name="display"/>
-      <ref name="font-formatting"/>
-      <ref name="delimiter">
-        <a:documentation>the delimiter between name groups</a:documentation>
-      </ref>
-      <attribute name="variable">
+    <define name="names.attributes">
+      <attribute>
+        <name ns="">variable</name>
         <list>
           <oneOrMore>
-            <ref name="cs-names"/>
+            <ref name="variables.names"/>
           </oneOrMore>
         </list>
       </attribute>
+      <ref name="affixes"/>
+      <ref name="delimiter"/>
+      <ref name="display"/>
+      <ref name="font-formatting"/>
+    </define>
+    <define name="names.name">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">name</name>
+        <ref name="name.attributes"/>
+        <optional>
+          <attribute a:defaultValue="long">
+            <a:documentation>Select the "long" (first name + last name, for Western names),
+"short" (last name only, for Western names), or "count" name form
+(returning the number of names in the name variable, which can be
+useful for some sorting algorithms).</a:documentation>
+            <name ns="">form</name>
+            <choice>
+              <value>long</value>
+              <value>short</value>
+              <value>count</value>
+            </choice>
+          </attribute>
+        </optional>
+        <ref name="affixes"/>
+        <ref name="delimiter" a:defaultValue=", "/>
+        <ref name="font-formatting"/>
+        <zeroOrMore>
+          <ref name="name.name-part"/>
+        </zeroOrMore>
+      </element>
     </define>
-    <define name="name-opt">
-      <a:documentation>Options for cs:name, available for cs:style, cs:citation and cs:bibliography.</a:documentation>
-      <ref name="name-attributes"/>
-      <optional>
-        <attribute name="name-form">
-          <a:documentation>Indicates long (first name + last name, for Western names) or short
-(last name only, for Western names) form of name. Default is long
-form. The "count" form is used to return the count of the contributor
-list, and may be used in special sorting routines.</a:documentation>
+    <define name="name.attributes">
+      <optional>
+        <attribute>
+          <a:documentation>Use to separate the second-to-last and last name of a name list by
+the "and" term or ampersand.</a:documentation>
+          <name ns="">and</name>
           <choice>
-            <value>long</value>
-            <value>short</value>
-            <value>count</value>
+            <value>text</value>
+            <a:documentation>Use the "and" term (e.g., "Doe, Johnson and Smith").</a:documentation>
+            <value>symbol</value>
+            <a:documentation>Use the "ampersand" (e.g., "Doe, Johnson &amp; Smith").</a:documentation>
           </choice>
         </attribute>
       </optional>
       <optional>
-        <attribute name="name-delimiter">
-          <a:documentation>Delimiter between names (delimiter between variables is on &lt;names&gt;
-tag, where it should be). This is ", " in "J. Doe, S. Smith."</a:documentation>
-        </attribute>
-      </optional>
-    </define>
-    <define name="name-attributes">
-      <optional>
-        <attribute name="and">
-          <a:documentation>Controls appearance of "and"/"&amp;". To disable, do not specify.</a:documentation>
+        <attribute a:defaultValue="contextual">
+          <a:documentation>Specify when the name delimiter is used between a truncated name list
+and the "et-al" (or "and others") term in case of et-al abbreviation
+(e.g., "Smith, Doe et al." or "Smith, Doe, et al.").</a:documentation>
+          <name ns="">delimiter-precedes-et-al</name>
           <choice>
-            <value>text</value>
-            <value>symbol</value>
+            <value>contextual</value>
+            <a:documentation>The name delimiter is only used when the truncated name list
+consists of two or more names.</a:documentation>
+            <value>always</value>
+            <a:documentation>The name delimiter is always used.</a:documentation>
+            <value>never</value>
+            <a:documentation>The name delimiter is never used.</a:documentation>
+            <value>after-inverted-name</value>
+            <a:documentation>The name delimiter is only used if the preceding name is inverted as
+a result of the "name-as-sort-order" attribute.</a:documentation>
           </choice>
         </attribute>
       </optional>
       <optional>
-        <attribute name="delimiter-precedes-last">
-          <a:documentation>Delimiter preceding the last name in a name list</a:documentation>
+        <attribute a:defaultValue="contextual">
+          <a:documentation>Specify when the name delimiter is used between the second-to-last
+and last name of a non-truncated name list. Only has an effect when
+the "and" term or ampersand is used (e.g., "Doe and Smith" or "Doe,
+and Smith").</a:documentation>
+          <name ns="">delimiter-precedes-last</name>
           <choice>
             <value>contextual</value>
-            <a:documentation>Default behavior; delimiter is included for name lists of length
-three or more:
-2 authors: "J. Doe and T. Timmons,"
-3 authors: "J. Doe, S. Smith, and T. Timmons" (note comma preceding 'and').</a:documentation>
+            <a:documentation>The name delimiter is only used when the name list consists of
+three or more names.</a:documentation>
             <value>always</value>
-            <a:documentation>Delimiter is always included
-2 author result: "J. Doe, and T. Timmons"
-3 authors: "J. Doe, S. Smith, and T. Timmons" (note comma preceding 'and').</a:documentation>
+            <a:documentation>The name delimiter is always used.</a:documentation>
             <value>never</value>
-            <a:documentation>Delimiter is never included
-2 authors: "J. Doe and T. Timmons,"
-3 authors: "J. Doe, S. Smith and T. Timmons"</a:documentation>
+            <a:documentation>The name delimiter is never used.</a:documentation>
+            <value>after-inverted-name</value>
+            <a:documentation>The name delimiter is only used if the preceding name is inverted as
+a result of the "name-as-sort-order" attribute.</a:documentation>
           </choice>
         </attribute>
       </optional>
       <optional>
-        <attribute name="et-al-min">
-          <a:documentation>Specifies when "et al." name list abbreviation is used
-  et-al-min: the minimum number of contributors to use "et al."
-  et-al-use-first: the number of contributors to print before "et al."
-  et-al-subsequent-*: as above, but for subsequent citations</a:documentation>
+        <attribute>
+          <a:documentation>Set the minimum number of names needed in a name variable to activate
+et-al abbreviation.</a:documentation>
+          <name ns="">et-al-min</name>
           <data type="integer"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="et-al-use-first">
+        <attribute>
+          <a:documentation>Set the number of names to render when et-al abbreviation is active.</a:documentation>
+          <name ns="">et-al-use-first</name>
           <data type="integer"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="et-al-subsequent-min">
+        <attribute>
+          <a:documentation>As "et-al-min", but only affecting subsequent citations to an item.</a:documentation>
+          <name ns="">et-al-subsequent-min</name>
           <data type="integer"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="et-al-subsequent-use-first">
-          <data type="integer"/>
+        <attribute>
+          <a:documentation>As "et-al-use-first", but only affecting subsequent citations to an
+item.</a:documentation>
+          <name ns="">et-al-subsequent-use-first</name>
+          <data type="integer"/>
+        </attribute>
+      </optional>
+      <optional>
+        <attribute a:defaultValue="false">
+          <a:documentation>If set to "true", the "et-al" (or "and others") term is replaced by
+an ellipsis followed by the last name of the name variable.</a:documentation>
+          <name ns="">et-al-use-last</name>
+          <data type="boolean"/>
+        </attribute>
+      </optional>
+      <optional>
+        <attribute a:defaultValue="true">
+          <a:documentation>If set to "false", names are not initialized and "initialize-with"
+only affects initials already present in the input data.</a:documentation>
+          <name ns="">initialize</name>
+          <data type="boolean"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="initialize-with">
-          <a:documentation>Indicates whether given name parts ought to be given as initials
-(e.g., J. K. Rowling) and the text to follow each initial.</a:documentation>
+        <attribute>
+          <a:documentation>Activate initializing of given names. The attribute value is appended
+to each initial (e.g., with ". ", "Orson Welles" becomes "O. Welles").</a:documentation>
+          <name ns="">initialize-with</name>
+          <text/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="name-as-sort-order">
-          <a:documentation>Sets the author name order to correspond to the sort order of
-the bibliography; e.g. Doe, John (name-as-sort-order) vs. John Doe (w/o
-attribute).</a:documentation>
+        <attribute>
+          <a:documentation>Specify whether (and which) names should be rendered in their sort
+order (e.g., "Doe, John" instead of "John Doe").</a:documentation>
+          <name ns="">name-as-sort-order</name>
           <choice>
             <value>first</value>
-            <a:documentation>Applies name-as-sort-order to first author only.</a:documentation>
+            <a:documentation>Render the first name of each name variable in sort order.</a:documentation>
             <value>all</value>
-            <a:documentation>Applies name-as-sort-order to all authors.</a:documentation>
+            <a:documentation>Render all names in sort order.</a:documentation>
           </choice>
         </attribute>
       </optional>
       <optional>
-        <attribute name="sort-separator">
-          <a:documentation>The delimiter for personal name parts where sort order differs from 
-display order (for example, in standard Western names). This is the
-", " in "Doe, John."</a:documentation>
+        <attribute a:defaultValue=", ">
+          <a:documentation>Sets the delimiter for name-parts that have switched positions as a
+result of "name-as-sort-order" (e.g., ", " in "Doe, John").</a:documentation>
+          <name ns="">sort-separator</name>
+          <text/>
         </attribute>
       </optional>
     </define>
-    <define name="names">
-      <element name="cs:names">
-        <ref name="names-attributes"/>
-        <interleave>
-          <group>
-            <ref name="name"/>
-            <optional>
-              <ref name="et-al"/>
-            </optional>
-          </group>
-          <zeroOrMore>
-            <ref name="name-label"/>
-          </zeroOrMore>
-        </interleave>
-        <optional>
-          <ref name="substitute"/>
-        </optional>
-      </element>
-    </define>
-    <define name="names-short">
-      <a:documentation>Short version of "names" element, without children, allowed in &lt;substitute&gt;</a:documentation>
-      <element name="cs:names">
-        <ref name="names-attributes"/>
-      </element>
-    </define>
-    <define name="name">
-      <element name="cs:name">
-        <ref name="name-attributes"/>
+    <define name="name.name-part">
+      <element>
+        <a:documentation>Use to format individual name parts (e.g., "Jane DOE").</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">name-part</name>
+        <attribute>
+          <name ns="">name</name>
+          <choice>
+            <value>family</value>
+            <value>given</value>
+          </choice>
+        </attribute>
         <ref name="affixes"/>
         <ref name="font-formatting"/>
+        <ref name="text-case"/>
+      </element>
+    </define>
+    <define name="names.et-al">
+      <element>
+        <a:documentation>Specify the term used for et-al abbreviation and its formatting. </a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">et-al</name>
         <optional>
-          <attribute name="form">
-            <a:documentation>Indicates long (first name + last name, for Western names) or short
-(last name only, for Western names) form of name. Default is long
-form. The "count" form is used to return the count of the contributor
-list, and may be used in special sorting routines.</a:documentation>
+          <attribute a:defaultValue="et-al">
+            <a:documentation>Select the term to use for et-al abbreviation.</a:documentation>
+            <name ns="">term</name>
             <choice>
-              <value>long</value>
-              <value>short</value>
-              <value>count</value>
+              <value>et-al</value>
+              <value>and others</value>
             </choice>
           </attribute>
         </optional>
-        <ref name="delimiter">
-          <a:documentation>Delimiter between names (delimiter between variables is on &lt;names&gt;
-tag, where it should be). This is ", " in "J. Doe, S. Smith."</a:documentation>
-        </ref>
-        <zeroOrMore>
-          <element name="cs:name-part">
-            <a:documentation>Allows for separate configuration of name part formatting. For example, 
-Jane DOE. Order of these elements is not significant.</a:documentation>
-            <attribute name="name">
-              <choice>
-                <value>family</value>
-                <value>given</value>
-              </choice>
-            </attribute>
-            <ref name="text-case"/>
-            <ref name="font-formatting"/>
-          </element>
-        </zeroOrMore>
+        <ref name="font-formatting"/>
+        <ref name="names.et-al.legacy-attributes"/>
       </element>
     </define>
-    <define name="name-label">
-      <a:documentation>Similar to label as below, but inherits variable from &lt;names&gt; tag</a:documentation>
-      <element name="cs:label">
-        <ref name="label-primitives"/>
-      </element>
+    <define name="names.et-al.legacy-attributes">
+      <a:documentation>Ignored in CSL 1.0.1. Will be disallowed with CSL 1.1.</a:documentation>
+      <ref name="affixes"/>
     </define>
-    <define name="et-al">
-      <a:documentation>Configures formatting of the et al substitution. Only necessary to deviate from 
-default rendering (for example, to italicize the string).</a:documentation>
-      <element name="cs:et-al">
+    <define name="names.label">
+      <a:documentation>Inherits variable from the parent cs:names element.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">label</name>
         <optional>
-          <attribute name="term">
-            <a:documentation>term to use for et al substitution; "et-al" is default</a:documentation>
-            <choice>
-              <value>et-al</value>
-              <value>and others</value>
-            </choice>
+          <attribute a:defaultValue="long">
+            <name ns="">form</name>
+            <ref name="term.form"/>
           </attribute>
         </optional>
-        <ref name="affixes"/>
-        <ref name="font-formatting"/>
+        <ref name="label.attributes-shared"/>
       </element>
     </define>
-    <define name="substitute">
-      <a:documentation>Substitutions, if the name does not exist</a:documentation>
-      <element name="cs:substitute">
+    <define name="names.substitute">
+      <element>
+        <a:documentation>Specify substitution options when the name variables selected on the
+parent cs:names element are empty.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">substitute</name>
         <oneOrMore>
           <choice>
-            <ref name="names-short"/>
-            <ref name="cs-element"/>
+            <ref name="substitute.names"/>
+            <ref name="rendering-element"/>
           </choice>
         </oneOrMore>
       </element>
     </define>
+    <define name="substitute.names">
+      <a:documentation>Short version of cs:names, without children, allowed in cs:substitute.</a:documentation>
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">names</name>
+        <ref name="names.attributes"/>
+      </element>
+    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Dates</xhtml:h2>
+      <xhtml:h2>cs:date Rendering Element</xhtml:h2>
     </a:documentation>
-    <define name="date">
-      <element name="cs:date">
-        <attribute name="variable">
-          <ref name="cs-dates"/>
+    <define name="rendering-element.date">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">date</name>
+        <attribute>
+          <name ns="">variable</name>
+          <ref name="variables.dates"/>
         </attribute>
         <choice>
           <group>
             <optional>
-              <attribute name="form">
-                <a:documentation>Localized date formats are specified by setting `form`. The
-default date format can be changed for all locales by configuring
-the date-parts attribute and date-part elements.</a:documentation>
-                <choice>
-                  <value>text</value>
-                  <a:documentation>Use the localized text form of the date (e.g. "December 15, 2005" for en-US).</a:documentation>
-                  <value>numeric</value>
-                  <a:documentation>Use the localized numeric form of the date (e.g. "12-15-2005" for en-US)</a:documentation>
-                </choice>
-              </attribute>
-            </optional>
-            <optional>
-              <attribute name="date-parts">
-                <a:documentation>The date-parts attribute may be set to show fewer date elements.</a:documentation>
+              <attribute a:defaultValue="year-month-day">
+                <a:documentation>Limit the date parts rendered.</a:documentation>
+                <name ns="">date-parts</name>
                 <choice>
                   <value>year-month-day</value>
-                  <a:documentation>Year, month and day (default)</a:documentation>
+                  <a:documentation>Year, month and day</a:documentation>
                   <value>year-month</value>
                   <a:documentation>Year and month</a:documentation>
                   <value>year</value>
@@ -757,38 +1382,14 @@ the date-parts attribute and date-part e
                 </choice>
               </attribute>
             </optional>
+            <ref name="date.form"/>
             <zeroOrMore>
-              <element name="cs:date-part">
-                <a:documentation>For localized dates, date-part can be used to override layout
-options as defined in the locales (except for affixes, which
-are locale-specific), e.g. to force the use of leading-zeros,
-or the short month form. The inclusion of date-parts does not 
-affect which, and in what order, the date-parts are rendered.</a:documentation>
-                <ref name="text-case"/>
-                <ref name="font-formatting"/>
-                <choice>
-                  <ref name="month"/>
-                  <ref name="day"/>
-                  <ref name="year"/>
-                </choice>
-              </element>
+              <ref name="rendering-element.date.date-part.localized"/>
             </zeroOrMore>
           </group>
           <group>
             <oneOrMore>
-              <element name="cs:date-part">
-                <a:documentation>Non-localized dates are formatted by including, in the desired
-order, the relevant `date-part`-elements, and by applying formatting,
-affixes on cs:date and cs:date-part.</a:documentation>
-                <ref name="affixes"/>
-                <ref name="text-case"/>
-                <ref name="font-formatting"/>
-                <choice>
-                  <ref name="month"/>
-                  <ref name="day"/>
-                  <ref name="year"/>
-                </choice>
-              </element>
+              <ref name="rendering-element.date.date-part.non-localized"/>
             </oneOrMore>
             <ref name="delimiter"/>
           </group>
@@ -796,67 +1397,90 @@ affixes on cs:date and cs:date-part.</a:
         <ref name="affixes"/>
         <ref name="display"/>
         <ref name="font-formatting"/>
+        <ref name="text-case"/>
       </element>
     </define>
-    <define name="range-delimiter">
-      <a:documentation>The default delimiter for date ranges is the en-dash.
-If the range-delimiter attribute is set for the largest date-part ("day",
-"month" or "year") that differs between the two dates of the date range,
-its value is used instead.</a:documentation>
-      <optional>
-        <attribute name="range-delimiter"/>
-      </optional>
+    <define name="rendering-element.date.date-part.localized">
+      <element>
+        <a:documentation>Specify overriding formatting for localized dates (affixes
+cannot be overridden, as these are considered locale-specific).
+Example uses are forcing the use of leading-zeros, or of the
+"short" month form. Has no effect on which, and in what order,
+date parts are rendered.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">date-part</name>
+        <ref name="font-formatting"/>
+        <ref name="text-case"/>
+        <choice>
+          <ref name="day"/>
+          <ref name="month"/>
+          <ref name="year"/>
+        </choice>
+      </element>
     </define>
-    <define name="month">
-      <a:documentation>Month formats:
-    long (default): January
-    short: Jan
-    numeric: 1
-    numeric-leading-zeros: 01</a:documentation>
-      <attribute name="name">
-        <value>month</value>
+    <define name="rendering-element.date.date-part.non-localized">
+      <element>
+        <a:documentation>Specify, in the desired order, the date parts that should be
+rendered and their formatting.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">date-part</name>
+        <ref name="affixes"/>
+        <ref name="font-formatting"/>
+        <ref name="text-case"/>
+        <choice>
+          <ref name="day"/>
+          <ref name="month"/>
+          <ref name="year"/>
+        </choice>
+      </element>
+    </define>
+    <define name="day">
+      <attribute>
+        <name ns="">name</name>
+        <value>day</value>
       </attribute>
       <optional>
-        <attribute name="form">
+        <attribute a:defaultValue="numeric">
+          <a:documentation>Day forms: "numeric" ("5"), "numeric-leading-zeros" ("05"), "ordinal"
+("5th").</a:documentation>
+          <name ns="">form</name>
           <choice>
-            <value>long</value>
-            <value>short</value>
             <value>numeric</value>
             <value>numeric-leading-zeros</value>
+            <value>ordinal</value>
           </choice>
         </attribute>
       </optional>
       <ref name="range-delimiter"/>
-      <ref name="strip-periods"/>
     </define>
-    <define name="day">
-      <a:documentation>Day formats:
-    numeric (default): 5
-    numeric-leading-zeros: 05
-    ordinal: 5th</a:documentation>
-      <attribute name="name">
-        <value>day</value>
+    <define name="month">
+      <attribute>
+        <name ns="">name</name>
+        <value>month</value>
       </attribute>
       <optional>
-        <attribute name="form">
+        <attribute a:defaultValue="long">
+          <a:documentation>Months forms: "long" (e.g., "January"), "short" ("Jan."), "numeric"
+("1"), and "numeric-leading-zeros" ("01").</a:documentation>
+          <name ns="">form</name>
           <choice>
+            <value>long</value>
+            <value>short</value>
             <value>numeric</value>
             <value>numeric-leading-zeros</value>
-            <value>ordinal</value>
           </choice>
         </attribute>
       </optional>
       <ref name="range-delimiter"/>
+      <ref name="strip-periods"/>
     </define>
     <define name="year">
-      <a:documentation>Year formats:
-    long (default): 2005
-    short: 05</a:documentation>
-      <attribute name="name">
+      <attribute>
+        <name ns="">name</name>
         <value>year</value>
       </attribute>
       <optional>
-        <attribute name="form">
+        <attribute a:defaultValue="long">
+          <a:documentation>Year forms: "long" ("2005"), "short" ("05").</a:documentation>
+          <name ns="">form</name>
           <choice>
             <value>short</value>
             <value>long</value>
@@ -865,125 +1489,160 @@ its value is used instead.</a:documentat
       </optional>
       <ref name="range-delimiter"/>
     </define>
+    <define name="range-delimiter">
+      <optional>
+        <attribute a:defaultValue="–">
+          <a:documentation>Specify a delimiter for date ranges (by default the en-dash). A custom
+delimiter is retrieved from the largest date part ("day", "month" or
+"year") that differs between the two dates.</a:documentation>
+          <name ns="">range-delimiter</name>
+          <text/>
+        </attribute>
+      </optional>
+    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Formatting Text</xhtml:h2>
+      <xhtml:h2>cs:text Rendering Element</xhtml:h2>
     </a:documentation>
-    <define name="cs-text">
-      <a:documentation>The cs:text element is the main formatting element used to layout down content.</a:documentation>
-      <element name="cs:text">
+    <define name="rendering-element.text">
+      <element>
+        <a:documentation>Use to call macros, render variables, terms, or verbatim text.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">text</name>
+        <ref name="text.attributes"/>
         <ref name="affixes"/>
         <ref name="display"/>
         <ref name="font-formatting"/>
         <ref name="quotes"/>
         <ref name="strip-periods"/>
         <ref name="text-case"/>
-        <choice>
-          <attribute name="macro">
-            <a:documentation>render macro output</a:documentation>
-            <data type="NMTOKEN"/>
+      </element>
+    </define>
+    <define name="text.attributes">
+      <choice>
+        <attribute>
+          <a:documentation>Select a macro.</a:documentation>
+          <name ns="">macro</name>
+          <data type="NMTOKEN"/>
+        </attribute>
+        <group>
+          <attribute>
+            <a:documentation>Select a term.</a:documentation>
+            <name ns="">term</name>
+            <ref name="terms"/>
           </attribute>
-          <group>
-            <attribute name="term">
-              <a:documentation>render localized term</a:documentation>
-              <ref name="cs-terms"/>
+          <optional>
+            <attribute a:defaultValue="long">
+              <name ns="">form</name>
+              <ref name="term.form"/>
             </attribute>
-            <optional>
-              <attribute name="form">
-                <ref name="cs-term-forms"/>
-              </attribute>
-            </optional>
-            <optional>
-              <attribute name="plural">
-                <a:documentation>term plurality: single ("false", default) or multiple ("true")</a:documentation>
-                <data type="boolean"/>
-              </attribute>
-            </optional>
-          </group>
-          <attribute name="value">
-            <a:documentation>render verbatim text.</a:documentation>
+          </optional>
+          <optional>
+            <attribute a:defaultValue="false">
+              <a:documentation>Specify term plurality: singular ("false") or plural ("true").</a:documentation>
+              <name ns="">plural</name>
+              <data type="boolean"/>
+            </attribute>
+          </optional>
+        </group>
+        <attribute>
+          <a:documentation>Specify verbatim text.</a:documentation>
+          <name ns="">value</name>
+          <text/>
+        </attribute>
+        <group>
+          <attribute>
+            <a:documentation>Select a variable.</a:documentation>
+            <name ns="">variable</name>
+            <ref name="variables.standard"/>
           </attribute>
-          <group>
-            <attribute name="variable">
-              <a:documentation>render variable</a:documentation>
-              <ref name="cs-variables"/>
+          <optional>
+            <attribute a:defaultValue="long">
+              <name ns="">form</name>
+              <choice>
+                <value>short</value>
+                <value>long</value>
+              </choice>
             </attribute>
-            <optional>
-              <attribute name="form">
-                <choice>
-                  <value>short</value>
-                  <value>long</value>
-                </choice>
-              </attribute>
-            </optional>
-          </group>
-        </choice>
-      </element>
+          </optional>
+        </group>
+      </choice>
     </define>
-    <define name="cs-number">
-      <a:documentation>The number markup directive matches the first number found in a field, 
-and returns only that component. If no number is detected, the result 
-is empty. A non-empty number may be subject to further formatting consisting 
-of a form attribute whose value may be numeric, ordinal or roman to format 
-it as a simple number (the default), an ordinal number (1st, 2nd, 3rd etc), 
-a long-ordinal (first, second, third, etc), or roman (i, ii, iii, iv etc). 
-The text-case can also apply to capitalize the roman numbers for instance. 
-The other normal formatting rules apply too (font-style, ...). When used 
-in a conditional, number tests if there is a number present, allowing conditional 
-formatting.</a:documentation>
-      <element name="cs:number">
+  </div>
+  <div>
+    <a:documentation>
+      <xhtml:h2>cs:number Rendering Element</xhtml:h2>
+    </a:documentation>
+    <define name="rendering-element.number">
+      <element>
+        <a:documentation>Use to render a number variable.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">number</name>
+        <ref name="number.attributes"/>
         <ref name="affixes"/>
         <ref name="display"/>
         <ref name="font-formatting"/>
         <ref name="text-case"/>
-        <attribute name="variable">
-          <ref name="cs-numbers"/>
-        </attribute>
-        <optional>
-          <attribute name="form">
-            <choice>
-              <value>numeric</value>
-              <value>ordinal</value>
-              <value>roman</value>
-              <value>long-ordinal</value>
-            </choice>
-          </attribute>
-        </optional>
       </element>
     </define>
+    <define name="number.attributes">
+      <attribute>
+        <name ns="">variable</name>
+        <ref name="variables.numbers"/>
+      </attribute>
+      <optional>
+        <attribute a:defaultValue="numeric">
+          <a:documentation>Number forms: "numeric" ("4"), "ordinal" ("4th"), "long-ordinal"
+("fourth"), "roman" ("iv").</a:documentation>
+          <name ns="">form</name>
+          <choice>
+            <value>numeric</value>
+            <value>ordinal</value>
+            <value>long-ordinal</value>
+            <value>roman</value>
+          </choice>
+        </attribute>
+      </optional>
+    </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Label Text</xhtml:h2>
+      <xhtml:h2>cs:label Rendering Element</xhtml:h2>
     </a:documentation>
-    <define name="label">
-      <a:documentation>The label element is used to print text terms that depend on document content
-for pluralization. For labeling pages, this is preferable, as pages may be
-either singular or plural (p. or pp.)</a:documentation>
-      <element name="cs:label">
-        <ref name="label-primitives"/>
-        <attribute name="variable">
-          <choice>
-            <value>page</value>
-            <value>locator</value>
-          </choice>
-        </attribute>
+    <define name="rendering-element.label">
+      <element>
+        <a:documentation>Use to render a term whose pluralization depends on the content of a
+variable. E.g., if "page" variable holds a range, the plural label
+"pp." is selected instead of the singular "p.".</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">label</name>
+        <ref name="label.attributes"/>
+        <ref name="label.attributes-shared"/>
       </element>
     </define>
-    <define name="label-primitives">
-      <ref name="affixes"/>
-      <ref name="font-formatting"/>
-      <ref name="text-case"/>
-      <ref name="strip-periods"/>
+    <define name="label.attributes">
+      <attribute>
+        <name ns="">variable</name>
+        <choice>
+          <ref name="variables.numbers"/>
+          <value>locator</value>
+          <value>page</value>
+        </choice>
+      </attribute>
       <optional>
-        <attribute name="form">
-          <ref name="cs-term-forms"/>
+        <attribute a:defaultValue="long">
+          <name ns="">form</name>
+          <choice>
+            <value>long</value>
+            <value>short</value>
+            <value>symbol</value>
+          </choice>
         </attribute>
       </optional>
+    </define>
+    <define name="label.attributes-shared">
       <optional>
-        <attribute name="plural">
-          <a:documentation>modifies pluralization behavior (defaults to "contextual")</a:documentation>
+        <attribute a:defaultValue="contextual">
+          <a:documentation>Specify when the plural version of a term is selected.</a:documentation>
+          <name ns="">plural</name>
           <choice>
             <value>always</value>
             <value>never</value>
@@ -991,58 +1650,73 @@ either singular or plural (p. or pp.)</a
           </choice>
         </attribute>
       </optional>
+      <ref name="affixes"/>
+      <ref name="font-formatting"/>
+      <ref name="strip-periods"/>
+      <ref name="text-case"/>
     </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Groups</xhtml:h2>
+      <xhtml:h2>cs:group Rendering Element</xhtml:h2>
     </a:documentation>
-    <define name="group">
-      <a:documentation>cs:group and its child elements are suppressed if a) at least one
-rendering element in cs:group calls a variable (either directly or via a
-macro), and b) all variables that are called are empty.</a:documentation>
-      <element name="cs:group">
+    <define name="rendering-element.group">
+      <element>
+        <a:documentation>Use to group rendering elements. Groups are useful for setting a
+delimiter for the group children, for organizing the layout of
+bibliographic entries (using the "display" attribute), and for
+suppressing the rendering of terms and verbatim text when variables
+are empty.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">group</name>
+        <ref name="group.attributes"/>
         <ref name="affixes"/>
+        <ref name="delimiter"/>
         <ref name="display"/>
         <ref name="font-formatting"/>
-        <ref name="delimiter"/>
         <oneOrMore>
-          <ref name="cs-element"/>
+          <ref name="rendering-element"/>
         </oneOrMore>
       </element>
     </define>
+    <define name="group.attributes">
+      <optional>
+        <notAllowed/>
+      </optional>
+    </define>
   </div>
   <div>
     <a:documentation>
       <xhtml:h2>Options</xhtml:h2>
     </a:documentation>
-    <define name="style-options">
-      <ref name="demote-non-dropping-particle-opt"/>
-      <ref name="initialize-with-hyphen-opt"/>
-      <ref name="page-range-format-opt"/>
-      <ref name="name-opt"/>
-      <ref name="names-opt"/>
-    </define>
-    <define name="citation-options">
-      <ref name="collapse-opt"/>
-      <ref name="disambiguate-opt"/>
-      <ref name="note-distance-opt"/>
-      <ref name="name-opt"/>
-      <ref name="names-opt"/>
-    </define>
-    <define name="bibliography-options">
-      <ref name="hanging-indent-opt"/>
-      <ref name="line-formatting-opt"/>
-      <ref name="second-field-align-opt"/>
-      <ref name="subsequent-author-substitute-opt"/>
-      <ref name="name-opt"/>
-      <ref name="names-opt"/>
-    </define>
-    <define name="demote-non-dropping-particle-opt">
-      <a:documentation>Determines whether the non-dropping particle is demoted in inverted
-names (e.g. "Koning, W. de"). Defaults to "display-and-sort".</a:documentation>
-      <optional>
-        <attribute name="demote-non-dropping-particle">
+    <define name="style.options">
+      <ref name="style.demote-non-dropping-particle"/>
+      <ref name="style.initialize-with-hyphen"/>
+      <ref name="style.page-range-format"/>
+      <ref name="names-inheritable-options"/>
+      <ref name="name-inheritable-options"/>
+    </define>
+    <define name="citation.options">
+      <ref name="citation.cite-group-delimiter"/>
+      <ref name="citation.collapse-options"/>
+      <ref name="citation.disambiguate-options"/>
+      <ref name="citation.near-note-distance"/>
+      <ref name="names-inheritable-options"/>
+      <ref name="name-inheritable-options"/>
+    </define>
+    <define name="bibliography.options">
+      <ref name="bibliography.hanging-indent"/>
+      <ref name="bibliography.line-formatting-options"/>
+      <ref name="bibliography.second-field-align"/>
+      <ref name="bibliography.subsequent-author-substitute-options"/>
+      <ref name="names-inheritable-options"/>
+      <ref name="name-inheritable-options"/>
+    </define>
+    <define name="style.demote-non-dropping-particle">
+      <optional>
+        <attribute a:defaultValue="display-and-sort">
+          <a:documentation>Specify whether the non-dropping particle is demoted in inverted
+names (e.g., "Koning, W. de").</a:documentation>
+          <name ns="">demote-non-dropping-particle</name>
           <choice>
             <value>never</value>
             <value>sort-only</value>
@@ -1051,331 +1725,401 @@ names (e.g. "Koning, W. de"). Defaults t
         </attribute>
       </optional>
     </define>
-    <define name="initialize-with-hyphen-opt">
-      <a:documentation>Determines whether compound given names (e.g. "Jean-Luc") are
-initialized with (J-L) or without a hyphen (JL). Defaults to true.</a:documentation>
+    <define name="style.initialize-with-hyphen">
       <optional>
-        <attribute name="initialize-with-hyphen">
+        <attribute a:defaultValue="true">
+          <a:documentation>Specify whether compound given names (e.g., "Jean-Luc") are
+initialized with ("J-L") or without a hyphen ("JL").</a:documentation>
+          <name ns="">initialize-with-hyphen</name>
           <data type="boolean"/>
         </attribute>
       </optional>
     </define>
-    <define name="page-range-format-opt">
-      <a:documentation>Abbreviation setting of ranges in the page variable
-(by default no reformatting is applied to the input data).</a:documentation>
+    <define name="style.page-range-format">
       <optional>
-        <attribute name="page-range-format">
+        <attribute>
+          <a:documentation>Reformat page ranges in the "page" variable.</a:documentation>
+          <name ns="">page-range-format</name>
           <choice>
+            <value>chicago</value>
             <value>expanded</value>
             <value>minimal</value>
-            <value>chicago</value>
+            <value>minimal-two</value>
           </choice>
         </attribute>
       </optional>
     </define>
-    <define name="collapse-opt">
-      <a:documentation>The collapse options control citation collapsing.</a:documentation>
+    <define name="citation.cite-group-delimiter">
+      <optional>
+        <attribute a:defaultValue=", ">
+          <a:documentation>Activate cite grouping and specify the delimiter for cites within a
+cite group.</a:documentation>
+          <name ns="">cite-group-delimiter</name>
+          <text/>
+        </attribute>
+      </optional>
+    </define>
+    <define name="citation.collapse-options">
       <optional>
-        <attribute name="collapse">
+        <attribute>
+          <a:documentation>Activate cite grouping and specify the method of citation collapsing.</a:documentation>
+          <name ns="">collapse</name>
           <choice>
             <value>citation-number</value>
-            <a:documentation>collapses numeric citations from [1, 2, 3] to [1-3]</a:documentation>
+            <a:documentation>Collapse ranges of numeric cites, e.g. from "[1,2,3]" to "[1-3]".</a:documentation>
             <value>year</value>
-            <a:documentation>collapses cites from (Doe 2000, Doe 2001) to (Doe 2000, 2001)</a:documentation>
+            <a:documentation>Collapse cites by suppressing repeated names, e.g. from "(Doe
+2000, Doe 2001)" to "(Doe 2000, 2001)".</a:documentation>
             <value>year-suffix</value>
-            <a:documentation>collapses as "year", but also collapses (Doe 2000a, Doe 2000b)
-to (Doe 2000a, b). Collapses as "year" when
-disambiguate-add-year-suffix is not set to "true".</a:documentation>
+            <a:documentation>Collapse cites as with "year", but also suppresses repeated
+years, e.g. from "(Doe 2000a, Doe 2000b)" to "(Doe 2000a, b)".</a:documentation>
             <value>year-suffix-ranged</value>
-            <a:documentation>collapses as "year-suffix", but also collapses ranges of
-year-suffix markers, so (Doe 2000a, Doe 2000b, Doe 2000c)
-becomes (Doe 2000a-c). Collapses as "year" when
-disambiguate-add-year-suffix is not set to "true".</a:documentation>
+            <a:documentation>Collapses cites as with "year-suffix", but also collapses
+ranges of year-suffixes, e.g. from "(Doe 2000a, Doe 2000b,
+Doe 2000c)" to "(Doe 2000a-c)".</a:documentation>
           </choice>
         </attribute>
       </optional>
       <optional>
-        <attribute name="year-suffix-delimiter">
-          <a:documentation>Specifies the delimiter between year-suffix elements, when
-year-suffix collapsing takes place. If not set the delimiter defaults
-to that specified for the citation layout.</a:documentation>
+        <attribute>
+          <a:documentation>Specify the delimiter between year-suffixes. Defaults to the cite
+delimiter.</a:documentation>
+          <name ns="">year-suffix-delimiter</name>
+          <text/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="after-collapse-delimiter">
-          <a:documentation>Specifies the delimiter following a group of collapsed cites.</a:documentation>
+        <attribute>
+          <a:documentation>Specify the delimiter following a group of collapsed cites. Defaults
+to the cite delimiter.</a:documentation>
+          <name ns="">after-collapse-delimiter</name>
+          <text/>
         </attribute>
       </optional>
     </define>
-    <define name="disambiguate-opt">
+    <define name="citation.disambiguate-options">
       <optional>
-        <attribute name="disambiguate-add-names">
-          <a:documentation>When set true, add further names to uniquely identify the target
-source, overriding the constraint imposed by
-et-al-subsequent-use-first. The exact rendering of any names added is
-determined by applying, in order: the form ("long" or "short"); the
-initialize-with attribute, if present; and a given name
-disambiguation rule, if disambiguate-add-givenname is set true.</a:documentation>
+        <attribute a:defaultValue="false">
+          <a:documentation>Set to "true" to activate disambiguation by showing names that were
+originally hidden as a result of et-al abbreviation.</a:documentation>
+          <name ns="">disambiguate-add-names</name>
           <data type="boolean"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="disambiguate-add-givenname">
-          <a:documentation>When set true, transform names as required by by the rule specified
-by givenname-disambiguation-rule, or use the "all-names" rule by
-default. Note that, all of the given name disambiguation rules except
-for the "by-cite" rule, a name transformation will affect the way the
-name is rendered in multiple references.</a:documentation>
+        <attribute a:defaultValue="false">
+          <a:documentation>Set to "true" to activate disambiguation by expanding names, showing
+initials or full given names.</a:documentation>
+          <name ns="">disambiguate-add-givenname</name>
           <data type="boolean"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="disambiguate-add-year-suffix">
-          <a:documentation>Adds a year-suffix (e.g., 2007a) when there are two works by the same
-author published in the same year included in one bibliography.</a:documentation>
+        <attribute a:defaultValue="false">
+          <a:documentation>Set to "true" to activate disambiguation by adding year-suffixes
+(e.g., "(Doe 2007a, Doe 2007b)") for items from the same author(s)
+and year.</a:documentation>
+          <name ns="">disambiguate-add-year-suffix</name>
           <data type="boolean"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="givenname-disambiguation-rule">
+        <attribute a:defaultValue="by-cite">
+          <a:documentation>Specify how name are expanded for disambiguation.</a:documentation>
+          <name ns="">givenname-disambiguation-rule</name>
           <choice>
             <value>all-names</value>
-            <a:documentation>The default given name disambiguation rule.  A given
-name is first formatted as specified by the attributes
-to name (form, initialize-with).  If the resulting name
-does not uniquely identify the full name of the
-individual, it is progressively transformed in the following
-progression, until disambiguation succeeds:
-
-1. "short" becomes "long" + "initialize-with" if the latter is defined
-2. "long" + "initialize-with" becomes "long" if the former is defined
-3. "short" becomes "long"
-
-Note that if the name begins in long form with the
-given name as initials, step 1 in this list will be
-skipped.  Likewise, if the name begins in short form
-and the initialize-with attribute is not set, steps
-1 and 2 will be skipped.  If the name begins
-in long form, this option will have no effect.</a:documentation>
+            <a:documentation>Each ambiguous names is progressively transformed until
+disambiguated (when disambiguation is not possible, the name
+remains in its original form).</a:documentation>
             <value>all-names-with-initials</value>
-            <a:documentation>Same as the "all-names" rule above, but omitting
-steps 2 and 3 of that rule.</a:documentation>
+            <a:documentation>As "all-names", but name expansion is limited to showing
+initials.</a:documentation>
             <value>primary-name</value>
-            <a:documentation>Same as the "all-names" rule above, but ambiguity
-is only checked for the first-listed name
-source, and only first-listed names are affected
-by the transformation.</a:documentation>
+            <a:documentation>As "all-names", but disambiguation is limited to the first name
+of each cite.</a:documentation>
             <value>primary-name-with-initials</value>
-            <a:documentation>Same as the "primary-name" rule above, but omitting
-steps 2 and 3 of that rule.</a:documentation>
+            <a:documentation>As "all-names-with-initials", but disambiguation is limited to
+the first name of each cite.</a:documentation>
             <value>by-cite</value>
-            <a:documentation>Apply the transformation described under the "all-names"
-rule above, but limit the transformation to the current
-source.  The appearance of the name in other references
-will not be affected.</a:documentation>
+            <a:documentation>As "all-names", but only ambiguous names in ambiguous cites are
+expanded.</a:documentation>
           </choice>
         </attribute>
       </optional>
     </define>
-    <define name="note-distance-opt">
-      <a:documentation>The number of notes (footnotes or endnotes) within which a
-preceding reference to the same source must occur in order for
-position="near-note" to be true.  Defaults to 5.</a:documentation>
+    <define name="citation.near-note-distance">
       <optional>
-        <attribute name="near-note-distance">
+        <attribute a:defaultValue="5">
+          <a:documentation>Set the number of preceding notes (footnotes or endnotes) within
+which the current item needs to have been previously cited in order
+for the "near-note" position to be "true".</a:documentation>
+          <name ns="">near-note-distance</name>
           <data type="integer"/>
         </attribute>
       </optional>
     </define>
-    <define name="hanging-indent-opt">
-      <a:documentation>If "true", bibliographic entries are rendered with hanging-indents.</a:documentation>
+    <define name="bibliography.hanging-indent">
       <optional>
-        <attribute name="hanging-indent">
+        <attribute a:defaultValue="false">
+          <a:documentation>Set to "true" to render bibliographic entries with hanging indents.</a:documentation>
+          <name ns="">hanging-indent</name>
           <data type="boolean"/>
         </attribute>
       </optional>
     </define>
-    <define name="line-formatting-opt">
-      <a:documentation>Defines spacing between entries and between lines (measured in number
-of lines). Both attributes default to 1.</a:documentation>
+    <define name="bibliography.line-formatting-options">
       <optional>
-        <attribute name="entry-spacing">
-          <data type="integer"/>
+        <attribute a:defaultValue="1">
+          <a:documentation>Set the spacing between bibliographic entries.</a:documentation>
+          <name ns="">entry-spacing</name>
+          <data type="nonNegativeInteger"/>
         </attribute>
       </optional>
       <optional>
-        <attribute name="line-spacing">
-          <data type="integer"/>
+        <attribute a:defaultValue="1">
+          <a:documentation>Set the spacing between bibliographic lines.</a:documentation>
+          <name ns="">line-spacing</name>
+          <data type="integer">
+            <param name="minExclusive">0</param>
+          </data>
         </attribute>
       </optional>
     </define>
-    <define name="second-field-align-opt">
-      <a:documentation>Aligns any subsequent lines of a bibliography entry with the beginning
-of the second field. If set to "margin", the first field is put in the
-margin and all subsequent lines of text are aligned with the margin.</a:documentation>
+    <define name="bibliography.second-field-align">
       <optional>
-        <attribute name="second-field-align">
+        <attribute>
+          <a:documentation>Use to align any subsequent lines of bibliographic entries with the
+beginning of the second field.</a:documentation>
+          <name ns="">second-field-align</name>
           <choice>
             <value>flush</value>
+            <a:documentation>Align the first field with the margin.</a:documentation>
             <value>margin</value>
+            <a:documentation>Put the first field in the margin and align all subsequent
+lines of text with the margin.</a:documentation>
+          </choice>
+        </attribute>
+      </optional>
+    </define>
+    <define name="bibliography.subsequent-author-substitute-options">
+      <optional>
+        <attribute>
+          <a:documentation>Substitute names that repeat in subsequent bibliographic entries by
+the attribute value.</a:documentation>
+          <name ns="">subsequent-author-substitute</name>
+          <text/>
+        </attribute>
+      </optional>
+      <optional>
+        <attribute a:defaultValue="complete-all">
+          <a:documentation>Specify the method of substitution of names repeated in subsequent
+bibliographic entries.</a:documentation>
+          <name ns="">subsequent-author-substitute-rule</name>
+          <choice>
+            <value>complete-all</value>
+            <a:documentation>Requires a match of all rendered names in the name variable, and
+substitutes once for all names.</a:documentation>
+            <value>complete-each</value>
+            <a:documentation>Requires a match of all rendered names in the name variable,
+and substitutes for each name.</a:documentation>
+            <value>partial-each</value>
+            <a:documentation>Substitutes for each name, until the first mismatch.</a:documentation>
+            <value>partial-first</value>
+            <a:documentation>Substitutes the first name if it matches.</a:documentation>
           </choice>
         </attribute>
       </optional>
     </define>
-    <define name="subsequent-author-substitute-opt">
-      <a:documentation>Substitutes subsequent recurrences of an author for a given string.</a:documentation>
+    <define name="names-inheritable-options">
+      <a:documentation>Options affecting cs:names, for cs:style, cs:citation and cs:bibliography.</a:documentation>
+      <optional>
+        <attribute>
+          <a:documentation>Inheritable name option, companion for "delimiter" on cs:names.</a:documentation>
+          <name ns="">names-delimiter</name>
+          <text/>
+        </attribute>
+      </optional>
+    </define>
+    <define name="name-inheritable-options">
+      <a:documentation>Options affecting cs:name, for cs:style, cs:citation and cs:bibliography.</a:documentation>
+      <ref name="name.attributes"/>
+      <optional>
+        <attribute>
+          <a:documentation>Inheritable name option, companion for "delimiter" on cs:name.</a:documentation>
+          <name ns="">name-delimiter</name>
+          <text/>
+        </attribute>
+      </optional>
       <optional>
-        <attribute name="subsequent-author-substitute"/>
+        <attribute a:defaultValue="long">
+          <a:documentation>Inheritable name option, companion for "form" on cs:name.</a:documentation>
+          <name ns="">name-form</name>
+          <choice>
+            <value>long</value>
+            <value>short</value>
+            <value>count</value>
+          </choice>
+        </attribute>
       </optional>
     </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Sorting</xhtml:h2>
+      <xhtml:h2>cs:sort - Sorting</xhtml:h2>
     </a:documentation>
-    <define name="all-variables">
-      <choice>
-        <ref name="cs-variables"/>
-        <ref name="cs-dates"/>
-        <ref name="cs-names"/>
-      </choice>
-    </define>
     <define name="sort">
-      <a:documentation>Specifies the sort order within citations or the bibliography. By
-default, items are sorted in the order cited.</a:documentation>
-      <element name="cs:sort">
+      <element>
+        <a:documentation>Specify how cites and bibliographic entries should be sorted. By
+default, items appear in the order in which they were cited.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">sort</name>
         <oneOrMore>
-          <ref name="key"/>
+          <ref name="sort.key"/>
         </oneOrMore>
       </element>
     </define>
-    <define name="key">
-      <element name="cs:key">
+    <define name="sort.key">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">key</name>
         <choice>
-          <attribute name="variable">
-            <ref name="all-variables"/>
+          <attribute>
+            <name ns="">variable</name>
+            <ref name="variables"/>
           </attribute>
-          <attribute name="macro">
+          <attribute>
+            <name ns="">macro</name>
             <data type="NMTOKEN"/>
           </attribute>
         </choice>
         <optional>
-          <attribute name="sort">
-            <a:documentation>Default sort order is ascending</a:documentation>
+          <attribute>
+            <a:documentation>The minimum number of names needed in a name variable to activate
+name list truncation. Overrides the values set on any
+"et-al-(subsequent-)min" attributes.</a:documentation>
+            <name ns="">names-min</name>
+            <data type="integer"/>
+          </attribute>
+        </optional>
+        <optional>
+          <attribute>
+            <a:documentation>The number of names to render when name list truncation is
+activated. Overrides the values set on the
+"et-al-(subsequent-)use-first" attributes.</a:documentation>
+            <name ns="">names-use-first</name>
+            <data type="integer"/>
+          </attribute>
+        </optional>
+        <optional>
+          <attribute>
+            <a:documentation>Use to override the value of the "et-at-use-last" attribute.</a:documentation>
+            <name ns="">names-use-last</name>
+            <data type="boolean"/>
+          </attribute>
+        </optional>
+        <optional>
+          <attribute a:defaultValue="ascending">
+            <a:documentation>Select between an ascending and descending sort.</a:documentation>
+            <name ns="">sort</name>
             <choice>
               <value>ascending</value>
               <value>descending</value>
             </choice>
           </attribute>
         </optional>
-        <optional>
-          <group>
-            <a:documentation>names-min and names-use-first can be used to (further) constrain
-the number of names used in a name sort, overriding the values
-set on the et-al abbreviation attributes.</a:documentation>
-            <attribute name="names-min">
-              <data type="integer"/>
-            </attribute>
-            <attribute name="names-use-first">
-              <data type="integer"/>
-            </attribute>
-          </group>
-        </optional>
       </element>
     </define>
   </div>
   <div>
     <a:documentation>
-      <xhtml:h2>Conditional Statements</xhtml:h2>
+      <xhtml:h2>cs:choose - Conditional Statements</xhtml:h2>
     </a:documentation>
-    <define name="choose">
-      <a:documentation>The choose elements provides a simple conditional structure.</a:documentation>
-      <element name="cs:choose">
-        <ref name="if"/>
+    <define name="rendering-element.choose">
+      <element>
+        <a:documentation>Use to conditionally render rendering elements.</a:documentation>
+        <name ns="http://purl.org/net/xbiblio/csl">choose</name>
+        <ref name="choose.if"/>
         <zeroOrMore>
-          <ref name="else-if"/>
+          <ref name="choose.else-if"/>
         </zeroOrMore>
         <optional>
-          <ref name="else"/>
+          <ref name="choose.else"/>
         </optional>
       </element>
     </define>
-    <define name="if">
-      <element name="cs:if">
-        <ref name="condition"/>
+    <define name="choose.if">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">if</name>
+        <oneOrMore>
+          <ref name="condition"/>
+        </oneOrMore>
+        <ref name="match"/>
         <zeroOrMore>
-          <ref name="cs-element"/>
+          <ref name="rendering-element"/>
         </zeroOrMore>
       </element>
     </define>
-    <define name="else-if">
-      <element name="cs:else-if">
-        <ref name="condition"/>
+    <define name="choose.else-if">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">else-if</name>
+        <oneOrMore>
+          <ref name="condition"/>
+        </oneOrMore>
+        <ref name="match"/>
         <zeroOrMore>
-          <ref name="cs-element"/>
+          <ref name="rendering-element"/>
         </zeroOrMore>
       </element>
     </define>
-    <define name="else">
-      <element name="cs:else">
+    <define name="choose.else">
+      <element>
+        <name ns="http://purl.org/net/xbiblio/csl">else</name>
         <oneOrMore>
-          <ref name="cs-element"/>
+          <ref name="rendering-element"/>
         </oneOrMore>
       </element>
     </define>
     <define name="condition">
-      <optional>
-        <attribute name="disambiguate">
-          <a:documentation>The contents of an &lt;if disambiguate="true"&gt; block is only rendered if
-it disambiguates two otherwise identical citations. This attempt at
-disambiguation will only be made when all other disambiguation
-methods have failed to uniquely identify the target source.</a:documentation>
+      <choice>
+        <attribute a:defaultValue="true">
+          <a:documentation>If used, the element content is only rendered if it disambiguates two
+otherwise identical citations. This attempt at disambiguation is only
+made after all other disambiguation methods have failed.</a:documentation>
+          <name ns="">disambiguate</name>
           <value>true</value>
         </attribute>
-      </optional>
-      <optional>
-        <attribute name="is-numeric">
-          <a:documentation>Tests whether the given variables contain numeric data</a:documentation>
+        <attribute>
+          <a:documentation>Tests whether the given variables contain numeric text.</a:documentation>
+          <name ns="">is-numeric</name>
           <list>
             <oneOrMore>
-              <ref name="all-variables"/>
+              <ref name="variables"/>
             </oneOrMore>
           </list>
         </attribute>
-      </optional>
-      <optional>
-        <attribute name="is-uncertain-date">
-          <a:documentation>Tests whether the given date variables contain uncertain dates</a:documentation>
+        <attribute>
+          <a:documentation>Tests whether the given date variables contain approximate dates.</a:documentation>
+          <name ns="">is-uncertain-date</name>
           <list>
             <oneOrMore>
-              <ref name="cs-dates"/>
+              <ref name="variables.dates"/>
             </oneOrMore>
           </list>
         </attribute>
-      </optional>
-      <optional>
-        <attribute name="locator">
-          <a:documentation>Tests whether the locator matches the given locator variables</a:documentation>
+        <attribute>
+          <a:documentation>Tests whether the locator matches the given locator types.</a:documentation>
+          <name ns="">locator</name>
           <list>
             <oneOrMore>
-              <ref name="cs-terms.locator"/>
+              <choice>
+                <ref name="terms.locator.testable"/>
+                <value>sub-verbo</value>
+              </choice>
             </oneOrMore>
           </list>
         </attribute>
-      </optional>
-      <optional>
-        <attribute name="position">
-          <a:documentation>The boolean operators below indicate the relative position of a 
-reference within the document.  These should be checked in 
-the order shown below: "first" is true only once, on the first
-use of the reference; when "ibid-with-locator" is true, "ibid"
-and "subsequent are also true; and when "ibid" is true, "subsequent"
-is also true.  The "near-note" operator is true if and only if the
-reference has been used within five footnotes (or endnotes, as the 
-case may be), counting backward from the current note.  This threshold
-may be adjusted using the "near-note-distance" option.  The value of 
-"near-note" is *always* false for references that are not in a 
-footnote/endnote.</a:documentation>
+        <attribute>
+          <a:documentation>Tests whether the cite position matches the given positions.</a:documentation>
+          <name ns="">position</name>
           <list>
             <oneOrMore>
               <choice>
@@ -1388,40 +2132,42 @@ footnote/endnote.</a:documentation>
             </oneOrMore>
           </list>
         </attribute>
-      </optional>
-      <optional>
-        <attribute name="type">
-          <a:documentation>Tests whether the item matches the given types</a:documentation>
+        <attribute>
+          <a:documentation>Tests whether the item matches the given types.</a:documentation>
+          <name ns="">type</name>
           <list>
             <oneOrMore>
-              <ref name="cs-types"/>
+              <ref name="item-types"/>
             </oneOrMore>
           </list>
         </attribute>
-      </optional>
-      <optional>
-        <attribute name="variable">
-          <a:documentation>Tests whether the given variables contain non-empty values</a:documentation>
+        <attribute>
+          <a:documentation>Tests whether the default ("long") forms of the given variables
+contain non-empty values.</a:documentation>
+          <name ns="">variable</name>
           <list>
             <oneOrMore>
-              <ref name="all-variables"/>
+              <ref name="variables"/>
             </oneOrMore>
           </list>
         </attribute>
-      </optional>
+      </choice>
+    </define>
+    <define name="match">
       <optional>
-        <attribute name="match">
-          <a:documentation>Specifies the test criterion (default is all)
-    all: a condition tests "true" when it tests "true" for all of the
-         given condition values
-    any: a condition tests "true" when it tests "true" for any of the
-         given condition values
-   none: a condition tests "true" when it tests "true" for none of the
-         given condition values</a:documentation>
+        <attribute a:defaultValue="all">
+          <a:documentation>Set the testing logic.</a:documentation>
+          <name ns="">match</name>
           <choice>
             <value>all</value>
+            <a:documentation>Element only tests "true" when all conditions test "true" for all
+given test values.</a:documentation>
             <value>any</value>
+            <a:documentation>Element tests "true" when any condition tests "true" for any given
+test value.</a:documentation>
             <value>none</value>
+            <a:documentation>Element only tests "true" when none of the conditions test "true"
+for any given test value.</a:documentation>
           </choice>
         </attribute>
       </optional>
@@ -1431,49 +2177,53 @@ footnote/endnote.</a:documentation>
     <a:documentation>Formatting attributes.</a:documentation>
     <define name="affixes">
       <optional>
-        <attribute name="prefix"/>
+        <attribute a:defaultValue="">
+          <name ns="">prefix</name>
+          <text/>
+        </attribute>
       </optional>
       <optional>
-        <attribute name="suffix"/>
+        <attribute a:defaultValue="">
+          <name ns="">suffix</name>
+          <text/>
+        </attribute>
       </optional>
     </define>
     <define name="delimiter">
       <optional>
-        <attribute name="delimiter"/>
+        <attribute>
+          <name ns="">delimiter</name>
+          <text/>
+        </attribute>
       </optional>
     </define>
     <define name="display">
-      <a:documentation>The text of each individual cite is normally formatted as a
-single continuous run of text.  Portions of the cite text can be
-specially positioned using the display attribute.</a:documentation>
       <optional>
-        <attribute name="display">
+        <attribute>
+          <a:documentation>By default, bibliographic entries consist of continuous runs of text.
+With the "display" attribute, portions of each entry can be
+individually positioned.</a:documentation>
+          <name ns="">display</name>
           <choice>
             <value>block</value>
-            <a:documentation>Set the display value set to "block" to place the content
-in a block stretching from margin to margin.</a:documentation>
+            <a:documentation>Places the content in a block stretching from margin to margin.</a:documentation>
             <value>left-margin</value>
-            <a:documentation>Set the display value set to "left-margin" to place the
-content in a block of fixed width starting at the left 
-margin.  All "left-margin" blocks in a bibliography share
-the same width, set according to the maximum number of
-characters appearing in any one such block.</a:documentation>
+            <a:documentation>Places the content in a block starting at the left margin.</a:documentation>
             <value>right-inline</value>
-            <a:documentation>Set the display value to "right-inline" to place the
-content in a block directly to the right of any immediately
-preceding "left-margin" block, and extending to the
-right margin.</a:documentation>
+            <a:documentation>Places the content in a block to the right of a preceding
+"left-margin" block.</a:documentation>
             <value>indent</value>
-            <a:documentation>Set the display value to "indent" to block-indent the
-text to the right by a standard amount.</a:documentation>
+            <a:documentation>Places the content in a block indented to the right by a standard
+amount.</a:documentation>
           </choice>
         </attribute>
       </optional>
     </define>
     <define name="font-formatting">
-      <a:documentation>attributes are drawn directly from CSS and FO where possible</a:documentation>
+      <a:documentation>The font-formatting attributes are based on those of CSS and XSL-FO.</a:documentation>
       <optional>
-        <attribute name="font-style">
+        <attribute a:defaultValue="normal">
+          <name ns="">font-style</name>
           <choice>
             <value>italic</value>
             <value>normal</value>
@@ -1482,7 +2232,8 @@ text to the right by a standard amount.<
         </attribute>
       </optional>
       <optional>
-        <attribute name="font-variant">
+        <attribute a:defaultValue="normal">
+          <name ns="">font-variant</name>
           <choice>
             <value>normal</value>
             <value>small-caps</value>
@@ -1490,7 +2241,8 @@ text to the right by a standard amount.<
         </attribute>
       </optional>
       <optional>
-        <attribute name="font-weight">
+        <attribute a:defaultValue="normal">
+          <name ns="">font-weight</name>
           <choice>
             <value>normal</value>
             <value>bold</value>
@@ -1499,7 +2251,8 @@ text to the right by a standard amount.<
         </attribute>
       </optional>
       <optional>
-        <attribute name="text-decoration">
+        <attribute a:defaultValue="none">
+          <name ns="">text-decoration</name>
           <choice>
             <value>none</value>
             <value>underline</value>
@@ -1507,7 +2260,8 @@ text to the right by a standard amount.<
         </attribute>
       </optional>
       <optional>
-        <attribute name="vertical-align">
+        <attribute a:defaultValue="baseline">
+          <name ns="">vertical-align</name>
           <choice>
             <value>baseline</value>
             <value>sup</value>
@@ -1517,44 +2271,45 @@ text to the right by a standard amount.<
       </optional>
     </define>
     <define name="quotes">
-      <a:documentation>When set to true (false is the default), quotes (defined as terms) are
-placed around the rendered text. Nested quotes flipflop.</a:documentation>
       <optional>
-        <attribute name="quotes">
+        <attribute a:defaultValue="false">
+          <a:documentation>When set to "true", quotes are placed around the rendered text.</a:documentation>
+          <name ns="">quotes</name>
           <data type="boolean"/>
         </attribute>
       </optional>
     </define>
     <define name="strip-periods">
-      <a:documentation>Removes any periods from the rendered text (defaults to false)</a:documentation>
       <optional>
-        <attribute name="strip-periods">
+        <attribute a:defaultValue="false">
+          <a:documentation>When set to "true", periods are removed from the rendered text.</a:documentation>
+          <name ns="">strip-periods</name>
           <data type="boolean"/>
         </attribute>
       </optional>
     </define>
     <define name="text-case">
       <optional>
-        <attribute name="text-case">
+        <attribute>
+          <name ns="">text-case</name>
           <choice>
             <value>lowercase</value>
-            <a:documentation>display all text as lowercase</a:documentation>
+            <a:documentation>Renders text in lowercase.</a:documentation>
             <value>uppercase</value>
-            <a:documentation>display all text as uppercase</a:documentation>
+            <a:documentation>Renders text in uppercase.</a:documentation>
             <value>capitalize-first</value>
-            <a:documentation>capitalize first character; other characters
-displayed as is</a:documentation>
+            <a:documentation>Capitalizes the first character (other characters remain in
+their original case).</a:documentation>
             <value>capitalize-all</value>
-            <a:documentation>capitalize first character of every word;
-other characters displayed lowercase</a:documentation>
+            <a:documentation>Capitalizes the first character of every word (other characters
+remain in their original case).</a:documentation>
             <value>title</value>
-            <a:documentation>display as title case (the Chicago Manual
-of Style calls this "headline style")</a:documentation>
+            <a:documentation>Renders text in title case.</a:documentation>
             <value>sentence</value>
-            <a:documentation>display as sentence case/sentence style</a:documentation>
+            <a:documentation>Renders text in sentence case.</a:documentation>
           </choice>
         </attribute>
       </optional>
     </define>
   </div>
-</grammar>
+</grammar>
\ No newline at end of file
diff -pruN 0.3.0-6/citeproc/data/schema/csl-terms.rnc 0.5.1-1/citeproc/data/schema/csl-terms.rnc
--- 0.3.0-6/citeproc/data/schema/csl-terms.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-terms.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,138 @@
+
+## Terms
+div {
+  terms =
+    terms.gender-assignable
+    | terms.gender-variants
+    | terms.locator
+    | 
+      ## Contributor roles
+      variables.names
+    | "editortranslator"
+    | 
+      ## Miscellaneous terms
+      "accessed"
+    | "ad"
+    | "and"
+    | "and others"
+    | "anonymous"
+    | "at"
+    | "available at"
+    | "bc"
+    | "by"
+    | "circa"
+    | "cited"
+    | "et-al"
+    | "forthcoming"
+    | "from"
+    | "ibid"
+    | "in"
+    | "in press"
+    | "internet"
+    | "interview"
+    | "letter"
+    | "no date"
+    | "online"
+    | "presented at"
+    | "reference"
+    | "retrieved"
+    | "scale"
+    | "version"
+    | 
+      ## Punctuation
+      "open-quote"
+    | "close-quote"
+    | "open-inner-quote"
+    | "close-inner-quote"
+    | "page-range-delimiter"
+    | 
+      ## Seasons
+      "season-01"
+    | "season-02"
+    | "season-03"
+    | "season-04"
+    |
+      ## (legacy; remove in CSL 1.1)
+      category.field
+  
+  ## Terms to which a gender may be assigned
+  terms.gender-assignable =
+    
+    ## Months
+    "month-01"
+    | "month-02"
+    | "month-03"
+    | "month-04"
+    | "month-05"
+    | "month-06"
+    | "month-07"
+    | "month-08"
+    | "month-09"
+    | "month-10"
+    | "month-11"
+    | "month-12"
+    | terms.non-locator-number-variables
+    | terms.locator-number-variables
+  
+  ## Terms for which gender variants may be specified
+  terms.gender-variants =
+    terms.ordinals
+    | terms.long-ordinals
+  
+  terms.ordinals =
+    
+    ## Ordinals
+    xsd:string { pattern = "ordinal(-\d{2})?" }
+  
+  terms.long-ordinals =
+    
+    ## Long ordinals
+    "long-ordinal-01"
+    | "long-ordinal-02"
+    | "long-ordinal-03"
+    | "long-ordinal-04"
+    | "long-ordinal-05"
+    | "long-ordinal-06"
+    | "long-ordinal-07"
+    | "long-ordinal-08"
+    | "long-ordinal-09"
+    | "long-ordinal-10"
+  
+  ## Locators
+  terms.locator =
+    terms.locator.testable
+    | 
+      ## "sub verbo" is recognized as "sub" & "verbo" in attribute lists; term
+      ## should be renamed to "sub-verbo"
+      "sub verbo"
+    
+  ## Locator terms that can be tested with the "locator" conditional
+  ## ("sub verbo" can be tested with "sub-verbo")
+  terms.locator.testable =
+    "book"
+    | "chapter"
+    | "column"
+    | "figure"
+    | "folio"
+    | "line"
+    | "note"
+    | "opus"
+    | "page"
+    | "paragraph"
+    | "part"
+    | "section"
+    | "verse"
+    | terms.locator-number-variables
+  
+  ## Locator terms with matching number variables
+  terms.locator-number-variables = "issue" | "volume"
+  
+  ## Non-locator terms accompanying number variables
+  terms.non-locator-number-variables =
+    "chapter-number"
+    | "collection-number"
+    | "edition"
+    | "number"
+    | "number-of-pages"
+    | "number-of-volumes"
+}
diff -pruN 0.3.0-6/citeproc/data/schema/csl-terms.rng 0.5.1-1/citeproc/data/schema/csl-terms.rng
--- 0.3.0-6/citeproc/data/schema/csl-terms.rng	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-terms.rng	1970-01-01 00:00:00.000000000 +0000
@@ -1,107 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<grammar xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns="http://relaxng.org/ns/structure/1.0">
-  <div>
-    <a:documentation>Terms</a:documentation>
-    <define name="cs-terms">
-      <choice>
-        <value>accessed</value>
-        <a:documentation>Miscellaneous Terms</a:documentation>
-        <value>ad</value>
-        <value>and</value>
-        <value>and others</value>
-        <value>anonymous</value>
-        <value>at</value>
-        <value>bc</value>
-        <value>by</value>
-        <value>circa</value>
-        <value>cited</value>
-        <value>edition</value>
-        <value>et-al</value>
-        <value>forthcoming</value>
-        <value>from</value>
-        <value>ibid</value>
-        <value>in</value>
-        <value>in press</value>
-        <value>internet</value>
-        <value>interview</value>
-        <value>letter</value>
-        <value>no date</value>
-        <value>online</value>
-        <value>presented at</value>
-        <value>reference</value>
-        <value>retrieved</value>
-        <value>month-01</value>
-        <a:documentation>Months</a:documentation>
-        <value>month-02</value>
-        <value>month-03</value>
-        <value>month-04</value>
-        <value>month-05</value>
-        <value>month-06</value>
-        <value>month-07</value>
-        <value>month-08</value>
-        <value>month-09</value>
-        <value>month-10</value>
-        <value>month-11</value>
-        <value>month-12</value>
-        <value>season-01</value>
-        <a:documentation>Seasons</a:documentation>
-        <value>season-02</value>
-        <value>season-03</value>
-        <value>season-04</value>
-        <value>open-quote</value>
-        <a:documentation>Quotes</a:documentation>
-        <value>close-quote</value>
-        <value>open-inner-quote</value>
-        <value>close-inner-quote</value>
-        <value>ordinal-01</value>
-        <a:documentation>Ordinals</a:documentation>
-        <value>ordinal-02</value>
-        <value>ordinal-03</value>
-        <value>ordinal-04</value>
-        <value>long-ordinal-01</value>
-        <a:documentation>Long Ordinals</a:documentation>
-        <value>long-ordinal-02</value>
-        <value>long-ordinal-03</value>
-        <value>long-ordinal-04</value>
-        <value>long-ordinal-05</value>
-        <value>long-ordinal-06</value>
-        <value>long-ordinal-07</value>
-        <value>long-ordinal-08</value>
-        <value>long-ordinal-09</value>
-        <value>long-ordinal-10</value>
-        <ref name="cs-names">
-          <a:documentation>Contributor Roles</a:documentation>
-        </ref>
-        <value>editortranslator</value>
-        <ref name="info-field-categories">
-          <a:documentation>Categories</a:documentation>
-        </ref>
-        <ref name="cs-terms.locator">
-          <a:documentation>Locators</a:documentation>
-        </ref>
-        <ref name="cs-terms.extension"/>
-      </choice>
-    </define>
-    <define name="cs-terms.locator">
-      <a:documentation>Locators</a:documentation>
-      <choice>
-        <value>book</value>
-        <value>chapter</value>
-        <value>column</value>
-        <value>figure</value>
-        <value>folio</value>
-        <value>issue</value>
-        <value>line</value>
-        <value>note</value>
-        <value>opus</value>
-        <value>page</value>
-        <value>paragraph</value>
-        <value>part</value>
-        <value>section</value>
-        <value>sub verbo</value>
-        <value>verse</value>
-        <value>volume</value>
-      </choice>
-    </define>
-  </div>
-</grammar>
diff -pruN 0.3.0-6/citeproc/data/schema/csl-types.rnc 0.5.1-1/citeproc/data/schema/csl-types.rnc
--- 0.3.0-6/citeproc/data/schema/csl-types.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-types.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,40 @@
+
+## Item types
+div {
+  item-types =
+    "article"
+    | "article-journal"
+    | "article-magazine"
+    | "article-newspaper"
+    | "bill"
+    | "book"
+    | "broadcast"
+    | "chapter"
+    | "dataset"
+    | "entry"
+    | "entry-dictionary"
+    | "entry-encyclopedia"
+    | "figure"
+    | "graphic"
+    | "interview"
+    | "legal_case"
+    | "legislation"
+    | "manuscript"
+    | "map"
+    | "motion_picture"
+    | "musical_score"
+    | "pamphlet"
+    | "paper-conference"
+    | "patent"
+    | "personal_communication"
+    | "post"
+    | "post-weblog"
+    | "report"
+    | "review"
+    | "review-book"
+    | "song"
+    | "speech"
+    | "thesis"
+    | "treaty"
+    | "webpage"
+}
diff -pruN 0.3.0-6/citeproc/data/schema/csl-types.rng 0.5.1-1/citeproc/data/schema/csl-types.rng
--- 0.3.0-6/citeproc/data/schema/csl-types.rng	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-types.rng	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<grammar xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns="http://relaxng.org/ns/structure/1.0">
-  <div>
-    <a:documentation>CSL Types</a:documentation>
-    <define name="cs-types">
-      <choice>
-        <value>article</value>
-        <value>article-journal</value>
-        <value>article-magazine</value>
-        <value>article-newspaper</value>
-        <value>bill</value>
-        <value>book</value>
-        <value>broadcast</value>
-        <value>chapter</value>
-        <value>entry</value>
-        <value>entry-dictionary</value>
-        <value>entry-encyclopedia</value>
-        <value>figure</value>
-        <value>graphic</value>
-        <value>interview</value>
-        <value>legal_case</value>
-        <value>legislation</value>
-        <value>manuscript</value>
-        <value>map</value>
-        <value>motion_picture</value>
-        <value>musical_score</value>
-        <value>pamphlet</value>
-        <value>paper-conference</value>
-        <value>patent</value>
-        <value>personal_communication</value>
-        <value>post</value>
-        <value>post-weblog</value>
-        <value>report</value>
-        <value>review</value>
-        <value>review-book</value>
-        <value>song</value>
-        <value>speech</value>
-        <value>thesis</value>
-        <value>treaty</value>
-        <value>webpage</value>
-      </choice>
-    </define>
-  </div>
-</grammar>
diff -pruN 0.3.0-6/citeproc/data/schema/csl-variables.rnc 0.5.1-1/citeproc/data/schema/csl-variables.rnc
--- 0.3.0-6/citeproc/data/schema/csl-variables.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-variables.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,98 @@
+
+## Variables
+div {
+  
+  ## All variables
+  variables =
+    variables.dates
+    | variables.names
+    | variables.numbers
+    | variables.strings
+  
+  ## Standard variables
+  variables.standard = variables.numbers | variables.strings
+  
+  ## Date variables
+  variables.dates =
+    "accessed"
+    | "container"
+    | "event-date"
+    | "issued"
+    | "original-date"
+    | "submitted"
+  
+  ## Name variables
+  variables.names =
+    "author"
+    | "collection-editor"
+    | "composer"
+    | "container-author"
+    | "director"
+    | "editor"
+    | "editorial-director"
+    | "illustrator"
+    | "interviewer"
+    | "original-author"
+    | "recipient"
+    | "reviewed-author"
+    | "translator"
+  
+  ## Number variables
+  variables.numbers =
+    "chapter-number"
+    | "collection-number"
+    | "edition"
+    | "issue"
+    | "number"
+    | "number-of-pages"
+    | "number-of-volumes"
+    | "volume"
+  
+  ## String variables
+  variables.strings =
+    "abstract"
+    | "annote"
+    | "archive"
+    | "archive_location"
+    | "archive-place"
+    | "authority"
+    | "call-number"
+    | "citation-label"
+    | "citation-number"
+    | "collection-title"
+    | "container-title"
+    | "container-title-short"
+    | "dimensions"
+    | "DOI"
+    | "event"
+    | "event-place"
+    | "first-reference-note-number"
+    | "genre"
+    | "ISBN"
+    | "ISSN"
+    | "jurisdiction"
+    | "keyword"
+    | "locator"
+    | "medium"
+    | "note"
+    | "original-publisher"
+    | "original-publisher-place"
+    | "original-title"
+    | "page"
+    | "page-first"
+    | "PMID"
+    | "PMCID"
+    | "publisher"
+    | "publisher-place"
+    | "references"
+    | "reviewed-title"
+    | "scale"
+    | "section"
+    | "source"
+    | "status"
+    | "title"
+    | "title-short"
+    | "URL"
+    | "version"
+    | "year-suffix"
+}
diff -pruN 0.3.0-6/citeproc/data/schema/csl-variables.rng 0.5.1-1/citeproc/data/schema/csl-variables.rng
--- 0.3.0-6/citeproc/data/schema/csl-variables.rng	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/csl-variables.rng	1970-01-01 00:00:00.000000000 +0000
@@ -1,147 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<grammar xmlns:a="http://relaxng.org/ns/compatibility/annotations/1.0" xmlns="http://relaxng.org/ns/structure/1.0">
-  <div>
-    <a:documentation>Contributor Roles</a:documentation>
-    <define name="cs-names">
-      <choice>
-        <value>author</value>
-        <value>collection-editor</value>
-        <a:documentation>use for series editor</a:documentation>
-        <value>composer</value>
-        <value>container-author</value>
-        <a:documentation>use for book author when citing a book chapter</a:documentation>
-        <value>editor</value>
-        <value>editorial-director</value>
-        <value>interviewer</value>
-        <value>original-author</value>
-        <value>recipient</value>
-        <value>translator</value>
-      </choice>
-    </define>
-  </div>
-  <div>
-    <a:documentation>Dates</a:documentation>
-    <define name="cs-dates">
-      <choice>
-        <value>accessed</value>
-        <value>container</value>
-        <value>event-date</value>
-        <value>issued</value>
-        <value>original-date</value>
-        <value>submitted</value>
-      </choice>
-    </define>
-  </div>
-  <div>
-    <a:documentation>Numbers</a:documentation>
-    <define name="cs-numbers">
-      <choice>
-        <value>edition</value>
-        <value>issue</value>
-        <value>number</value>
-        <value>number-of-volumes</value>
-        <value>volume</value>
-      </choice>
-    </define>
-  </div>
-  <div>
-    <a:documentation>Simple Variables</a:documentation>
-    <define name="cs-variables">
-      <choice>
-        <value>abstract</value>
-        <a:documentation/>
-        <value>annote</value>
-        <a:documentation>notes made by a reader about the content of the resource</a:documentation>
-        <value>archive</value>
-        <a:documentation>the name of the archive</a:documentation>
-        <value>archive_location</value>
-        <a:documentation>the location within an archival collection (for example, box and folder)</a:documentation>
-        <value>archive-place</value>
-        <a:documentation>the place of the archive</a:documentation>
-        <value>authority</value>
-        <a:documentation>issuing authority (for patents) or judicial authority (such as court
-for legal cases)</a:documentation>
-        <value>call-number</value>
-        <a:documentation/>
-        <value>chapter-number</value>
-        <a:documentation/>
-        <value>citation-number</value>
-        <a:documentation>the number used for the in-text citation mark in numeric styles</a:documentation>
-        <value>citation-label</value>
-        <a:documentation>the label used for the in-text citation mark in label styles</a:documentation>
-        <value>collection-number</value>
-        <a:documentation>collection number; for example, series number</a:documentation>
-        <value>collection-title</value>
-        <a:documentation>the tertiary title for the cited item; for example, a series title</a:documentation>
-        <value>container-title</value>
-        <a:documentation>the secondary title for the cited item (book title for book chapters,
-journal title for articles, etc.).</a:documentation>
-        <value>DOI</value>
-        <a:documentation/>
-        <value>edition</value>
-        <a:documentation>an edition description</a:documentation>
-        <value>event</value>
-        <a:documentation>the name or title of a related event such as a conference or hearing</a:documentation>
-        <value>event-place</value>
-        <a:documentation>the location or place for the related event</a:documentation>
-        <value>first-reference-note-number</value>
-        <a:documentation>The number of a preceding note containing the first reference to this
-item. Relevant only for note-based styles, and null for first references.</a:documentation>
-        <value>genre</value>
-        <a:documentation/>
-        <value>ISBN</value>
-        <a:documentation/>
-        <value>issue</value>
-        <a:documentation>the issue number for the container publication</a:documentation>
-        <value>jurisdiction</value>
-        <a:documentation>For legislation and patents; scope of geographic relevance for a document.</a:documentation>
-        <value>keyword</value>
-        <a:documentation/>
-        <value>locator</value>
-        <a:documentation>a description to locate an item within some larger container or 
-collection; a volume or issue number is a kind of locator, for example.</a:documentation>
-        <value>medium</value>
-        <a:documentation>medium description (DVD, CD, etc.)</a:documentation>
-        <value>note</value>
-        <a:documentation>a short inline note, often used to refer to additional details of the resource</a:documentation>
-        <value>number</value>
-        <a:documentation>a document number; useful for reports and such</a:documentation>
-        <value>number-of-pages</value>
-        <a:documentation>refers to the number of pages in a book or other document</a:documentation>
-        <value>number-of-volumes</value>
-        <a:documentation>refers to the number of items in multi-volume books and such</a:documentation>
-        <value>original-publisher</value>
-        <a:documentation>the name of the original publisher</a:documentation>
-        <value>original-publisher-place</value>
-        <a:documentation>the place of the original publisher</a:documentation>
-        <value>original-title</value>
-        <a:documentation>title of a related original version; often useful in cases of translation</a:documentation>
-        <value>page</value>
-        <a:documentation>the range of pages an item covers in a containing item</a:documentation>
-        <value>page-first</value>
-        <a:documentation>the first page of an item within a containing item</a:documentation>
-        <value>publisher</value>
-        <a:documentation>the name of the publisher</a:documentation>
-        <value>publisher-place</value>
-        <a:documentation>the place of the publisher</a:documentation>
-        <value>references</value>
-        <a:documentation>for related referenced resources; used for legal case histories, but
-may be relevant for other contexts.</a:documentation>
-        <value>section</value>
-        <a:documentation>a section description (for newspapers, etc.)</a:documentation>
-        <value>status</value>
-        <a:documentation>the (typically publication) status of an item; for example "forthcoming"</a:documentation>
-        <value>title</value>
-        <a:documentation>the primary title for the cited item</a:documentation>
-        <value>URL</value>
-        <a:documentation/>
-        <value>version</value>
-        <a:documentation/>
-        <value>volume</value>
-        <a:documentation>volume number for the container periodical</a:documentation>
-        <value>year-suffix</value>
-        <a:documentation>The year suffix for author-date styles; e.g. the 'a' in '1999a'.</a:documentation>
-      </choice>
-    </define>
-  </div>
-</grammar>
diff -pruN 0.3.0-6/citeproc/data/schema/README.md 0.5.1-1/citeproc/data/schema/README.md
--- 0.3.0-6/citeproc/data/schema/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/README.md	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,20 @@
+https://github.com/citation-style-language/schema/ is the official repository
+for the Citation Style Language (CSL) schema.
+
+The CSL schema consists of the files:
+
+* csl.rnc
+* csl-categories.rnc
+* csl-terms.rnc
+* csl-types.rnc
+* csl-variables.rnc
+
+CSL styles and locale files can be validated against csl.rnc, which incorporates
+the contents of the other four files.
+
+In addition, the repository contains the files csl-data.json and
+csl-citation.json, which describe the metadata model used by citeproc-js for its
+input data and for embedded citation data in word processor documents,
+respectively. At this point these JSON schemas are not yet normative.
+
+For more information, see CitationStyles.org.
\ No newline at end of file
diff -pruN 0.3.0-6/citeproc/data/schema/test.rnc 0.5.1-1/citeproc/data/schema/test.rnc
--- 0.3.0-6/citeproc/data/schema/test.rnc	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/data/schema/test.rnc	2020-02-10 00:04:41.000000000 +0000
@@ -0,0 +1,25 @@
+
+namespace cs = "http://purl.org/net/xbiblio/csl"
+namespace dc = "http://purl.org/dc/elements/1.1/"
+namespace sch = "http://www.ascc.net/xml/schematron"
+namespace xhtml = "http://www.w3.org/1999/xhtml"
+
+dc:title [ "CSL Test Suite Schema" ]
+dc:creator [ "Bruce D'Arcus" ]
+dc:rights [ "Permission to freely use, copy and distribute." ]
+dc:description [
+    "Describes a simple format for CSL processor tests."
+]
+
+include "csl.rnc"{
+   # here I've redefined the style pattern to allow an optional 
+   # no-namespace style link (not sure if it should be namespaced)
+   style |= element style { attribute src { xsd:anyURI } }
+   start = element test { input & style & style-locale* & description? & tag* & output }
+ }
+
+input = element input { text }
+description = element description { text }
+tag = element tag { token }
+# right now plain text, but we can (should?) define an HTML output subset?
+output = element output { text }
diff -pruN 0.3.0-6/citeproc/__init__.py 0.5.1-1/citeproc/__init__.py
--- 0.3.0-6/citeproc/__init__.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/__init__.py	2020-04-06 16:16:08.000000000 +0000
@@ -4,9 +4,7 @@ from __future__ import (absolute_import,
 from citeproc.py2compat import *
 
 import os
-
-from glob import glob
-from warnings import warn
+import json
 
 from . import types, formatter
 
@@ -41,8 +39,10 @@ VARIABLES = (['abstract', 'annote', 'arc
               'title_short', 'URL', 'version', 'year_suffix'] +
              NAMES + DATES + NUMBERS)
 
-LOCALES = [os.path.basename(path)[8:-4]
-           for path in glob(os.path.join(LOCALES_PATH, 'locales-*.xml'))]
+with open(os.path.join(LOCALES_PATH, 'locales.json')) as file:
+    locales_json = json.load(file)
+    PRIMARY_DIALECTS = locales_json['primary-dialects']
+    LANGUAGE_NAMES = locales_json['language-names']
 
 
 from .frontend import CitationStylesStyle, CitationStylesBibliography
diff -pruN 0.3.0-6/citeproc/model.py 0.5.1-1/citeproc/model.py
--- 0.3.0-6/citeproc/model.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/model.py	2020-04-06 16:16:08.000000000 +0000
@@ -4,16 +4,17 @@ from citeproc.py2compat import *
 
 import re
 import unicodedata
-import sys
+import os
 
-from functools import reduce, cmp_to_key
+from functools import cmp_to_key
+from glob import glob
 from operator import itemgetter
 
 from lxml import etree
 
-from . import NAMES, DATES, NUMBERS
+from . import NAMES, DATES, NUMBERS, PRIMARY_DIALECTS, LANGUAGE_NAMES
 from .source import VariableError, DateRange, LiteralDate
-from .string import String
+from .string import String, join
 
 
 # Base class
@@ -125,55 +126,42 @@ class CitationStylesElement(SomewhatObje
 # Top level elements
 
 class Style(CitationStylesElement):
-    _locale_fallback = {'de-AT': 'de-DE',
-                        'de-CH': 'de-DE',
-                        'en-GB': 'en-US',
-                        'pt-BR': 'pt-PT',
-                        'zh-TW': 'zh-CN'}
-
     def set_locale_list(self, output_locale, validate=True):
         """Set up list of locales in which to search for localizable units"""
         from .frontend import CitationStylesLocale
 
-        def search_locale(locale):
-            return self.xpath_search('./cs:locale[@xml:lang="{}"]'
-                                     .format(locale))[0]
-
         self.locales = []
+        system_locales_added = set()
+
+        def add_instyle_locale(locale):
+            expr = ('./cs:locale[@xml:lang="{}"]'.format(locale)
+                    if locale else './cs:locale[not(@xml:lang)]')
+            results = self.xpath_search(expr)
+            if results:
+                locale_element, = results
+                self.locales.append(locale_element)
+
+        def add_system_locale(locale):
+            if locale not in system_locales_added:
+                csl_locale = CitationStylesLocale(locale, validate=validate)
+                self.locales.append(csl_locale.root)
+                system_locales_added.add(locale)
+
         # 1) (in-style locale) chosen dialect
-        try:
-            self.locales.append(search_locale(output_locale))
-        except IndexError:
-            pass
+        add_instyle_locale(output_locale)
         # 2) (in-style locale) matching language
         language = output_locale.split('-')[0]
-        try:
-            self.locales.append(search_locale(language))
-        except IndexError:
-            pass
+        add_instyle_locale(language)
         # 3) (in-style locale) no language set
-        try:
-            expr = './cs:locale[not(@xml:lang)]'
-            self.locales.append(self.xpath_search(expr)[0])
-        except IndexError:
-            pass
-        # 4) (locale files) chosen dialect
-        try:
-            self.locales.append(CitationStylesLocale(output_locale,
-                                                     validate=validate).root)
-        except ValueError:
-            pass
+        add_instyle_locale(None)
+        # 4) (locale files) chosen or primary dialect
+        if output_locale in LANGUAGE_NAMES:
+            add_system_locale(output_locale)
         # 5) (locale files) fall back to primary language dialect
-        try:
-            fallback_locale = self._locale_fallback[output_locale]
-            self.locales.append(CitationStylesLocale(fallback_locale,
-                                                     validate=validate).root)
-        except KeyError:
-            pass
+        if language in PRIMARY_DIALECTS:
+            add_system_locale(PRIMARY_DIALECTS[language])
         # 6) (locale files) default locale (en-US)
-        if output_locale != 'en-US':
-            self.locales.append(CitationStylesLocale('en-US',
-                                                     validate=validate).root)
+        add_system_locale('en-US')
         for locale in self.locales:
             locale.style = self
 
@@ -323,17 +311,18 @@ class Formatted(object):
 
 class Affixed(object):
     def wrap(self, string):
-        prefix = self.get('prefix', '')
-        suffix = self.get('suffix', '')
-        return prefix + string + suffix
+        if string is not None:
+            prefix = self.get('prefix', '')
+            suffix = self.get('suffix', '')
+            return prefix + string + suffix
+        return None
 
 
 class Delimited(object):
     def join(self, strings, default_delimiter=''):
         delimiter = self.get('delimiter', default_delimiter)
         try:
-            text = reduce(lambda a, b: a + delimiter + b,
-                          filter(lambda s: s is not None, strings))
+            text = join((s for s in strings if s is not None), delimiter)
         except:
             text = String('')
         return text
@@ -583,7 +572,7 @@ class Parent(object):
             except VariableError:
                 pass
         if output:
-            return reduce(lambda a, b: a + b, output)
+            return join(output)
         else:
             return None
 
@@ -642,8 +631,67 @@ class Layout(CitationStylesElement, Pare
         return output_items
 
 
-class Text(CitationStylesElement, Formatted, Affixed, Quoted, TextCased,
-           StrippedPeriods):
+class FormatNumber(object):
+    def _process(self, value, variable):
+        page_range_delimiter = (self.get_term('page-range-delimiter').single
+                                if variable.startswith('page') else None)
+        range_delimiter = (page_range_delimiter
+                           or self.unicode_character('EN DASH'))
+
+        en_dash = unicodedata.lookup('EN DASH')
+        def format_number_or_range(item):
+            try:
+                first, last = (number.strip() for number
+                               in item.replace(en_dash, '-').split('-'))
+            except ValueError:
+                return self.format_number(item.strip())
+            first = self.format_number(first)
+            if variable == 'page-first':
+                return first
+            last = self.format_number(self._format_last_page(first, last)
+                                      if variable == 'page' else last)
+            return join((first, last), range_delimiter)
+
+        amp_delimiter = ' ' + self.unicode_character('AMPERSAND') + ' '
+        return join((join((format_number_or_range(item)
+                           for item in comma_item.split('&')), amp_delimiter)
+                     for comma_item in value.split(',')), delimiter=', ')
+
+    def _format_last_page(self, first, last):
+        def find_common(first, last):
+            count = 0
+            for count, (f, l) in enumerate(zip(first, last)):
+                if f != l:
+                    return count
+            return count + 1
+
+        range_format = self.get_root().get_option('page-range-format')
+        common = find_common(first, last)
+        if range_format == 'chicago':
+            m = re.search('\d+', first)
+            first_number = int(m.group())
+            if first_number < 100 or first_number % 100 == 0:
+                range_format = 'expanded'
+            elif len(first) >= 4 and common < 2:
+                range_format = 'expanded'
+            elif first_number % 100 in range(1, 10):
+                range_format = 'minimal'
+            elif first_number % 100 in range(10, 100):
+                range_format = 'minimal-two'
+        if range_format in ('expanded', None):
+            index = 0
+        elif range_format == 'minimal':
+            index = common
+        elif range_format == 'minimal-two':
+            index = min(common, len(first) - 2)
+        return last[index:]
+
+    def format_number(self, number):
+        return str(number)
+
+
+class Text(CitationStylesElement, FormatNumber, Formatted, Affixed, Quoted,
+           TextCased, StrippedPeriods):
     generated_variables = ('year-suffix', 'citation-number')
 
     def calls_variable(self):
@@ -688,62 +736,18 @@ class Text(CitationStylesElement, Format
             if short_variable.replace('-', '_') in item.reference:
                 variable = short_variable
 
-        if variable == 'page':
-            text = self._page(item, context)
+        if variable.startswith('page'):
+            text = self._process(item.reference.page, variable)
         elif variable == 'citation-number':
             text = item.number
         elif variable == 'locator':
             en_dash = self.unicode_character('EN DASH')
             text = str(item.locator.identifier).replace('-', en_dash)
-        elif variable == 'page-first':
-            text = str(item.reference.page.first)
         else:
             text = item.reference[variable.replace('-', '_')]
 
         return text
 
-    def _page(self, item, context):
-        page = item.reference.page
-        str_first = str(page.first)
-        text = str_first
-        if 'last' in page:
-            str_last = str(page.last)
-            text += self.unicode_character('EN DASH')
-            if len(str_first) != len(str_last):
-                text += str_last
-            else:
-                range_fmt = self.get_root().get_option('page-range-format')
-                text += self._page_format_last(str_first, str_last, range_fmt)
-        return text
-
-    @staticmethod
-    def _page_format_last(first, last, range_format):
-        def find_common(first, last):
-            for count, (f, l) in enumerate(zip(first, last)):
-                if f != l:
-                    return count
-            return count + 1
-
-        common = find_common(first, last)
-        if range_format == 'chicago':
-            m = re.search('\d+', first)
-            first_number = int(m.group())
-            if first_number < 100 or first_number % 100 == 0:
-                range_format = 'expanded'
-            elif len(first) >= 4 and common < 2:
-                range_format = 'expanded'
-            elif first_number % 100 in range(1, 10):
-                range_format = 'minimal'
-            elif first_number % 100 in range(10, 100):
-                range_format = 'minimal-two'
-        if range_format in ('expanded', None):
-            index = 0
-        elif range_format == 'minimal':
-            index = common
-        elif range_format == 'minimal-two':
-            index = min(common, len(first) - 2)
-        return last[index:]
-
     def _term(self, item):
         form = self.get('form', 'long')
         plural = self.get('plural', 'false').lower() == 'true'
@@ -957,44 +961,31 @@ class Date_Part(CitationStylesElement, F
             return None
 
 
-class Number(CitationStylesElement, Formatted, Affixed, Displayed, TextCased,
-             StrippedPeriods):
-    re_numeric = re.compile(r'^(\d+).*')
-    re_range = re.compile(r'^(\d+)\s*-\s*(\d+)$')
-
+class Number(CitationStylesElement, FormatNumber, Formatted, Affixed, Displayed,
+             TextCased, StrippedPeriods):
     def calls_variable(self):
         return True
 
     def process(self, item, context=None, **kwargs):
-        form = self.get('form', 'numeric')
         variable = self.get('variable')
         if variable == 'locator':
             try:
-                variable = item.locator.identifier
+                variable = item.locator.label
+                value = item.locator.identifier
             except KeyError:
                 return None
         elif variable == 'page-first':
-            variable = item.reference.page.first
+            value = item.reference.page
         else:
-            variable = item.reference[variable]
+            value = item.reference[variable]
+        return self._process(value, variable)
 
+    def format_number(self, number):
+        form = self.get('form', 'numeric')
         try:
-            first, last = map(int, self.re_range.match(str(variable)).groups())
-            first = self.format_number(first, form)
-            last = self.format_number(last, form)
-            text = first + self.unicode_character('EN DASH') + last
-        except AttributeError:
-            try:
-                number = int(self.re_numeric.match(str(variable)).group(1))
-                text = self.format_number(number, form)
-            except AttributeError:
-                text = variable
-        except TypeError:
-            text = str(variable)
-
-        return text
-
-    def format_number(self, number, form):
+            number = int(number)
+        except ValueError:
+            return number
         if form == 'numeric':
             text = str(number)
         elif form == 'ordinal' or form == 'long-ordinal' and number > 10:
@@ -1003,7 +994,6 @@ class Number(CitationStylesElement, Form
             text = self.get_term('long-ordinal-{:02}'.format(number)).single
         elif form == 'roman':
             text = romanize(number).lower()
-
         return text
 
     def markup(self, text):
@@ -1186,7 +1176,7 @@ class Name(CitationStylesElement, Format
 
                 if form == 'long':
                     if (name_as_sort_order == 'all' or
-                        (name_as_sort_order == 'first' and i == 0)):
+                            (name_as_sort_order == 'first' and i == 0)):
                         if demote_ndp in ('never', 'sort-only'):
                             family = ' '.join([n for n in (ndp, family) if n])
                             given = ' '.join([n for n in (given, dp) if n])
@@ -1459,8 +1449,10 @@ class If(CitationStylesElement, Parent):
                 output.append(variable in item.reference)
         return output
 
+    re_numeric = re.compile(r'^([A-Z]*\d+[A-Z]*)$', re.I)
+
     def _is_numeric(self, item):
-        numeric_match = Number.re_numeric.match
+        numeric_match = self.re_numeric.match
         return [var.replace('-', '_') in item.reference and
                 numeric_match(str(item.reference[var.replace('-', '_')]))
                 for var in self.get('is-numeric').split()]
diff -pruN 0.3.0-6/citeproc/py2compat.py 0.5.1-1/citeproc/py2compat.py
--- 0.3.0-6/citeproc/py2compat.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/py2compat.py	2020-04-06 16:16:08.000000000 +0000
@@ -20,7 +20,7 @@ if PY2:
     def print(*objects, **kwargs):
         if kwargs.get('file', sys.stdout) == sys.stdout:
             objects = (unicode(obj) for obj in objects)
-            if not sys.stdout.encoding:
+            if not getattr(sys.stdout, 'encoding', None):
                 objects = (obj.encode(locale.getpreferredencoding())
                            for obj in objects)
         std_print(*objects, **kwargs)
diff -pruN 0.3.0-6/citeproc/source/bibtex/bibparse.py 0.5.1-1/citeproc/source/bibtex/bibparse.py
--- 0.3.0-6/citeproc/source/bibtex/bibparse.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/source/bibtex/bibparse.py	2020-04-06 16:16:08.000000000 +0000
@@ -12,6 +12,18 @@ class BibTeXEntry(dict):
         self.document_type = document_type
 
 
+class BibTeXDecodeError(Exception):
+    """Exception raised when the encoding passed to BibTeXParser cannot decode
+    the BibTeX database file."""
+    def __init__(self, decode_error, line_number):
+        msg = ("'{}' decode error on line {}: {}. Please specify the BibTeX's "
+               "database character encoding when instantiating BibTeXParser."
+               .format(decode_error.encoding, line_number, decode_error.reason))
+        super(BibTeXDecodeError, self).__init__(msg)
+        self.line_number = line_number
+        self.decode_error = decode_error
+
+
 class BibTeXParser(dict):
     standard_variables = {'jan': 'January',
                           'feb': 'February',
@@ -26,9 +38,9 @@ class BibTeXParser(dict):
                           'nov': 'November',
                           'dec': 'December'}
 
-    def __init__(self, file_or_filename):
+    def __init__(self, file_or_filename, encoding='ascii'):
         try:
-            self.file = open(file_or_filename, 'rt', encoding='ascii')
+            self.file = open(file_or_filename, 'rt', encoding=encoding)
         except TypeError:
             self.file = file_or_filename
         self.variables = {}
@@ -43,6 +55,15 @@ class BibTeXParser(dict):
                 if entry is not None:
                     entry_type, key, attributes = entry
                     self[key] = BibTeXEntry(entry_type, attributes)
+            except UnicodeDecodeError as decode_error:
+                # I'm not convinced the following is robust
+                safe_part = decode_error.object[:decode_error.start]
+                line_number = len(safe_part.splitlines())
+                offset = file.tell() - len(decode_error.object)
+                if offset > 0:
+                    file.seek(0)
+                    line_number += file.read(offset).count(file.newlines)
+                raise BibTeXDecodeError(decode_error, line_number)
             except EOFError:
                 break
 
@@ -99,6 +120,8 @@ class BibTeXParser(dict):
         while char != ',':
             key += char
             char = file.read(1)
+            if not char:
+                raise ValueError('End of file while parsing key')
         return key.strip().lower()
 
     def _parse_name(self, file):
@@ -134,6 +157,8 @@ class BibTeXParser(dict):
         depth = 0
         while True:
             char = file.read(1)
+            if not char:
+                raise ValueError('End of file while parsing string value')
             if char == '{':
                 depth += 1
             elif depth == 0 and char == closing_character:
diff -pruN 0.3.0-6/citeproc/source/bibtex/bibtex.py 0.5.1-1/citeproc/source/bibtex/bibtex.py
--- 0.3.0-6/citeproc/source/bibtex/bibtex.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/source/bibtex/bibtex.py	2020-04-06 16:16:08.000000000 +0000
@@ -11,18 +11,20 @@ from warnings import warn
 from ...types import (ARTICLE, ARTICLE_JOURNAL, BOOK, CHAPTER, MANUSCRIPT,
                       PAMPHLET, PAPER_CONFERENCE, REPORT, THESIS)
 from ...string import String, MixedString, NoCase
-from .. import BibliographySource, Reference, Name, Date, DateRange, Pages
+from .. import BibliographySource, Reference, Name, Date, DateRange
 from .bibparse import BibTeXParser
 from .latex import parse_latex
 from .latex.macro import NewCommand, Macro
 
 
 class BibTeX(BibliographySource):
-    fields = {'address': 'publisher_place',
+    fields = {'abstract': 'abstract',
+              'address': 'publisher_place',
               'annote': 'annote',
               'author': 'author',
               'booktitle': 'container_title',
               'chapter': 'chapter_number',
+              'doi': 'DOI',
               'edition': 'edition',
               'editor': 'editor',
 #              'howpublished': None,
@@ -33,6 +35,7 @@ class BibTeX(BibliographySource):
               'number': 'issue',
 #              'organization': None,
               'pages': 'page',
+              'pmid': 'PMID',
               'publisher': 'publisher',
 #              'school': None,
               'series': 'collection_title',
@@ -45,7 +48,8 @@ class BibTeX(BibliographySource):
               'isbn': 'ISBN',
               'issn': 'ISSN'}
 
-    types = {'article': ARTICLE_JOURNAL,
+    types = {# standard entry types
+             'article': ARTICLE_JOURNAL,
              'book': BOOK,
              'booklet': PAMPHLET,
              'conference': PAPER_CONFERENCE,
@@ -58,10 +62,15 @@ class BibTeX(BibliographySource):
              'phdthesis': THESIS,
              'proceedings': BOOK,
              'techreport': REPORT,
-             'unpublished': MANUSCRIPT}
+             'unpublished': MANUSCRIPT,
 
-    def __init__(self, filename):
-        bibtex_database = BibTeXParser(filename)
+             # non-standard entry types
+             'thesis': THESIS,
+             'report': REPORT,
+             }
+
+    def __init__(self, filename, encoding='ascii'):
+        bibtex_database = BibTeXParser(filename, encoding)
         self.preamble_macros = {}
         parse_latex(bibtex_database.preamble,
                     {'newcommand': NewCommand(self.preamble_macros),
@@ -74,6 +83,10 @@ class BibTeX(BibliographySource):
         csl_dict = {}
         for field, value in bibtex_entry.items():
             try:
+                value = value.strip()
+            except AttributeError:
+                pass
+            try:
                 csl_field = self.fields[field]
             except KeyError:
                 if field not in ('year', 'month', 'filename'):
@@ -85,11 +98,7 @@ class BibTeX(BibliographySource):
                 except ValueError:
                     pass
             elif field == 'pages':
-                if value.endswith('+'):
-                    value = Pages(first=int(value[:-1]))
-                else:
-                    first, last = value.replace(' ', '').split('--')
-                    value = Pages(first=int(first), last=int(last))
+                value = self._bibtex_to_csl_pages(value)
             elif field in ('author', 'editor'):
                 value = [name for name in self._parse_author(value)]
             else:
@@ -100,8 +109,20 @@ class BibTeX(BibliographySource):
             csl_dict[csl_field] = value
         return csl_dict
 
+    @staticmethod
+    def _bibtex_to_csl_pages(value):
+        value = value.replace(' ', '')
+        if '-' in value:
+            try:
+                first, last = value.split('--')
+            except ValueError:
+                first, last = value.split('-')
+            pages = '-'.join((first, last))
+        else:
+            pages = value[:-1] if value.endswith('+') else value
+        return pages
+
     def _bibtex_to_csl_date(self, bibtex_entry):
-        is_range = False
         if 'month' in bibtex_entry:
             begin_dict, end_dict = self._parse_month(bibtex_entry['month'])
         else:
@@ -130,25 +151,38 @@ class BibTeX(BibliographySource):
             begin_year = end_year = int(year_str)
         return begin_year, end_year
 
-    months = ('jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul', 'aug', 'sep',
-              'oct', 'nov', 'dec')
+    MONTHS = ('jan', 'feb', 'mar', 'apr', 'may', 'jun',
+              'jul', 'aug', 'sep', 'oct', 'nov', 'dec')
+    RE_DAY = '(?P<day>\d+)'
+    RE_MONTH = '(?P<month>\w+)'
+
+    @staticmethod
+    def _parse_month(month):
+        def month_name_to_index(name):
+            try:
+                return BibTeX.MONTHS.index(name[:3].lower()) + 1
+            except ValueError:
+                return int(name)
 
-    def _parse_month(self, month):
         begin = {}
         end = {}
         month = month.strip()
         month = month.replace(', ', '-')
-        if month.replace('-', '').isalpha():
+        if month.isdecimal():
+            begin['month'] = end['month'] = month
+        elif month.replace('-', '').isalpha():
             if '-' in month:
                 begin['month'], end['month'] = month.split('-')
             else:
                 begin['month'] = end['month'] = month
         else:
-            m = re.match('(?P<day>\d+)[ ~]*(?P<month>\w+)', month)
-            begin['day'] = end['day'] = m.group('day')
+            m = re.match(BibTeX.RE_DAY + '[ ~]*' + BibTeX.RE_MONTH, month)
+            if m is None:
+                m = re.match(BibTeX.RE_MONTH + '[ ~]*' + BibTeX.RE_DAY, month)
+            begin['day'] = end['day'] = int(m.group('day'))
             begin['month'] = end['month'] = m.group('month')
-        begin['month'] = self.months.index(begin['month'][:3].lower())
-        end['month'] = self.months.index(end['month'][:3].lower())
+        begin['month'] = month_name_to_index(begin['month'])
+        end['month'] = month_name_to_index(end['month'])
         return begin, end
 
     def _parse_string(self, title):
diff -pruN 0.3.0-6/citeproc/source/bibtex/latex/macro.py 0.5.1-1/citeproc/source/bibtex/latex/macro.py
--- 0.3.0-6/citeproc/source/bibtex/latex/macro.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/source/bibtex/latex/macro.py	2020-04-06 16:16:08.000000000 +0000
@@ -192,6 +192,7 @@ MACROS = {
     'textparagraph': SymbolByName('PILCROW SIGN'),
     'textperiodcentered': SymbolByName('MIDDLE DOT'),
     'textquestiondown': SymbolByName('INVERTED QUESTION MARK'),
+    'textquotesingle': Symbol("'"),  # from the textcomp package
     'textquotedbl': Symbol('"'),
     'textquotedblleft': SymbolByName('LEFT DOUBLE QUOTATION MARK'),
     'textquotedblright': SymbolByName('RIGHT DOUBLE QUOTATION MARK'),
diff -pruN 0.3.0-6/citeproc/source/__init__.py 0.5.1-1/citeproc/source/__init__.py
--- 0.3.0-6/citeproc/source/__init__.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/source/__init__.py	2020-04-06 16:16:08.000000000 +0000
@@ -64,9 +64,8 @@ class VariableError(Exception):
 
 class Name(CustomDict):
     def __init__(self, **args):
-        if 'name' in args:
-            required = {'name'}
-            optional = set()
+        if 'literal' in args:
+            required, optional = {'literal'}, set()
         else:
             required = {'family'}
             optional = {'given', 'dropping-particle', 'non-dropping-particle',
@@ -74,9 +73,12 @@ class Name(CustomDict):
         super(Name, self).__init__(args, required, optional)
 
     def parts(self):
-        return (self.get('given'), self.get('family'),
-                self.get('dropping-particle'),
-                self.get('non-dropping-particle'), self.get('suffix'))
+        if 'literal' in self:
+            return (None, self['literal'], None, None, None)
+        else:
+            return (self.get('given'), self.get('family'),
+                    self.get('dropping-particle'),
+                    self.get('non-dropping-particle'), self.get('suffix'))
 
 
 class DateBase(CustomDict):
@@ -134,18 +136,6 @@ class DateRange(DateBase):
         raise NotImplementedError
 
 
-class Pages(CustomDict):
-    def __init__(self, **args):
-        required = {'first'}
-        optional = {'last'}
-        for key, value in args.items():
-            try:
-                args[key] = int(value)
-            except ValueError:
-                pass
-        super(Pages, self).__init__(args, required, optional)
-
-
 class Citation(CustomDict):
     def __init__(self, cites, **kwargs):
         for cite in cites:
diff -pruN 0.3.0-6/citeproc/source/json.py 0.5.1-1/citeproc/source/json.py
--- 0.3.0-6/citeproc/source/json.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/source/json.py	2020-04-06 16:16:08.000000000 +0000
@@ -7,9 +7,9 @@ import sys
 import unicodedata
 
 from . import BibliographySource, Reference
-from . import Pages, Name, Date, DateRange, LiteralDate
+from . import Name, Date, DateRange, LiteralDate
 from ..string import String, MixedString, NoCase
-from .. import NAMES, DATES, NUMBERS
+from .. import NAMES, DATES
 
 
 class CiteProcJSON(BibliographySource):
@@ -30,9 +30,7 @@ class CiteProcJSON(BibliographySource):
                 if python_key == 'shortTitle':
                     python_key = 'title_short'
 
-                if python_key == 'page':
-                    value = self.parse_page(value)
-                elif python_key in NAMES:
+                if python_key in NAMES:
                     value = self.parse_names(value)
                 elif python_key in DATES:
                     value = self.parse_date(value)
@@ -67,16 +65,6 @@ class CiteProcJSON(BibliographySource):
                 output += String(regular)
         return output
 
-    def parse_page(self, json_data):
-        json_data = json_data.replace(unicodedata.lookup('EN DASH'), '-')
-        if '-' in json_data:
-            first, last = (number.strip() for number in json_data.split('-'))
-            if len(last) < len(first):
-                last = first[:- len(last)] + last
-            return Pages(first=first, last=last)
-        else:
-            return Pages(first=json_data)
-
     def parse_names(self, json_data):
         names = []
         for name_data in json_data:
diff -pruN 0.3.0-6/citeproc/string.py 0.5.1-1/citeproc/string.py
--- 0.3.0-6/citeproc/string.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/citeproc/string.py	2020-04-06 16:16:08.000000000 +0000
@@ -3,7 +3,7 @@ from __future__ import (absolute_import,
                         unicode_literals)
 from citeproc.py2compat import *
 
-from functools import wraps
+from functools import wraps, reduce
 
 
 def discard_empty_other(method):
@@ -134,3 +134,7 @@ class NoCase(String):
 
     def capitalize_first(self):
         return self
+
+
+def join(items, delimiter=''):
+    return reduce(lambda a, b: a + delimiter + b, items)
diff -pruN 0.3.0-6/citeproc/version.py 0.5.1-1/citeproc/version.py
--- 0.3.0-6/citeproc/version.py	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc/version.py	2020-04-06 16:40:51.000000000 +0000
@@ -0,0 +1,2 @@
+__version__ = '0.5.1'
+__release_date__ = 'Apr 06 2020, 12:40:51'
diff -pruN 0.3.0-6/citeproc_py.egg-info/dependency_links.txt 0.5.1-1/citeproc_py.egg-info/dependency_links.txt
--- 0.3.0-6/citeproc_py.egg-info/dependency_links.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc_py.egg-info/dependency_links.txt	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 0.3.0-6/citeproc_py.egg-info/PKG-INFO 0.5.1-1/citeproc_py.egg-info/PKG-INFO
--- 0.3.0-6/citeproc_py.egg-info/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc_py.egg-info/PKG-INFO	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1,216 @@
+Metadata-Version: 1.1
+Name: citeproc-py
+Version: 0.5.1
+Summary: Citations and bibliography formatter
+Home-page: https://github.com/brechtm/citeproc-py
+Author: Brecht Machiels
+Author-email: brecht@mos6581.org
+License: 2-clause BSD License
+Description: ===========
+        citeproc-py
+        ===========
+        
+        .. image:: http://img.shields.io/pypi/v/citeproc-py.svg
+           :target: https://pypi.python.org/pypi/citeproc-py
+           :alt: PyPI
+        
+        .. image:: https://travis-ci.org/brechtm/citeproc-py.svg
+           :target: https://travis-ci.org/brechtm/citeproc-py
+           :alt: Build status
+        
+        .. image:: https://coveralls.io/repos/brechtm/citeproc-py/badge.svg?branch=master&service=github
+           :target: https://coveralls.io/github/brechtm/citeproc-py?branch=master
+           :alt: Code coverage
+        
+        .. image:: https://www.quantifiedcode.com/api/v1/project/61fcd880bcd04d478d659f2a8a1034ae/badge.svg
+           :target: https://www.quantifiedcode.com/app/project/61fcd880bcd04d478d659f2a8a1034ae
+           :alt: Code issues
+        
+        citeproc-py is a `CSL`_ processor for Python. It aims to implement the
+        `CSL 1.0.1 specification`_. citeproc-py can output styled citations and
+        bibliographies in a number of different output formats. Currently
+        supported are plain text, reStructuredText and HTML. Other formats can
+        be added easily.
+        
+        citeproc-py uses `semantic versioning`_. Currently, its major version
+        number is still at 0, meaning the API is not yet stable. However, you
+        should not expect to see any major API changes soon.
+        
+        .. _CSL: http://citationstyles.org/
+        .. _CSL 1.0.1 specification: http://citationstyles.org/downloads/specification.html
+        .. _semantic versioning: http://semver.org/
+        
+        
+        Requirements
+        ------------
+        
+        citeproc-py was originally developed for Python 3 but now also runs on Python
+        2.6+. It depends on `lxml`_ for parsing and navigating the CSL style and locale
+        files.
+        
+        .. _lxml: http://lxml.de/
+        
+        
+        Installation
+        ------------
+        
+        The recommended way of installing citeproc-py is by using `pip`_::
+        
+           pip install citeproc-py
+        
+        If lxml isn't installed, pip will try to install it for you.
+        
+        .. _pip: https://pip.pypa.io/en/latest/
+        
+        If you insist, you can manually install citeproc-py from distribution packages
+        hosted at `PyPI`_. Please ignore the release archives offered by GitHub.
+        
+        .. _PyPI: https://pypi.python.org/pypi/citeproc-py/
+        
+        
+        Getting Started
+        ---------------
+        
+        To get started with citeproc-py, take a look at the examples under
+        ``examples/``. Two examples are provided, one parsing references from a
+        JSON representation of references as supported by citeproc-js, another
+        parsing the references from a BibTeX file. Both show and explain how to
+        cite references and render the bibliography.
+        
+        
+        CSL Compatibility
+        -----------------
+        
+        Currently, citeproc-py passes almost 60% of the (relevant) tests in the
+        `citeproc-test suite`_. However, it is more than 60% complete, as
+        citeproc-py doesn't take care of double spaces and repeated punctuation
+        marks yet, making a good deal of the tests fail. In addition, the
+        following features have not yet been implemented (there are probably
+        some I forgot though):
+        
+        -  disambiguation/year-suffix
+        -  et-al-subsequent-min/et-al-subsequent-use-first
+        -  collapsing
+        -  punctuation-in-quote
+        -  display
+        
+        Also, some `citeproc-js`_ functionality that is not part of the CSL spec
+        is not (yet) supported:
+        
+        -  raw dates
+        -  static-ordering
+        -  literal names
+        
+        .. _citeproc-test suite: https://bitbucket.org/bdarcus/citeproc-test
+        .. _citeproc-js: http://bitbucket.org/fbennett/citeproc-js/wiki/Home
+        
+        
+        Running the Tests
+        -----------------
+        
+        First clone the `citeproc-test suite`_ so that it sits next to the
+        citeproc-py directory. Now you can run ``citeproc-test.py`` (in the ``tests``
+        directory). Run ``citeproc-test.py --help`` to see its usage information.
+        
+        .. _citeproc-test suite: https://bitbucket.org/bdarcus/citeproc-test
+        
+        
+        Changelog
+        ---------
+        
+        Release 0.5.1 (2020-03-06)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        Bug fixed:
+        
+        * avoid rnc2rng 2.6.2 which breaks installation of citeproc-py
+        
+        Release 0.5.0 (2020-02-09)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        Enhancements:
+        
+        * handle commas and ampersands in a functional style
+        * Number: handle commas and ampersands
+        * added symbol for textquotesingle
+        * specify fallback locales for fr-CA and es-CL
+        * improved page number and ranges parsing
+        
+        Bug fixed:
+        
+        * don't fail on empty page ranges (#90) (bbm)
+        * detect end of file while parsing incorrect bib (#59) (John Vandenberg)
+        
+        Other changes:
+        
+        * Removed 3.2-3.4 and added 3.7, 3.8 to supported Pythons
+        * Refactored locales handling
+        
+        Release 0.4.0 (2017-06-23)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        New features:
+        
+        * allow specifying the encoding of a BibTeX database file (#20 and #25)
+        * BibTeX 'month' field: support integers and "<month> <day>" values
+        * BibTeX 'pages' field: support "10", "10+", "10-12" and "10--12" formats
+        * BibTeX entry types: map the non-standard 'thesis' and 'report' entries
+        * update the CSL schema to version 1.0.1 (#5)
+        * update the CSL locales to commit 49bf3fc0
+        
+        Bug fixed:
+        
+        * avoid crash when there is nothing to affix (David Lesieur)
+        * fix BibTeX month to CSL month mapping (#24)
+        * strip leading/trailing whitespace from BibTeX values (#37)
+        
+        Release 0.3.0 (2014-11-07)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        Major improvements to the BibTeX parser:
+        
+        * split names into parts and assign them to the equivalent CSL name parts
+        * fixed handling of accent macros and escaped characters
+        * more compatible (La)TeX macro handling in general (but still basic)
+        * handle standard Computer Modern ligatures such as --, ---, and <<
+        * added unit tests for the BibTeX and LaTeX parsers
+        
+        Other changes:
+        
+        * disable RelaxNG validation of CSL styles by default (API change)
+        
+        Release 0.2.0 (2014-10-25)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        * bad cite callback function can determine how a bad cite is displayed (hetsch)
+        * added option to disable RelaxNG validation (Jasper Op de Coul)
+        * distutils was replaced with setuptools (Joshua Carp)
+        * bug fixes (Yaroslav Halchenko, David Lesieur)
+        * CitationStylesBibliography.bibliography() now returns the list of entries
+        
+Keywords: csl citation html rst bibtex xml
+Platform: UNKNOWN
+Classifier: Development Status :: 3 - Alpha
+Classifier: Environment :: Console
+Classifier: Environment :: Other Environment
+Classifier: Environment :: Web Environment
+Classifier: Intended Audience :: Developers
+Classifier: Intended Audience :: Education
+Classifier: Intended Audience :: End Users/Desktop
+Classifier: Intended Audience :: Legal Industry
+Classifier: Intended Audience :: Other Audience
+Classifier: Intended Audience :: Science/Research
+Classifier: License :: OSI Approved :: BSD License
+Classifier: Operating System :: OS Independent
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 2.7
+Classifier: Programming Language :: Python :: 3.4
+Classifier: Programming Language :: Python :: 3.5
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Classifier: Programming Language :: Python :: 3.8
+Classifier: Topic :: Documentation
+Classifier: Topic :: Printing
+Classifier: Topic :: Software Development :: Documentation
+Classifier: Topic :: Software Development :: Libraries :: Python Modules
+Provides: citeproc
diff -pruN 0.3.0-6/citeproc_py.egg-info/requires.txt 0.5.1-1/citeproc_py.egg-info/requires.txt
--- 0.3.0-6/citeproc_py.egg-info/requires.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc_py.egg-info/requires.txt	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1 @@
+lxml
diff -pruN 0.3.0-6/citeproc_py.egg-info/SOURCES.txt 0.5.1-1/citeproc_py.egg-info/SOURCES.txt
--- 0.3.0-6/citeproc_py.egg-info/SOURCES.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc_py.egg-info/SOURCES.txt	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1,109 @@
+.gitignore
+.gitmodules
+.travis.yml
+CHANGES.rst
+LICENSE
+MANIFEST.in
+README.rst
+coveralls.py
+setup.cfg
+setup.py
+tox.ini
+bin/csl_unsorted
+citeproc/__init__.py
+citeproc/frontend.py
+citeproc/model.py
+citeproc/py2compat.py
+citeproc/string.py
+citeproc/types.py
+citeproc/version.py
+citeproc/data/locales/locales-af-ZA.xml
+citeproc/data/locales/locales-ar.xml
+citeproc/data/locales/locales-bg-BG.xml
+citeproc/data/locales/locales-ca-AD.xml
+citeproc/data/locales/locales-cs-CZ.xml
+citeproc/data/locales/locales-cy-GB.xml
+citeproc/data/locales/locales-da-DK.xml
+citeproc/data/locales/locales-de-AT.xml
+citeproc/data/locales/locales-de-CH.xml
+citeproc/data/locales/locales-de-DE.xml
+citeproc/data/locales/locales-el-GR.xml
+citeproc/data/locales/locales-en-GB.xml
+citeproc/data/locales/locales-en-US.xml
+citeproc/data/locales/locales-es-CL.xml
+citeproc/data/locales/locales-es-ES.xml
+citeproc/data/locales/locales-es-MX.xml
+citeproc/data/locales/locales-et-EE.xml
+citeproc/data/locales/locales-eu.xml
+citeproc/data/locales/locales-fa-IR.xml
+citeproc/data/locales/locales-fi-FI.xml
+citeproc/data/locales/locales-fr-CA.xml
+citeproc/data/locales/locales-fr-FR.xml
+citeproc/data/locales/locales-he-IL.xml
+citeproc/data/locales/locales-hr-HR.xml
+citeproc/data/locales/locales-hu-HU.xml
+citeproc/data/locales/locales-id-ID.xml
+citeproc/data/locales/locales-is-IS.xml
+citeproc/data/locales/locales-it-IT.xml
+citeproc/data/locales/locales-ja-JP.xml
+citeproc/data/locales/locales-km-KH.xml
+citeproc/data/locales/locales-ko-KR.xml
+citeproc/data/locales/locales-lt-LT.xml
+citeproc/data/locales/locales-lv-LV.xml
+citeproc/data/locales/locales-mn-MN.xml
+citeproc/data/locales/locales-nb-NO.xml
+citeproc/data/locales/locales-nl-NL.xml
+citeproc/data/locales/locales-nn-NO.xml
+citeproc/data/locales/locales-pl-PL.xml
+citeproc/data/locales/locales-pt-BR.xml
+citeproc/data/locales/locales-pt-PT.xml
+citeproc/data/locales/locales-ro-RO.xml
+citeproc/data/locales/locales-ru-RU.xml
+citeproc/data/locales/locales-sk-SK.xml
+citeproc/data/locales/locales-sl-SI.xml
+citeproc/data/locales/locales-sr-RS.xml
+citeproc/data/locales/locales-sv-SE.xml
+citeproc/data/locales/locales-th-TH.xml
+citeproc/data/locales/locales-tr-TR.xml
+citeproc/data/locales/locales-uk-UA.xml
+citeproc/data/locales/locales-vi-VN.xml
+citeproc/data/locales/locales-zh-CN.xml
+citeproc/data/locales/locales-zh-TW.xml
+citeproc/data/locales/locales.json
+citeproc/data/schema/README.md
+citeproc/data/schema/csl-categories.rnc
+citeproc/data/schema/csl-data.rnc
+citeproc/data/schema/csl-relaxed.rnc
+citeproc/data/schema/csl-terms.rnc
+citeproc/data/schema/csl-types.rnc
+citeproc/data/schema/csl-variables.rnc
+citeproc/data/schema/csl.rnc
+citeproc/data/schema/csl.rng
+citeproc/data/schema/test.rnc
+citeproc/data/styles/harvard1.csl
+citeproc/formatter/__init__.py
+citeproc/formatter/html.py
+citeproc/formatter/plain.py
+citeproc/formatter/rst.py
+citeproc/source/__init__.py
+citeproc/source/json.py
+citeproc/source/bibtex/__init__.py
+citeproc/source/bibtex/bibparse.py
+citeproc/source/bibtex/bibtex.py
+citeproc/source/bibtex/latex/__init__.py
+citeproc/source/bibtex/latex/macro.py
+citeproc_py.egg-info/PKG-INFO
+citeproc_py.egg-info/SOURCES.txt
+citeproc_py.egg-info/dependency_links.txt
+citeproc_py.egg-info/requires.txt
+citeproc_py.egg-info/top_level.txt
+examples/bibtex.py
+examples/citeproc_json.py
+examples/xampl.bib
+tests/check_string.py
+tests/citeproc-test.py
+tests/failing_tests.txt
+tests/test.bib
+tests/test_bibparse.py
+tests/test_bibtex.py
+tests/test_latex.py
\ No newline at end of file
diff -pruN 0.3.0-6/citeproc_py.egg-info/top_level.txt 0.5.1-1/citeproc_py.egg-info/top_level.txt
--- 0.3.0-6/citeproc_py.egg-info/top_level.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/citeproc_py.egg-info/top_level.txt	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1 @@
+citeproc
diff -pruN 0.3.0-6/coveralls.py 0.5.1-1/coveralls.py
--- 0.3.0-6/coveralls.py	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/coveralls.py	2020-04-06 16:16:08.000000000 +0000
@@ -0,0 +1,24 @@
+#!/bin/env/python
+
+import os
+
+from contextlib import suppress
+from distutils.sysconfig import get_python_lib
+from subprocess import call
+
+
+if __name__ == '__main__':
+    # chdir to the site-packages directory so the report lists relative paths
+    dot_coverage_path = os.path.join(os.getcwd(), '.coverage')
+    os.chdir(get_python_lib())
+    with suppress(OSError):
+        os.remove('.coverage')
+    os.symlink(dot_coverage_path, '.coverage')
+
+    # create a report from the coverage data
+    if 'TRAVIS' in os.environ:
+        rc = call('coveralls')
+        raise SystemExit(rc)
+    else:
+        rc = call(['coverage', 'report'])
+        raise SystemExit(rc)
diff -pruN 0.3.0-6/debian/changelog 0.5.1-1/debian/changelog
--- 0.3.0-6/debian/changelog	2020-02-10 02:24:19.000000000 +0000
+++ 0.5.1-1/debian/changelog	2020-09-25 21:21:50.000000000 +0000
@@ -1,6 +1,27 @@
+citeproc-py (0.5.1-1) unstable; urgency=medium
+
+  [ Yaroslav Halchenko ]
+  * Team upload:
+    - debian/control: added myself
+  * Fresh upstream release (Closes #923560)
+    - resolves some outstandaing Python3 incompatibility issues
+  * debian/patches - refreshed to account for upstream changes and
+    a new version
+  * debian/control
+    - now uses rnc2rng at build time, packaged as python3-rnc2rng
+      (ITP #865666), added to Build-Depends
+
+  [ Ondřej Nový ]
+  * d/control: Update Maintainer field with new Debian Python Team
+    contact address.
+  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
+    layout.
+
+ -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 25 Sep 2020 17:21:50 -0400
+
 citeproc-py (0.3.0-6) unstable; urgency=medium
 
-  * d/control: set DPMT as maintainer (Closes ##863355).
+  * d/control: set DPMT as maintainer (Closes #863355).
     - Set me as uploaders.
   * d/control: Bump standard-version to 4.5.0.
   * d/copyright: add me debian/* files.
diff -pruN 0.3.0-6/debian/control 0.5.1-1/debian/control
--- 0.3.0-6/debian/control	2020-02-10 02:24:19.000000000 +0000
+++ 0.5.1-1/debian/control	2020-09-25 21:21:50.000000000 +0000
@@ -1,8 +1,8 @@
 Source: citeproc-py
 Section: python
 Priority: optional
-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Uploaders: Emmanuel Arias <eamanu@yaerobi.com>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Uploaders: Emmanuel Arias <eamanu@yaerobi.com>, Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends:
  debhelper-compat (= 12),
  dh-python,
@@ -10,11 +10,12 @@ Build-Depends:
  python3-lxml,
  python3-setuptools,
  python3-pytest,
+ python3-rnc2rng (>= 2.6.3~),
  txt2man
 Standards-Version: 4.5.0
 Homepage: https://github.com/brechtm/citeproc-py
-Vcs-Git: https://salsa.debian.org/python-team/modules/citeproc-py.git
-Vcs-Browser: https://salsa.debian.org/python-team/modules/citeproc-py
+Vcs-Git: https://salsa.debian.org/python-team/packages/citeproc-py.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/citeproc-py
 
 Package: python3-citeproc
 Architecture: all
diff -pruN 0.3.0-6/debian/patches/0001-no-version-from-git.patch 0.5.1-1/debian/patches/0001-no-version-from-git.patch
--- 0.3.0-6/debian/patches/0001-no-version-from-git.patch	2020-02-10 02:24:19.000000000 +0000
+++ 0.5.1-1/debian/patches/0001-no-version-from-git.patch	2020-09-25 21:21:50.000000000 +0000
@@ -8,15 +8,13 @@ Subject: no-version-from-git
  setup.py | 1 +
  1 file changed, 1 insertion(+)
 
-diff --git a/setup.py b/setup.py
-index 99e2b13..ecdf9a6 100755
 --- a/setup.py
 +++ b/setup.py
-@@ -19,6 +19,7 @@ VERSION_FILE = PACKAGE + '/version.py'
+@@ -29,6 +29,7 @@ os.chdir(BASE_PATH)
  # retrieve the version number from git or VERSION_FILE
  # inspired by http://dcreager.net/2010/02/10/setuptools-git-version-numbers/
  try:
 +    raise OSError
      print('Attempting to get version number from git...')
-     git = Popen(['git', 'describe', '--abbrev=4', '--dirty'],
+     git = Popen(['git', 'describe', '--always', '--dirty'],
                  stdout=PIPE, stderr=sys.stderr)
diff -pruN 0.3.0-6/debian/patches/0002-fix-missing-version.py.patch 0.5.1-1/debian/patches/0002-fix-missing-version.py.patch
--- 0.3.0-6/debian/patches/0002-fix-missing-version.py.patch	2020-02-10 02:24:19.000000000 +0000
+++ 0.5.1-1/debian/patches/0002-fix-missing-version.py.patch	2020-09-25 21:21:50.000000000 +0000
@@ -9,11 +9,9 @@ Forwarded: not-needed
  setup.py | 8 ++++----
  1 file changed, 4 insertions(+), 4 deletions(-)
 
-diff --git a/setup.py b/setup.py
-index ecdf9a6..e2c84cf 100755
 --- a/setup.py
 +++ b/setup.py
-@@ -34,9 +34,9 @@ try:
+@@ -45,9 +45,9 @@ try:
  except OSError as e:
      print('Assume we are running from a source distribution.')
      # read version from VERSION_FILE
@@ -24,14 +22,14 @@ index ecdf9a6..e2c84cf 100755
 +    #     code = compile(version_file.read(), VERSION_FILE, 'exec')
 +    #     exec(code)
  
- with open('README.rst') as file:
-     README = file.read()
-@@ -44,7 +44,7 @@ with open('README.rst') as file:
+ 
+ def long_description():
+@@ -84,7 +84,7 @@ class custom_develop(develop):
  
  setup(
      name='citeproc-py',
 -    version=__version__,
-+    version='0.3.0',
++    version='0.5.1',
+     cmdclass = dict(build_py=custom_build_py, develop=custom_develop),
      packages=find_packages(),
      package_data={PACKAGE: ['data/locales/*.xml',
-                             'data/schema/*.rng',
diff -pruN 0.3.0-6/.gitmodules 0.5.1-1/.gitmodules
--- 0.3.0-6/.gitmodules	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/.gitmodules	2020-04-06 16:16:08.000000000 +0000
@@ -0,0 +1,7 @@
+[submodule "citeproc/data/schema"]
+	path = citeproc/data/schema
+	url = https://github.com/citation-style-language/schema.git
+[submodule "citeproc/data/locales"]
+	path = citeproc/data/locales
+	url = https://github.com/citation-style-language/locales.git
+	branch = master
diff -pruN 0.3.0-6/MANIFEST.in 0.5.1-1/MANIFEST.in
--- 0.3.0-6/MANIFEST.in	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/MANIFEST.in	2020-04-06 16:16:08.000000000 +0000
@@ -1,3 +1,6 @@
-include LICENSE README.rst
+include LICENSE README.rst CHANGES.rst
+recursive-include citeproc/data/schema *.rnc *.md
 recursive-include docs *.html *.css *.png
 recursive-include examples *.py *.csl *.bib
+recursive-include tests *.py *.bib
+prune tests/citeproc-test
diff -pruN 0.3.0-6/PKG-INFO 0.5.1-1/PKG-INFO
--- 0.3.0-6/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/PKG-INFO	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1,216 @@
+Metadata-Version: 1.1
+Name: citeproc-py
+Version: 0.5.1
+Summary: Citations and bibliography formatter
+Home-page: https://github.com/brechtm/citeproc-py
+Author: Brecht Machiels
+Author-email: brecht@mos6581.org
+License: 2-clause BSD License
+Description: ===========
+        citeproc-py
+        ===========
+        
+        .. image:: http://img.shields.io/pypi/v/citeproc-py.svg
+           :target: https://pypi.python.org/pypi/citeproc-py
+           :alt: PyPI
+        
+        .. image:: https://travis-ci.org/brechtm/citeproc-py.svg
+           :target: https://travis-ci.org/brechtm/citeproc-py
+           :alt: Build status
+        
+        .. image:: https://coveralls.io/repos/brechtm/citeproc-py/badge.svg?branch=master&service=github
+           :target: https://coveralls.io/github/brechtm/citeproc-py?branch=master
+           :alt: Code coverage
+        
+        .. image:: https://www.quantifiedcode.com/api/v1/project/61fcd880bcd04d478d659f2a8a1034ae/badge.svg
+           :target: https://www.quantifiedcode.com/app/project/61fcd880bcd04d478d659f2a8a1034ae
+           :alt: Code issues
+        
+        citeproc-py is a `CSL`_ processor for Python. It aims to implement the
+        `CSL 1.0.1 specification`_. citeproc-py can output styled citations and
+        bibliographies in a number of different output formats. Currently
+        supported are plain text, reStructuredText and HTML. Other formats can
+        be added easily.
+        
+        citeproc-py uses `semantic versioning`_. Currently, its major version
+        number is still at 0, meaning the API is not yet stable. However, you
+        should not expect to see any major API changes soon.
+        
+        .. _CSL: http://citationstyles.org/
+        .. _CSL 1.0.1 specification: http://citationstyles.org/downloads/specification.html
+        .. _semantic versioning: http://semver.org/
+        
+        
+        Requirements
+        ------------
+        
+        citeproc-py was originally developed for Python 3 but now also runs on Python
+        2.6+. It depends on `lxml`_ for parsing and navigating the CSL style and locale
+        files.
+        
+        .. _lxml: http://lxml.de/
+        
+        
+        Installation
+        ------------
+        
+        The recommended way of installing citeproc-py is by using `pip`_::
+        
+           pip install citeproc-py
+        
+        If lxml isn't installed, pip will try to install it for you.
+        
+        .. _pip: https://pip.pypa.io/en/latest/
+        
+        If you insist, you can manually install citeproc-py from distribution packages
+        hosted at `PyPI`_. Please ignore the release archives offered by GitHub.
+        
+        .. _PyPI: https://pypi.python.org/pypi/citeproc-py/
+        
+        
+        Getting Started
+        ---------------
+        
+        To get started with citeproc-py, take a look at the examples under
+        ``examples/``. Two examples are provided, one parsing references from a
+        JSON representation of references as supported by citeproc-js, another
+        parsing the references from a BibTeX file. Both show and explain how to
+        cite references and render the bibliography.
+        
+        
+        CSL Compatibility
+        -----------------
+        
+        Currently, citeproc-py passes almost 60% of the (relevant) tests in the
+        `citeproc-test suite`_. However, it is more than 60% complete, as
+        citeproc-py doesn't take care of double spaces and repeated punctuation
+        marks yet, making a good deal of the tests fail. In addition, the
+        following features have not yet been implemented (there are probably
+        some I forgot though):
+        
+        -  disambiguation/year-suffix
+        -  et-al-subsequent-min/et-al-subsequent-use-first
+        -  collapsing
+        -  punctuation-in-quote
+        -  display
+        
+        Also, some `citeproc-js`_ functionality that is not part of the CSL spec
+        is not (yet) supported:
+        
+        -  raw dates
+        -  static-ordering
+        -  literal names
+        
+        .. _citeproc-test suite: https://bitbucket.org/bdarcus/citeproc-test
+        .. _citeproc-js: http://bitbucket.org/fbennett/citeproc-js/wiki/Home
+        
+        
+        Running the Tests
+        -----------------
+        
+        First clone the `citeproc-test suite`_ so that it sits next to the
+        citeproc-py directory. Now you can run ``citeproc-test.py`` (in the ``tests``
+        directory). Run ``citeproc-test.py --help`` to see its usage information.
+        
+        .. _citeproc-test suite: https://bitbucket.org/bdarcus/citeproc-test
+        
+        
+        Changelog
+        ---------
+        
+        Release 0.5.1 (2020-03-06)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        Bug fixed:
+        
+        * avoid rnc2rng 2.6.2 which breaks installation of citeproc-py
+        
+        Release 0.5.0 (2020-02-09)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        Enhancements:
+        
+        * handle commas and ampersands in a functional style
+        * Number: handle commas and ampersands
+        * added symbol for textquotesingle
+        * specify fallback locales for fr-CA and es-CL
+        * improved page number and ranges parsing
+        
+        Bug fixed:
+        
+        * don't fail on empty page ranges (#90) (bbm)
+        * detect end of file while parsing incorrect bib (#59) (John Vandenberg)
+        
+        Other changes:
+        
+        * Removed 3.2-3.4 and added 3.7, 3.8 to supported Pythons
+        * Refactored locales handling
+        
+        Release 0.4.0 (2017-06-23)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        New features:
+        
+        * allow specifying the encoding of a BibTeX database file (#20 and #25)
+        * BibTeX 'month' field: support integers and "<month> <day>" values
+        * BibTeX 'pages' field: support "10", "10+", "10-12" and "10--12" formats
+        * BibTeX entry types: map the non-standard 'thesis' and 'report' entries
+        * update the CSL schema to version 1.0.1 (#5)
+        * update the CSL locales to commit 49bf3fc0
+        
+        Bug fixed:
+        
+        * avoid crash when there is nothing to affix (David Lesieur)
+        * fix BibTeX month to CSL month mapping (#24)
+        * strip leading/trailing whitespace from BibTeX values (#37)
+        
+        Release 0.3.0 (2014-11-07)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        Major improvements to the BibTeX parser:
+        
+        * split names into parts and assign them to the equivalent CSL name parts
+        * fixed handling of accent macros and escaped characters
+        * more compatible (La)TeX macro handling in general (but still basic)
+        * handle standard Computer Modern ligatures such as --, ---, and <<
+        * added unit tests for the BibTeX and LaTeX parsers
+        
+        Other changes:
+        
+        * disable RelaxNG validation of CSL styles by default (API change)
+        
+        Release 0.2.0 (2014-10-25)
+        ~~~~~~~~~~~~~~~~~~~~~~~~~~
+        
+        * bad cite callback function can determine how a bad cite is displayed (hetsch)
+        * added option to disable RelaxNG validation (Jasper Op de Coul)
+        * distutils was replaced with setuptools (Joshua Carp)
+        * bug fixes (Yaroslav Halchenko, David Lesieur)
+        * CitationStylesBibliography.bibliography() now returns the list of entries
+        
+Keywords: csl citation html rst bibtex xml
+Platform: UNKNOWN
+Classifier: Development Status :: 3 - Alpha
+Classifier: Environment :: Console
+Classifier: Environment :: Other Environment
+Classifier: Environment :: Web Environment
+Classifier: Intended Audience :: Developers
+Classifier: Intended Audience :: Education
+Classifier: Intended Audience :: End Users/Desktop
+Classifier: Intended Audience :: Legal Industry
+Classifier: Intended Audience :: Other Audience
+Classifier: Intended Audience :: Science/Research
+Classifier: License :: OSI Approved :: BSD License
+Classifier: Operating System :: OS Independent
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 2.7
+Classifier: Programming Language :: Python :: 3.4
+Classifier: Programming Language :: Python :: 3.5
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Classifier: Programming Language :: Python :: 3.8
+Classifier: Topic :: Documentation
+Classifier: Topic :: Printing
+Classifier: Topic :: Software Development :: Documentation
+Classifier: Topic :: Software Development :: Libraries :: Python Modules
+Provides: citeproc
diff -pruN 0.3.0-6/README.rst 0.5.1-1/README.rst
--- 0.3.0-6/README.rst	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/README.rst	2020-04-06 16:16:08.000000000 +0000
@@ -2,6 +2,22 @@
 citeproc-py
 ===========
 
+.. image:: http://img.shields.io/pypi/v/citeproc-py.svg
+   :target: https://pypi.python.org/pypi/citeproc-py
+   :alt: PyPI
+
+.. image:: https://travis-ci.org/brechtm/citeproc-py.svg
+   :target: https://travis-ci.org/brechtm/citeproc-py
+   :alt: Build status
+
+.. image:: https://coveralls.io/repos/brechtm/citeproc-py/badge.svg?branch=master&service=github
+   :target: https://coveralls.io/github/brechtm/citeproc-py?branch=master
+   :alt: Code coverage
+
+.. image:: https://www.quantifiedcode.com/api/v1/project/61fcd880bcd04d478d659f2a8a1034ae/badge.svg
+   :target: https://www.quantifiedcode.com/app/project/61fcd880bcd04d478d659f2a8a1034ae
+   :alt: Code issues
+
 citeproc-py is a `CSL`_ processor for Python. It aims to implement the
 `CSL 1.0.1 specification`_. citeproc-py can output styled citations and
 bibliographies in a number of different output formats. Currently
@@ -13,20 +29,37 @@ number is still at 0, meaning the API is
 should not expect to see any major API changes soon.
 
 .. _CSL: http://citationstyles.org/
-.. _CSL 1.0.1 specification: http://citationstyles.org/documentation/
+.. _CSL 1.0.1 specification: http://citationstyles.org/downloads/specification.html
 .. _semantic versioning: http://semver.org/
 
 
 Requirements
 ------------
 
-citeproc-py has been developed for Python 3 but also runs on Python
-2.6+. It depends on `lxml`_ for parsing and navigating the CSL style and
-locale files.
+citeproc-py was originally developed for Python 3 but now also runs on Python
+2.6+. It depends on `lxml`_ for parsing and navigating the CSL style and locale
+files.
 
 .. _lxml: http://lxml.de/
 
 
+Installation
+------------
+
+The recommended way of installing citeproc-py is by using `pip`_::
+
+   pip install citeproc-py
+
+If lxml isn't installed, pip will try to install it for you.
+
+.. _pip: https://pip.pypa.io/en/latest/
+
+If you insist, you can manually install citeproc-py from distribution packages
+hosted at `PyPI`_. Please ignore the release archives offered by GitHub.
+
+.. _PyPI: https://pypi.python.org/pypi/citeproc-py/
+
+
 Getting Started
 ---------------
 
@@ -68,9 +101,7 @@ Running the Tests
 -----------------
 
 First clone the `citeproc-test suite`_ so that it sits next to the
-citeproc-py directory. Then run the ``processor.py`` script to generate
-the test fixtures (using Python 2.x). After that, you can run
-``citeproc-test.py`` (in the ``tests`` directory). Run
-``citeproc-test.py --help`` to see its usage information.
+citeproc-py directory. Now you can run ``citeproc-test.py`` (in the ``tests``
+directory). Run ``citeproc-test.py --help`` to see its usage information.
 
 .. _citeproc-test suite: https://bitbucket.org/bdarcus/citeproc-test
diff -pruN 0.3.0-6/setup.cfg 0.5.1-1/setup.cfg
--- 0.3.0-6/setup.cfg	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/setup.cfg	2020-04-06 16:40:54.000000000 +0000
@@ -0,0 +1,7 @@
+[bdist_wheel]
+universal = 1
+
+[egg_info]
+tag_build = 
+tag_date = 0
+
diff -pruN 0.3.0-6/setup.py 0.5.1-1/setup.py
--- 0.3.0-6/setup.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/setup.py	2020-04-06 16:34:05.000000000 +0000
@@ -4,28 +4,39 @@
 Setup script for citeproc-py
 """
 
+import io
 import os
+import re
 import sys
 
 from datetime import datetime
 from subprocess import Popen, PIPE
 from setuptools import setup, find_packages
+from setuptools.command.build_py import build_py
+from setuptools.command.develop import develop
 
 
 PACKAGE = 'citeproc'
-PACKAGE_ABSPATH = os.path.abspath(PACKAGE)
-VERSION_FILE = PACKAGE + '/version.py'
+BASE_PATH = os.path.dirname(os.path.abspath(__file__))
+PACKAGE_ABSPATH = os.path.join(BASE_PATH, PACKAGE)
+VERSION_FILE = os.path.join(PACKAGE_ABSPATH, 'version.py')
+
+VERSION_FORMAT = re.compile(r'v\d+\.\d+\.\d+')
+
+# All external commands are relative to BASE_PATH
+os.chdir(BASE_PATH)
 
 # retrieve the version number from git or VERSION_FILE
 # inspired by http://dcreager.net/2010/02/10/setuptools-git-version-numbers/
 try:
     print('Attempting to get version number from git...')
-    git = Popen(['git', 'describe', '--abbrev=4', '--dirty'],
+    git = Popen(['git', 'describe', '--always', '--dirty'],
                 stdout=PIPE, stderr=sys.stderr)
     if git.wait() != 0:
         raise OSError
-    line = git.stdout.readlines()[0]
-    __version__ = line.strip()[1:].decode('ascii')
+    line, = git.stdout.readlines()
+    line = line.strip().decode('ascii')
+    __version__ = line[1:] if VERSION_FORMAT.match(line) else line
     __release_date__ = datetime.now().strftime('%b %d %Y, %H:%M:%S')
     with open(VERSION_FILE, 'w') as version_file:
         version_file.write("__version__ = '{}'\n".format(__version__))
@@ -37,18 +48,50 @@ except OSError as e:
         code = compile(version_file.read(), VERSION_FILE, 'exec')
         exec(code)
 
-with open('README.rst') as file:
-    README = file.read()
+
+def long_description():
+    with open(os.path.join(BASE_PATH, 'README.rst')) as readme:
+        result = readme.read()
+    result += '\n\n'
+    with open(os.path.join(BASE_PATH, 'CHANGES.rst')) as changes:
+        result += changes.read()
+    return result
+
+
+CSL_SCHEMA_RNC = 'citeproc/data/schema/csl.rnc'
+
+def convert_rnc():
+    import rnc2rng
+
+    filename_root, _ = os.path.splitext(CSL_SCHEMA_RNC)
+    root = rnc2rng.load(CSL_SCHEMA_RNC)
+    with io.open(filename_root + '.rng', 'w', encoding='utf-8') as rng:
+        rnc2rng.dump(root, rng)
+
+
+class custom_build_py(build_py):
+    def run(self):
+        convert_rnc()
+        build_py.run(self)
+
+
+class custom_develop(develop):
+    def run(self):
+        convert_rnc()
+        develop.run(self)
 
 
 setup(
     name='citeproc-py',
     version=__version__,
+    cmdclass = dict(build_py=custom_build_py, develop=custom_develop),
     packages=find_packages(),
     package_data={PACKAGE: ['data/locales/*.xml',
+                            'data/locales/locales.json',
                             'data/schema/*.rng',
                             'data/styles/*.csl']},
     scripts=['bin/csl_unsorted'],
+    setup_requires=['rnc2rng>=2.6.1,!=2.6.2'],
     install_requires=['lxml'],
     provides=[PACKAGE],
     #test_suite='nose.collector',
@@ -56,7 +99,7 @@ setup(
     author='Brecht Machiels',
     author_email='brecht@mos6581.org',
     description='Citations and bibliography formatter',
-    long_description=README,
+    long_description=long_description(),
     url='https://github.com/brechtm/citeproc-py',
     keywords='csl citation html rst bibtex xml',
     license='2-clause BSD License',
@@ -74,9 +117,12 @@ setup(
         'License :: OSI Approved :: BSD License',
         'Operating System :: OS Independent',
         'Programming Language :: Python',
-        'Programming Language :: Python :: 2.6',
         'Programming Language :: Python :: 2.7',
-        'Programming Language :: Python :: 3',
+        'Programming Language :: Python :: 3.4',
+        'Programming Language :: Python :: 3.5',
+        'Programming Language :: Python :: 3.6',
+        'Programming Language :: Python :: 3.7',
+        'Programming Language :: Python :: 3.8',
         'Topic :: Documentation',
         'Topic :: Printing',
         'Topic :: Software Development :: Documentation',
diff -pruN 0.3.0-6/tests/citeproc-test.py 0.5.1-1/tests/citeproc-test.py
--- 0.3.0-6/tests/citeproc-test.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/tests/citeproc-test.py	2020-04-06 16:16:08.000000000 +0000
@@ -6,7 +6,6 @@ from citeproc.py2compat import *
 
 import glob
 import io
-import json
 import os
 import sys
 import traceback
@@ -14,20 +13,23 @@ import traceback
 from codecs import utf_8_encode
 from functools import reduce
 from optparse import OptionParser
+from subprocess import Popen, PIPE
 
 from citeproc import CitationStylesStyle, CitationStylesBibliography
 from citeproc.source import Citation, CitationItem, Locator
 from citeproc.source.json import CiteProcJSON
 
 
-if sys.version_info[0] < 3:
-    str = unicode
+CITEPROC_TEST_REPOSITORY = 'https://github.com/citation-style-language/test-suite.git'
+CITEPROC_TEST_COMMIT = '5779a8cd6e2560ef28e5b72225ec15368b089084'
 
+CITEPROC_TEST_PATH = os.path.abspath(os.path.join(os.path.dirname(__file__),
+                                     'test-suite'))
+TEST_PARSER_PATH = os.path.join(CITEPROC_TEST_PATH, 'processor.py')
+TESTS_PATH = os.path.join(CITEPROC_TEST_PATH, 'processor-tests', 'humans')
+
+FAILING_TESTS_FILE = 'failing_tests.txt'
 
-TESTS_PATH = os.path.abspath(os.path.join(os.path.dirname(__file__),
-                                          os.path.pardir, os.path.pardir,
-                                          'citeproc-test', 'processor-tests',
-                                          'machines'))
 
 # The results of the following tests are ignored, since they don't test CSL
 # features, but citeproc-js specific features
@@ -45,23 +47,29 @@ IGNORED_RESULS = {
 
 
 class ProcessorTest(object):
+    """Parses atest fixture and provides a method for processing the tests
+    defined in it."""
     bib_prefix = '<div class="csl-bib-body">'
     bib_suffix = '</div>'
     item_prefix = '  <div class="csl-entry">'
     item_suffix = '</div>'
 
     def __init__(self, filename):
-        with open(filename, 'rt', encoding='UTF-8') as f:
-            self.json_data = json.load(f)
-
-        csl_io = io.BytesIO(utf_8_encode(self.json_data['csl'])[0])
+        self.csl_test = CslTest({}, None, (filename, ),
+                                os.path.basename(filename))
+        self.csl_test.parse()
+        csl_io = io.BytesIO(utf_8_encode(self.data['csl'])[0])
         self.style = CitationStylesStyle(csl_io)
-        self._fix_input(self.json_data['input'])
-        self.references = [item['id'] for item in self.json_data['input']]
-        self.references_dict = CiteProcJSON(self.json_data['input'])
+        self._fix_input(self.data['input'])
+        self.references = [item['id'] for item in self.data['input']]
+        self.references_dict = CiteProcJSON(self.data['input'])
         self.bibliography = CitationStylesBibliography(self.style,
                                                        self.references_dict)
-        self.expected = self.json_data['result'].splitlines()
+        self.expected = self.data['result'].splitlines()
+
+    @property
+    def data(self):
+        return self.csl_test.data
 
     @staticmethod
     def _fix_input(input_data):
@@ -72,12 +80,12 @@ class ProcessorTest(object):
                 ref['type'] = 'book'
 
     def execute(self):
-        if self.json_data['citation_items']:
+        if self.data['citation_items']:
             citations = [self.parse_citation(item)
-                         for item in self.json_data['citation_items']]
-        elif self.json_data['citations']:
+                         for item in self.data['citation_items']]
+        elif self.data['citations']:
             citations = []
-            for cit in self.json_data['citations']:
+            for cit in self.data['citations']:
                 cit = cit[0]
                 citation_items = [self.parse_citation_item(cititem)
                                   for cititem in cit['citationItems']]
@@ -85,9 +93,9 @@ class ProcessorTest(object):
                 citation.key = cit['citationID']
                 citation.note_index = cit['properties']['noteIndex']
                 citations.append(citation)
-        elif self.json_data['bibentries']:
+        elif self.data['bibentries']:
             citation_items = [self.parse_citation_item({'id': entry})
-                              for entry in self.json_data['bibentries'][-1]]
+                              for entry in self.data['bibentries'][-1]]
             citations = [Citation(citation_items)]
         else:
             citation_items = [self.parse_citation_item({'id': ref})
@@ -102,8 +110,8 @@ class ProcessorTest(object):
 
         results = []
         do_nothing = lambda x: None     # callback passed to cite()
-        if self.json_data['mode'] == 'citation':
-            if self.json_data['citations']:
+        if self.data['mode'] == 'citation':
+            if self.data['citations']:
                 for i, citation in enumerate(citations):
                     if i == len(citations) - 1:
                         dots_or_other = '>>'
@@ -114,13 +122,12 @@ class ProcessorTest(object):
             else:
                 for citation in citations:
                     results.append(self.bibliography.cite(citation, do_nothing))
-        elif self.json_data['mode'] in ('bibliography', 'bibliography-nosort'):
+        elif self.data['mode'] in ('bibliography', 'bibliography-nosort'):
             results.append(self.bib_prefix)
             for entry in self.bibliography.bibliography():
                 text = self.item_prefix + str(entry) + self.item_suffix
                 results.append(text)
             results.append(self.bib_suffix)
-
         return results
 
     def parse_citation(self, citation_data):
@@ -128,7 +135,6 @@ class ProcessorTest(object):
         for item in citation_data:
             citation_item = self.parse_citation_item(item)
             citation_items.append(citation_item)
-
         return Citation(citation_items)
 
     def parse_citation_item(self, citation_item_data):
@@ -149,25 +155,120 @@ class ProcessorTest(object):
                 pass
             else:
                 options[python_key] = value
-
         return CitationItem(reference_key, **options)
 
 
-def main():
+class FailedTests(object):
+    """Read the known failed tests from a file and update the file with the
+    results from a new test run."""
+    def __init__(self, filename):
+        self.filename = filename
+        with open(filename, 'r') as file:
+            self.lines = file.readlines()
+        self.now_failing = {}
+        self.updated_lines = []
+
+    def mark_failure(self, test_name, reason=None):
+        self.now_failing[test_name] = reason
+
+    def compare(self):
+        assert not self.updated_lines
+        was_failing = set()
+        new_failing_tests = []
+        new_fixed_tests = []
+        for line in self.lines:
+            test_name, comment = (line.split('#') if '#' in line
+                                  else (line, None))
+            test_name = test_name.strip()
+            if test_name and test_name not in self.now_failing:
+                new_fixed_tests.append(test_name)
+                continue
+            was_failing.add(test_name)
+            self.updated_lines.append(line)
+        for test_name in sorted(self.now_failing.keys()):
+            if test_name not in was_failing:
+                reason = self.now_failing[test_name]
+                line = ('{:<66} # {}'.format(test_name, reason) if reason
+                        else test_name)
+                self.updated_lines.append(line + '\n')
+                new_failing_tests.append(test_name)
+        return new_failing_tests, new_fixed_tests
+
+    def update_file(self):
+        assert self.updated_lines
+        with open(self.filename, 'w') as file:
+            file.writelines(self.updated_lines)
+
+
+def execute_git_command(args, echo=False):
+    """Execute a git command, exiting this script when it returns a
+    non-zero error code."""
+    command = ['git'] + args
+    if echo:
+        print(' '.join(command))
+    process = Popen(command, stdin=PIPE, stdout=PIPE, stderr=PIPE)
+    out, err = process.communicate()
+    if process.returncode:
+        print('Calling git failed. Make sure git is installed. Aborting.')
+        sys.exit(1)
+    return out, err
+
+
+def clone_test_suite():
+    """Clone the citeproc-test repository if it is not present. Otherwise, check
+    whether the correct commit is checked out."""
+    if not os.path.exists(CITEPROC_TEST_PATH):
+        git_clone = ['clone', CITEPROC_TEST_REPOSITORY, CITEPROC_TEST_PATH]
+        print('Cloning the test-suite repository...')
+        execute_git_command(git_clone, echo=True)
+        git_checkout = ['-C', CITEPROC_TEST_PATH, 'checkout',
+                        CITEPROC_TEST_COMMIT]
+        print('Checking out the specified commit...')
+        execute_git_command(git_checkout)
+    else:
+        git_ref = ['-C', CITEPROC_TEST_PATH, 'rev-parse', 'HEAD']
+        commit_ref, _ = execute_git_command(git_ref)
+        if commit_ref.strip() != CITEPROC_TEST_COMMIT.encode('ascii'):
+            print('The checked-out commit of test-suite does not match \n'
+                  'the one recorded in this test script. Aborting.')
+            sys.exit(1)
+        git_fetch = ['-C', CITEPROC_TEST_PATH, 'fetch']
+        execute_git_command(git_fetch)
+    git_ref = ['-C', CITEPROC_TEST_PATH, 'rev-parse', 'origin/master']
+    commit_ref, _ = execute_git_command(git_ref)
+    has_updates = commit_ref.strip() != CITEPROC_TEST_COMMIT.encode('ascii')
+    return has_updates
+
+
+RED = '\033[91m'
+GREEN = '\033[92m'
+BOLD = '\033[1m'
+END = '\033[0m'
+
+
+if __name__ == '__main__':
     usage = ('usage: %prog [options] glob_pattern\n\n'
              'glob_pattern limits the tests that are executed, for example:\n'
              '  %prog *Sort*\n'
              'runs only test fixtures that have "Sort" in the filename')
     parser = OptionParser(usage)
     parser.add_option('-m', '--max', dest='max', default=-1,
-                      help='run maximally MAX tests', metavar='MAX')
+                      help='run up to MAX tests', metavar='MAX')
+    parser.add_option('-v', '--verbose', dest='verbose', action='store_true',
+                      default=False, help='print results for each test')
     parser.add_option('-r', '--raise', dest='catch_exceptions', default=True,
                       action='store_false',
-                      help='exceptions are not caught (aborts program)')
+                      help='do not catch exceptions (aborts program)')
+    parser.add_option('-s', '--summary', dest='summary', action='store_true',
+                      default=False, help='print a summary of the test results')
+    parser.add_option('-n', '--no-update', dest='update', action='store_false',
+                      default=True, help='do not update {}'
+                                         .format(FAILING_TESTS_FILE))
     parser.add_option('-f', '--file', dest='file', default=None,
                       help='write output to FILE', metavar='FILE')
     (options, args) = parser.parse_args()
 
+    max_tests = int(options.max)
     try:
         destination = open(options.file, 'wt', encoding='utf-8')
         class UnicodeWriter(object):
@@ -176,89 +277,138 @@ def main():
         sys.stderr = UnicodeWriter()
     except TypeError:
         destination = sys.stdout
+
     def out(*args):
         if not args:
             destination.write('\n')
         else:
             print(*args, file=destination)
 
+    def print_result(name, passed, total):
+        out(' {:<13} {:>3} / {:>3} ({:>4.0%})'.format(name, passed, total,
+                                                      passed / total))
+
     try:
         glob_pattern = args[0]
-        filter_tests = False
+        run_all_tests = False
     except IndexError:
         glob_pattern = '*'
-        filter_tests = True
+        run_all_tests = True
+
+    test_repo_has_updates = clone_test_suite()
+
+    # import the text fixture parser included with citeproc-test
+    try:  # Python 3.3+
+        from importlib.machinery import SourceFileLoader
+        loader = SourceFileLoader('processor', TEST_PARSER_PATH)
+        processor = loader.load_module()
+    except ImportError:  # older Python versions
+        from imp import load_source
+        processor = load_source('processor', TEST_PARSER_PATH)
+    from processor import CslTest
+    global CslTest
 
     total_count = {}
     passed_count = {}
-    failed = []
-    max_tests = int(options.max)
-
+    failed_tests = FailedTests(os.path.join(os.path.dirname(__file__),
+                                            FAILING_TESTS_FILE))
     count = 0
-    for filename in glob.glob(os.path.join(TESTS_PATH,
-                                           '{}.json'.format(glob_pattern))):
-        test_name = os.path.basename(filename).split('.json')[0]
-        category = os.path.basename(filename).split('_')[0]
+    test_files = os.path.join(TESTS_PATH, '{}.txt'.format(glob_pattern))
+    for filename in sorted(glob.glob(test_files)):
+        test_name, _ = os.path.basename(filename).split('.txt')
+        category, _ = os.path.basename(filename).split('_')
         passed_count.setdefault(category, 0)
         if count == max_tests:
             break
 
+        reason = None
         try:
             if test_name not in IGNORED_RESULS:
                 total_count[category] = total_count.get(category, 0) + 1
                 count += 1
             t = ProcessorTest(filename)
-            if filter_tests and (t.json_data['mode'] == 'bibliography-header' or
-                                 t.json_data['bibsection']):
+            if run_all_tests and (t.data['mode'] == 'bibliography-header' or
+                                  t.data['bibsection']):
                 continue
-            out('>>> Testing {}'.format(os.path.basename(filename)))
-            out('EXP: ' + '\n     '.join(t.expected))
+            if options.verbose:
+                out('>>> Testing {}'.format(os.path.basename(filename)))
+                out('EXP: ' + '\n     '.join(t.expected))
 
             results = t.execute()
             results = reduce(lambda x, y: x+y,
                              [item.split('\n') for item in results])
             results = [item.replace('&amp;', '&#38;')
                        for item in results]
-            out('RES: ' + '\n     '.join(results))
+            if options.verbose:
+                out('RES: ' + '\n     '.join(results))
             if results == t.expected:
                 if test_name not in IGNORED_RESULS:
                     passed_count[category] += 1
-                out('<<< SUCCESS\n')
+                if options.verbose:
+                    out('<<< SUCCESS\n')
                 continue
             else:
-                out('<<< FAILED\n')
+                if options.verbose:
+                    out('<<< FAILED\n')
             del t
         except Exception as e:
-            out('Exception in', os.path.basename(filename))
-            if options.catch_exceptions:
-                traceback.print_exc()
-            else:
+            if not options.catch_exceptions:
                 raise
+            if options.verbose:
+                out('Exception in', os.path.basename(filename))
+                traceback.print_exc()
+                out('<<< FAILED\n')
+            reason = 'uncaught exception'
         if test_name not in IGNORED_RESULS:
-            failed.append(test_name)
+            failed_tests.mark_failure(test_name, reason)
 
+    success = False
     if sum(total_count.values()) == 0:
         print('<no tests found>: check README.md file for instructions')
     else:
-        def print_result(name, passed, total):
-            out(' {:<13} {:>3} / {:>3} ({:>4.0%})'.format(name, passed, total,
-                                                          passed / total))
-
-        out('Failed tests:')
-        for test_name in failed:
-            out(' ' + test_name)
-
-        out()
-        out('Summary:')
-        for category in sorted(total_count.keys()):
-            print_result(category, passed_count[category], total_count[category])
-        out()
-        print_result('total', sum(passed_count.values()), sum(total_count.values()))
+        if run_all_tests:
+            new_failing, new_fixed = failed_tests.compare()
+            success = not (new_failing or new_fixed)
+            if options.update:
+                failed_tests.update_file()
+
+            if new_failing:
+                out(BOLD + 'New failing tests:' + END)
+                for test_name in new_failing:
+                    out(' ' + RED + test_name + END)
+            if new_failing or new_fixed:
+                out()
+            else:
+                out('All is well.')
+            if new_fixed:
+                out(BOLD + 'Fixed tests:' + END)
+                for test_name in new_fixed:
+                    out(' ' + GREEN + test_name + END)
+                out()
+                out('You need to fix the newly failing tests and may commit the \n'
+                    'removal of the fixed tests from {}'.format(FAILING_TESTS_FILE))
+
+            if test_repo_has_updates:
+                out()
+                out(BOLD + 'The test-suite repository has updates! Consider '
+                           'updating the test script.' + END)
+        else:
+            failing = sorted(failed_tests.now_failing.keys())
+            success = not failing
+            out(BOLD + 'Failing tests:' + END)
+            for test_name in failing:
+                out(' ' + RED + test_name + END)
+        if options.summary:
+            out()
+            out(BOLD + 'Summary:' + END)
+            for category in sorted(total_count.keys()):
+                print_result(category, passed_count[category],
+                             total_count[category])
+            out()
+            print_result('total', sum(passed_count.values()),
+                         sum(total_count.values()))
     try:
         destination.close()
     except AttributeError:
         pass
-
-
-if __name__ == '__main__':
-    main()
+    sys.exit(0 if success else 1)
diff -pruN 0.3.0-6/tests/failing_tests.txt 0.5.1-1/tests/failing_tests.txt
--- 0.3.0-6/tests/failing_tests.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/tests/failing_tests.txt	2020-04-06 16:16:08.000000000 +0000
@@ -0,0 +1,359 @@
+# This file contains a list of the test fixtures that are known to fail.
+# It is used to check for regressions.
+
+affix_MovingPunctuation
+affix_PrefixFullCitationTextOnly
+affix_PrefixWithDecorations
+affix_SpaceWithQuotes
+affix_WithCommas
+affix_WordProcessorAffixNoSpace
+api_SuppressAuthor
+bugreports_AffiliationSpoofingDemoPageFullCiteCruftOnSubsequent    # uncaught exception
+bugreports_AllCapsLeakage
+bugreports_ApostropheOnParticle
+bugreports_ArabicLocale
+bugreports_AsaSpacing
+bugreports_AsmJournals
+bugreports_AuthorPosition
+bugreports_AutomaticallyDeleteItemsFails
+bugreports_BadCitationUpdate
+bugreports_BadDelimiterBeforeCollapse
+bugreports_ByBy
+bugreports_CapsAfterOneWordPrefix
+bugreports_ChicagoAuthorDateLooping
+bugreports_CitationSortsWithEtAl
+bugreports_CollapseFailure
+bugreports_ContainerTitleShort
+bugreports_ContentPunctuationDuplicate1
+bugreports_CreepingAddNames
+bugreports_DelimiterOnLayout                                       # uncaught exception
+bugreports_DemoPageFullCiteCruftOnSubsequent                       # uncaught exception
+bugreports_DisambiguationAddNames
+bugreports_DisambiguationAddNamesBibliography
+bugreports_DoubleEncodedAngleBraces                                # uncaught exception
+bugreports_DuplicateSpaces
+bugreports_DuplicateSpaces2
+bugreports_DuplicateSpaces3
+bugreports_DuplicateTerminalPunctuationInBibliography
+bugreports_EtAlSubsequent
+bugreports_FourAndFour
+bugreports_FrenchApostrophe
+bugreports_GreekStyleProblems                                      # uncaught exception
+bugreports_GreekStyleTwoEditors                                    # uncaught exception
+bugreports_IeeePunctuation
+bugreports_ikeyOne
+bugreports_LabelsOutOfPlace
+bugreports_MissingItemInJoin
+bugreports_MovePunctuationInsideQuotesForLocator
+bugreports_NoCaseEscape
+bugreports_NonBreakingSpaceJoinFail                                # uncaught exception
+bugreports_NoTitle
+bugreports_NumberAffixEscape
+bugreports_NumberInMacroWithVerticalAlign
+bugreports_NumericStyleFirstRefMultipleCiteFailure                 # uncaught exception
+bugreports_OldMhraDisambiguationFailure
+bugreports_parenthesis
+bugreports_parseName
+bugreports_ProcessorHang1
+bugreports_SingleQuote
+bugreports_SmallCapsEscape
+bugreports_SortedIeeeItalicsFail
+bugreports_SortSecondaryKey
+bugreports_ThesisUniversityAppearsTwice
+bugreports_TitleCase
+bugreports_TwoFullStops
+bugreports_UndefinedBeforeVal
+bugreports_UndefinedInName                                         # uncaught exception
+bugreports_UndefinedInName3
+bugreports_UndefinedNotString
+bugreports_UndefinedStr
+bugreports_UriWrapping
+bugreports_YearSuffixInHarvard1                                    # uncaught exception
+bugreports_YearSuffixLingers
+collapse_AuthorCollapse
+collapse_AuthorCollapseNoDate
+collapse_AuthorCollapseNoDateSorted
+collapse_CitationNumberRangesInsert
+collapse_CitationNumberRangesMixed
+collapse_CitationNumberRangesMixed2
+collapse_CitationNumberRangesMixed3
+collapse_CitationNumberRangesWithAffixes
+collapse_CitationNumberRangesWithAffixesGrouped
+collapse_CitationNumberRangesWithAffixesGroupedLocator
+collapse_NumericDuplicate
+collapse_NumericDuplicate2
+collapse_TrailingDelimiter
+collapse_YearSuffixCollapse
+collapse_YearSuffixCollapseNoRange
+collapse_YearSuffixCollapseNoYearSuffixDelimiter
+collapse_YearSuffixImplicitCollapseNoYearSuffixDelimiter
+condition_IsNumeric
+date_DateNoDateNoTest
+date_VariousInvalidDates                                           # uncaught exception
+date_YearSuffixDelimiter
+date_YearSuffixImplicitWithNoDate
+date_YearSuffixImplicitWithNoDateOneOnly
+date_YearSuffixWithNoDate
+decorations_AndTermUnaffectedByNameDecorations
+decorations_Baseline
+decorations_NestedQuotes
+decorations_NestedQuotesInnerReverse
+decorations_NoNormalWithoutDecoration
+decorations_SimpleFlipFlop
+disambiguate_AddNamesSuccess
+disambiguate_AllNamesBaseNameCountOnFailureIfYearSuffixAvailable
+disambiguate_AllNamesGenerally
+disambiguate_AllNamesSimpleSequence
+disambiguate_AllNamesWithInitialsGenerally
+disambiguate_AndreaEg1a
+disambiguate_AndreaEg1b
+disambiguate_AndreaEg2
+disambiguate_AndreaEg3
+disambiguate_AndreaEg4
+disambiguate_AndreaEg5
+disambiguate_BasedOnEtAlSubsequent
+disambiguate_BasedOnSubsequentFormWithBackref
+disambiguate_BasedOnSubsequentFormWithLocator
+disambiguate_ByCiteBaseNameCountOnFailureIfYearSuffixAvailable
+disambiguate_ByCiteGivennameExpandCrossNestedNames
+disambiguate_ByCiteGivennameNoShortFormInitializeWith
+disambiguate_ByCiteGivennameShortFormInitializeWith
+disambiguate_ByCiteGivennameShortFormNoInitializeWith
+disambiguate_ByCiteIncremental1                                    # uncaught exception
+disambiguate_ByCiteIncremental2                                    # uncaught exception
+disambiguate_ByCiteMinimalGivennameExpandMinimalNames
+disambiguate_ByCiteRetainNamesOnFailureIfYearSuffixNotAvailable
+disambiguate_CitationLabelDefault
+disambiguate_CitationLabelInData
+disambiguate_DisambiguateTrueAndYearSuffixOne
+disambiguate_DisambiguateTrueAndYearSuffixTwo
+disambiguate_DisambiguateWithThree
+disambiguate_DisambiguateWithThree2
+disambiguate_DisambiguationHang
+disambiguate_ExtraTextCitation
+disambiguate_FailWithYearSuffix
+disambiguate_ImplicitYearSuffixOnceOnly
+disambiguate_IncrementalExtraText
+disambiguate_InitializeWithButNoDisambiguation
+disambiguate_LastOnlyFailWithByCite
+disambiguate_NoTextElementUsesYearSuffixVariable
+disambiguate_PrimaryNameGenerally
+disambiguate_PrimaryNameWithInitialsLimitedToPrimary
+disambiguate_SetsOfNames
+disambiguate_SkipAccessedYearSuffix
+disambiguate_ToInitialOnly
+disambiguate_Trigraph
+disambiguate_YearCollapseWithInstitution
+disambiguate_YearSuffixAndSort
+disambiguate_YearSuffixAtTwoLevels                                 # uncaught exception
+disambiguate_YearSuffixFiftyTwoEntries                             # uncaught exception
+disambiguate_YearSuffixFiftyTwoEntriesByCite                       # uncaught exception
+disambiguate_YearSuffixMacroSameYearExplicit
+disambiguate_YearSuffixMacroSameYearImplicit
+disambiguate_YearSuffixMidInsert
+disambiguate_YearSuffixMixedDates
+disambiguate_YearSuffixTwoPairsBibliography
+disambiguate_YearSuffixTwoPairsFirstNameBibliography
+disambiguate_YearSuffixWithEtAlSubequent
+disambiguate_YearSuffixWithMixedCreatorTypes
+discretionary_SuppressAuthorSolo
+discretionary_SuppressEditorSolo
+discretionary_SuppressEditorSubstitute
+discretionary_SuppressMultipleAuthors
+display_AuthorAsHeading
+display_DisplayBlock
+display_LostSuffix
+display_SecondFieldAlignClone
+display_SecondFieldAlignMigratePunctuation
+etal_CitationAndBibliographyDecorationsInBibliography
+etal_CitationAndBibliographyDecorationsInCitation
+etal_ShortFormOfName
+etal_UseZeroFirst
+flipflop_Apostrophes
+flipflop_BoldfaceNodeLevelMarkup
+flipflop_ItalicsFlipped
+flipflop_ItalicsSimple
+flipflop_ItalicsWithOk
+flipflop_ItalicsWithOkAndTextcase
+flipflop_LeadingSingleQuote
+flipflop_OrphanQuote
+flipflop_QuotesInFieldNotOnNode
+flipflop_QuotesNodeLevelMarkup
+flipflop_SingleQuotesOnItalics
+flipflop_SmallCaps
+flipflop_StartingApostrophe
+fullstyles_ABdNT
+fullstyles_ChicagoArticleTitleQuestion
+fullstyles_ChicagoAuthorDateSimple
+group_ComplexNesting
+group_LegalWithAuthorDate                                          # uncaught exception
+group_SuppressTermInMacro
+integration_CrossCitationIbidOnInsert
+integration_DeleteName
+integration_DisambiguateAddGivenname1                              # uncaught exception
+integration_DisambiguateAddGivenname2                              # uncaught exception
+integration_DuplicateItem                                          # uncaught exception
+integration_DuplicateItem2                                         # uncaught exception
+integration_FirstReferenceNoteNumberPositionChange
+integration_IbidOnInsert
+integration_SimpleFirstReferenceNoteNumber
+integration_SimpleIbid
+integration_YearSuffixOnOffOn                                      # uncaught exception
+label_CollapsedPageNumberPluralDetection
+label_EditorTranslator1                                            # uncaught exception
+label_MissingReturnsEmpty                                          # uncaught exception
+label_PluralNumberOfVolumes
+locale_EmptyPlusOverrideStyleOpt
+locale_EmptyStyleOpt
+locale_SpecificStyleOpt
+locale_TitleCaseEnglishLangUpperEmptyLocale
+locator_SimpleLocators
+locator_TrickyEntryForPlurals
+locator_WithLeadingSpace
+magic_CapitalizeFirstOccurringTerm
+magic_CitationLabelInBibliography
+magic_CitationLabelInCitation
+magic_ImplicitYearSuffixDelimiter
+magic_ImplicitYearSuffixExplicitDelimiter
+magic_NameSuffixNoComma
+magic_NameSuffixWithComma
+magic_PunctuationInQuoteDefaultEnglishDelimiter
+magic_PunctuationInQuoteDefaultEnglishSuffix
+magic_PunctuationInQuoteDelimiterTrue
+magic_PunctuationInQuoteNested
+magic_PunctuationInQuoteSuffixTrue
+magic_PunctuationInQuoteTrueSuppressExtra
+magic_SecondFieldAlign
+magic_StripPeriodsFalse
+magic_StripPeriodsTrue
+magic_StripPeriodsTrueShortForm
+magic_SubsequentAuthorSubstitute
+magic_SubsequentAuthorSubstituteNotFooled
+magic_SubsequentAuthorSubstituteOfTitleField
+magic_SuperscriptChars
+magic_SuppressDuplicateVariableRendering                           # uncaught exception
+magic_SuppressLayoutDelimiterIfPrefixComma
+magic_TermCapitalizationWithPrefix
+name_AfterInvertedName
+name_ApostropheInGivenName
+name_ArticularWithComma
+name_AsianGlyphs
+name_AuthorCountWithMultipleVariables
+name_AuthorCountWithSameVarContentAndCombinedTermFail
+name_AuthorEditorCount
+name_CiteGroupDelimiterWithYearCollapse
+name_CiteGroupDelimiterWithYearSuffixCollapse
+name_CiteGroupDelimiterWithYearSuffixCollapse2
+name_CiteGroupDelimiterWithYearSuffixCollapse3
+name_EtAlWithCombined
+name_FormattingOfParticles
+name_HebrewAnd
+name_HyphenatedNonDroppingParticle1
+name_HyphenatedNonDroppingParticle2
+name_LongAbbreviation
+name_LowercaseSurnameSuffix
+name_namepartAffixes
+name_OnlyGivenname                                                 # uncaught exception
+name_ParsedCommaDelimitedDroppingParticleSortOrderingWithoutAffixes
+name_ParsedDroppingParticleWithApostrophe
+name_ParsedNonDroppingParticleWithApostrophe
+name_ParseNames
+name_ParticleCaps3
+name_ParticlesDemoteNonDroppingNever
+name_SubsequentAuthorSubstituteMultipleNames
+name_SubstituteInheritLabel
+name_TwoRolesSameRenderingSeparateRoleLabels
+name_WithNonBreakingSpace
+nameattr_EtAlSubsequentMinOnCitationInCitation
+nameattr_EtAlSubsequentMinOnStyleInCitation
+nameattr_EtAlSubsequentUseFirstOnCitationInCitation
+nameattr_EtAlSubsequentUseFirstOnStyleInCitation
+nameattr_EtAlUseFirstOnCitationInBibliography
+number_EditionSort                                                 # uncaught exception
+number_NewOrdinalsEdition
+number_NewOrdinalsWithGenderChange
+number_OrdinalSpacing                                              # uncaught exception
+number_PlainHyphenOrEnDashAlwaysPlural
+number_SeparateOrdinalNamespaces
+page_Chicago
+page_ChicagoWeird
+page_Expand                                                        # uncaught exception
+page_ExpandWeirdComposite
+page_Minimal
+parallel_Bibliography
+parallel_HackedChicago
+parallel_JournalArticleReverse
+parallel_JournalArticleSimple
+parallel_TrailingIbid
+position_FirstTrueOnlyOnce
+position_IbidInText
+position_IbidSeparateCiteSameNote
+position_IbidWithLocator
+position_IbidWithMultipleSoloCitesInBackref
+position_IbidWithPrefixFullStop
+position_IfIbidWithLocatorIsTrueThenIbidIsTrue
+position_NearNoteSameNote                                          # uncaught exception
+position_NearNoteTrue
+position_ResetNoteNumbers
+punctuation_DefaultYearSuffixDelimiter
+punctuation_DelimiterWithStripPeriodsAndSubstitute2
+punctuation_FieldDuplicates
+punctuation_FrenchOrthography
+punctuation_FullMontyField
+punctuation_FullMontyPlain
+punctuation_FullMontyQuotesIn
+punctuation_FullMontyQuotesOut
+punctuation_OnMacro
+punctuation_SemicolonDelimiter
+punctuation_SuppressPrefixPeriodForDelimiterSemicolon
+quotes_Punctuation
+quotes_PunctuationNasty
+quotes_PunctuationWithInnerQuote
+quotes_QuotesUnderQuotesFalse
+simplespace_case1
+sort_AguStyle
+sort_AguStyleReverseGroups
+sort_AuthorDateWithYearSuffix
+sort_BibliographyCitationNumberDescendingViaMacro
+sort_BibliographyNosortOption
+sort_ChicagoYearSuffix1                                            # uncaught exception
+sort_ChicagoYearSuffix2                                            # uncaught exception
+sort_CitationEdit
+sort_CitationUnsorted
+sort_CiteGroupDelimiter
+sort_ConditionalMacroDates
+sort_DateMacroSortWithSecondFieldAlign
+sort_DropNameLabelInSort
+sort_GroupedByAuthorstring
+sort_LeadingA
+sort_LeadingApostropheOnNameParticle
+sort_NameVariable
+sort_OmittedBibRefMixedNumericStyle
+sort_Quotes
+sort_RangeUnaffected
+sort_SeparateAuthorsAndOthers
+sort_StripMarkup
+sort_SubstituteTitle
+sort_WithAndInOneEntry
+substitute_SharedMacro                                             # uncaught exception
+substitute_SuppressOrdinaryVariable
+testers_FirstAutoGeneratedZoteroPluginTest
+testers_SecondAutoGeneratedZoteroPluginTest
+textcase_AfterQuote
+textcase_InQuotes
+textcase_Lowercase
+textcase_NonEnglishChars
+textcase_RepeatedTitleBug
+textcase_SkipNameParticlesInTitleCase
+textcase_StopWordBeforeHyphen
+textcase_TitleCapitalization2
+textcase_TitleCaseWithFinalNocase
+textcase_TitleCaseWithHyphens
+textcase_TitleCaseWithNonBreakSpace
+textcase_TitleWithEmDash
+textcase_TitleWithEnDash
+textcase_Uppercase
+variables_ShortForm
+variables_TitleShortOnAbbrevWithTitle
+variables_TitleShortOnAbbrevWithTitleCondition
+variables_TitleShortOnAbbrevWithTitleGroup
diff -pruN 0.3.0-6/tests/test.bib 0.5.1-1/tests/test.bib
--- 0.3.0-6/tests/test.bib	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/tests/test.bib	2020-04-06 16:16:08.000000000 +0000
@@ -0,0 +1,12 @@
+@INPROCEEDINGS{Blakley1979,
+  AUTHOR    = {Blakley, G. R.},
+  BOOKTITLE = {Proceedings of the National Computer Conference},
+  DOI       = {10.1109/AFIPS.1979.98},
+  LOCATION  = {Los Alamitos, CA, USA},
+  PAGES     = {313},
+  PUBLISHER = {IEEE Computer Society},
+  TITLE     = {{Safeguarding cryptographic key’s}},
+  URL       = {http://www.computer.org/csdl/proceedings/afips/1979/5087/00/50870313-abs.html http://www.computer.org/csdl/proceedings/afips/1979/5087/00/50870313.pdf},
+  VOLUME    = {0},
+  YEAR      = {1979},
+}
\ No newline at end of file
diff -pruN 0.3.0-6/tests/test_bibparse.py 0.5.1-1/tests/test_bibparse.py
--- 0.3.0-6/tests/test_bibparse.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/tests/test_bibparse.py	2020-04-06 16:16:08.000000000 +0000
@@ -4,21 +4,38 @@ from __future__ import (absolute_import,
                         unicode_literals)
 from citeproc.py2compat import *
 
+import os
+
 from io import StringIO
 from unittest import TestCase
 
-from citeproc.source.bibtex.bibparse import BibTeXParser
+from citeproc.source.bibtex.bibparse import BibTeXParser, BibTeXDecodeError
+
+
+TEST_BIB = os.path.join(os.path.dirname(__file__), 'test.bib')
 
 
 class TestBibTeXParser(TestCase):
     def test_parse(self):
         file = StringIO(sample)
         bib = BibTeXParser(file)
+        self.print_entries(bib)
+        # TODO: perform useful checks
+
+    def test_parse_file(self):
+        test_bib = BibTeXParser(TEST_BIB, encoding='utf-8')
+        self.print_entries(test_bib)
+
+    def test_parse_file_bad_encoding(self):
+        with self.assertRaises(BibTeXDecodeError):
+            BibTeXParser(TEST_BIB)
+
+    @staticmethod
+    def print_entries(bib):
         for key, entry in bib.items():
             print(key)
             for name, value in entry.items():
                 print('   {}: {}'.format(name, value))
-        # TODO: perform useful checks
 
 
 # based on the sample BibTeX database by Xavier Décoret
diff -pruN 0.3.0-6/tests/test_bibtex.py 0.5.1-1/tests/test_bibtex.py
--- 0.3.0-6/tests/test_bibtex.py	2014-11-07 15:31:50.000000000 +0000
+++ 0.5.1-1/tests/test_bibtex.py	2020-04-06 16:16:08.000000000 +0000
@@ -6,6 +6,7 @@ from citeproc.py2compat import *
 
 from unittest import TestCase
 
+from citeproc.source.bibtex import BibTeX
 from citeproc.source.bibtex.bibtex import split_names, split_name, parse_name
 
 
@@ -32,6 +33,31 @@ class TestBibTeX(TestCase):
             print('{:24}  {}'.format(name, parse_name(name)))
             self.assertEqual(parse_name(name), reference)
 
+    def test_date_months(self):
+        for january in ['jan', 'JAN', '01']:
+            self.assertEqual(BibTeX._parse_month(january),
+                             ({'month': 1}, ) * 2)
+        self.assertEqual(BibTeX._parse_month("10~jan"),
+                         ({'month': 1, 'day': 10}, ) * 2)
+        self.assertEqual(BibTeX._parse_month("jul~4"),
+                         ({'month': 7, 'day': 4}, ) * 2)
+
+    def test_pages(self):
+        def test(bibtex, csl):
+            self.assertEqual(BibTeX._bibtex_to_csl_pages(bibtex), csl)
+
+        test('313', '313')
+        test('R112', 'R112')
+        test('12+', '12')
+        # page ranges
+        test('1--3', '1-3')
+        test('1-3', '1-3')
+        test('i-iv', 'i-iv')
+        test('11.1--11.27', '11.1-11.27')
+        test('S43--S67', 'S43-S67')
+        # Arabic letters
+        test('ا-ي', 'ا-ي')
+
 
 SPLIT_NAMES = [
     ('AA BB', ['AA BB']),
diff -pruN 0.3.0-6/tox.ini 0.5.1-1/tox.ini
--- 0.3.0-6/tox.ini	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/tox.ini	2020-04-06 16:16:08.000000000 +0000
@@ -0,0 +1,21 @@
+[tox]
+envlist = py27,py35,py36,py37,py38
+
+[testenv]
+deps = nose
+changedir = {envtmpdir}
+commands =
+    nosetests --where={toxinidir}/tests --ignore-files=citeproc-test.py
+    python {toxinidir}/tests/citeproc-test.py --no-update
+
+[testenv:py36]
+passenv = TRAVIS TRAVIS_JOB_ID TRAVIS_BRANCH
+deps =
+    {[testenv]deps}
+    coverage
+    coveralls
+commands =
+    nosetests --where={toxinidir}/tests --ignore-files=citeproc-test.py \
+              --with-coverage --cover-package=citeproc
+    coverage run --source=citeproc --append {toxinidir}/tests/citeproc-test.py
+    python {toxinidir}/coveralls.py
diff -pruN 0.3.0-6/.travis.yml 0.5.1-1/.travis.yml
--- 0.3.0-6/.travis.yml	1970-01-01 00:00:00.000000000 +0000
+++ 0.5.1-1/.travis.yml	2020-04-06 16:16:08.000000000 +0000
@@ -0,0 +1,16 @@
+language: python
+
+sudo: false
+
+python:
+  - 2.7
+  - 3.5
+  - 3.6
+  - 3.7
+  - 3.8
+
+install:
+  - pip install tox-travis
+
+script:
+  - tox
